import { computed as h, ref as v, watch as be, onMounted as Be, onBeforeUnmount as Me, openBlock as s, createElementBlock as u, normalizeClass as me, normalizeStyle as xe, createBlock as _, createCommentVNode as y, unref as p, createSlots as Ue, withCtx as f, renderSlot as g, normalizeProps as A, guardReactiveProps as z, createVNode as ke, createElementVNode as n, Fragment as T, renderList as F, toDisplayString as V, createTextVNode as Ee, nextTick as De } from "vue";
import { u as We, c as Ge, t as Xe, o as je, e as N, C as He, v as I, X as Ye, w as W, D as qe, s as Je, x as Ke, y as Qe, q as Ze, r as et, E as we } from "./index-DnVHQ2xI.js";
import { t as tt, u as lt } from "./useResponsive-NZB-WLRF.js";
import { _ as ot } from "./Title-5VmBwT4i.js";
import { u as at, U as st } from "./usePrinter-BEeNAqS5.js";
import { _ as ut } from "./Tooltip-Cj4EF7v1.js";
import { D as it } from "./DataTable-DTk7C4Pr.js";
import nt from "./vue-ui-skeleton-aZmkNzAe.js";
import { S as rt } from "./Slicer-CU7dRZR0.js";
import vt from "./vue-ui-accordion-DspS4q3f.js";
import { u as $e } from "./useNestedProp-Cox0K0Y5.js";
import { _ as dt } from "./PackageVersion-CvCRsT5_.js";
import { P as yt } from "./PenAndPaper-Jb0pLt3G.js";
import { _ as ct } from "./_plugin-vue_export-helper-CHgC5LLL.js";
const ht = ["id"], pt = ["xmlns", "viewBox"], ft = { key: 0 }, gt = ["id"], bt = ["stop-color"], mt = ["stop-color"], xt = ["stop-color"], kt = ["id"], wt = ["stop-color"], $t = ["stop-color"], Ct = ["stop-color"], _t = { key: 0 }, Nt = ["x1", "x2", "y1", "y2", "stroke", "stroke-width"], St = ["x1", "x2", "y1", "y2", "stroke", "stroke-width"], At = { key: 1 }, zt = ["x1", "x2", "y1", "y2", "stroke", "stroke-width"], Tt = ["x", "y", "font-size", "fill", "font-weight"], Ft = { key: 2 }, Lt = ["transform", "text-anchor", "font-size", "fill", "font-weight"], Rt = ["x1", "x2", "y1", "y2", "stroke", "stroke-width"], Vt = { key: 0 }, It = ["cx", "cy", "r", "fill"], Ot = ["cx", "cy", "r", "fill"], Pt = { key: 1 }, Bt = ["x1", "x2", "y1", "y2", "stroke", "stroke-width"], Mt = ["x1", "x2", "y1", "y2", "stroke", "stroke-width"], Ut = ["x", "y", "height", "width", "fill", "rx"], Et = ["x", "y", "height", "width", "fill", "rx", "stroke", "stroke-width"], Dt = ["x", "y", "height", "width", "fill", "onMouseover"], Wt = {
  key: 4,
  class: "vue-data-ui-watermark"
}, Gt = ["innerHTML"], Xt = {
  __name: "vue-ui-candlestick",
  props: {
    config: {
      type: Object,
      default() {
        return {};
      }
    },
    dataset: {
      type: Array,
      default() {
        return [];
      }
    }
  },
  setup($, { expose: Ce }) {
    const k = $, { vue_ui_candlestick: _e } = We(), L = h(() => !!k.dataset && k.dataset.length), x = v(Ge()), Ne = v(null), G = v(!1), X = v(""), j = v(void 0), K = v(0), S = v(null), Q = v(null), Z = v(null), ee = v(null), O = v(0), te = v(0), le = v(0), e = h({
      get: () => oe(),
      set: (t) => t
    });
    function oe() {
      const t = $e({
        userConfig: k.config,
        defaultConfig: _e
      });
      return t.theme ? {
        ...$e({
          userConfig: Xe.vue_ui_candlestick[t.theme] || k.config,
          defaultConfig: t
        })
      } : t;
    }
    be(() => k.config, (t) => {
      e.value = oe(), ae(), O.value += 1, le.value += 1, te.value += 1;
    }, { deep: !0 }), be(() => k.dataset, (t) => {
      c.value.start = 0, c.value.end = t.length, O.value += 1;
    }, { deep: !0 });
    const d = v({
      height: e.value.style.height,
      width: e.value.style.width,
      xAxisFontSize: e.value.style.layout.grid.xAxis.dataLabels.fontSize,
      yAxisFontSize: e.value.style.layout.grid.yAxis.dataLabels.fontSize
    }), P = v(null);
    Be(() => {
      ae();
    });
    function ae() {
      if (je(k.dataset) && N({
        componentName: "VueUiCandlestick",
        type: "dataset"
      }), e.value.responsive) {
        const t = tt(() => {
          const { width: a, height: l } = lt({
            chart: S.value,
            title: e.value.style.title.text ? Q.value : null,
            slicer: ee.value,
            legend: Z.value
          });
          d.value.width = a, d.value.height = l, d.value.xAxisFontSize = we({
            relator: Math.min(a, l),
            adjuster: e.value.style.width,
            source: e.value.style.layout.grid.xAxis.dataLabels.fontSize,
            threshold: 6,
            fallback: 6
          }), d.value.yAxisFontSize = we({
            relator: Math.min(a, l),
            adjuster: e.value.style.width,
            source: e.value.style.layout.grid.yAxis.dataLabels.fontSize,
            threshold: 6,
            fallback: 6
          });
        });
        P.value = new ResizeObserver(t), P.value.observe(S.value.parentNode);
      }
    }
    Me(() => {
      P.value && P.value.disconnect();
    });
    const { isPrinting: se, isImaging: ue, generatePdf: ie, generateImage: ne } = at({
      elementId: `vue-ui-candlestick_${x.value}`,
      fileName: e.value.style.title.text || "vue-ui-candlestick"
    }), w = v({
      showTable: e.value.table.show,
      showTooltip: e.value.style.tooltip.show
    }), i = h(() => {
      const { top: t, right: a, bottom: l, left: o } = e.value.style.layout.padding;
      return {
        top: t,
        right: d.value.width - a,
        left: o,
        bottom: d.value.height - l,
        width: d.value.width - o - a,
        height: d.value.height - t - l
      };
    }), H = h(() => k.dataset.length), c = v({
      start: 0,
      end: H.value
    }), re = h(() => k.dataset.slice(c.value.start, c.value.end)), Y = h(() => (k.dataset.forEach((t, a) => {
      [null, void 0].includes(t[0]) && N({
        componentName: "VueUiCandlestick",
        type: "datasetAttribute",
        property: "period (index 0)",
        index: a
      }), [null, void 0].includes(t[1]) && N({
        componentName: "VueUiCandlestick",
        type: "datasetAttribute",
        property: "open (index 1)",
        index: a
      }), [null, void 0].includes(t[2]) && N({
        componentName: "VueUiCandlestick",
        type: "datasetAttribute",
        property: "high (index 2)",
        index: a
      }), [null, void 0].includes(t[3]) && N({
        componentName: "VueUiCandlestick",
        type: "datasetAttribute",
        property: "low (index 3)",
        index: a
      }), [null, void 0].includes(t[4]) && N({
        componentName: "VueUiCandlestick",
        type: "datasetAttribute",
        property: "last (index 4)",
        index: a
      }), [null, void 0].includes(t[5]) && N({
        componentName: "VueUiCandlestick",
        type: "datasetAttribute",
        property: "volume (index 5)",
        index: a
      });
    }), re.value.map((t) => ({
      period: t[0],
      open: t[1],
      high: t[2],
      low: t[3],
      last: t[4],
      volume: t[5]
    })))), r = h(() => i.value.width / re.value.length), ve = h(() => ({
      max: Math.max(...Y.value.map((t) => t.high)),
      min: 0
    })), C = h(() => He(ve.value.min, ve.value.max, e.value.style.layout.grid.yAxis.dataLabels.steps));
    function B(t, a) {
      return {
        ...t,
        x: I(i.value.left + a * r.value + r.value / 2),
        y: I(i.value.top + (1 - t / C.value.max) * i.value.height),
        value: I(t)
      };
    }
    const b = h(() => Y.value.map((t, a) => {
      const l = B(t.open, a), o = B(t.high, a), m = B(t.low, a), E = B(t.last, a), D = t.last > t.open;
      return {
        period: t.period,
        open: l,
        high: o,
        low: m,
        last: E,
        volume: t.volume,
        isBullish: D
      };
    }));
    function Se(t) {
      return I(t / C.value.max);
    }
    const Ae = h(() => C.value.ticks.map((t) => ({
      y: i.value.bottom - i.value.height * Se(t),
      value: I(t)
    }))), ze = h(() => Y.value.map((t) => t.period)), q = v(null);
    function Te(t, a) {
      j.value = t, q.value = {
        datapoint: a,
        seriesIndex: t,
        series: b.value,
        config: e.value
      };
      const l = e.value.style.tooltip.customFormat;
      if (Ke(l) && Qe(() => l({
        seriesIndex: t,
        datapoint: a,
        series: b.value,
        config: e.value
      })))
        X.value = l({
          seriesIndex: t,
          datapoint: a,
          series: b.value,
          config: e.value
        });
      else if (e.value.style.tooltip.show) {
        let o = "";
        const { period: m, open: E, high: D, low: he, last: pe, volume: fe, isBullish: ge } = b.value[t], { period: jt, open: Re, high: Ve, low: Ie, last: Oe, volume: Pe } = e.value.translations;
        o += `<div><svg style="margin-right:6px" viewBox="0 0 12 12" height="12" width="12"><rect x="0" y="0" height="12" width="12" rx="${e.value.style.layout.candle.borderRadius * 3}" stroke="${e.value.style.layout.candle.stroke}" stroke-width="${e.value.style.layout.candle.strokeWidth}" 
                fill="${e.value.style.layout.candle.gradient.show ? ge ? `url(#bullish_gradient_${x.value})` : `url(#bearish_gradient_${x.value})` : ge ? e.value.style.layout.candle.colors.bullish : e.value.style.layout.candle.colors.bearish}"/></svg>${m}</div>`, o += `${Pe} : <b>${isNaN(fe) ? "-" : Number(fe.toFixed(e.value.style.tooltip.roundingValue)).toLocaleString()}</b>`, o += `<div style="margin-top:6px;padding-top:6px;border-top:1px solid ${e.value.style.tooltip.borderColor}">`, o += `<div>${Re}: <b>${e.value.style.tooltip.prefix} ${isNaN(E.value) ? "-" : Number(E.value.toFixed(e.value.style.tooltip.roundingValue)).toLocaleString()} ${e.value.style.tooltip.suffix}</b></div>`, o += `<div>${Ve}: <b>${e.value.style.tooltip.prefix} ${isNaN(D.value) ? "-" : Number(D.value.toFixed(e.value.style.tooltip.roundingValue)).toLocaleString()} ${e.value.style.tooltip.suffix}</b></div>`, o += `<div>${Ie}: <b>${e.value.style.tooltip.prefix} ${isNaN(he.value) ? "-" : Number(he.value.toFixed(e.value.style.tooltip.roundingValue)).toLocaleString()} ${e.value.style.tooltip.suffix}</b></div>`, o += `<div>${Oe}: <b>${e.value.style.tooltip.prefix} ${isNaN(pe.value) ? "-" : Number(pe.value.toFixed(e.value.style.tooltip.roundingValue)).toLocaleString()} ${e.value.style.tooltip.suffix}</b></div>`, o += "</div>", X.value = `<div style="text-align:right">${o}</div>`;
      }
      G.value = !0;
    }
    function Fe() {
      c.value = {
        start: 0,
        end: H.value
      }, O.value += 1;
    }
    function de() {
      De(() => {
        const t = [e.value.translations.period, e.value.translations.open, e.value.translations.high, e.value.translations.low, e.value.translations.last, e.value.translations.volume], a = b.value.map((m) => [
          m.period,
          m.open.value,
          m.high.value,
          m.low.value,
          m.last.value,
          m.volume
        ]), l = [[e.value.style.title.text], [e.value.style.title.subtitle.text], [[""], [""], [""]]].concat([t]).concat(a), o = Ze(l);
        et({ csvContent: o, title: e.value.style.title.text || "vue-ui-candlestick" });
      });
    }
    const M = h(() => {
      const t = b.value.map((o) => [
        `<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 12 12" height="12" width="12" style="margin-right: 6px"><rect x="0" y="0" height="12" width="12" :rx="${e.value.style.layout.candle.borderRadius * 3}" fill="${e.value.style.layout.candle.gradient.show ? o.isBullish ? `url(#bullish_gradient_${x.value}` : `url(#bearish_gradient_${x.value})` : o.isBullish ? e.value.style.layout.candle.colors.bullish : e.value.style.layout.candle.colors.bearish}"/></svg> ${o.period}`,
        `${e.value.table.td.prefix} ${isNaN(o.open.value) ? "-" : Number(o.open.value.toFixed(e.value.table.td.roundingValue)).toLocaleString()} ${e.value.table.td.suffix}`,
        `${e.value.table.td.prefix} ${isNaN(o.high.value) ? "-" : Number(o.high.value.toFixed(e.value.table.td.roundingValue)).toLocaleString()} ${e.value.table.td.suffix}`,
        `${e.value.table.td.prefix} ${isNaN(o.low.value) ? "-" : Number(o.low.value.toFixed(e.value.table.td.roundingValue)).toLocaleString()} ${e.value.table.td.suffix}`,
        `${e.value.table.td.prefix} ${isNaN(o.last.value) ? "-" : Number(o.last.value.toFixed(e.value.table.td.roundingValue)).toLocaleString()} ${e.value.table.td.suffix}`,
        `${isNaN(o.volume) ? "-" : o.volume.toLocaleString()}`
      ]), a = {
        th: {
          backgroundColor: e.value.table.th.backgroundColor,
          color: e.value.table.th.color,
          outline: e.value.table.th.outline
        },
        td: {
          backgroundColor: e.value.table.td.backgroundColor,
          color: e.value.table.td.color,
          outline: e.value.table.td.outline
        },
        breakpoint: e.value.table.responsiveBreakpoint
      }, l = [
        e.value.translations.period,
        e.value.translations.open,
        e.value.translations.high,
        e.value.translations.low,
        e.value.translations.last,
        e.value.translations.volume
      ];
      return { head: l, body: t, config: a, colNames: l };
    }), R = v(!1);
    function Le(t) {
      R.value = t, K.value += 1;
    }
    function ye() {
      w.value.showTable = !w.value.showTable;
    }
    function ce() {
      w.value.showTooltip = !w.value.showTooltip;
    }
    const U = v(!1);
    function J() {
      U.value = !U.value;
    }
    return Ce({
      generatePdf: ie,
      generateCsv: de,
      generateImage: ne,
      toggleTable: ye,
      toggleTooltip: ce,
      toggleAnnotator: J
    }), (t, a) => (s(), u("div", {
      ref_key: "candlestickChart",
      ref: S,
      class: me(`vue-ui-candlestick ${R.value ? "vue-data-ui-wrapper-fullscreen" : ""} ${e.value.useCssAnimation ? "" : "vue-ui-dna"}`),
      style: xe(`position:relative;font-family:${e.value.style.fontFamily}; text-align:center;${e.value.style.title.text ? "" : "padding-top:36px"};background:${e.value.style.backgroundColor}; ${e.value.responsive ? "height: 100%" : ""}`),
      id: `vue-ui-candlestick_${x.value}`
    }, [
      e.value.userOptions.buttons.annotator ? (s(), _(yt, {
        key: 0,
        parent: S.value,
        backgroundColor: e.value.style.backgroundColor,
        color: e.value.style.color,
        active: U.value,
        onClose: J
      }, null, 8, ["parent", "backgroundColor", "color", "active"])) : y("", !0),
      e.value.style.title.text ? (s(), u("div", {
        key: 1,
        ref_key: "chartTitle",
        ref: Q,
        style: "width:100%;background:transparent"
      }, [
        (s(), _(ot, {
          key: `title_${le.value}`,
          config: {
            title: {
              cy: "candlestick-div-title",
              ...e.value.style.title
            },
            subtitle: {
              cy: "candlestick-div-subtitle",
              ...e.value.style.title.subtitle
            }
          }
        }, null, 8, ["config"]))
      ], 512)) : y("", !0),
      e.value.userOptions.show && L.value ? (s(), _(st, {
        ref_key: "details",
        ref: Ne,
        key: `user_options_${K.value}`,
        backgroundColor: e.value.style.backgroundColor,
        color: e.value.style.color,
        isImaging: p(ue),
        isPrinting: p(se),
        uid: x.value,
        hasTooltip: e.value.userOptions.buttons.tooltip && e.value.style.tooltip.show,
        hasPdf: e.value.userOptions.buttons.pdf,
        hasImg: e.value.userOptions.buttons.img,
        hasXls: e.value.userOptions.buttons.csv,
        hasTable: e.value.userOptions.buttons.table,
        hasFullscreen: e.value.userOptions.buttons.fullscreen,
        isFullscreen: R.value,
        isTooltip: w.value.showTooltip,
        titles: { ...e.value.userOptions.buttonTitles },
        chartElement: S.value,
        position: e.value.userOptions.position,
        hasAnnotator: e.value.userOptions.buttons.annotator,
        isAnnotation: U.value,
        onToggleFullscreen: Le,
        onGeneratePdf: p(ie),
        onGenerateCsv: de,
        onGenerateImage: p(ne),
        onToggleTable: ye,
        onToggleTooltip: ce,
        onToggleAnnotator: J
      }, Ue({ _: 2 }, [
        t.$slots.optionTooltip ? {
          name: "optionTooltip",
          fn: f(() => [
            g(t.$slots, "optionTooltip", {}, void 0, !0)
          ]),
          key: "0"
        } : void 0,
        t.$slots.optionPdf ? {
          name: "optionPdf",
          fn: f(() => [
            g(t.$slots, "optionPdf", {}, void 0, !0)
          ]),
          key: "1"
        } : void 0,
        t.$slots.optionCsv ? {
          name: "optionCsv",
          fn: f(() => [
            g(t.$slots, "optionCsv", {}, void 0, !0)
          ]),
          key: "2"
        } : void 0,
        t.$slots.optionImg ? {
          name: "optionImg",
          fn: f(() => [
            g(t.$slots, "optionImg", {}, void 0, !0)
          ]),
          key: "3"
        } : void 0,
        t.$slots.optionTable ? {
          name: "optionTable",
          fn: f(() => [
            g(t.$slots, "optionTable", {}, void 0, !0)
          ]),
          key: "4"
        } : void 0,
        t.$slots.optionFullscreen ? {
          name: "optionFullscreen",
          fn: f(({ toggleFullscreen: l, isFullscreen: o }) => [
            g(t.$slots, "optionFullscreen", A(z({ toggleFullscreen: l, isFullscreen: o })), void 0, !0)
          ]),
          key: "5"
        } : void 0,
        t.$slots.optionAnnotator ? {
          name: "optionAnnotator",
          fn: f(({ toggleAnnotator: l, isAnnotator: o }) => [
            g(t.$slots, "optionAnnotator", A(z({ toggleAnnotator: l, isAnnotator: o })), void 0, !0)
          ]),
          key: "6"
        } : void 0
      ]), 1032, ["backgroundColor", "color", "isImaging", "isPrinting", "uid", "hasTooltip", "hasPdf", "hasImg", "hasXls", "hasTable", "hasFullscreen", "isFullscreen", "isTooltip", "titles", "chartElement", "position", "hasAnnotator", "isAnnotation", "onGeneratePdf", "onGenerateImage"])) : y("", !0),
      L.value ? (s(), u("svg", {
        key: 3,
        xmlns: p(Ye),
        class: me({ "vue-data-ui-fullscreen--on": R.value, "vue-data-ui-fulscreen--off": !R.value }),
        viewBox: `0 0 ${d.value.width <= 0 ? 10 : d.value.width} ${d.value.height <= 0 ? 10 : d.value.height}`,
        style: xe(`max-width:100%;overflow:visible;background:transparent;color:${e.value.style.color}`)
      }, [
        ke(dt),
        b.value.length > 0 ? (s(), u("g", ft, [
          n("defs", null, [
            n("linearGradient", {
              id: `bearish_gradient_${x.value}`,
              x2: "0%",
              y2: "100%"
            }, [
              n("stop", {
                offset: "0%",
                "stop-color": e.value.style.layout.candle.colors.bearish
              }, null, 8, bt),
              n("stop", {
                offset: "50%",
                "stop-color": `${p(W)(e.value.style.layout.candle.colors.bearish, 0.02)}DE`
              }, null, 8, mt),
              n("stop", {
                offset: "100%",
                "stop-color": `${p(W)(e.value.style.layout.candle.colors.bearish, 0.05)}66`
              }, null, 8, xt)
            ], 8, gt),
            n("linearGradient", {
              id: `bullish_gradient_${x.value}`,
              x2: "0%",
              y2: "100%"
            }, [
              n("stop", {
                offset: "0%",
                "stop-color": e.value.style.layout.candle.colors.bullish
              }, null, 8, wt),
              n("stop", {
                offset: "50%",
                "stop-color": `${p(W)(e.value.style.layout.candle.colors.bullish, 0.02)}DE`
              }, null, 8, $t),
              n("stop", {
                offset: "100%",
                "stop-color": `${p(W)(e.value.style.layout.candle.colors.bullish, 0.05)}66`
              }, null, 8, Ct)
            ], 8, kt)
          ]),
          e.value.style.layout.grid.show ? (s(), u("g", _t, [
            n("line", {
              x1: i.value.left,
              x2: i.value.left,
              y1: i.value.top,
              y2: i.value.bottom,
              stroke: e.value.style.layout.grid.stroke,
              "stroke-width": e.value.style.layout.grid.strokeWidth,
              "stroke-linecap": "round"
            }, null, 8, Nt),
            n("line", {
              x1: i.value.left,
              x2: i.value.right,
              y1: i.value.bottom,
              y2: i.value.bottom,
              stroke: e.value.style.layout.grid.stroke,
              "stroke-width": e.value.style.layout.grid.strokeWidth,
              "stroke-linecap": "round"
            }, null, 8, St)
          ])) : y("", !0),
          e.value.style.layout.grid.yAxis.dataLabels.show ? (s(), u("g", At, [
            (s(!0), u(T, null, F(Ae.value, (l, o) => (s(), u("g", null, [
              l.value >= C.value.min && l.value <= C.value.max ? (s(), u("line", {
                key: 0,
                x1: i.value.left,
                x2: i.value.left - 5,
                y1: l.y,
                y2: l.y,
                stroke: e.value.style.layout.grid.stroke,
                "stroke-width": e.value.style.layout.grid.strokeWidth,
                "stroke-linecap": "round"
              }, null, 8, zt)) : y("", !0),
              l.value >= C.value.min && l.value <= C.value.max ? (s(), u("text", {
                key: 1,
                x: i.value.left - 8 + e.value.style.layout.grid.yAxis.dataLabels.offsetX,
                y: l.y + d.value.yAxisFontSize / 3,
                "font-size": d.value.yAxisFontSize,
                "text-anchor": "end",
                fill: e.value.style.layout.grid.yAxis.dataLabels.color,
                "font-weight": e.value.style.layout.grid.yAxis.dataLabels.bold ? "bold" : "normal"
              }, V(e.value.style.layout.grid.yAxis.dataLabels.prefix) + " " + V(p(qe)(l.value) ? l.value.toFixed(e.value.style.layout.grid.yAxis.dataLabels.roundingValue) : "") + " " + V(e.value.style.layout.grid.yAxis.dataLabels.suffix), 9, Tt)) : y("", !0)
            ]))), 256))
          ])) : y("", !0),
          e.value.style.layout.grid.xAxis.dataLabels.show ? (s(), u("g", Ft, [
            (s(!0), u(T, null, F(ze.value, (l, o) => (s(), u("g", null, [
              n("text", {
                transform: `translate(${i.value.left + r.value * o + r.value / 2}, ${i.value.bottom + d.value.xAxisFontSize * 2 + e.value.style.layout.grid.xAxis.dataLabels.offsetY}), rotate(${e.value.style.layout.grid.xAxis.dataLabels.rotation})`,
                "text-anchor": e.value.style.layout.grid.xAxis.dataLabels.rotation > 0 ? "start" : e.value.style.layout.grid.xAxis.dataLabels.rotation < 0 ? "end" : "middle",
                "font-size": d.value.xAxisFontSize,
                fill: e.value.style.layout.grid.xAxis.dataLabels.color,
                "font-weight": e.value.style.layout.grid.xAxis.dataLabels.bold ? "bold" : "normal"
              }, V(l), 9, Lt)
            ]))), 256))
          ])) : y("", !0),
          n("g", null, [
            (s(!0), u(T, null, F(b.value, (l, o) => (s(), u("g", null, [
              n("line", {
                x1: l.open.x,
                x2: l.open.x,
                y1: l.high.y,
                y2: l.low.y,
                stroke: e.value.style.layout.wick.stroke,
                "stroke-width": e.value.style.layout.wick.strokeWidth,
                "stroke-linecap": "round"
              }, null, 8, Rt),
              e.value.style.layout.wick.extremity.shape === "circle" ? (s(), u("g", Vt, [
                n("circle", {
                  cx: l.high.x,
                  cy: l.high.y,
                  r: e.value.style.layout.wick.extremity.size === "auto" ? r.value / 20 : e.value.style.layout.wick.extremity.size,
                  fill: e.value.style.layout.wick.extremity.color
                }, null, 8, It),
                n("circle", {
                  cx: l.low.x,
                  cy: l.low.y,
                  r: e.value.style.layout.wick.extremity.size === "auto" ? r.value / 20 : e.value.style.layout.wick.extremity.size,
                  fill: e.value.style.layout.wick.extremity.color
                }, null, 8, Ot)
              ])) : y("", !0),
              e.value.style.layout.wick.extremity.shape === "line" ? (s(), u("g", Pt, [
                n("line", {
                  x1: l.high.x - (e.value.style.layout.wick.extremity.size === "auto" ? r.value * e.value.style.layout.candle.widthRatio : e.value.style.layout.wick.extremity.size) / 2,
                  x2: l.high.x + (e.value.style.layout.wick.extremity.size === "auto" ? r.value * e.value.style.layout.candle.widthRatio : e.value.style.layout.wick.extremity.size) / 2,
                  y1: l.high.y,
                  y2: l.high.y,
                  stroke: e.value.style.layout.wick.extremity.color,
                  "stroke-width": e.value.style.layout.wick.strokeWidth,
                  "stroke-linecap": "round"
                }, null, 8, Bt),
                n("line", {
                  x1: l.low.x - (e.value.style.layout.wick.extremity.size === "auto" ? r.value * e.value.style.layout.candle.widthRatio : e.value.style.layout.wick.extremity.size) / 2,
                  x2: l.low.x + (e.value.style.layout.wick.extremity.size === "auto" ? r.value * e.value.style.layout.candle.widthRatio : e.value.style.layout.wick.extremity.size) / 2,
                  y1: l.low.y,
                  y2: l.low.y,
                  stroke: e.value.style.layout.wick.extremity.color,
                  "stroke-width": e.value.style.layout.wick.strokeWidth,
                  "stroke-linecap": "round"
                }, null, 8, Mt)
              ])) : y("", !0)
            ]))), 256))
          ]),
          n("g", null, [
            (s(!0), u(T, null, F(b.value, (l, o) => (s(), u("rect", {
              x: l.open.x - r.value / 2 + r.value * (1 - e.value.style.layout.candle.widthRatio) / 2,
              y: l.isBullish ? l.last.y : l.open.y,
              height: Math.abs(l.last.y - l.open.y) <= 0 ? 1e-4 : Math.abs(l.last.y - l.open.y),
              width: r.value * e.value.style.layout.candle.widthRatio <= 0 ? 1e-4 : r.value * e.value.style.layout.candle.widthRatio,
              fill: e.value.style.layout.candle.gradient.underlayer,
              rx: e.value.style.layout.candle.borderRadius,
              stroke: "none"
            }, null, 8, Ut))), 256)),
            (s(!0), u(T, null, F(b.value, (l, o) => (s(), u("rect", {
              x: l.open.x - r.value / 2 + r.value * (1 - e.value.style.layout.candle.widthRatio) / 2,
              y: l.isBullish ? l.last.y : l.open.y,
              height: Math.abs(l.last.y - l.open.y) <= 0 ? 1e-4 : Math.abs(l.last.y - l.open.y),
              width: r.value * e.value.style.layout.candle.widthRatio <= 0 ? 1e-4 : r.value * e.value.style.layout.candle.widthRatio,
              fill: l.isBullish ? e.value.style.layout.candle.gradient.show ? `url(#bullish_gradient_${x.value})` : e.value.style.layout.candle.colors.bullish : e.value.style.layout.candle.gradient.show ? `url(#bearish_gradient_${x.value})` : e.value.style.layout.candle.colors.bearish,
              rx: e.value.style.layout.candle.borderRadius,
              stroke: e.value.style.layout.candle.stroke,
              "stroke-width": e.value.style.layout.candle.strokeWidth,
              "stroke-linecap": "round",
              "stroke-linejoin": "round"
            }, null, 8, Et))), 256))
          ]),
          n("g", null, [
            (s(!0), u(T, null, F(b.value, (l, o) => (s(), u("rect", {
              x: i.value.left + o * r.value,
              y: i.value.top,
              height: i.value.height <= 0 ? 1e-4 : i.value.height,
              width: r.value <= 0 ? 1e-4 : r.value,
              fill: j.value === o ? p(Je)(e.value.style.layout.selector.color, e.value.style.layout.selector.opacity) : "transparent",
              onMouseover: (m) => Te(o, l),
              onMouseleave: a[0] || (a[0] = (m) => {
                j.value = void 0, G.value = !1;
              })
            }, null, 40, Dt))), 256))
          ])
        ])) : y("", !0),
        g(t.$slots, "svg", { svg: d.value }, void 0, !0)
      ], 14, pt)) : y("", !0),
      t.$slots.watermark ? (s(), u("div", Wt, [
        g(t.$slots, "watermark", A(z({ isPrinting: p(se) || p(ue) })), void 0, !0)
      ])) : y("", !0),
      L.value ? y("", !0) : (s(), _(nt, {
        key: 5,
        config: {
          type: "candlesticks",
          style: {
            backgroundColor: e.value.style.backgroundColor,
            candlesticks: {
              axis: {
                color: "#CCCCCC"
              },
              candle: {
                color: "#CCCCCC"
              }
            }
          }
        }
      }, null, 8, ["config"])),
      e.value.style.zoom.show && L.value ? (s(), u("div", {
        key: 6,
        ref_key: "chartSlicer",
        ref: ee
      }, [
        (s(), _(rt, {
          key: `slicer_${O.value}`,
          background: e.value.style.zoom.color,
          borderColor: e.value.style.backgroundColor,
          fontSize: e.value.style.zoom.fontSize,
          useResetSlot: e.value.style.zoom.useResetSlot,
          labelLeft: $.dataset[c.value.start] ? $.dataset[c.value.start][0] : $.dataset[0][0],
          labelRight: $.dataset[c.value.end - 1] ? $.dataset[c.value.end - 1][0] : $.dataset.at(-1)[0],
          textColor: e.value.style.color,
          inputColor: e.value.style.zoom.color,
          selectColor: e.value.style.zoom.highlightColor,
          max: H.value,
          min: 0,
          valueStart: c.value.start,
          valueEnd: c.value.end,
          start: c.value.start,
          "onUpdate:start": a[1] || (a[1] = (l) => c.value.start = l),
          end: c.value.end,
          "onUpdate:end": a[2] || (a[2] = (l) => c.value.end = l),
          onReset: Fe
        }, {
          "reset-action": f(({ reset: l }) => [
            g(t.$slots, "reset-action", A(z({ reset: l })), void 0, !0)
          ]),
          _: 3
        }, 8, ["background", "borderColor", "fontSize", "useResetSlot", "labelLeft", "labelRight", "textColor", "inputColor", "selectColor", "max", "valueStart", "valueEnd", "start", "end"]))
      ], 512)) : y("", !0),
      n("div", {
        ref_key: "chartLegend",
        ref: Z
      }, [
        g(t.$slots, "legend", { legend: b.value }, void 0, !0)
      ], 512),
      ke(ut, {
        show: w.value.showTooltip && G.value,
        backgroundColor: e.value.style.tooltip.backgroundColor,
        color: e.value.style.tooltip.color,
        borderRadius: e.value.style.tooltip.borderRadius,
        borderColor: e.value.style.tooltip.borderColor,
        borderWidth: e.value.style.tooltip.borderWidth,
        fontSize: e.value.style.tooltip.fontSize,
        backgroundOpacity: e.value.style.tooltip.backgroundOpacity,
        position: e.value.style.tooltip.position,
        offsetY: e.value.style.tooltip.offsetY,
        parent: S.value,
        content: X.value,
        isCustom: e.value.style.tooltip.customFormat && typeof e.value.style.tooltip.customFormat == "function"
      }, {
        "tooltip-before": f(() => [
          g(t.$slots, "tooltip-before", A(z({ ...q.value })), void 0, !0)
        ]),
        "tooltip-after": f(() => [
          g(t.$slots, "tooltip-after", A(z({ ...q.value })), void 0, !0)
        ]),
        _: 3
      }, 8, ["show", "backgroundColor", "color", "borderRadius", "borderColor", "borderWidth", "fontSize", "backgroundOpacity", "position", "offsetY", "parent", "content", "isCustom"]),
      L.value ? (s(), _(vt, {
        key: 7,
        hideDetails: "",
        config: {
          open: w.value.showTable,
          maxHeight: 1e4,
          body: {
            backgroundColor: e.value.style.backgroundColor,
            color: e.value.style.color
          },
          head: {
            backgroundColor: e.value.style.backgroundColor,
            color: e.value.style.color
          }
        }
      }, {
        content: f(() => [
          (s(), _(it, {
            key: `table_${te.value}`,
            colNames: M.value.colNames,
            head: M.value.head,
            body: M.value.body,
            config: M.value.config,
            title: `${e.value.style.title.text}${e.value.style.title.subtitle.text ? ` : ${e.value.style.title.subtitle.text}` : ""}`,
            onClose: a[3] || (a[3] = (l) => w.value.showTable = !1)
          }, {
            th: f(({ th: l }) => [
              Ee(V(l), 1)
            ]),
            td: f(({ td: l }) => [
              n("div", { innerHTML: l }, null, 8, Gt)
            ]),
            _: 1
          }, 8, ["colNames", "head", "body", "config", "title"]))
        ]),
        _: 1
      }, 8, ["config"])) : y("", !0)
    ], 14, ht));
  }
}, il = /* @__PURE__ */ ct(Xt, [["__scopeId", "data-v-3c46f286"]]);
export {
  il as default
};
