import { computed as _, ref as d, onMounted as Qe, onBeforeUnmount as Ze, watch as Ie, openBlock as o, createElementBlock as n, normalizeClass as ce, normalizeStyle as Y, createBlock as V, createCommentVNode as v, renderSlot as k, unref as s, createSlots as et, withCtx as P, normalizeProps as U, guardReactiveProps as E, createVNode as De, createElementVNode as h, Fragment as m, renderList as O, toDisplayString as x, createTextVNode as Be, nextTick as tt, pushScopeId as lt, popScopeId as at } from "vue";
import { u as ot, o as ut, e as Me, g as st, c as nt, b as rt, d as Ge, p as j, m as it, G as vt, f as L, X as ct, s as ee, w as dt, j as ht, H as F, i as A, k as b, n as te, t as yt, a as ft, x as pt, q as gt, r as bt } from "./index-DnVHQ2xI.js";
import { t as mt, u as wt } from "./useResponsive-NZB-WLRF.js";
import { _ as kt } from "./Title-5VmBwT4i.js";
import { u as _t, U as xt } from "./usePrinter-BEeNAqS5.js";
import { D as Ct } from "./DataTable-DTk7C4Pr.js";
import { _ as $t } from "./Tooltip-Cj4EF7v1.js";
import { L as Pt } from "./Legend-CYF2gpXG.js";
import St from "./vue-ui-skeleton-aZmkNzAe.js";
import Lt from "./vue-ui-accordion-DspS4q3f.js";
import { u as Ve } from "./useNestedProp-Cox0K0Y5.js";
import { _ as Ft } from "./PackageVersion-CvCRsT5_.js";
import { P as Tt } from "./PenAndPaper-Jb0pLt3G.js";
import { _ as zt } from "./_plugin-vue_export-helper-CHgC5LLL.js";
const Yt = (W) => (lt("data-v-e89705b6"), W = W(), at(), W), At = ["id"], Xt = ["xmlns", "viewBox"], Nt = { key: 0 }, Ot = ["id"], It = ["stop-color"], Dt = ["offset", "stop-color"], Bt = ["offset", "stop-color"], Mt = ["stop-color"], Gt = { key: 1 }, Vt = ["id", "cx", "cy"], jt = ["stop-color", "stop-opacity"], Ht = ["stop-color"], Rt = ["id"], Ut = ["id"], Et = /* @__PURE__ */ Yt(() => /* @__PURE__ */ h("feColorMatrix", {
  type: "saturate",
  values: "0"
}, null, -1)), Wt = ["id"], qt = ["flood-color"], Jt = ["id"], Kt = ["flood-color"], Qt = ["d", "stroke", "filter"], Zt = ["x1", "y1", "x2", "y2", "stroke", "filter"], el = ["cx", "cy", "r", "fill", "filter"], tl = ["stroke", "d"], ll = ["d", "fill", "stroke", "stroke-width", "filter"], al = { key: 0 }, ol = ["stroke", "d"], ul = { key: 0 }, sl = ["d", "stroke", "stroke-width", "filter"], nl = ["d", "fill", "stroke", "stroke-width", "filter"], rl = { key: 1 }, il = ["cx", "cy", "r", "fill", "stroke", "stroke-width"], vl = ["cx", "cy", "r", "stroke"], cl = ["cx", "cy", "r", "fill"], dl = { key: 0 }, hl = ["d", "fill", "onMouseenter", "onClick"], yl = { key: 1 }, fl = ["cx", "cy", "r", "fill"], pl = ["x", "y", "fill", "font-size"], gl = ["x", "y", "fill", "font-size"], bl = ["x", "y", "fill", "font-size"], ml = ["x", "y", "fill", "font-size"], wl = ["filter"], kl = { key: 0 }, _l = ["x", "y"], xl = { key: 1 }, Cl = ["cx", "cy", "fill", "stroke", "filter", "onClick"], $l = ["cx", "cy", "fill", "stroke", "filter", "onClick"], Pl = ["text-anchor", "x", "y", "fill", "font-size", "onClick"], Sl = ["text-anchor", "x", "y", "fill", "font-size", "onClick"], Ll = ["text-anchor", "x", "y", "fill", "font-size", "onClick"], Fl = ["text-anchor", "x", "y", "fill", "font-size", "onClick"], Tl = { key: 2 }, zl = ["x", "y", "width"], Yl = ["x", "y", "width"], Al = {
  key: 4,
  class: "vue-data-ui-watermark"
}, Xl = ["onClick"], Nl = {
  key: 0,
  style: { "font-variant-numeric": "tabular-nums" }
}, Ol = { key: 1 }, Il = ["innerHTML"], Dl = {
  __name: "vue-ui-donut",
  props: {
    config: {
      type: Object,
      default() {
        return {};
      }
    },
    dataset: {
      type: Array,
      default() {
        return [];
      }
    }
  },
  emits: ["selectLegend", "selectDatapoint"],
  setup(W, { expose: je, emit: de }) {
    const X = W, { vue_ui_donut: He } = ot(), q = _({
      get() {
        return !!X.dataset && X.dataset.length;
      },
      set(l) {
        return l;
      }
    }), H = d(null), he = d(null), ye = d(null), le = d(null), fe = d(0), pe = d(0), ge = d(0);
    Qe(() => {
      be();
    }), Ze(() => {
      le.value && le.value.disconnect();
    });
    function be() {
      if (ut(X.dataset) ? Me({
        componentName: "VueUiDonut",
        type: "dataset"
      }) : X.dataset.forEach((l, r) => {
        st({
          datasetObject: l,
          requiredAttributes: ["name", "values"]
        }).forEach((t) => {
          q.value = !1, Me({
            componentName: "VueUiDonut",
            type: "datasetSerieAttribute",
            property: t,
            index: r
          });
        });
      }), e.value.responsive) {
        const l = mt(() => {
          const { width: r, height: t } = wt({
            chart: H.value,
            title: e.value.style.chart.title.text ? he.value : null,
            legend: e.value.style.chart.legend.show ? ye.value : null
          });
          u.value.width = r, u.value.height = t;
        });
        le.value = new ResizeObserver(l), le.value.observe(H.value.parentNode);
      }
    }
    const w = d(nt()), Re = d(null), ae = d(!1), se = d(""), S = d(null), me = d(0);
    function we() {
      const l = Ve({
        userConfig: X.config,
        defaultConfig: He
      });
      return l.theme ? {
        ...Ve({
          userConfig: yt.vue_ui_donut[l.theme] || X.config,
          defaultConfig: l
        }),
        customPalette: ft[l.theme] || j
      } : l;
    }
    const e = _({
      get: () => we(),
      set: (l) => l
    });
    Ie(() => X.config, (l) => {
      e.value = we(), be(), fe.value += 1, pe.value += 1, ge.value += 1;
    }, { deep: !0 });
    const { isPrinting: ke, isImaging: _e, generatePdf: xe, generateImage: Ce } = _t({
      elementId: `donut__${w.value}`,
      fileName: e.value.style.chart.title.text || "vue-ui-donut"
    }), $e = _(() => rt(e.value.customPalette)), y = d({
      dataLabels: {
        show: e.value.style.chart.layout.labels.dataLabels.show
      },
      showTable: e.value.table.show,
      showTooltip: e.value.style.chart.tooltip.show
    }), u = d({
      height: 360,
      width: 512
    }), J = _(() => {
      const l = e.value.style.chart.layout.donut.strokeWidth / 512, r = u.value.width * l, t = r > C.value ? C.value : r;
      return t < 24 ? 24 : t;
    }), M = _(() => X.dataset.map((l, r) => ({
      name: l.name,
      color: Ge(l.color) || $e.value[r] || j[r] || j[r % j.length],
      value: l.values.reduce((t, a) => t + a, 0),
      absoluteValues: l.values,
      comment: l.comment || ""
    }))), T = d(M.value);
    Ie(() => M.value, (l) => T.value = l);
    function Ue() {
      return M.value.map((l) => ({
        name: l.name,
        color: l.color,
        value: l.value
      }));
    }
    const N = d([]), Pe = d(null), Se = d(null), G = d(!1);
    function Le(l) {
      const r = M.value.find((i, g) => g === l);
      let a = T.value.find((i, g) => g === l).value;
      if (N.value.includes(l)) {
        let g = function() {
          a > i ? (cancelAnimationFrame(Pe.value), T.value = T.value.map((p, ve) => l === ve ? {
            ...p,
            value: i
          } : p), G.value = !1) : (G.value = !0, a += i * 0.025, T.value = T.value.map((p, ve) => l === ve ? {
            ...p,
            value: a
          } : p), Pe.value = requestAnimationFrame(g));
        };
        N.value = N.value.filter((p) => p !== l);
        const i = r.value;
        g();
      } else if (N.value.length < M.value.length - 1) {
        let i = function() {
          a < 0.1 ? (cancelAnimationFrame(Se.value), N.value.push(l), T.value = T.value.map((g, p) => l === p ? {
            ...g,
            value: 0
          } : g), G.value = !1) : (G.value = !0, a /= 1.1, T.value = T.value.map((g, p) => l === p ? {
            ...g,
            value: a
          } : g), Se.value = requestAnimationFrame(i));
        };
        i();
      }
      de("selectLegend", I.value.map((i) => ({
        name: i.name,
        color: i.color,
        value: i.value
      })));
    }
    const I = _(() => (T.value.forEach((l, r) => {
      if ([null, void 0].includes(l.values))
        return {
          ...l,
          values: []
        };
    }), T.value.map((l, r) => ({
      ...l,
      seriesIndex: r
    })).filter((l, r) => !N.value.includes(r)))), Fe = _(() => X.dataset.map((l, r) => ({
      name: l.name,
      color: Ge(l.color) || $e.value[r] || j[r] || j[r % j.length],
      value: (l.values || []).reduce((t, a) => t + a, 0),
      shape: "circle"
    })).map((l, r) => ({
      ...l,
      proportion: l.value / X.dataset.map((t) => (t.values || []).reduce((a, i) => a + i, 0)).reduce((t, a) => t + a, 0),
      opacity: N.value.includes(r) ? 0.5 : 1,
      segregate: () => Le(r),
      isSegregated: N.value.includes(r)
    }))), Ee = _(() => ({
      cy: "donut-div-legend",
      backgroundColor: e.value.style.chart.legend.backgroundColor,
      color: e.value.style.chart.legend.color,
      fontSize: e.value.style.chart.legend.fontSize,
      paddingBottom: 12,
      fontWeight: e.value.style.chart.legend.bold ? "bold" : ""
    })), C = _(() => {
      const l = Math.min(u.value.width / 3, u.value.height / 3);
      return l < 55 ? 55 : l;
    }), f = _(() => it({ series: I.value }, u.value.width / 2, u.value.height / 2, C.value, C.value, 1.99999, 2, 1, 360, 105.25, J.value)), c = _(() => {
      const l = Math.max(...I.value.map((t) => t.value)), r = I.value.map((t) => t.value / l);
      return vt({
        series: r,
        center: {
          x: u.value.width / 2,
          y: u.value.height / 2
        },
        maxRadius: Math.min(u.value.width, u.value.height) / 3
      });
    });
    function R(l) {
      return l.x > u.value.width / 2 + 6 ? "start" : l.x < u.value.width / 2 - 6 ? "end" : "middle";
    }
    function We(l) {
      return l.middlePoint.y > u.value.height / 2 ? F({ initX: l.middlePoint.x, initY: l.middlePoint.y, offset: 100, centerX: u.value.width / 2, centerY: u.value.height / 2 }).y : F({ initX: l.middlePoint.x, initY: l.middlePoint.y, offset: 0, centerX: u.value.width / 2, centerY: u.value.height / 2 }).y - 100;
    }
    function z(l) {
      return l.proportion * 100 > e.value.style.chart.layout.labels.dataLabels.hideUnderValue;
    }
    function ne(l, r) {
      const t = l.value / qe(r);
      return isNaN(t) ? 0 : A(
        e.value.style.chart.layout.labels.percentage.formatter,
        t * 100,
        L({
          v: t * 100,
          s: "%",
          r: e.value.style.chart.layout.labels.percentage.rounding
        }),
        { datapoint: l }
      );
    }
    function qe(l) {
      return [...l].map((r) => r.value).reduce((r, t) => r + t, 0);
    }
    const $ = _(() => I.value.map((l) => l.value).reduce((l, r) => l + r, 0)), Te = _(() => $.value / I.value.length), re = d(null), K = d(!1);
    function ze({ datapoint: l, relativeIndex: r, seriesIndex: t, show: a = !1 }) {
      re.value = { datapoint: l, seriesIndex: t, config: e.value, series: M.value }, ae.value = a, S.value = r;
      let i = "";
      const g = e.value.style.chart.tooltip.customFormat;
      if (K.value = !1, pt(g))
        try {
          const p = g({
            seriesIndex: t,
            datapoint: l,
            series: M.value,
            config: e.value
          });
          typeof p == "string" && (se.value = p, K.value = !0);
        } catch {
          console.warn("Custom format cannot be applied."), K.value = !1;
        }
      if (!K.value) {
        if (i += `<div style="width:100%;text-align:center;border-bottom:1px solid ${e.value.style.chart.tooltip.borderColor};padding-bottom:6px;margin-bottom:3px;">${l.name}</div>`, i += `<div style="display:flex;flex-direction:row;gap:6px;align-items:center;"><svg viewBox="0 0 12 12" height="14" width="14"><circle cx="6" cy="6" r="6" stroke="none" fill="${l.color}"/></svg>`, e.value.style.chart.tooltip.showValue && (i += `<b>${A(
          e.value.style.chart.layout.labels.value.formatter,
          l.value,
          L({
            p: e.value.style.chart.layout.labels.dataLabels.prefix,
            v: l.value,
            s: e.value.style.chart.layout.labels.dataLabels.suffix,
            r: e.value.style.chart.tooltip.roundingValue
          }),
          {
            datapoint: l,
            relativeIndex: r,
            seriesIndex: t
          }
        )}</b>`), e.value.style.chart.tooltip.showPercentage) {
          const p = A(
            e.value.style.chart.layout.labels.percentage.formatter,
            l.proportion * 100,
            L({
              v: l.proportion * 100,
              s: "%",
              r: e.value.style.chart.tooltip.roundingPercentage
            }),
            {
              datapoint: l,
              relativeIndex: r,
              seriesIndex: t
            }
          );
          e.value.style.chart.tooltip.showValue ? i += `<span>(${p})</span></div>` : i += `<b>${p}</b></div>`;
        }
        e.value.style.chart.comments.showInTooltip && l.comment && (i += `<div class="vue-data-ui-tooltip-comment" style="background:${l.color}20; padding: 6px; margin-bottom: 6px; margin-top:6px; border-left: 1px solid ${l.color}">${l.comment}</div>`), se.value = `<div>${i}</div>`;
      }
    }
    function Q(l) {
      return e.value.useBlurOnHover && ![null, void 0].includes(S.value) && S.value !== l ? `url(#blur_${w.value})` : "";
    }
    const D = _(() => {
      const l = I.value.map((t) => ({
        name: t.name,
        color: t.color
      })), r = I.value.map((t) => t.value);
      return { head: l, body: r };
    });
    function Ye() {
      tt(() => {
        const l = D.value.head.map((a, i) => [[
          a.name
        ], [D.value.body[i]], [isNaN(D.value.body[i] / $.value) ? "-" : D.value.body[i] / $.value * 100]]), r = [[e.value.style.chart.title.text], [e.value.style.chart.title.subtitle.text], [[""], ["val"], ["%"]]].concat(l), t = gt(r);
        bt({ csvContent: t, title: e.value.style.chart.title.text || "vue-ui-donut" });
      });
    }
    const oe = _(() => {
      const l = [
        ' <svg xmlns="http://www.w3.org/2000/svg" width="16" height="16" viewBox="0 0 24 24" stroke-width="1.5" stroke="currentColor" fill="none" stroke-linecap="round" stroke-linejoin="round"><path stroke="none" d="M0 0h24v24H0z" fill="none"/><path d="M18 16v2a1 1 0 0 1 -1 1h-11l6 -7l-6 -7h11a1 1 0 0 1 1 1v2" /></svg>',
        L({ p: e.value.style.chart.layout.labels.dataLabels.prefix, v: $.value, s: e.value.style.chart.layout.labels.dataLabels.suffix, r: e.value.table.td.roundingValue }),
        "100%"
      ], r = D.value.head.map((i, g) => {
        const p = L({ p: e.value.style.chart.layout.labels.dataLabels.prefix, v: D.value.body[g], s: e.value.style.chart.layout.labels.dataLabels.suffix, r: e.value.table.td.roundingValue });
        return [
          {
            color: i.color,
            name: i.name
          },
          p,
          isNaN(D.value.body[g] / $.value) ? "-" : (D.value.body[g] / $.value * 100).toFixed(e.value.table.td.roundingPercentage) + "%"
        ];
      }), t = {
        th: {
          backgroundColor: e.value.table.th.backgroundColor,
          color: e.value.table.th.color,
          outline: e.value.table.th.outline
        },
        td: {
          backgroundColor: e.value.table.td.backgroundColor,
          color: e.value.table.td.color,
          outline: e.value.table.td.outline
        },
        breakpoint: e.value.table.responsiveBreakpoint
      };
      return {
        colNames: [
          e.value.table.columnNames.series,
          e.value.table.columnNames.value,
          e.value.table.columnNames.percentage
        ],
        head: l,
        body: r,
        config: t
      };
    }), Z = d(!1);
    function Je(l) {
      Z.value = l, me.value += 1;
    }
    const Ae = _(() => /^((?!chrome|android).)*safari/i.test(navigator.userAgent));
    function Ke(l) {
      return l.toFixed(e.value.style.chart.legend.roundingPercentage).split("").map((r) => "-").join("");
    }
    function B(l, r) {
      de("selectDatapoint", { datapoint: l, index: r });
    }
    function Xe() {
      y.value.showTable = !y.value.showTable;
    }
    function Ne() {
      y.value.dataLabels.show = !y.value.dataLabels.show;
    }
    function Oe() {
      y.value.showTooltip = !y.value.showTooltip;
    }
    const ue = d(!1);
    function ie() {
      ue.value = !ue.value;
    }
    return je({
      getData: Ue,
      generatePdf: xe,
      generateCsv: Ye,
      generateImage: Ce,
      toggleTable: Xe,
      toggleLabels: Ne,
      toggleTooltip: Oe,
      toggleAnnotator: ie
    }), (l, r) => (o(), n("div", {
      ref_key: "donutChart",
      ref: H,
      class: ce(`vue-ui-donut ${Z.value ? "vue-data-ui-wrapper-fullscreen" : ""} ${e.value.useCssAnimation ? "" : "vue-ui-dna"}`),
      style: Y(`font-family:${e.value.style.fontFamily};width:100%; ${e.value.responsive ? "height:100%;" : ""} text-align:center;${e.value.style.chart.title.text ? "" : "padding-top:36px"};background:${e.value.style.chart.backgroundColor}`),
      id: `donut__${w.value}`
    }, [
      e.value.userOptions.buttons.annotator ? (o(), V(Tt, {
        key: 0,
        parent: H.value,
        backgroundColor: e.value.style.chart.backgroundColor,
        color: e.value.style.chart.color,
        active: ue.value,
        onClose: ie
      }, null, 8, ["parent", "backgroundColor", "color", "active"])) : v("", !0),
      k(l.$slots, "userConfig", {}, void 0, !0),
      e.value.style.chart.title.text ? (o(), n("div", {
        key: 1,
        ref_key: "chartTitle",
        ref: he,
        style: "width:100%;background:transparent;padding-bottom:24px"
      }, [
        (o(), V(kt, {
          key: `title_${fe.value}`,
          config: {
            title: {
              cy: "donut-div-title",
              ...e.value.style.chart.title
            },
            subtitle: {
              cy: "donut-div-subtitle",
              ...e.value.style.chart.title.subtitle
            }
          }
        }, null, 8, ["config"]))
      ], 512)) : v("", !0),
      e.value.userOptions.show && q.value ? (o(), V(xt, {
        ref_key: "details",
        ref: Re,
        key: `user_option_${me.value}`,
        backgroundColor: e.value.style.chart.backgroundColor,
        color: e.value.style.chart.color,
        isPrinting: s(ke),
        isImaging: s(_e),
        uid: w.value,
        hasTooltip: e.value.style.chart.tooltip.show && e.value.userOptions.buttons.tooltip,
        hasPdf: e.value.userOptions.buttons.pdf,
        hasImg: e.value.userOptions.buttons.img,
        hasXls: e.value.userOptions.buttons.csv,
        hasTable: e.value.userOptions.buttons.table,
        hasLabel: e.value.userOptions.buttons.labels,
        hasFullscreen: e.value.userOptions.buttons.fullscreen,
        isFullscreen: Z.value,
        chartElement: H.value,
        position: e.value.userOptions.position,
        isTooltip: y.value.showTooltip,
        titles: { ...e.value.userOptions.buttonTitles },
        hasAnnotator: e.value.userOptions.buttons.annotator,
        isAnnotation: ue.value,
        onToggleFullscreen: Je,
        onGeneratePdf: s(xe),
        onGenerateCsv: Ye,
        onGenerateImage: s(Ce),
        onToggleTable: Xe,
        onToggleLabels: Ne,
        onToggleTooltip: Oe,
        onToggleAnnotator: ie
      }, et({ _: 2 }, [
        l.$slots.optionTooltip ? {
          name: "optionTooltip",
          fn: P(() => [
            k(l.$slots, "optionTooltip", {}, void 0, !0)
          ]),
          key: "0"
        } : void 0,
        l.$slots.optionPdf ? {
          name: "optionPdf",
          fn: P(() => [
            k(l.$slots, "optionPdf", {}, void 0, !0)
          ]),
          key: "1"
        } : void 0,
        l.$slots.optionCsv ? {
          name: "optionCsv",
          fn: P(() => [
            k(l.$slots, "optionCsv", {}, void 0, !0)
          ]),
          key: "2"
        } : void 0,
        l.$slots.optionImg ? {
          name: "optionImg",
          fn: P(() => [
            k(l.$slots, "optionImg", {}, void 0, !0)
          ]),
          key: "3"
        } : void 0,
        l.$slots.optionTable ? {
          name: "optionTable",
          fn: P(() => [
            k(l.$slots, "optionTable", {}, void 0, !0)
          ]),
          key: "4"
        } : void 0,
        l.$slots.optionLabels ? {
          name: "optionLabels",
          fn: P(() => [
            k(l.$slots, "optionLabels", {}, void 0, !0)
          ]),
          key: "5"
        } : void 0,
        l.$slots.optionFullscreen ? {
          name: "optionFullscreen",
          fn: P(({ toggleFullscreen: t, isFullscreen: a }) => [
            k(l.$slots, "optionFullscreen", U(E({ toggleFullscreen: t, isFullscreen: a })), void 0, !0)
          ]),
          key: "6"
        } : void 0,
        l.$slots.optionAnnotator ? {
          name: "optionAnnotator",
          fn: P(({ toggleAnnotator: t, isAnnotator: a }) => [
            k(l.$slots, "optionAnnotator", U(E({ toggleAnnotator: t, isAnnotator: a })), void 0, !0)
          ]),
          key: "7"
        } : void 0
      ]), 1032, ["backgroundColor", "color", "isPrinting", "isImaging", "uid", "hasTooltip", "hasPdf", "hasImg", "hasXls", "hasTable", "hasLabel", "hasFullscreen", "isFullscreen", "chartElement", "position", "isTooltip", "titles", "hasAnnotator", "isAnnotation", "onGeneratePdf", "onGenerateImage"])) : v("", !0),
      q.value ? (o(), n("svg", {
        key: 3,
        xmlns: s(ct),
        class: ce({ "vue-data-ui-fullscreen--on": Z.value, "vue-data-ui-fulscreen--off": !Z.value }),
        viewBox: `0 0 ${u.value.width <= 0 ? 10 : u.value.width} ${u.value.height <= 0 ? 10 : u.value.height}`,
        style: Y(`max-width:100%; overflow: visible; background:transparent;color:${e.value.style.chart.color}`)
      }, [
        De(Ft),
        e.value.type === "classic" ? (o(), n("defs", Nt, [
          e.value.style.chart.useGradient ? (o(), n("radialGradient", {
            key: 0,
            id: `gradient_${w.value}`
          }, [
            h("stop", {
              offset: "0%",
              "stop-color": s(ee)(e.value.style.chart.backgroundColor, 0),
              "stop-opacity": "0"
            }, null, 8, It),
            h("stop", {
              offset: `${(1 - J.value / C.value) * 100}%`,
              "stop-color": s(ee)("#FFFFFF", 0),
              "stop-opacity": "0"
            }, null, 8, Dt),
            h("stop", {
              offset: `${(1 - J.value / C.value / 2) * 100}%`,
              "stop-color": s(ee)("#FFFFFF", e.value.style.chart.gradientIntensity)
            }, null, 8, Bt),
            h("stop", {
              offset: "100%",
              "stop-color": s(ee)(e.value.style.chart.backgroundColor, 0),
              "stop-opacity": "0"
            }, null, 8, Mt)
          ], 8, Ot)) : v("", !0)
        ])) : v("", !0),
        e.value.type === "polar" ? (o(), n("defs", Gt, [
          (o(!0), n(m, null, O(c.value, (t, a) => (o(), n("radialGradient", {
            id: `polar_gradient_${a}_${w.value}`,
            cx: t.middlePoint.x / u.value.width * 100 + "%",
            cy: t.middlePoint.y / u.value.height * 100 + "%",
            r: "62%"
          }, [
            h("stop", {
              offset: "0%",
              "stop-color": s(dt)(f.value[a].color, 0.05),
              "stop-opacity": e.value.style.chart.gradientIntensity / 100
            }, null, 8, jt),
            h("stop", {
              offset: "100%",
              "stop-color": f.value[a].color
            }, null, 8, Ht)
          ], 8, Vt))), 256))
        ])) : v("", !0),
        h("defs", null, [
          h("filter", {
            id: `blur_${w.value}`,
            x: "-50%",
            y: "-50%",
            width: "200%",
            height: "200%"
          }, [
            h("feGaussianBlur", {
              in: "SourceGraphic",
              stdDeviation: 2,
              id: `blur_std_${w.value}`
            }, null, 8, Ut),
            Et
          ], 8, Rt),
          h("filter", {
            id: `shadow_${w.value}`,
            "color-interpolation-filters": "sRGB"
          }, [
            h("feDropShadow", {
              dx: "0",
              dy: "0",
              stdDeviation: "10",
              "flood-opacity": "0.5",
              "flood-color": e.value.style.chart.layout.donut.shadowColor
            }, null, 8, qt)
          ], 8, Wt),
          h("filter", {
            id: `drop_shadow_${w.value}`,
            "color-interpolation-filters": "sRGB",
            x: "-50%",
            y: "-50%",
            width: "200%",
            height: "200%"
          }, [
            h("feDropShadow", {
              dx: "0",
              dy: "0",
              stdDeviation: "3",
              "flood-opacity": "1",
              "flood-color": e.value.style.chart.layout.donut.shadowColor
            }, null, 8, Kt)
          ], 8, Jt)
        ]),
        e.value.type === "classic" ? (o(!0), n(m, { key: 2 }, O(f.value, (t, a) => (o(), n("g", null, [
          z(t) && y.value.dataLabels.show ? (o(), n("path", {
            key: 0,
            d: s(ht)(t, { x: u.value.width / 2, y: u.value.height / 2 }, 16, 16, !1, !1, J.value),
            stroke: t.color,
            "stroke-width": "1",
            "stroke-linecap": "round",
            "stroke-linejoin": "round",
            fill: "none",
            filter: Q(a)
          }, null, 8, Qt)) : v("", !0)
        ]))), 256)) : v("", !0),
        e.value.type === "polar" ? (o(!0), n(m, { key: 3 }, O(f.value, (t, a) => (o(), n("g", null, [
          z(t) && y.value.dataLabels.show ? (o(), n("line", {
            key: 0,
            x1: s(F)({ initX: c.value[a].middlePoint.x, initY: c.value[a].middlePoint.y, offset: 24, centerX: u.value.width / 2, centerY: u.value.height / 2 }).x,
            y1: s(F)({ initX: c.value[a].middlePoint.x, initY: c.value[a].middlePoint.y, offset: 24, centerX: u.value.width / 2, centerY: u.value.height / 2 }).y,
            x2: c.value[a].middlePoint.x,
            y2: c.value[a].middlePoint.y,
            stroke: t.color,
            "stroke-width": "1",
            "stroke-linecap": "round",
            "stroke-linejoin": "round",
            fill: "none",
            filter: Q(a)
          }, null, 8, Zt)) : v("", !0)
        ]))), 256)) : v("", !0),
        e.value.type === "classic" ? (o(), n("circle", {
          key: 4,
          cx: u.value.width / 2,
          cy: u.value.height / 2,
          r: C.value <= 0 ? 10 : C.value,
          fill: e.value.style.chart.backgroundColor,
          filter: e.value.style.chart.layout.donut.useShadow ? `url(#shadow_${w.value})` : ""
        }, null, 8, el)) : v("", !0),
        $.value && e.value.type === "classic" ? (o(), n(m, { key: 5 }, [
          (o(!0), n(m, null, O(f.value, (t, a) => (o(), n("path", {
            stroke: e.value.style.chart.backgroundColor,
            d: t.arcSlice,
            fill: "#FFFFFF"
          }, null, 8, tl))), 256)),
          (o(!0), n(m, null, O(f.value, (t, a) => (o(), n("path", {
            class: "vue-ui-donut-arc-path",
            d: t.arcSlice,
            fill: s(ee)(t.color, 80),
            stroke: e.value.style.chart.backgroundColor,
            "stroke-width": e.value.style.chart.layout.donut.borderWidth,
            filter: Q(a)
          }, null, 8, ll))), 256))
        ], 64)) : v("", !0),
        $.value && e.value.type === "polar" ? (o(), n(m, { key: 6 }, [
          f.value.length > 1 ? (o(), n("g", al, [
            (o(!0), n(m, null, O(f.value, (t, a) => (o(), n("path", {
              stroke: e.value.style.chart.backgroundColor,
              d: c.value[a].path,
              fill: "#FFFFFF"
            }, null, 8, ol))), 256)),
            e.value.style.chart.layout.donut.useShadow ? (o(), n("g", ul, [
              (o(!0), n(m, null, O(f.value, (t, a) => (o(), n("path", {
                class: "vue-ui-donut-arc-path",
                d: c.value[a].path,
                fill: "transparent",
                stroke: e.value.style.chart.backgroundColor,
                "stroke-width": e.value.style.chart.layout.donut.borderWidth,
                filter: `url(#drop_shadow_${w.value})`
              }, null, 8, sl))), 256))
            ])) : v("", !0),
            (o(!0), n(m, null, O(f.value, (t, a) => (o(), n("path", {
              class: "vue-ui-donut-arc-path",
              d: c.value[a].path,
              fill: e.value.style.chart.useGradient ? `url(#polar_gradient_${a}_${w.value})` : t.color,
              stroke: e.value.style.chart.backgroundColor,
              "stroke-width": e.value.style.chart.layout.donut.borderWidth,
              filter: Q(a)
            }, null, 8, nl))), 256))
          ])) : (o(), n("g", rl, [
            h("circle", {
              cx: u.value.width / 2,
              cy: u.value.height / 2,
              r: C.value,
              fill: e.value.style.chart.useGradient ? `url(#polar_gradient_0_${w.value})` : f.value[0].color,
              stroke: e.value.style.chart.backgroundColor,
              "stroke-width": e.value.style.chart.layout.donut.borderWidth
            }, null, 8, il)
          ]))
        ], 64)) : (o(), n("circle", {
          key: 7,
          cx: u.value.width / 2,
          cy: u.value.height / 2,
          r: C.value <= 0 ? 10 : C.value,
          fill: "transparent",
          stroke: e.value.style.chart.backgroundColor
        }, null, 8, vl)),
        e.value.style.chart.useGradient && e.value.type === "classic" ? (o(), n("circle", {
          key: 8,
          cx: u.value.width / 2,
          cy: u.value.height / 2,
          r: (
            /* This might require adjustments */
            C.value <= 0 ? 10 : C.value
          ),
          fill: `url(#gradient_${w.value})`
        }, null, 8, cl)) : v("", !0),
        $.value ? (o(), n(m, { key: 9 }, [
          f.value.length > 1 || e.value.type === "classic" ? (o(), n("g", dl, [
            (o(!0), n(m, null, O(f.value, (t, a) => (o(), n("path", {
              "data-cy-donut-trap": "",
              d: e.value.type === "classic" ? t.arcSlice : c.value[a].path,
              fill: S.value === a ? "rgba(0,0,0,0.1)" : "transparent",
              onMouseenter: (i) => ze({
                datapoint: t,
                relativeIndex: a,
                seriesIndex: t.seriesIndex,
                show: !0
              }),
              onMouseleave: r[0] || (r[0] = (i) => {
                ae.value = !1, S.value = null;
              }),
              onClick: (i) => B(t, a)
            }, null, 40, hl))), 256))
          ])) : (o(), n("g", yl, [
            h("circle", {
              cx: u.value.width / 2,
              cy: u.value.height / 2,
              r: C.value,
              fill: S.value === l.i ? "rgba(0,0,0,0.1)" : "transparent",
              "data-cy-donut-trap": "",
              onMouseenter: r[1] || (r[1] = (t) => ze({
                datapoint: f.value[0],
                relativeIndex: 0,
                seriesIndex: f.value[0].seriesIndex,
                show: !0
              })),
              onMouseleave: r[2] || (r[2] = (t) => {
                ae.value = !1, S.value = null;
              }),
              onClick: r[3] || (r[3] = (t) => B(f.value[0], l.i))
            }, null, 40, fl)
          ]))
        ], 64)) : v("", !0),
        e.value.type === "classic" ? (o(), n(m, { key: 10 }, [
          e.value.style.chart.layout.labels.hollow.total.show ? (o(), n("text", {
            key: 0,
            "text-anchor": "middle",
            x: u.value.width / 2,
            y: u.value.height / 2 - (e.value.style.chart.layout.labels.hollow.average.show ? e.value.style.chart.layout.labels.hollow.total.fontSize : 0) + e.value.style.chart.layout.labels.hollow.total.offsetY,
            fill: e.value.style.chart.layout.labels.hollow.total.color,
            "font-size": e.value.style.chart.layout.labels.hollow.total.fontSize,
            style: Y(`font-weight:${e.value.style.chart.layout.labels.hollow.total.bold ? "bold" : ""}`)
          }, x(e.value.style.chart.layout.labels.hollow.total.text), 13, pl)) : v("", !0),
          e.value.style.chart.layout.labels.hollow.total.show ? (o(), n("text", {
            key: 1,
            "text-anchor": "middle",
            x: u.value.width / 2,
            y: u.value.height / 2 + e.value.style.chart.layout.labels.hollow.total.fontSize - (e.value.style.chart.layout.labels.hollow.average.show ? e.value.style.chart.layout.labels.hollow.total.fontSize : 0) + e.value.style.chart.layout.labels.hollow.total.value.offsetY,
            fill: e.value.style.chart.layout.labels.hollow.total.value.color,
            "font-size": e.value.style.chart.layout.labels.hollow.total.value.fontSize,
            style: Y(`font-weight:${e.value.style.chart.layout.labels.hollow.total.value.bold ? "bold" : ""}`)
          }, x(s(A)(
            e.value.style.chart.layout.labels.hollow.total.value.formatter,
            $.value,
            s(L)({
              p: e.value.style.chart.layout.labels.hollow.total.value.prefix,
              v: $.value,
              s: e.value.style.chart.layout.labels.hollow.total.value.suffix
            })
          )), 13, gl)) : v("", !0),
          e.value.style.chart.layout.labels.hollow.average.show ? (o(), n("text", {
            key: 2,
            "text-anchor": "middle",
            x: u.value.width / 2,
            y: u.value.height / 2 + (e.value.style.chart.layout.labels.hollow.total.show ? e.value.style.chart.layout.labels.hollow.average.fontSize : 0) + e.value.style.chart.layout.labels.hollow.average.offsetY,
            fill: e.value.style.chart.layout.labels.hollow.average.color,
            "font-size": e.value.style.chart.layout.labels.hollow.average.fontSize,
            style: Y(`font-weight:${e.value.style.chart.layout.labels.hollow.average.bold ? "bold" : ""}`)
          }, x(e.value.style.chart.layout.labels.hollow.average.text), 13, bl)) : v("", !0),
          e.value.style.chart.layout.labels.hollow.average.show ? (o(), n("text", {
            key: 3,
            "text-anchor": "middle",
            x: u.value.width / 2,
            y: u.value.height / 2 + (e.value.style.chart.layout.labels.hollow.total.show ? e.value.style.chart.layout.labels.hollow.average.fontSize : 0) + e.value.style.chart.layout.labels.hollow.average.fontSize + e.value.style.chart.layout.labels.hollow.average.value.offsetY,
            fill: e.value.style.chart.layout.labels.hollow.average.value.color,
            "font-size": e.value.style.chart.layout.labels.hollow.average.value.fontSize,
            style: Y(`font-weight:${e.value.style.chart.layout.labels.hollow.average.value.bold ? "bold" : ""}`)
          }, x(G.value ? "--" : s(A)(
            e.value.style.chart.layout.labels.hollow.average.value.formatter,
            Te.value,
            s(L)({
              p: e.value.style.chart.layout.labels.hollow.average.value.prefix,
              v: Te.value,
              s: e.value.style.chart.layout.labels.hollow.average.value.suffix,
              r: e.value.style.chart.layout.labels.hollow.average.value.rounding
            })
          )), 13, ml)) : v("", !0)
        ], 64)) : v("", !0),
        (o(!0), n(m, null, O(f.value, (t, a) => (o(), n("g", {
          filter: Q(a),
          class: ce({ animated: e.value.useCssAnimation })
        }, [
          e.value.style.chart.layout.labels.dataLabels.useLabelSlots ? (o(), n("g", kl, [
            (o(), n("foreignObject", {
              x: s(b)(t, !0).anchor === "end" ? s(b)(t).x - 120 : s(b)(t, !0).anchor === "middle" ? s(b)(t).x - 60 : s(b)(t).x,
              y: s(te)(t) - (Ae.value ? 20 : 0),
              width: "120",
              height: "60",
              style: { overflow: "visible" }
            }, [
              h("div", null, [
                k(l.$slots, "dataLabel", U(E({
                  datapoint: t,
                  isBlur: !e.value.useBlurOnHover || [null, void 0].includes(S.value) || S.value === a,
                  isSafari: Ae.value,
                  isVisible: z(t) && y.value.dataLabels.show,
                  textAlign: s(b)(t, !0, 16, !0).anchor,
                  flexAlign: s(b)(t, !0, 16).anchor,
                  percentage: ne(t, f.value)
                })), void 0, !0)
              ])
            ], 8, _l))
          ])) : (o(), n("g", xl, [
            e.value.type === "classic" ? (o(), n(m, { key: 0 }, [
              z(t) && y.value.dataLabels.show ? (o(), n("circle", {
                key: 0,
                cx: s(b)(t).x,
                cy: s(te)(t) - 3.5,
                fill: t.color,
                stroke: e.value.style.chart.backgroundColor,
                "stroke-width": 1,
                r: 3,
                filter: !e.value.useBlurOnHover || [null, void 0].includes(S.value) || S.value === a ? "" : `url(#blur_${w.value})`,
                onClick: (i) => B(t, a)
              }, null, 8, Cl)) : v("", !0)
            ], 64)) : v("", !0),
            e.value.type === "polar" ? (o(), n(m, { key: 1 }, [
              z(t) && y.value.dataLabels.show ? (o(), n("circle", {
                key: 0,
                cx: s(F)({ initX: c.value[a].middlePoint.x, initY: c.value[a].middlePoint.y, offset: 24, centerX: u.value.width / 2, centerY: u.value.height / 2 }).x,
                cy: s(F)({ initX: c.value[a].middlePoint.x, initY: c.value[a].middlePoint.y, offset: 24, centerX: u.value.width / 2, centerY: u.value.height / 2 }).y,
                fill: t.color,
                stroke: e.value.style.chart.backgroundColor,
                "stroke-width": 1,
                r: 3,
                filter: !e.value.useBlurOnHover || [null, void 0].includes(S.value) || S.value === a ? "" : `url(#blur_${w.value})`,
                onClick: (i) => B(t, a)
              }, null, 8, $l)) : v("", !0)
            ], 64)) : v("", !0),
            e.value.type === "classic" ? (o(), n(m, { key: 2 }, [
              z(t) && y.value.dataLabels.show ? (o(), n("text", {
                key: 0,
                "text-anchor": s(b)(t, !0, 12).anchor,
                x: s(b)(t, !0, 12).x,
                y: s(te)(t),
                fill: e.value.style.chart.layout.labels.percentage.color,
                "font-size": e.value.style.chart.layout.labels.percentage.fontSize,
                style: Y(`font-weight:${e.value.style.chart.layout.labels.percentage.bold ? "bold" : ""}`),
                onClick: (i) => B(t, a)
              }, x(ne(t, f.value)) + " " + x(e.value.style.chart.layout.labels.value.show ? `(${s(A)(
                e.value.style.chart.layout.labels.value.formatter,
                t.value,
                s(L)({
                  p: e.value.style.chart.layout.labels.dataLabels.prefix,
                  v: t.value,
                  s: e.value.style.chart.layout.labels.dataLabels.suffix,
                  r: e.value.style.chart.layout.labels.value.rounding
                }),
                { datapoint: t }
              )})` : ""), 13, Pl)) : v("", !0),
              z(t) && y.value.dataLabels.show ? (o(), n("text", {
                key: 1,
                "text-anchor": s(b)(t).anchor,
                x: s(b)(t, !0, 12).x,
                y: s(te)(t) + e.value.style.chart.layout.labels.percentage.fontSize,
                fill: e.value.style.chart.layout.labels.name.color,
                "font-size": e.value.style.chart.layout.labels.name.fontSize,
                style: Y(`font-weight:${e.value.style.chart.layout.labels.name.bold ? "bold" : ""}`),
                onClick: (i) => B(t, a)
              }, x(t.name), 13, Sl)) : v("", !0)
            ], 64)) : v("", !0),
            e.value.type === "polar" ? (o(), n(m, { key: 3 }, [
              z(t) && y.value.dataLabels.show ? (o(), n("text", {
                key: 0,
                "text-anchor": R(c.value[a].middlePoint),
                x: s(F)({ initX: c.value[a].middlePoint.x, initY: c.value[a].middlePoint.y, offset: 42, centerX: u.value.width / 2, centerY: u.value.height / 2 }).x,
                y: s(F)({ initX: c.value[a].middlePoint.x, initY: c.value[a].middlePoint.y, offset: 42, centerX: u.value.width / 2, centerY: u.value.height / 2 }).y,
                fill: e.value.style.chart.layout.labels.percentage.color,
                "font-size": e.value.style.chart.layout.labels.percentage.fontSize,
                style: Y(`font-weight:${e.value.style.chart.layout.labels.percentage.bold ? "bold" : ""}`),
                onClick: (i) => B(t, a)
              }, x(ne(t, f.value)) + " " + x(e.value.style.chart.layout.labels.value.show ? `(${s(A)(
                e.value.style.chart.layout.labels.value.formatter,
                t.value,
                s(L)({
                  p: e.value.style.chart.layout.labels.dataLabels.prefix,
                  v: t.value,
                  s: e.value.style.chart.layout.labels.dataLabels.suffix,
                  r: e.value.style.chart.layout.labels.value.rounding
                }),
                { datapoint: t }
              )})` : ""), 13, Ll)) : v("", !0),
              z(t) && y.value.dataLabels.show ? (o(), n("text", {
                key: 1,
                "text-anchor": R(c.value[a].middlePoint),
                x: s(F)({ initX: c.value[a].middlePoint.x, initY: c.value[a].middlePoint.y, offset: 42, centerX: u.value.width / 2, centerY: u.value.height / 2 }).x,
                y: s(F)({ initX: c.value[a].middlePoint.x, initY: c.value[a].middlePoint.y, offset: 42, centerX: u.value.width / 2, centerY: u.value.height / 2 }).y + e.value.style.chart.layout.labels.percentage.fontSize,
                fill: e.value.style.chart.layout.labels.name.color,
                "font-size": e.value.style.chart.layout.labels.name.fontSize,
                style: Y(`font-weight:${e.value.style.chart.layout.labels.name.bold ? "bold" : ""}`),
                onClick: (i) => B(t, a)
              }, x(t.name), 13, Fl)) : v("", !0)
            ], 64)) : v("", !0)
          ])),
          y.value.dataLabels.show && e.value.style.chart.comments.show && t.comment ? (o(), n("g", Tl, [
            z(t) && e.value.type === "classic" ? (o(), n("foreignObject", {
              key: 0,
              x: e.value.style.chart.comments.offsetX + (s(b)(t, !0).anchor === "end" ? s(b)(t).x - e.value.style.chart.comments.width : s(b)(t, !0).anchor === "middle" ? s(b)(t).x - e.value.style.chart.comments.width / 2 : s(b)(t).x),
              y: s(te)(t) + 24 + e.value.style.chart.comments.offsetY,
              width: e.value.style.chart.comments.width,
              height: "200",
              style: { overflow: "visible", "pointer-events": "none" }
            }, [
              h("div", null, [
                k(l.$slots, "plot-comment", {
                  plot: { ...t, textAlign: s(b)(t, !0, 16, !0).anchor, flexAlign: s(b)(t, !0, 16).anchor }
                }, void 0, !0)
              ])
            ], 8, zl)) : v("", !0),
            z(t) && e.value.type === "polar" ? (o(), n("foreignObject", {
              key: 1,
              x: e.value.style.chart.comments.offsetX + (R(c.value[a].middlePoint) === "end" ? s(F)({ initX: c.value[a].middlePoint.x, initY: c.value[a].middlePoint.y, offset: 42, centerX: u.value.width / 2, centerY: u.value.height / 2 }).x - e.value.style.chart.comments.width : R(c.value[a].middlePoint) === "middle" ? s(F)({ initX: c.value[a].middlePoint.x, initY: c.value[a].middlePoint.y, offset: 42, centerX: u.value.width / 2, centerY: u.value.height / 2 }).x - e.value.style.chart.comments.width / 2 : s(F)({ initX: c.value[a].middlePoint.x, initY: c.value[a].middlePoint.y, offset: 42, centerX: u.value.width / 2, centerY: u.value.height / 2 }).x),
              y: We(c.value[a]) + e.value.style.chart.comments.offsetY,
              width: e.value.style.chart.comments.width,
              height: "200",
              style: { overflow: "visible", "pointer-events": "none" }
            }, [
              h("div", null, [
                k(l.$slots, "plot-comment", {
                  plot: { ...t, textAlign: R(c.value[a].middlePoint), flexAlign: R(c.value[a].middlePoint) }
                }, void 0, !0)
              ])
            ], 8, Yl)) : v("", !0)
          ])) : v("", !0)
        ], 10, wl))), 256)),
        k(l.$slots, "svg", { svg: u.value }, void 0, !0)
      ], 14, Xt)) : v("", !0),
      l.$slots.watermark ? (o(), n("div", Al, [
        k(l.$slots, "watermark", U(E({ isPrinting: s(ke) || s(_e) })), void 0, !0)
      ])) : v("", !0),
      q.value ? v("", !0) : (o(), V(St, {
        key: 5,
        config: {
          type: "donut",
          style: {
            backgroundColor: e.value.style.chart.backgroundColor,
            donut: {
              color: "#CCCCCC",
              strokeWidth: J.value * 0.8
            }
          }
        }
      }, null, 8, ["config"])),
      h("div", {
        ref_key: "chartLegend",
        ref: ye
      }, [
        e.value.style.chart.legend.show ? (o(), V(Pt, {
          key: `legend_${ge.value}`,
          legendSet: Fe.value,
          config: Ee.value,
          onClickMarker: r[4] || (r[4] = ({ i: t }) => Le(t))
        }, {
          item: P(({ legend: t, index: a }) => [
            h("div", {
              onClick: (i) => t.segregate(),
              style: Y(`opacity:${N.value.includes(a) ? 0.5 : 1}`)
            }, [
              Be(x(t.name) + ": " + x(s(A)(
                e.value.style.chart.layout.labels.value.formatter,
                t.value,
                s(L)({
                  p: e.value.style.chart.layout.labels.dataLabels.prefix,
                  v: t.value,
                  s: e.value.style.chart.layout.labels.dataLabels.suffix,
                  r: e.value.style.chart.legend.roundingValue
                }),
                {
                  datapoint: t,
                  index: a
                }
              )) + " ", 1),
              N.value.includes(a) ? (o(), n("span", Ol, " ( " + x(Ke(t.proportion * 100)) + " % ) ", 1)) : (o(), n("span", Nl, " (" + x(isNaN(t.value / $.value) ? "-" : s(A)(
                e.value.style.chart.layout.labels.percentage.formatter,
                G.value ? t.proportion * 100 : t.value / $.value * 100,
                s(L)({
                  v: G.value ? t.proportion * 100 : t.value / $.value * 100,
                  s: "%",
                  r: e.value.style.chart.legend.roundingPercentage
                })
              )) + ") ", 1))
            ], 12, Xl)
          ]),
          _: 1
        }, 8, ["legendSet", "config"])) : v("", !0),
        k(l.$slots, "legend", { legend: Fe.value }, void 0, !0)
      ], 512),
      De($t, {
        show: y.value.showTooltip && ae.value,
        backgroundColor: e.value.style.chart.tooltip.backgroundColor,
        color: e.value.style.chart.tooltip.color,
        fontSize: e.value.style.chart.tooltip.fontSize,
        borderRadius: e.value.style.chart.tooltip.borderRadius,
        borderColor: e.value.style.chart.tooltip.borderColor,
        borderWidth: e.value.style.chart.tooltip.borderWidth,
        backgroundOpacity: e.value.style.chart.tooltip.backgroundOpacity,
        position: e.value.style.chart.tooltip.position,
        offsetY: e.value.style.chart.tooltip.offsetY,
        parent: H.value,
        content: se.value,
        isCustom: K.value
      }, {
        "tooltip-before": P(() => [
          k(l.$slots, "tooltip-before", U(E({ ...re.value })), void 0, !0)
        ]),
        "tooltip-after": P(() => [
          k(l.$slots, "tooltip-after", U(E({ ...re.value })), void 0, !0)
        ]),
        _: 3
      }, 8, ["show", "backgroundColor", "color", "fontSize", "borderRadius", "borderColor", "borderWidth", "backgroundOpacity", "position", "offsetY", "parent", "content", "isCustom"]),
      q.value ? (o(), V(Lt, {
        key: 6,
        hideDetails: "",
        config: {
          open: y.value.showTable,
          maxHeight: 1e4,
          body: {
            backgroundColor: e.value.style.chart.backgroundColor,
            color: e.value.style.chart.color
          },
          head: {
            backgroundColor: e.value.style.chart.backgroundColor,
            color: e.value.style.chart.color
          }
        }
      }, {
        content: P(() => [
          (o(), V(Ct, {
            key: `table_${pe.value}`,
            colNames: oe.value.colNames,
            head: oe.value.head,
            body: oe.value.body,
            config: oe.value.config,
            title: `${e.value.style.chart.title.text}${e.value.style.chart.title.subtitle.text ? ` : ${e.value.style.chart.title.subtitle.text}` : ""}`,
            onClose: r[5] || (r[5] = (t) => y.value.showTable = !1)
          }, {
            th: P(({ th: t }) => [
              h("div", {
                innerHTML: t,
                style: { display: "flex", "align-items": "center" }
              }, null, 8, Il)
            ]),
            td: P(({ td: t }) => [
              Be(x(t.name ? t.name : isNaN(Number(t)) ? t.includes("%") ? t : s(A)(
                e.value.style.chart.layout.labels.percentage.formatter,
                t,
                s(L)({
                  v: t,
                  s: "%",
                  r: e.value.style.chart.layout.labels.percentage.rounding
                })
              ) : s(A)(
                e.value.style.chart.layout.labels.value.formatter,
                t,
                s(L)({
                  p: e.value.style.chart.layout.labels.dataLabels.prefix,
                  v: t,
                  s: e.value.style.chart.layout.labels.dataLabels.suffix,
                  r: e.value.style.chart.layout.labels.value.rounding
                })
              )), 1)
            ]),
            _: 1
          }, 8, ["colNames", "head", "body", "config", "title"]))
        ]),
        _: 1
      }, 8, ["config"])) : v("", !0)
    ], 14, At));
  }
}, Zl = /* @__PURE__ */ zt(Dl, [["__scopeId", "data-v-e89705b6"]]);
export {
  Zl as default
};
