import { computed as m, ref as d, watch as Pe, onMounted as Qe, onBeforeUnmount as Ze, openBlock as u, createElementBlock as n, normalizeClass as P, normalizeStyle as re, createBlock as D, createCommentVNode as f, unref as r, createSlots as je, withCtx as g, renderSlot as $, normalizeProps as R, guardReactiveProps as E, createVNode as De, createElementVNode as y, Fragment as x, renderList as S, toDisplayString as N, createTextVNode as Q, nextTick as et, pushScopeId as tt, popScopeId as lt } from "vue";
import { u as at, c as ot, t as st, a as ut, p as Z, o as nt, e as V, b as rt, I as ze, d as it, m as Ve, f as L, X as dt, s as Me, K as ct, k as M, n as ie, i as G, x as Be, y as vt, q as ft, r as ht } from "./index-DnVHQ2xI.js";
import { t as pt, u as yt } from "./useResponsive-NZB-WLRF.js";
import { _ as bt } from "./Title-5VmBwT4i.js";
import { u as gt, U as mt } from "./usePrinter-BEeNAqS5.js";
import { D as kt } from "./DataTable-DTk7C4Pr.js";
import { _ as wt } from "./Tooltip-Cj4EF7v1.js";
import { L as _t } from "./Legend-CYF2gpXG.js";
import $t from "./vue-ui-skeleton-aZmkNzAe.js";
import xt from "./vue-ui-accordion-DspS4q3f.js";
import { u as Ue } from "./useNestedProp-Cox0K0Y5.js";
import { _ as Lt } from "./PackageVersion-CvCRsT5_.js";
import { P as Ct } from "./PenAndPaper-Jb0pLt3G.js";
import { _ as Ft } from "./_plugin-vue_export-helper-CHgC5LLL.js";
const de = (B) => (tt("data-v-ab64cd29"), B = B(), lt(), B), St = ["id"], Tt = ["xmlns", "viewBox"], Nt = ["id"], It = /* @__PURE__ */ de(() => /* @__PURE__ */ y("stop", {
  offset: "0%",
  "stop-color": "#FFFFFF",
  "stop-opacity": "0"
}, null, -1)), At = ["offset", "stop-color"], Ot = ["offset", "stop-opacity"], Pt = /* @__PURE__ */ de(() => /* @__PURE__ */ y("stop", {
  offset: "100%",
  "stop-color": "#FFFFFF",
  "stop-opacity": "0"
}, null, -1)), Dt = ["id"], zt = ["id"], Vt = /* @__PURE__ */ de(() => /* @__PURE__ */ y("feColorMatrix", {
  type: "saturate",
  values: "0"
}, null, -1)), Mt = ["id"], Bt = ["flood-color"], Ut = ["d", "fill", "stroke", "stroke-width", "filter"], Rt = { key: 0 }, Et = ["d", "fill"], Gt = { key: 1 }, Yt = ["x", "y", "font-size", "font-weight", "fill"], Xt = { key: 2 }, Wt = ["filter"], Ht = ["text-anchor", "x", "y", "fill", "font-size", "font-weight"], qt = ["text-anchor", "x", "y", "fill", "font-size", "font-weight"], Kt = ["text-anchor", "x", "y", "fill", "font-size", "font-weight"], Jt = ["d", "fill", "onMouseenter", "onClick"], Qt = {
  key: 4,
  class: "vue-data-ui-watermark"
}, Zt = {
  key: 0,
  class: "vue-ui-nested-donuts-legend-title"
}, jt = ["onClick"], el = ["innerHTML"], tl = {
  __name: "vue-ui-nested-donuts",
  props: {
    config: {
      type: Object,
      default() {
        return {};
      }
    },
    dataset: {
      type: Array,
      default() {
        return [];
      }
    }
  },
  emits: ["selectLegend", "selectDatapoint"],
  setup(B, { expose: Re, emit: ce }) {
    const I = B, { vue_ui_nested_donuts: Ee } = at(), Y = m(() => !!I.dataset && I.dataset.length), k = d(ot()), j = d(!1), ee = d(""), Ge = d(null), ve = d(0), z = d(null), fe = d(null), te = d(null), he = d(0), pe = d(0), ye = d(0), U = d(!1);
    function Ye(t) {
      U.value = t, ve.value += 1;
    }
    const e = m({
      get: () => be(),
      set: (t) => t
    });
    function be() {
      const t = Ue({
        userConfig: I.config,
        defaultConfig: Ee
      });
      return t.theme ? {
        ...Ue({
          userConfig: st.vue_ui_nested_donuts[t.theme] || I.config,
          defaultConfig: t
        }),
        customPalette: ut[t.theme] || Z
      } : t;
    }
    Pe(() => I.config, (t) => {
      e.value = be(), ge(), he.value += 1, pe.value += 1, ye.value += 1;
    }, { deep: !0 });
    const X = d(null);
    Qe(() => {
      ge();
    });
    function ge() {
      if (nt(I.dataset) && V({
        componentName: "VueUiNestedDonuts",
        type: "dataset"
      }), e.value.responsive) {
        const t = pt(() => {
          const { width: s, height: a } = yt({
            chart: z.value,
            title: e.value.style.chart.title.text ? fe.value : null,
            legend: e.value.style.chart.legend.show ? te.value : null
          });
          h.value.width = s, h.value.height = a;
        });
        X.value = new ResizeObserver(t), X.value.observe(z.value.parentNode);
      }
    }
    Ze(() => {
      X.value && X.value.disconnect();
    });
    const { isPrinting: me, isImaging: ke, generatePdf: we, generateImage: _e } = gt({
      elementId: `nested_donuts_${k.value}`,
      fileName: e.value.style.chart.title.text || "vue-ui-nested-donuts"
    }), Xe = m(() => rt(e.value.customPalette)), w = d({
      dataLabels: {
        show: e.value.style.chart.layout.labels.dataLabels.show
      },
      showTable: e.value.table.show,
      showTooltip: e.value.style.chart.tooltip.show
    }), h = d({
      height: 512,
      width: 512
    });
    function We({ datapoint: t, index: s }) {
      ce("selectDatapoint", { datapoint: t, index: s });
    }
    const p = d([]), C = m(() => (I.dataset.forEach((t, s) => {
      [null, void 0].includes(t.name) && V({
        componentName: "VueUiNestedDonuts",
        type: "datasetSerieAttribute",
        property: "name",
        index: s
      }), [null, void 0].includes(t.series) ? V({
        componentName: "VueUiNestedDonuts",
        type: "datasetSerieAttribute",
        property: "series",
        index: s
      }) : t.series.length === 0 ? V({
        componentName: "VueUiNestedDonuts",
        type: "datasetAttributeEmpty",
        property: `series at index ${s}`
      }) : t.series.forEach((a, o) => {
        [null, void 0].includes(a.name) && V({
          componentName: "VueUiNestedDonuts",
          type: "datasetSerieAttribute",
          property: "name",
          index: o,
          key: "serie"
        }), [null, void 0].includes(a.values) && V({
          componentName: "VueUiNestedDonuts",
          type: "datasetSerieAttribute",
          property: "values",
          index: o,
          key: "serie"
        });
      });
    }), I.dataset.map((t, s) => ({
      ...t,
      total: t.series.filter((a) => !p.value.includes(a.id)).map((a) => ze(a.values).reduce((o, l) => o + l, 0)).reduce((a, o) => a + o, 0),
      datasetIndex: s,
      id: `${k.value}_${s}`,
      series: t.series.map((a, o) => ({
        name: a.name,
        arcOf: t.name,
        arcOfId: `${k.value}_${s}`,
        id: `${k.value}_${s}_${o}`,
        seriesIndex: o,
        datasetIndex: s,
        color: it(a.color) || Xe.value[o] || Z[o] || Z[o % Z.length],
        value: ze(a.values).reduce((l, i) => l + i, 0),
        absoluteValues: a.values || []
      }))
    })))), F = m(() => Math.min(h.value.height, h.value.width) * (e.value.style.chart.layout.donut.strokeWidth / 512)), $e = m(() => [...C.value].map((t, s) => {
      const a = t.series.filter((o) => !p.value.includes(o.id)).map((o) => o.value).reduce((o, l) => o + l, 0);
      return {
        ...t,
        total: a,
        series: t.series.filter((o) => !p.value.includes(o.id)).map((o) => ({
          ...o,
          proportion: o.value / a
        }))
      };
    }));
    function He(t, s, a) {
      let o = 0;
      for (let l = 0; l < t.length; l += 1)
        a.includes(t[l]) && (o += 1);
      return o < s;
    }
    const v = d($e.value);
    Pe(() => $e.value, (t) => v.value = t);
    const xe = d(null), Le = d(null);
    function le(t) {
      ce("selectLegend", t);
      const s = C.value.flatMap((c) => c.series).find((c) => c.id === t.id), a = v.value.flatMap((c) => c.series).find((c) => c.id === t.id);
      let l = a ? a.value : 0;
      const i = C.value.find((c) => c.id === s.arcOfId).series.map((c) => c.id), b = He(i, i.length - 1, p.value);
      if (p.value.includes(t.id)) {
        let c = function() {
          l > s.value ? (cancelAnimationFrame(xe.value), v.value = v.value.map((_) => ({
            ..._,
            series: _.series.map((T) => T.id == t.id ? {
              ...T,
              value: s.value
            } : T)
          }))) : (l += s.value * 0.025, v.value = v.value.map((_) => ({
            ..._,
            series: _.series.map((T) => T.id === t.id ? {
              ...T,
              value: l
            } : T)
          })), xe.value = requestAnimationFrame(c));
        };
        p.value = p.value.filter((_) => _ !== t.id), c();
      } else if (b) {
        let c = function() {
          l < 0.1 ? (cancelAnimationFrame(Le.value), p.value.push(t.id), v.value = v.value.map((_, T) => ({
            ..._,
            series: _.series.map((O) => O.id === t.id ? {
              ...O,
              value: 0
            } : O)
          }))) : (l /= 1.1, v.value = v.value.map((_, T) => ({
            ..._,
            series: _.series.map((O) => O.id === t.id ? {
              ...O,
              value: l
            } : O)
          })), Le.value = requestAnimationFrame(c));
        };
        c();
      }
    }
    const ae = m(() => F.value / C.value.length * e.value.style.chart.layout.donut.spacingRatio), Ce = m(() => v.value.map((t, s) => F.value - s * F.value / C.value.length)), W = m(() => v.value.map((t, s) => {
      const a = s * F.value / C.value.length;
      return {
        ...t,
        radius: F.value - a,
        donut: Ve(
          { series: t.series },
          h.value.width / 2,
          h.value.height / 2,
          F.value - a,
          F.value - a,
          1.99999,
          2,
          1,
          360,
          105.25,
          ae.value
        )
      };
    })), Fe = m(() => [...C.value].map((t, s) => {
      const a = s * F.value / C.value.length;
      return {
        sizeRatio: a,
        donut: Ve(
          { series: [{ value: 1 }] },
          h.value.width / 2,
          h.value.height / 2,
          F.value - a,
          F.value - a,
          1.99999,
          2,
          1,
          360,
          105.25,
          F.value / C.value.length * e.value.style.chart.layout.donut.spacingRatio
        )[0]
      };
    })), Se = d(null), H = d(null), q = d(null), oe = d(null);
    function qe({ datapoint: t, _relativeIndex: s, seriesIndex: a }) {
      Se.value = t.arcOfId, H.value = t.id, q.value = a, oe.value = {
        datapoint: t,
        seriesIndex: a,
        series: v.value,
        config: e.value
      };
      const o = e.value.style.chart.tooltip.customFormat;
      if (Be(o) && vt(() => o({
        seriesIndex: a,
        datapoint: t,
        series: v.value,
        config: e.value
      })))
        ee.value = o({
          seriesIndex: a,
          datapoint: t,
          series: v.value,
          config: e.value
        });
      else {
        let l = "";
        if (e.value.style.chart.tooltip.showAllItemsAtIndex && p.value.length === 0) {
          const i = v.value.map((b) => b.series.find((c) => c.seriesIndex === a));
          i.forEach((b, c) => {
            if (!b) return "";
            l += `
                    <div style="display:flex; flex-direction: column; justify-content:flex-start; align-items:flex-start;padding:6px 0; ${c < i.length - 1 ? `border-bottom:1px solid ${e.value.style.chart.tooltip.borderColor}` : ""}">
                        <div style="display:flex; flex-direction: row; gap: 3px; justify-content:flex-start; align-items:center;">
                            <svg viewBox="0 0 20 20" height="${e.value.style.chart.tooltip.fontSize}" width="${e.value.style.chart.tooltip.fontSize}">
                                <circle cx="10" cy="10" r="10" fill="${b.color}"/>
                            </svg>
                            <span>
                                ${b.arcOf ?? ""} - ${b.name}
                            </span>
                        </div>
                        <span>
                            ${e.value.style.chart.tooltip.showValue ? `<b>${G(
              e.value.style.chart.layout.labels.dataLabels.formatter,
              t.value,
              L({
                p: e.value.style.chart.layout.labels.dataLabels.prefix,
                v: t.value,
                s: e.value.style.chart.layout.labels.dataLabels.suffix,
                r: e.value.style.chart.tooltip.roundingValue
              }),
              { datapoint: t, seriesIndex: a }
            )}
                        </b>` : ""}
                            ${e.value.style.chart.tooltip.showPercentage ? `(${L({
              v: b.proportion * 100,
              s: "%",
              r: e.value.style.chart.tooltip.roundingPercentage
            })})` : ""}
                        </span>
                    </div>
                `;
          });
        } else
          l += `<div style="width:100%;text-align:center;border-bottom:1px solid ${e.value.style.chart.tooltip.borderColor};padding-bottom:6px;margin-bottom:3px;">${t.arcOf ?? ""} - ${t.name}</div>`, l += `<div style="display:flex;flex-direction:row;gap:6px;align-items:center;"><svg viewBox="0 0 12 12" height="14" width="14"><circle cx="6" cy="6" r="6" stroke="none" fill="${t.color}"/></svg>`, e.value.style.chart.tooltip.showValue && (l += `<b>${G(
            e.value.style.chart.layout.labels.dataLabels.formatter,
            t.value,
            L({
              p: e.value.style.chart.layout.labels.dataLabels.prefix,
              v: t.value,
              s: e.value.style.chart.layout.labels.dataLabels.suffix,
              r: e.value.style.chart.tooltip.roundingValue
            }),
            { datapoint: t, seriesIndex: a }
          )}</b>`), e.value.style.chart.tooltip.showPercentage && (e.value.style.chart.tooltip.showValue ? l += `<span>(${L({
            v: t.proportion * 100,
            s: "%",
            r: e.value.style.chart.tooltip.roundingPercentage
          })})</span></div>` : l += `<b>${L({
            v: t.proportion * 100,
            s: "%",
            r: e.value.style.chart.tooltip.roundingPercentage
          })}</b></div>`);
        ee.value = `<div style="font-size:${e.value.style.chart.tooltip.fontSize}px">${l}</div>`;
      }
      j.value = !0;
    }
    function se(t) {
      return t.proportion * 100 > e.value.style.chart.layout.labels.dataLabels.hideUnderValue;
    }
    function Te(t, s) {
      if (!e.value.useBlurOnHover)
        return "";
      if (e.value.style.chart.tooltip.showAllItemsAtIndex && p.value.length === 0)
        return [null, void 0].includes(q.value) || q.value === s ? "" : `url(#blur_${k.value})`;
      if (!e.value.style.chart.tooltip.showAllItemsAtIndex || p.value.length)
        return [null, void 0].includes(H.value) || H.value === t.id ? "" : `url(#blur_${k.value})`;
    }
    const ue = m(() => C.value.map((t, s) => t.series.map((a, o) => ({
      name: a.name,
      color: a.color,
      value: a.value,
      shape: "circle",
      arcOf: a.arcOf,
      id: a.id,
      seriesIndex: o,
      datasetIndex: s,
      total: t.series.filter((l) => !p.value.includes(l.id)).map((l) => l.value).reduce((l, i) => l + i, 0)
    })).map((a) => ({
      ...a,
      opacity: p.value.includes(a.id) ? 0.5 : 1,
      segregate: () => le(a),
      isSegregated: p.value.includes(a.id)
    })))), Ke = m(() => ({
      cy: "nested-donuts-legend",
      backgroundColor: e.value.style.chart.legend.backgroundColor,
      color: e.value.style.chart.legend.color,
      fontSize: e.value.style.chart.legend.fontSize,
      paddingBottom: 12,
      fontWeight: e.value.style.chart.legend.bold ? "bold" : ""
    })), A = m(() => {
      const t = v.value.flatMap((a) => a.series.map((o) => ({
        name: `${a.name} - ${o.name}`,
        color: o.color,
        total: a.total
      }))), s = v.value.flatMap((a) => a.series.map((o) => o.value));
      return { head: t, body: s };
    });
    function Ne() {
      et(() => {
        const t = A.value.head.map((o, l) => [[
          o.name
        ], [A.value.body[l]], [isNaN(A.value.body[l] / o.total) ? "-" : A.value.body[l] / o.total * 100]]), s = [[e.value.style.chart.title.text], [e.value.style.chart.title.subtitle.text], [[""], ["val"], ["%"]]].concat(t), a = ft(s);
        ht({ csvContent: a, title: e.value.style.chart.title.text || "vue-ui-nested-donuts" });
      });
    }
    const K = m(() => {
      const t = [
        e.value.table.columnNames.series,
        e.value.table.columnNames.value,
        e.value.table.columnNames.percentage
      ], s = A.value.head.map((l, i) => {
        const b = L({ p: e.value.style.chart.layout.labels.dataLabels.prefix, v: A.value.body[i], s: e.value.style.chart.layout.labels.dataLabels.suffix, r: e.value.table.td.roundingValue });
        return [
          {
            color: l.color,
            name: l.name
          },
          b,
          isNaN(A.value.body[i] / l.total) ? "-" : L({
            v: A.value.body[i] / l.total * 100,
            s: "%",
            r: e.value.table.td.roundingPercentage
          })
        ];
      }), a = {
        th: {
          backgroundColor: e.value.table.th.backgroundColor,
          color: e.value.table.th.color,
          outline: e.value.table.th.outline
        },
        td: {
          backgroundColor: e.value.table.td.backgroundColor,
          color: e.value.table.td.color,
          outline: e.value.table.td.outline
        },
        breakpoint: e.value.table.responsiveBreakpoint
      };
      return {
        colNames: [
          e.value.table.columnNames.series,
          e.value.table.columnNames.value,
          e.value.table.columnNames.percentage
        ],
        head: t,
        body: s,
        config: a
      };
    });
    function Je() {
      return C.value;
    }
    function Ie() {
      w.value.showTable = !w.value.showTable;
    }
    function Ae() {
      w.value.dataLabels.show = !w.value.dataLabels.show;
    }
    function Oe() {
      w.value.showTooltip = !w.value.showTooltip;
    }
    const J = d(!1);
    function ne() {
      J.value = !J.value;
    }
    return Re({
      getData: Je,
      generatePdf: we,
      generateCsv: Ne,
      generateImage: _e,
      toggleTable: Ie,
      toggleLabels: Ae,
      toggleTooltip: Oe,
      toggleAnnotator: ne
    }), (t, s) => (u(), n("div", {
      ref_key: "nestedDonutsChart",
      ref: z,
      class: P(`vue-ui-nested-donuts ${U.value ? "vue-data-ui-wrapper-fullscreen" : ""} ${e.value.useCssAnimation ? "" : "vue-ui-dna"}`),
      style: re(`font-family:${e.value.style.fontFamily};width:100%; text-align:center;${!e.value.style.chart.title.text && e.value.userOptions.show ? "padding-top:36px" : ""};background:${e.value.style.chart.backgroundColor}`),
      id: `nested_donuts_${k.value}`
    }, [
      e.value.userOptions.buttons.annotator ? (u(), D(Ct, {
        key: 0,
        parent: z.value,
        backgroundColor: e.value.style.chart.backgroundColor,
        color: e.value.style.chart.color,
        active: J.value,
        onClose: ne
      }, null, 8, ["parent", "backgroundColor", "color", "active"])) : f("", !0),
      e.value.style.chart.title.text ? (u(), n("div", {
        key: 1,
        ref_key: "chartTitle",
        ref: fe
      }, [
        (u(), D(bt, {
          key: `title_${he.value}`,
          config: {
            title: {
              cy: "donut-div-title",
              ...e.value.style.chart.title
            },
            subtitle: {
              cy: "donut-div-subtitle",
              ...e.value.style.chart.title.subtitle
            }
          }
        }, null, 8, ["config"]))
      ], 512)) : f("", !0),
      e.value.userOptions.show && Y.value ? (u(), D(mt, {
        ref: "details",
        key: `user_option_${ve.value}`,
        backgroundColor: e.value.style.chart.backgroundColor,
        color: e.value.style.chart.color,
        isPrinting: r(me),
        isImaging: r(ke),
        uid: k.value,
        hasTooltip: e.value.userOptions.buttons.tooltip && e.value.style.chart.tooltip.show,
        hasPdf: e.value.userOptions.buttons.pdf,
        hasXls: e.value.userOptions.buttons.csv,
        hasImg: e.value.userOptions.buttons.img,
        hasTable: e.value.userOptions.buttons.table,
        hasLabel: e.value.userOptions.buttons.labels,
        hasFullscreen: e.value.userOptions.buttons.fullscreen,
        isFullscreen: U.value,
        isTooltip: w.value.showTooltip,
        titles: { ...e.value.userOptions.buttonTitles },
        chartElement: z.value,
        position: e.value.userOptions.position,
        hasAnnotator: e.value.userOptions.buttons.annotator,
        isAnnotation: J.value,
        onToggleFullscreen: Ye,
        onGeneratePdf: r(we),
        onGenerateCsv: Ne,
        onGenerateImage: r(_e),
        onToggleTable: Ie,
        onToggleLabels: Ae,
        onToggleTooltip: Oe,
        onToggleAnnotator: ne
      }, je({ _: 2 }, [
        t.$slots.optionTooltip ? {
          name: "optionTooltip",
          fn: g(() => [
            $(t.$slots, "optionTooltip", {}, void 0, !0)
          ]),
          key: "0"
        } : void 0,
        t.$slots.optionPdf ? {
          name: "optionPdf",
          fn: g(() => [
            $(t.$slots, "optionPdf", {}, void 0, !0)
          ]),
          key: "1"
        } : void 0,
        t.$slots.optionCsv ? {
          name: "optionCsv",
          fn: g(() => [
            $(t.$slots, "optionCsv", {}, void 0, !0)
          ]),
          key: "2"
        } : void 0,
        t.$slots.optionImg ? {
          name: "optionImg",
          fn: g(() => [
            $(t.$slots, "optionImg", {}, void 0, !0)
          ]),
          key: "3"
        } : void 0,
        t.$slots.optionTable ? {
          name: "optionTable",
          fn: g(() => [
            $(t.$slots, "optionTable", {}, void 0, !0)
          ]),
          key: "4"
        } : void 0,
        t.$slots.optionLabels ? {
          name: "optionLabels",
          fn: g(() => [
            $(t.$slots, "optionLabels", {}, void 0, !0)
          ]),
          key: "5"
        } : void 0,
        t.$slots.optionFullscreen ? {
          name: "optionFullscreen",
          fn: g(({ toggleFullscreen: a, isFullscreen: o }) => [
            $(t.$slots, "optionFullscreen", R(E({ toggleFullscreen: a, isFullscreen: o })), void 0, !0)
          ]),
          key: "6"
        } : void 0,
        t.$slots.optionAnnotator ? {
          name: "optionAnnotator",
          fn: g(({ toggleAnnotator: a, isAnnotator: o }) => [
            $(t.$slots, "optionAnnotator", R(E({ toggleAnnotator: a, isAnnotator: o })), void 0, !0)
          ]),
          key: "7"
        } : void 0
      ]), 1032, ["backgroundColor", "color", "isPrinting", "isImaging", "uid", "hasTooltip", "hasPdf", "hasXls", "hasImg", "hasTable", "hasLabel", "hasFullscreen", "isFullscreen", "isTooltip", "titles", "chartElement", "position", "hasAnnotator", "isAnnotation", "onGeneratePdf", "onGenerateImage"])) : f("", !0),
      Y.value ? (u(), n("svg", {
        key: 3,
        xmlns: r(dt),
        class: P({ "vue-data-ui-fullscreen--on": U.value, "vue-data-ui-fulscreen--off": !U.value }),
        viewBox: `0 0 ${h.value.width <= 0 ? 1e-3 : h.value.width} ${h.value.height < 0 ? 1e-3 : h.value.height}`,
        style: re(`max-width:100%; overflow: visible; background:transparent;color:${e.value.style.chart.color}`)
      }, [
        De(Lt),
        y("defs", null, [
          (u(!0), n(x, null, S(Fe.value, (a, o) => (u(), n("radialGradient", {
            id: `radial_${k.value}_${o}`
          }, [
            It,
            y("stop", {
              offset: `${(1 - ae.value / Ce.value[o]) * 100}%`,
              "stop-color": r(Me)("#FFFFFF", 0),
              "stop-opacity": "0"
            }, null, 8, At),
            y("stop", {
              offset: `${(1 - ae.value / Ce.value[o] / 2) * 100}%`,
              "stop-color": "#FFFFFF",
              "stop-opacity": e.value.style.chart.gradientIntensity / 100
            }, null, 8, Ot),
            Pt
          ], 8, Nt))), 256))
        ]),
        y("defs", null, [
          y("filter", {
            id: `blur_${k.value}`,
            x: "-50%",
            y: "-50%",
            width: "200%",
            height: "200%"
          }, [
            y("feGaussianBlur", {
              in: "SourceGraphic",
              stdDeviation: 2,
              id: `blur_std_${k.value}`
            }, null, 8, zt),
            Vt
          ], 8, Dt),
          y("filter", {
            id: `shadow_${k.value}`,
            "color-interpolation-filters": "sRGB"
          }, [
            y("feDropShadow", {
              dx: "0",
              dy: "0",
              stdDeviation: "10",
              "flood-opacity": "0.5",
              "flood-color": e.value.style.chart.layout.donut.shadowColor
            }, null, 8, Bt)
          ], 8, Mt)
        ]),
        (u(!0), n(x, null, S(W.value, (a, o) => (u(), n("g", null, [
          (u(!0), n(x, null, S(a.donut, (l, i) => (u(), n("g", null, [
            y("path", {
              class: "vue-ui-donut-arc-path",
              d: l.arcSlice,
              fill: r(Me)(l.color, 80),
              stroke: e.value.style.chart.backgroundColor,
              "stroke-width": e.value.style.chart.layout.donut.borderWidth,
              filter: Te(l, i)
            }, null, 8, Ut)
          ]))), 256))
        ]))), 256)),
        e.value.style.chart.useGradient ? (u(), n("g", Rt, [
          (u(!0), n(x, null, S(Fe.value, (a, o) => (u(), n("g", null, [
            y("path", {
              d: a.donut.arcSlice,
              fill: `url(#radial_${k.value}_${o})`,
              stroke: "transparent",
              "stroke-width": "0"
            }, null, 8, Et)
          ]))), 256))
        ])) : f("", !0),
        e.value.style.chart.layout.labels.dataLabels.showDonutName ? (u(), n("g", Gt, [
          (u(!0), n(x, null, S(W.value, (a, o) => (u(), n("g", null, [
            (u(!0), n(x, null, S(a.donut, (l, i) => (u(), n("g", null, [
              i === 0 && h.value.width && h.value.height ? (u(), n("text", {
                key: 0,
                class: P({ animated: e.value.useCssAnimation }),
                x: h.value.width / 2,
                y: l.startY - e.value.style.chart.layout.labels.dataLabels.fontSize + e.value.style.chart.layout.labels.dataLabels.donutNameOffsetY,
                "text-anchor": "middle",
                "font-size": e.value.style.chart.layout.labels.dataLabels.fontSize,
                "font-weight": e.value.style.chart.layout.labels.dataLabels.boldDonutName ? "bold" : "normal",
                fill: e.value.style.chart.layout.labels.dataLabels.color
              }, N(e.value.style.chart.layout.labels.dataLabels.donutNameAbbreviation ? r(ct)({ source: a.name, length: e.value.style.chart.layout.labels.dataLabels.donutNameMaxAbbreviationSize }) : a.name), 11, Yt)) : f("", !0)
            ]))), 256))
          ]))), 256))
        ])) : f("", !0),
        e.value.style.chart.layout.labels.dataLabels.show ? (u(), n("g", Xt, [
          (u(!0), n(x, null, S(W.value, (a, o) => (u(), n("g", null, [
            (u(!0), n(x, null, S(a.donut, (l, i) => (u(), n("g", {
              filter: Te(l, i)
            }, [
              se(l) && w.value.dataLabels.show && e.value.style.chart.layout.labels.dataLabels.showPercentage ? (u(), n("text", {
                key: 0,
                class: P({ animated: e.value.useCssAnimation }),
                "text-anchor": r(M)(l, !0).anchor,
                x: r(M)(l, !1, e.value.style.chart.layout.labels.dataLabels.offsetX).x || 0,
                y: r(ie)(l, e.value.style.chart.layout.labels.dataLabels.offsetY, e.value.style.chart.layout.labels.dataLabels.offsetY),
                fill: e.value.style.chart.layout.labels.dataLabels.useSerieColor ? l.color : e.value.style.chart.layout.labels.dataLabels.color,
                "font-size": e.value.style.chart.layout.labels.dataLabels.fontSize,
                "font-weight": e.value.style.chart.layout.labels.dataLabels.boldPercentage ? "bold" : "normal"
              }, N(r(L)({ v: l.proportion * 100, s: "%", r: e.value.style.chart.layout.labels.dataLabels.roundingPercentage })), 11, Ht)) : f("", !0),
              se(l) && w.value.dataLabels.show && e.value.style.chart.layout.labels.dataLabels.showPercentage && e.value.style.chart.layout.labels.dataLabels.showValue ? (u(), n("text", {
                key: 1,
                class: P({ animated: e.value.useCssAnimation }),
                "text-anchor": r(M)(l, !0).anchor,
                x: r(M)(l, !1, e.value.style.chart.layout.labels.dataLabels.offsetX).x || 0,
                y: r(ie)(l, e.value.style.chart.layout.labels.dataLabels.offsetY, e.value.style.chart.layout.labels.dataLabels.offsetY) + e.value.style.chart.layout.labels.dataLabels.fontSize,
                fill: e.value.style.chart.layout.labels.dataLabels.useSerieColor ? l.color : e.value.style.chart.layout.labels.dataLabels.color,
                "font-size": e.value.style.chart.layout.labels.dataLabels.fontSize,
                "font-weight": e.value.style.chart.layout.labels.dataLabels.boldValue ? "bold" : "normal"
              }, " (" + N(r(G)(
                e.value.style.chart.layout.labels.dataLabels.formatter,
                l.value,
                r(L)({
                  p: e.value.style.chart.layout.labels.dataLabels.prefix,
                  v: l.value,
                  s: e.value.style.chart.layout.labels.dataLabels.suffix,
                  r: e.value.style.chart.layout.labels.dataLabels.roundingValue
                }),
                { datapoint: l, seriesIndex: o, datapointIndex: i }
              )) + ") ", 11, qt)) : f("", !0),
              se(l) && w.value.dataLabels.show && !e.value.style.chart.layout.labels.dataLabels.showPercentage && e.value.style.chart.layout.labels.dataLabels.showValue ? (u(), n("text", {
                key: 2,
                class: P({ animated: e.value.useCssAnimation }),
                "text-anchor": r(M)(l, !0).anchor,
                x: r(M)(l, !1, e.value.style.chart.layout.labels.dataLabels.offsetX).x || 0,
                y: r(ie)(l, e.value.style.chart.layout.labels.dataLabels.offsetY, e.value.style.chart.layout.labels.dataLabels.offsetY),
                fill: e.value.style.chart.layout.labels.dataLabels.useSerieColor ? l.color : e.value.style.chart.layout.labels.dataLabels.color,
                "font-size": e.value.style.chart.layout.labels.dataLabels.fontSize,
                "font-weight": e.value.style.chart.layout.labels.dataLabels.boldValue ? "bold" : "normal"
              }, N(r(G)(
                e.value.style.chart.layout.labels.dataLabels.formatter,
                l.value,
                r(L)({
                  p: e.value.style.chart.layout.labels.dataLabels.prefix,
                  v: l.value,
                  s: e.value.style.chart.layout.labels.dataLabels.suffix,
                  r: e.value.style.chart.layout.labels.dataLabels.roundingValue
                }),
                { datapoint: l, seriesIndex: o, datapointIndex: i }
              )), 11, Kt)) : f("", !0)
            ], 8, Wt))), 256))
          ]))), 256))
        ])) : f("", !0),
        (u(!0), n(x, null, S(W.value, (a, o) => (u(), n("g", null, [
          (u(!0), n(x, null, S(a.donut, (l, i) => (u(), n("g", null, [
            y("path", {
              "data-cy-donut-trap": "",
              d: l.arcSlice,
              fill: Ge.value === o ? "rgba(0,0,0,0.1)" : "transparent",
              onMouseenter: (b) => qe({
                datapoint: l,
                relativeIndex: o,
                seriesIndex: l.seriesIndex
              }),
              onClick: (b) => We({ datapoint: l, index: i }),
              onMouseleave: s[0] || (s[0] = (b) => {
                j.value = !1, Se.value = null, H.value = null, q.value = null;
              })
            }, null, 40, Jt)
          ]))), 256))
        ]))), 256)),
        $(t.$slots, "svg", { svg: h.value }, void 0, !0)
      ], 14, Tt)) : f("", !0),
      t.$slots.watermark ? (u(), n("div", Qt, [
        $(t.$slots, "watermark", R(E({ isPrinting: r(me) || r(ke) })), void 0, !0)
      ])) : f("", !0),
      Y.value ? f("", !0) : (u(), D($t, {
        key: 5,
        config: {
          type: "donut",
          style: {
            backgroundColor: e.value.style.chart.backgroundColor,
            donut: {
              color: "#CCCCCC"
            }
          }
        }
      }, null, 8, ["config"])),
      De(wt, {
        show: w.value.showTooltip && j.value,
        backgroundColor: e.value.style.chart.tooltip.backgroundColor,
        color: e.value.style.chart.tooltip.color,
        borderRadius: e.value.style.chart.tooltip.borderRadius,
        borderColor: e.value.style.chart.tooltip.borderColor,
        borderWidth: e.value.style.chart.tooltip.borderWidth,
        fontSize: e.value.style.chart.tooltip.fontSize,
        backgroundOpacity: e.value.style.chart.tooltip.backgroundOpacity,
        position: e.value.style.chart.tooltip.position,
        offsetY: e.value.style.chart.tooltip.offsetY,
        parent: z.value,
        content: ee.value,
        isCustom: r(Be)(e.value.style.chart.tooltip.customFormat)
      }, {
        "tooltip-before": g(() => [
          $(t.$slots, "tooltip-before", R(E({ ...oe.value })), void 0, !0)
        ]),
        "tooltip-after": g(() => [
          $(t.$slots, "tooltip-after", R(E({ ...oe.value })), void 0, !0)
        ]),
        _: 3
      }, 8, ["show", "backgroundColor", "color", "borderRadius", "borderColor", "borderWidth", "fontSize", "backgroundOpacity", "position", "offsetY", "parent", "content", "isCustom"]),
      e.value.style.chart.legend.show ? (u(), n("div", {
        key: 6,
        ref_key: "chartLegend",
        ref: te,
        class: P({ "vue-ui-nested-donuts-legend": ue.value.length > 1 })
      }, [
        (u(!0), n(x, null, S(ue.value, (a, o) => (u(), D(_t, {
          key: `legend_${o}_${ye.value}`,
          legendSet: a,
          config: Ke.value,
          onClickMarker: s[1] || (s[1] = ({ legend: l }) => le(l))
        }, {
          legendTitle: g(({ titleSet: l }) => [
            l[0] && l[0].arcOf ? (u(), n("div", Zt, N(l[0].arcOf), 1)) : f("", !0)
          ]),
          item: g(({ legend: l, index: i }) => [
            y("div", {
              onClick: (b) => le(l),
              style: re(`opacity:${p.value.includes(l.id) ? 0.5 : 1}`)
            }, [
              Q(N(l.name) + ": " + N(r(G)(
                e.value.style.chart.layout.labels.dataLabels.formatter,
                l.value,
                r(L)({
                  p: e.value.style.chart.layout.labels.dataLabels.prefix,
                  v: l.value,
                  s: e.value.style.chart.layout.labels.dataLabels.suffix,
                  r: e.value.style.chart.legend.roundingValue
                }),
                { datapoint: l, seriesIndex: i }
              )) + " ", 1),
              p.value.includes(l.id) ? (u(), n(x, { key: 1 }, [
                Q(" ( - % ) ")
              ], 64)) : (u(), n(x, { key: 0 }, [
                Q(" (" + N(isNaN(l.value / l.total) ? "-" : r(L)({ v: l.value / l.total * 100, s: "%", r: e.value.style.chart.legend.roundingPercentage })) + ") ", 1)
              ], 64))
            ], 12, jt)
          ]),
          _: 2
        }, 1032, ["legendSet", "config"]))), 128))
      ], 2)) : f("", !0),
      e.value.style.chart.legend.show ? f("", !0) : (u(), n("div", {
        key: 7,
        ref_key: "chartLegend",
        ref: te
      }, [
        $(t.$slots, "legend", { legend: ue.value }, void 0, !0)
      ], 512)),
      Y.value ? (u(), D(xt, {
        key: 8,
        hideDetails: "",
        config: {
          open: w.value.showTable,
          maxHeight: 1e4,
          body: {
            backgroundColor: e.value.style.chart.backgroundColor,
            color: e.value.style.chart.color
          },
          head: {
            backgroundColor: e.value.style.chart.backgroundColor,
            color: e.value.style.chart.color
          }
        }
      }, {
        content: g(() => [
          (u(), D(kt, {
            key: `table_${pe.value}`,
            colNames: K.value.colNames,
            head: K.value.head,
            body: K.value.body,
            config: K.value.config,
            title: `${e.value.style.chart.title.text}${e.value.style.chart.title.subtitle.text ? ` : ${e.value.style.chart.title.subtitle.text}` : ""}`,
            onClose: s[2] || (s[2] = (a) => w.value.showTable = !1)
          }, {
            th: g(({ th: a }) => [
              y("div", {
                innerHTML: a,
                style: { display: "flex", "align-items": "center" }
              }, null, 8, el)
            ]),
            td: g(({ td: a }) => [
              Q(N(a.name || a), 1)
            ]),
            _: 1
          }, 8, ["colNames", "head", "body", "config", "title"]))
        ]),
        _: 1
      }, 8, ["config"])) : f("", !0)
    ], 14, St));
  }
}, yl = /* @__PURE__ */ Ft(tl, [["__scopeId", "data-v-ab64cd29"]]);
export {
  yl as default
};
