import { computed as f, ref as h, watch as Ee, onMounted as Be, onBeforeUnmount as Re, openBlock as u, createElementBlock as r, normalizeClass as U, normalizeStyle as T, createBlock as z, createCommentVNode as g, unref as M, createSlots as je, withCtx as b, renderSlot as x, normalizeProps as W, guardReactiveProps as E, createVNode as Ce, Fragment as C, renderList as I, createElementVNode as P, toDisplayString as L, createTextVNode as Ue } from "vue";
import { u as Ve, c as Z, t as Ge, a as He, p as V, o as Xe, e as we, g as Ye, b as qe, d as Qe, C as Je, Q as Ke, R as Ze, S as et, X as tt, x as $e, i as Ae, f as _e, y as at, q as lt, r as ot, E as G } from "./index-DnVHQ2xI.js";
import { t as st, u as nt } from "./useResponsive-NZB-WLRF.js";
import { _ as ut } from "./Title-5VmBwT4i.js";
import { L as rt } from "./Legend-CYF2gpXG.js";
import { _ as it } from "./Tooltip-Cj4EF7v1.js";
import { _ as ct } from "./Shape-BpPn4eWR.js";
import { u as vt, U as dt } from "./usePrinter-BEeNAqS5.js";
import { D as ht } from "./DataTable-DTk7C4Pr.js";
import pt from "./vue-ui-accordion-DspS4q3f.js";
import mt from "./vue-ui-skeleton-aZmkNzAe.js";
import { u as Te } from "./useNestedProp-Cox0K0Y5.js";
import { _ as yt } from "./PackageVersion-CvCRsT5_.js";
import { P as ft } from "./PenAndPaper-Jb0pLt3G.js";
import { _ as gt } from "./_plugin-vue_export-helper-CHgC5LLL.js";
const bt = ["id"], xt = ["xmlns", "viewBox"], kt = { style: { "pointer-events": "none" } }, Ct = ["x1", "x2", "y1", "y2", "stroke", "stroke-width"], wt = ["x", "y", "fill", "font-size", "font-weight"], $t = ["x1", "x2", "y1", "y2", "stroke", "stroke-width"], At = ["x", "y", "fill", "font-size", "font-weight"], _t = { key: 0 }, Tt = ["x", "y", "font-size", "fill"], zt = ["width", "x", "y"], Mt = { style: { width: "100%" } }, It = ["x", "y", "fill", "font-weight", "font-size", "onMouseenter"], Pt = ["d", "stroke", "stroke-width", "onMouseenter"], Ft = {
  key: 4,
  class: "vue-data-ui-watermark"
}, Nt = ["onClick"], St = ["innerHTML"], Lt = {
  __name: "vue-ui-parallel-coordinate-plot",
  props: {
    config: {
      type: Object,
      default() {
        return {};
      }
    },
    dataset: {
      type: Array,
      default() {
        return [];
      }
    }
  },
  emits: ["selectLegend", "selectDatapoint"],
  setup(ze, { expose: Me, emit: ee }) {
    const A = ze, { vue_ui_parallel_coordinate_plot: Ie } = Ve(), F = f({
      get() {
        return !!A.dataset && A.dataset.length;
      },
      set(t) {
        return t;
      }
    }), te = h(0), N = h(null), ae = h(null), le = h(null), oe = h(0), se = h(0), ne = h(0), H = h(Z()), O = h(!1);
    function Pe(t) {
      O.value = t, te.value += 1;
    }
    const e = f({
      get: () => ue(),
      set: (t) => t
    });
    function ue() {
      const t = Te({
        userConfig: A.config,
        defaultConfig: Ie
      });
      return t.theme ? {
        ...Te({
          userConfig: Ge.vue_ui_parallel_coordinate_plot[t.theme] || A.config,
          defaultConfig: t
        }),
        customPalette: He[t.theme] || V
      } : t;
    }
    Ee(() => A.config, (t) => {
      e.value = ue(), re(), oe.value += 1, ne.value += 1, se.value += 1;
    }, { deep: !0 });
    const B = h(null);
    Be(() => {
      re();
    });
    function re() {
      if (Xe(A.dataset) ? we({
        componentName: "VueUiParallelCoordinatePlot",
        type: "dataset"
      }) : A.dataset.forEach((t, l) => {
        Ye({
          datasetObject: t,
          requiredAttributes: ["name", "series"]
        }).forEach((a) => {
          F.value = !1, we({
            componentName: "VueUiParallelCoordinatePlot",
            type: "datasetSerieAttribute",
            property: a,
            index: l
          });
        });
      }), e.value.responsive) {
        const t = st(() => {
          const { width: l, height: a } = nt({
            chart: N.value,
            title: e.value.style.chart.title.text ? ae.value : null,
            legend: e.value.style.chart.legend.show ? le.value : null
          });
          c.value.width = l, c.value.height = a, c.value.plotSize = G({
            relator: Math.min(l, a),
            adjuster: 600,
            source: e.value.style.chart.plots.radius,
            threshold: 2,
            fallback: 2
          }), c.value.ticksFontSize = G({
            relator: Math.min(l, a),
            adjuster: 600,
            source: e.value.style.chart.yAxis.labels.ticks.fontSize,
            threshold: 10,
            fallback: 10
          }), c.value.datapointFontSize = G({
            relator: Math.min(l, a),
            adjuster: 600,
            source: e.value.style.chart.yAxis.labels.datapoints.fontSize,
            threshold: 10,
            fallback: 10
          }), c.value.axisNameFontSize = G({
            relator: Math.min(l, a),
            adjuster: 600,
            source: e.value.style.chart.yAxis.labels.axisNamesFontSize,
            threshold: 12,
            fallback: 12
          });
        });
        B.value = new ResizeObserver(t), B.value.observe(N.value.parentNode);
      }
    }
    Re(() => {
      B.value && B.value.disconnect();
    });
    const { isPrinting: ie, isImaging: ce, generatePdf: ve, generateImage: de } = vt({
      elementId: `pcp_${H.value}`,
      fileName: e.value.style.chart.title.text || "vue-ui-parallel-coordinate-plot"
    }), c = h({
      height: e.value.style.chart.height,
      width: e.value.style.chart.width,
      plotSize: e.value.style.chart.plots.radius,
      // ratio 100
      ticksFontSize: e.value.style.chart.yAxis.labels.ticks.fontSize,
      // ratio 42.85
      datapointFontSize: e.value.style.chart.yAxis.labels.datapoints.fontSize,
      axisNameFontSize: e.value.style.chart.yAxis.labels.axisNamesFontSize
    }), v = f(() => {
      const { top: t, right: l, bottom: a, left: o } = e.value.style.chart.padding, n = c.value.height, s = c.value.width;
      return {
        chartHeight: n,
        chartWidth: s,
        height: n - t - a,
        width: s - o - l,
        top: t,
        left: o,
        right: s - l,
        bottom: n - a
      };
    }), Fe = f(() => qe(e.value.customPalette)), y = h({
      dataLabels: {
        show: e.value.style.chart.yAxis.labels.datapoints.show
      },
      showTable: e.value.table.show,
      showTooltip: e.value.style.chart.tooltip.show
    }), w = h([]);
    function he(t) {
      w.value.includes(t) ? w.value = w.value.filter((l) => l !== t) : w.value.push(t);
    }
    const _ = f(() => A.dataset.map((t, l) => {
      const a = Qe(t.color) || Fe.value[l] || V[l] || V[l % V.length];
      return {
        ...t,
        series: t.series.map((o) => ({
          ...o,
          id: Z(),
          color: a
        })),
        seriesIndex: l,
        color: a,
        id: Z(),
        shape: t.shape || "circle"
      };
    })), Ne = f(() => _.value.map((t) => ({
      ...t,
      opacity: w.value.includes(t.id) ? 0.5 : 1,
      segregate: () => he(t.id),
      isSegregated: w.value.includes(t.id)
    }))), Se = f(() => ({
      cy: "pcp-div-legend",
      backgroundColor: e.value.style.chart.legend.backgroundColor,
      color: e.value.style.chart.legend.color,
      fontSize: e.value.style.chart.legend.fontSize,
      paddingBottom: 12,
      fontWeight: e.value.style.chart.legend.bold ? "bold" : ""
    })), pe = f(() => Math.max(
      ..._.value.filter((t) => !w.value.includes(t.id)).map((t) => Math.max(...t.series.flatMap((l) => l.values.length)))
    )), k = f(() => v.value.width / pe.value), X = f(() => _.value.filter((t) => !w.value.includes(t.id))), m = f(() => {
      let t = [];
      for (let l = 0; l < pe.value; l += 1) {
        const a = Math.min(...X.value.flatMap((d) => d.series.map((j) => j.values[l] || 0) || 0)), o = Math.max(...X.value.flatMap((d) => d.series.map((j) => j.values[l] || 0) || 0)), n = o === a ? a / 4 : a, s = o === a ? o * 2 : o, i = Je(n, s, e.value.style.chart.yAxis.scaleTicks), $ = i.ticks.map((d, j) => {
          const De = i.min < 0 ? d + Math.abs(i.min) : d - Math.abs(i.min), We = i.min < 0 ? i.max + Math.abs(i.min) : i.max - Math.abs(i.min);
          return {
            y: v.value.bottom - v.value.height * (De / We),
            x: v.value.left + k.value * l + k.value / 2,
            value: d
          };
        });
        t.push({
          scale: i,
          ticks: $,
          name: e.value.style.chart.yAxis.labels.axisNames[l] || `Y-${l + 1}`
        });
      }
      return t;
    }), Y = f(() => X.value.map((t, l) => ({
      ...t,
      series: t.series.map((a, o) => ({
        ...a,
        datapoints: a.values.map((n, s) => {
          const i = m.value[s].scale.min < 0 ? (n || 0) + Math.abs(m.value[s].scale.min) : (n || 0) - Math.abs(m.value[s].scale.min), $ = m.value[s].scale.min < 0 ? m.value[s].scale.max + Math.abs(m.value[s].scale.min) : m.value[s].scale.max - Math.abs(m.value[s].scale.min);
          return {
            name: a.name,
            seriesName: t.name,
            axisIndex: s,
            datapointIndex: o,
            seriesIndex: l,
            value: n || 0,
            x: v.value.left + k.value * s + k.value / 2,
            y: v.value.bottom - v.value.height * (i / $),
            comment: a.comments && a.comments[s] || ""
          };
        })
      }))
    })).map((t) => ({
      ...t,
      series: t.series.map((l) => {
        const a = Ke(l.datapoints), o = Ze(l.datapoints), n = et(e.value.style.chart.lines.smooth ? `M ${o}` : `M ${a}`);
        return {
          ...l,
          smoothPath: o,
          straightPath: a,
          pathLength: n
        };
      })
    })));
    function me({ value: t, index: l, datapoint: a }) {
      return Ae(
        e.value.style.chart.yAxis.labels.formatters[l] || null,
        t,
        _e({
          p: e.value.style.chart.yAxis.labels.prefixes[l] || "",
          v: t,
          s: e.value.style.chart.yAxis.labels.suffixes[l] || "",
          r: e.value.style.chart.yAxis.labels.roundings[l] || 0
        }),
        { datapoint: a, seriesIndex: l }
      );
    }
    const p = h(null), q = h(null), D = h(!1), Q = h("");
    function J({ shape: t, serieName: l, serie: a, relativeIndex: o, seriesIndex: n }) {
      q.value = { serie: a, relativeIndex: o, seriesIndex: n, series: _.value, scales: m.value }, D.value = !0, p.value = a.id;
      let s = "";
      const i = e.value.style.chart.tooltip.customFormat;
      $e(i) && at(() => i({
        serie: a,
        seriesIndex: a.seriesIndex,
        series: _.value,
        config: e.value,
        scales: m.value
      })) ? Q.value = i({
        serie: a,
        seriesIndex: a.seriesIndex,
        series: _.value,
        config: e.value,
        scales: m.value
      }) : (s += `<div style="width:100%;text-align:center;border-bottom:1px solid ${e.value.style.chart.tooltip.borderColor};padding-bottom:6px;margin-bottom:3px;">${l ? l + " - " : ""}${a.name}</div>`, m.value.map(($) => $.name).forEach(($, d) => {
        s += `
                <div class="vue-ui-tooltip-item" style="text-align:left">
                    <span>${$}: </span>
                    <span>
                        ${Ae(
          e.value.style.chart.yAxis.labels.formatters[d] || null,
          a.datapoints[d].value,
          _e({
            p: e.value.style.chart.yAxis.labels.prefixes[d] || "",
            v: a.datapoints[d].value,
            s: e.value.style.chart.yAxis.labels.suffixes[d] || "",
            r: e.value.style.chart.yAxis.labels.roundings[d] || ""
          }),
          { datapoint: a.datapoints[d], seriesIndex: d }
        )}    
                    </span>
                </div>
            `, e.value.style.chart.comments.showInTooltip && a.datapoints[d].comment && (s += `<div class="vue-data-ui-tooltip-comment" style="background:${a.color}20; padding: 6px; margin-bottom: 6px; border-left: 1px solid ${a.color}">${a.datapoints[d].comment}</div>`);
      }), Q.value = `<div>${s}</div>`);
    }
    function Le() {
      return _.value;
    }
    const S = f(() => {
      const t = [e.value.table.columnNames.series].concat([e.value.table.columnNames.item]).concat(m.value.map((n) => n.name)), l = Y.value.flatMap((n, s) => n.series.map((i) => [n.name].concat([i.name]).concat(i.values))), a = {
        th: {
          backgroundColor: e.value.table.th.backgroundColor,
          color: e.value.table.th.color,
          outline: e.value.table.th.outline
        },
        td: {
          backgroundColor: e.value.table.td.backgroundColor,
          color: e.value.table.td.color,
          outline: e.value.table.td.outline
        },
        breakpoint: e.value.table.responsiveBreakpoint
      }, o = [e.value.table.columnNames.series].concat([e.value.table.columnNames.item]).concat(m.value.map((n) => n.name));
      return {
        body: l,
        head: t,
        config: a,
        colNames: o
      };
    }), ye = f(() => Y.value.length === 0 ? { head: [], body: [], config: {}, columnNames: [] } : {
      head: S.value.head,
      body: S.value.body
    });
    function fe() {
      const t = [[e.value.style.chart.title.text], [e.value.style.chart.title.subtitle.text], [""]], l = ye.value.head, a = ye.value.body, o = t.concat([l]).concat(a), n = lt(o);
      ot({ csvContent: n, title: e.value.style.chart.title.text || "vue-ui-parallel-coordinate-plot" });
    }
    function Oe(t) {
      ee("selectDatapoint", t);
    }
    function ge(t) {
      ee("selectLegend", {
        ...t,
        isSegregated: !t.isSegregated,
        opacity: t.isSegregated ? 1 : 0.5
      });
    }
    function be() {
      y.value.showTable = !y.value.showTable;
    }
    function xe() {
      y.value.dataLabels.show = !y.value.dataLabels.show;
    }
    function ke() {
      y.value.showTooltip = !y.value.showTooltip;
    }
    const R = h(!1);
    function K() {
      R.value = !R.value;
    }
    return Me({
      getData: Le,
      generateCsv: fe,
      generatePdf: ve,
      generateImage: de,
      toggleTable: be,
      toggleLabels: xe,
      toggleTooltip: ke,
      toggleAnnotator: K
    }), (t, l) => (u(), r("div", {
      ref_key: "pcpChart",
      ref: N,
      class: U(`vue-ui-pcp ${O.value ? "vue-data-ui-wrapper-fullscreen" : ""} ${e.value.useCssAnimation ? "" : "vue-ui-dna"}`),
      style: T(`font-family:${e.value.style.fontFamily};width:100%; text-align:center;${e.value.style.chart.title.text ? "" : "padding-top:36px"};background:${e.value.style.chart.backgroundColor};${e.value.responsive ? "height:100%" : ""}`),
      id: `pcp_${H.value}`
    }, [
      e.value.userOptions.buttons.annotator ? (u(), z(ft, {
        key: 0,
        parent: N.value,
        backgroundColor: e.value.style.chart.backgroundColor,
        color: e.value.style.chart.color,
        active: R.value,
        onClose: K
      }, null, 8, ["parent", "backgroundColor", "color", "active"])) : g("", !0),
      e.value.style.chart.title.text ? (u(), r("div", {
        key: 1,
        ref_key: "chartTitle",
        ref: ae,
        style: "width:100%;background:transparent;padding-bottom:24px"
      }, [
        (u(), z(ut, {
          key: `title_${oe.value}`,
          config: {
            title: {
              cy: "pcp-div-title",
              ...e.value.style.chart.title
            },
            subtitle: {
              cy: "pcp-div-subtitle",
              ...e.value.style.chart.title.subtitle
            }
          }
        }, null, 8, ["config"]))
      ], 512)) : g("", !0),
      e.value.userOptions.show && F.value ? (u(), z(dt, {
        ref: "details",
        key: `user_options_${te.value}`,
        backgroundColor: e.value.style.chart.backgroundColor,
        color: e.value.style.chart.color,
        isPrinting: M(ie),
        isImaging: M(ce),
        uid: H.value,
        hasTooltip: e.value.userOptions.buttons.tooltip && e.value.style.chart.tooltip.show,
        hasPdf: e.value.userOptions.buttons.pdf,
        hasXls: e.value.userOptions.buttons.csv,
        hasImg: e.value.userOptions.buttons.img,
        hasTable: e.value.userOptions.buttons.table,
        hasLabel: e.value.userOptions.buttons.labels,
        hasFullscreen: e.value.userOptions.buttons.fullscreen,
        isFullscreen: O.value,
        isTooltip: y.value.showTooltip,
        titles: { ...e.value.userOptions.buttonTitles },
        chartElement: N.value,
        position: e.value.userOptions.position,
        hasAnnotator: e.value.userOptions.buttons.annotator,
        isAnnotation: R.value,
        onToggleFullscreen: Pe,
        onGeneratePdf: M(ve),
        onGenerateCsv: fe,
        onGenerateImage: M(de),
        onToggleTable: be,
        onToggleLabels: xe,
        onToggleTooltip: ke,
        onToggleAnnotator: K
      }, je({ _: 2 }, [
        t.$slots.optionPdf ? {
          name: "optionPdf",
          fn: b(() => [
            x(t.$slots, "optionPdf", {}, void 0, !0)
          ]),
          key: "0"
        } : void 0,
        t.$slots.optionCsv ? {
          name: "optionCsv",
          fn: b(() => [
            x(t.$slots, "optionCsv", {}, void 0, !0)
          ]),
          key: "1"
        } : void 0,
        t.$slots.optionImg ? {
          name: "optionImg",
          fn: b(() => [
            x(t.$slots, "optionImg", {}, void 0, !0)
          ]),
          key: "2"
        } : void 0,
        t.$slots.optionTable ? {
          name: "optionTable",
          fn: b(() => [
            x(t.$slots, "optionTable", {}, void 0, !0)
          ]),
          key: "3"
        } : void 0,
        t.$slots.optionLabels ? {
          name: "optionLabels",
          fn: b(() => [
            x(t.$slots, "optionLabels", {}, void 0, !0)
          ]),
          key: "4"
        } : void 0,
        t.$slots.optionFullscreen ? {
          name: "optionFullscreen",
          fn: b(({ toggleFullscreen: a, isFullscreen: o }) => [
            x(t.$slots, "optionFullscreen", W(E({ toggleFullscreen: a, isFullscreen: o })), void 0, !0)
          ]),
          key: "5"
        } : void 0,
        t.$slots.optionAnnotator ? {
          name: "optionAnnotator",
          fn: b(({ toggleAnnotator: a, isAnnotator: o }) => [
            x(t.$slots, "optionAnnotator", W(E({ toggleAnnotator: a, isAnnotator: o })), void 0, !0)
          ]),
          key: "6"
        } : void 0
      ]), 1032, ["backgroundColor", "color", "isPrinting", "isImaging", "uid", "hasTooltip", "hasPdf", "hasXls", "hasImg", "hasTable", "hasLabel", "hasFullscreen", "isFullscreen", "isTooltip", "titles", "chartElement", "position", "hasAnnotator", "isAnnotation", "onGeneratePdf", "onGenerateImage"])) : g("", !0),
      F.value ? (u(), r("svg", {
        key: 3,
        xmlns: M(tt),
        class: U({ "vue-data-ui-fullscreen--on": O.value, "vue-data-ui-fulscreen--off": !O.value }),
        viewBox: `0 0 ${v.value.chartWidth <= 0 ? 10 : v.value.chartWidth} ${v.value.chartHeight <= 0 ? 10 : v.value.chartHeight}`,
        style: T(`max-width:100%; overflow: visible; background:transparent;color:${e.value.style.chart.color}`)
      }, [
        Ce(yt),
        (u(!0), r(C, null, I(m.value, (a, o) => (u(), r("g", kt, [
          P("line", {
            x1: v.value.left + k.value * o + k.value / 2,
            x2: v.value.left + k.value * o + k.value / 2,
            y1: v.value.top,
            y2: v.value.bottom,
            stroke: e.value.style.chart.yAxis.stroke,
            "stroke-width": e.value.style.chart.yAxis.strokeWidth
          }, null, 8, Ct),
          P("text", {
            x: v.value.left + k.value * o + k.value / 2,
            y: v.value.top - 24,
            fill: e.value.style.chart.yAxis.labels.axisNamesColor,
            "font-size": c.value.axisNameFontSize,
            "font-weight": e.value.style.chart.yAxis.labels.axisNamesBold ? "bold" : "",
            "text-anchor": "middle"
          }, L(a.name), 9, wt),
          e.value.style.chart.yAxis.labels.ticks.show ? (u(), r(C, { key: 0 }, [
            (u(!0), r(C, null, I(a.ticks, (n) => (u(), r("line", {
              x1: n.x,
              x2: n.x - 10,
              y1: n.y,
              y2: n.y,
              stroke: e.value.style.chart.yAxis.stroke,
              "stroke-width": e.value.style.chart.yAxis.strokeWidth,
              style: T(`opacity:${p.value && !y.value.showTooltip ? 0.2 : 1}`)
            }, null, 12, $t))), 256)),
            (u(!0), r(C, null, I(a.ticks, (n) => (u(), r("text", {
              x: n.x - 12 + e.value.style.chart.yAxis.labels.ticks.offsetX,
              y: n.y + e.value.style.chart.yAxis.labels.ticks.offsetY + c.value.ticksFontSize / 3,
              fill: e.value.style.chart.yAxis.labels.ticks.color,
              "text-anchor": "end",
              "font-size": c.value.ticksFontSize,
              "font-weight": e.value.style.chart.yAxis.labels.ticks.bold ? "bold" : "normal",
              style: T(`opacity:${p.value && !y.value.showTooltip ? 0.2 : 1}`)
            }, L(me({ value: n.value, index: o, datapoint: n })), 13, At))), 256))
          ], 64)) : g("", !0)
        ]))), 256)),
        (u(!0), r(C, null, I(Y.value, (a) => (u(), r("g", null, [
          (u(!0), r(C, null, I(a.series, (o, n) => (u(), r("g", null, [
            e.value.style.chart.plots.show ? (u(), r("g", _t, [
              (u(!0), r(C, null, I(o.datapoints, (s) => (u(), z(ct, {
                plot: { x: s.x, y: s.y },
                color: a.color,
                shape: a.shape,
                radius: a.shape === "triangle" ? c.value.plotSize * 1.2 : c.value.plotSize,
                stroke: e.value.style.chart.backgroundColor,
                strokeWidth: 0.5,
                onMouseenter: (i) => J({
                  shape: a.shape,
                  serieName: a.name,
                  serie: o,
                  relativeIndex: n,
                  seriesIndex: o.seriesIndex
                }),
                onMouseleave: l[0] || (l[0] = (i) => {
                  p.value = null, D.value = !1;
                }),
                style: T(`opacity:${p.value ? p.value === o.id ? e.value.style.chart.plots.opacity : 0.2 : e.value.style.chart.plots.opacity}`),
                onClick: () => Oe(s)
              }, null, 8, ["plot", "color", "shape", "radius", "stroke", "onMouseenter", "style", "onClick"]))), 256)),
              y.value.showTooltip ? g("", !0) : (u(), r(C, { key: 0 }, [
                p.value && p.value === o.id && o.datapoints.length ? (u(), r("text", {
                  key: 0,
                  x: o.datapoints[0].x - c.value.ticksFontSize,
                  y: o.datapoints[0].y + c.value.ticksFontSize / 3,
                  "text-anchor": "end",
                  "font-size": c.value.ticksFontSize,
                  fill: a.color,
                  "font-weight": "bold"
                }, L(o.name), 9, Tt)) : g("", !0)
              ], 64)),
              e.value.style.chart.comments.show ? (u(!0), r(C, { key: 1 }, I(o.datapoints, (s) => (u(), r("g", null, [
                s.comment ? (u(), r("foreignObject", {
                  key: 0,
                  style: { overflow: "visible" },
                  height: "12",
                  width: e.value.style.chart.comments.width,
                  x: s.x - e.value.style.chart.comments.width / 2 + e.value.style.chart.comments.offsetX,
                  y: s.y + e.value.style.chart.comments.offsetY + 6
                }, [
                  P("div", Mt, [
                    x(t.$slots, "plot-comment", {
                      plot: { ...s, color: a.color }
                    }, void 0, !0)
                  ])
                ], 8, zt)) : g("", !0)
              ]))), 256)) : g("", !0)
            ])) : g("", !0),
            y.value.dataLabels.show || p.value && p.value === o.id ? (u(!0), r(C, { key: 1 }, I(o.datapoints, (s, i) => (u(), r("text", {
              x: s.x + 12 + e.value.style.chart.yAxis.labels.datapoints.offsetX,
              y: s.y + e.value.style.chart.yAxis.labels.datapoints.offsetY + c.value.datapointFontSize / 3,
              fill: e.value.style.chart.yAxis.labels.datapoints.useSerieColor ? a.color : e.value.style.chart.yAxis.labels.datapoints.color,
              "text-anchor": "start",
              "font-weight": e.value.style.chart.yAxis.labels.datapoints.bold ? "bold" : "normal",
              class: U({ "vue-ui-pcp-animated": !1, "vue-ui-pcp-transition": !0 }),
              "font-size": c.value.datapointFontSize,
              onMouseenter: ($) => J({
                shape: a.shape,
                serieName: a.name,
                serie: o,
                relativeIndex: n,
                seriesIndex: o.seriesIndex
              }),
              onMouseleave: l[1] || (l[1] = ($) => {
                p.value = null, D.value = !1;
              }),
              style: T(`opacity:${p.value ? p.value === o.id ? 1 : 0.2 : 1}`)
            }, L(me({ value: s.value, index: i, datapoint: s })), 45, It))), 256)) : g("", !0),
            P("path", {
              d: `M${e.value.style.chart.lines.smooth ? o.smoothPath : o.straightPath}`,
              stroke: a.color,
              "stroke-width": e.value.style.chart.lines.strokeWidth,
              fill: "none",
              class: U({ "vue-ui-pcp-animated vue-data-ui-line-animated": e.value.useCssAnimation, "vue-ui-pcp-transition": !0 }),
              onMouseenter: (s) => J({
                shape: a.shape,
                serieName: a.name,
                serie: o,
                relativeIndex: n,
                seriesIndex: o.seriesIndex
              }),
              onMouseleave: l[2] || (l[2] = (s) => {
                p.value = null, D.value = !1;
              }),
              style: T(`opacity:${p.value ? p.value === o.id ? e.value.style.chart.lines.opacity : 0.2 : e.value.style.chart.lines.opacity}; stroke-dasharray:${o.pathLength}; stroke-dashoffset: ${e.value.useCssAnimation ? o.pathLength : 0}`)
            }, null, 46, Pt)
          ]))), 256))
        ]))), 256)),
        x(t.$slots, "svg", { svg: v.value }, void 0, !0)
      ], 14, xt)) : g("", !0),
      t.$slots.watermark ? (u(), r("div", Ft, [
        x(t.$slots, "watermark", W(E({ isPrinting: M(ie) || M(ce) })), void 0, !0)
      ])) : g("", !0),
      F.value ? g("", !0) : (u(), z(mt, {
        key: 5,
        config: {
          type: "parallelCoordinatePlot",
          style: {
            backgroundColor: e.value.style.chart.backgroundColor
          }
        }
      }, null, 8, ["config"])),
      P("div", {
        ref_key: "chartLegend",
        ref: le
      }, [
        e.value.style.chart.legend.show && F.value ? (u(), z(rt, {
          key: `legend_${se.value}`,
          legendSet: Ne.value,
          config: Se.value,
          onClickMarker: l[3] || (l[3] = ({ legend: a }) => {
            he(a.id), ge(a);
          })
        }, {
          item: b(({ legend: a, index: o }) => [
            P("div", {
              onClick: (n) => {
                a.segregate(), ge(a);
              },
              style: T(`opacity:${w.value.includes(a.id) ? 0.5 : 1}`)
            }, L(a.name), 13, Nt)
          ]),
          _: 1
        }, 8, ["legendSet", "config"])) : x(t.$slots, "legend", {
          key: 1,
          legend: _.value
        }, void 0, !0)
      ], 512),
      Ce(it, {
        show: y.value.showTooltip && D.value,
        backgroundColor: e.value.style.chart.tooltip.backgroundColor,
        color: e.value.style.chart.tooltip.color,
        fontSize: e.value.style.chart.tooltip.fontSize,
        borderRadius: e.value.style.chart.tooltip.borderRadius,
        borderColor: e.value.style.chart.tooltip.borderColor,
        borderWidth: e.value.style.chart.tooltip.borderWidth,
        backgroundOpacity: e.value.style.chart.tooltip.backgroundOpacity,
        position: e.value.style.chart.tooltip.position,
        offsetY: e.value.style.chart.tooltip.offsetY,
        parent: N.value,
        content: Q.value,
        isCustom: M($e)(e.value.style.chart.tooltip.customFormat)
      }, {
        "tooltip-before": b(() => [
          x(t.$slots, "tooltip-before", W(E({ ...q.value })), void 0, !0)
        ]),
        "tooltip-after": b(() => [
          x(t.$slots, "tooltip-after", W(E({ ...q.value })), void 0, !0)
        ]),
        _: 3
      }, 8, ["show", "backgroundColor", "color", "fontSize", "borderRadius", "borderColor", "borderWidth", "backgroundOpacity", "position", "offsetY", "parent", "content", "isCustom"]),
      F.value ? (u(), z(pt, {
        key: 6,
        hideDetails: "",
        config: {
          open: y.value.showTable,
          maxHeight: 1e4,
          body: {
            backgroundColor: e.value.style.chart.backgroundColor,
            color: e.value.style.chart.color
          },
          head: {
            backgroundColor: e.value.style.chart.backgroundColor,
            color: e.value.style.chart.color
          }
        }
      }, {
        content: b(() => [
          (u(), z(ht, {
            key: `table_${ne.value}`,
            colNames: S.value.colNames,
            head: S.value.head,
            body: S.value.body,
            config: S.value.config,
            title: `${e.value.style.chart.title.text}${e.value.style.chart.title.subtitle.text ? ` : ${e.value.style.chart.title.subtitle.text}` : ""}`,
            onClose: l[4] || (l[4] = (a) => y.value.showTable = !1)
          }, {
            th: b(({ th: a }) => [
              P("div", { innerHTML: a }, null, 8, St)
            ]),
            td: b(({ td: a }) => [
              Ue(L(a), 1)
            ]),
            _: 1
          }, 8, ["colNames", "head", "body", "config", "title"]))
        ]),
        _: 1
      }, 8, ["config"])) : g("", !0)
    ], 14, bt));
  }
}, Jt = /* @__PURE__ */ gt(Lt, [["__scopeId", "data-v-5f0cc747"]]);
export {
  Jt as default
};
