import { ref as P, computed as V, watch as Ee, onMounted as vt, onBeforeUnmount as dt, openBlock as a, createElementBlock as l, normalizeClass as ne, normalizeStyle as N, createBlock as Le, createCommentVNode as m, unref as f, createSlots as ct, withCtx as Q, renderSlot as U, normalizeProps as H, guardReactiveProps as re, toDisplayString as E, createVNode as se, createElementVNode as A, Fragment as p, renderList as L, mergeProps as Re, pushScopeId as ht, popScopeId as ft } from "vue";
import { u as gt, c as mt, t as pt, a as xt, p as D, b as yt, I as kt, e as bt, d as Oe, m as St, C as Ze, X as wt, j as At, k as pe, n as Ne, i as X, f as M, R as Ye, v as Z, x as ze, y as Fe } from "./index-DnVHQ2xI.js";
import { t as _t, u as Lt } from "./useResponsive-NZB-WLRF.js";
import $e from "./BaseIcon-rRli6Sfv.js";
import { _ as zt } from "./Tooltip-Cj4EF7v1.js";
import { u as $t, U as Ct } from "./usePrinter-BEeNAqS5.js";
import { S as Pt } from "./Slicer-CU7dRZR0.js";
import Tt from "./vue-ui-skeleton-aZmkNzAe.js";
import { u as Je } from "./useNestedProp-Cox0K0Y5.js";
import { _ as It } from "./PackageVersion-CvCRsT5_.js";
import { P as Et } from "./PenAndPaper-Jb0pLt3G.js";
import { _ as Rt } from "./_plugin-vue_export-helper-CHgC5LLL.js";
const _ = {
  LINE: "LINE",
  BAR: "BAR",
  DONUT: "DONUT"
}, Ot = ["SERIE", "SERIES", "DATA", "VALUE", "VALUES", "NUM"];
function Nt({ dataset: s, barLineSwitch: $ = 6 }) {
  let g = null, R = null, q = 0;
  if ((typeof s == "number" || typeof s == "string") && console.warn(`The provided dataset (${s}) is not sufficient to build a chart`), xe(s) && (Y(s) && (s.length < $ ? g = _.BAR : g = _.LINE, R = s, q = s.length), Ce(s))) {
    if (!Mt(s))
      return console.warn("The objects in the dataset array have a different data structure. Either keys or value types are different."), !1;
    const oe = Object.keys(s[0]), ve = Object.values(s[0]);
    if (!oe.some((T) => Bt(T)))
      return console.warn("The data type of the dataset objects in the array must contain one of the following keys: DATA, SERIES, VALUE, VALUES, NUM. Casing is not important."), !1;
    Qe(ve, (T) => typeof T == "number") && (g = _.DONUT, R = s), Qe(ve, (T) => Array.isArray(T) && Y(T)) && (Ke(s) > $ ? g = _.LINE : g = _.BAR, q = Ke(s), R = s.map((T) => ({
      ...T,
      data: Ut(T, (G) => Y(G))
    }))), s = s.map((T) => et(T)), R = R.map((T) => et(T));
  }
  return xe(s) && [...new Set(s.flatMap((oe) => Array.isArray(oe)))][0], {
    dataset: s,
    type: g,
    usableDataset: R,
    maxSeriesLength: q
  };
}
function tt(s) {
  return !s || xe(s) && !s.length;
}
function xe(s) {
  return Array.isArray(s);
}
function Y(s) {
  if (!xe(s) || tt(s)) return !1;
  const $ = s.map((g) => Number(g));
  return ![...new Set($.flatMap((g) => typeof g == "number" && !isNaN(g)))].includes(!1);
}
function Ce(s) {
  return !xe(s) || tt(s) || !![...new Set(s.flatMap((g) => typeof g == "object" && !Array.isArray(g)))].includes(!1) ? !1 : !s.map((g) => Object.keys(g).length > 0).includes(!1);
}
function Ft(s, $) {
  const g = Object.keys(s).sort(), R = Object.keys($).sort();
  if (g.length !== R.length)
    return !1;
  for (let q = 0; q < g.length; q += 1) {
    const W = g[q], le = R[q];
    if (W !== le || typeof s[W] != typeof $[le])
      return !1;
  }
  return !0;
}
function Mt(s) {
  if (s.length <= 1) return !0;
  for (let $ = 0; $ < s.length; $ += 1)
    for (let g = $ + 1; g < s.length; g += 1)
      if (!Ft(s[$], s[g]))
        return !1;
  return !0;
}
function Bt(s) {
  return Ot.includes(s.toUpperCase());
}
function Qe(s, $) {
  let g = [];
  for (let R = 0; R < s.length; R += 1)
    g.push($(s[R]));
  return g.includes(!0);
}
function Ke(s) {
  return Math.max(...[...s].flatMap(($) => Object.values($).filter((g) => Y(g)).map((g) => g.length)));
}
function Ut(s, $) {
  return Object.values(s).filter((g) => $(g))[0];
}
function et(s) {
  const $ = {};
  for (let g in s)
    s.hasOwnProperty(g) && ($[g.toUpperCase()] = s[g]);
  return $;
}
const at = (s) => (ht("data-v-e73a7249"), s = s(), ft(), s), Dt = ["id"], Vt = ["xmlns", "viewBox"], qt = ["id"], Wt = ["id"], jt = /* @__PURE__ */ at(() => /* @__PURE__ */ A("feColorMatrix", {
  type: "saturate",
  values: "0"
}, null, -1)), Gt = ["id"], Ht = ["flood-color"], Xt = {
  key: 0,
  class: "donut-label-connectors"
}, Zt = ["d", "stroke", "stroke-width", "filter"], Yt = ["cx", "cy", "r", "fill", "filter"], Jt = { class: "donut" }, Qt = ["d", "fill", "stroke", "stroke-width", "filter"], Kt = ["d", "onMouseenter", "onClick"], ea = {
  key: 1,
  class: "donut-labels quick-animation"
}, ta = ["cx", "cy", "fill", "stroke", "filter"], aa = ["text-anchor", "x", "y", "fill", "font-size", "filter"], la = ["text-anchor", "x", "y", "fill", "font-size", "filter"], oa = {
  key: 2,
  class: "donut-hollow quick-animation"
}, ia = ["x", "y", "font-size", "fill"], ua = ["x", "y", "font-size", "fill"], na = {
  key: 0,
  class: "line-grid"
}, ra = ["x1", "x2", "y1", "y2", "stroke", "stroke-width"], sa = ["x1", "x2", "y1", "y2", "stroke", "stroke-width"], va = {
  key: 1,
  class: "line-axis"
}, da = ["x1", "x2", "y1", "y2", "stroke", "stroke-width"], ca = ["x1", "x2", "y1", "y2", "stroke", "stroke-width"], ha = {
  key: 2,
  class: "yLabels"
}, fa = ["x1", "x2", "y1", "y2", "stroke", "stroke-width"], ga = ["x", "y", "font-size", "fill"], ma = {
  key: 3,
  class: "periodLabels"
}, pa = ["x1", "x2", "y1", "y2", "stroke", "stroke-width"], xa = ["font-size", "text-anchor", "fill", "transform"], ya = { class: "plots" }, ka = { class: "line-plot-series" }, ba = ["d", "stroke", "stroke-width"], Sa = ["d", "stroke", "stroke-width"], wa = ["d", "stroke", "stroke-width"], Aa = ["d", "stroke", "stroke-width"], _a = ["cx", "cy", "fill", "stroke"], La = {
  key: 4,
  class: "dataLabels"
}, za = ["font-size", "fill", "x", "y"], $a = { class: "tooltip-traps" }, Ca = ["x", "y", "height", "width", "fill", "onMouseenter", "onClick"], Pa = {
  key: 0,
  class: "line-grid"
}, Ta = ["x1", "x2", "y1", "y2", "stroke", "stroke-width"], Ia = ["x1", "x2", "y1", "y2", "stroke", "stroke-width"], Ea = {
  key: 1,
  class: "line-axis"
}, Ra = ["x1", "x2", "y1", "y2", "stroke", "stroke-width"], Oa = ["x1", "x2", "y1", "y2", "stroke", "stroke-width"], Na = {
  key: 2,
  class: "yLabels"
}, Fa = ["x1", "x2", "y1", "y2", "stroke", "stroke-width"], Ma = ["x", "y", "font-size", "fill"], Ba = {
  key: 3,
  class: "periodLabels"
}, Ua = ["x1", "x2", "y1", "y2", "stroke", "stroke-width"], Da = ["font-size", "text-anchor", "transform", "fill"], Va = { class: "plots" }, qa = ["x", "width", "height", "y", "fill", "stroke", "stroke-width"], Wa = ["to"], ja = ["from", "to"], Ga = {
  key: 4,
  class: "dataLabels"
}, Ha = ["x", "y", "font-size", "fill"], Xa = { class: "tooltip-traps" }, Za = ["x", "y", "height", "width", "fill", "onMouseenter", "onClick"], Ya = {
  key: 3,
  class: "axis-labels"
}, Ja = { key: 0 }, Qa = ["font-size", "fill", "x", "y"], Ka = { key: 1 }, el = ["font-size", "fill", "x", "y"], tl = { key: 2 }, al = ["font-size", "fill", "transform"], ll = { key: 3 }, ol = ["font-size", "fill", "transform"], il = {
  key: 5,
  class: "vue-data-ui-watermark"
}, ul = ["onClick"], nl = ["onClick"], rl = ["onClick"], sl = {
  key: 1,
  class: "vue-ui-quick-chart-not-processable"
}, vl = /* @__PURE__ */ at(() => /* @__PURE__ */ A("span", null, "Dataset is not processable", -1)), dl = {
  __name: "vue-ui-quick-chart",
  props: {
    config: {
      type: Object,
      default() {
        return {};
      }
    },
    dataset: {
      type: [Array, Object, String, Number],
      default() {
        return null;
      }
    }
  },
  emits: ["selectDatapoint", "selectLegend"],
  setup(s, { expose: $, emit: g }) {
    const R = s, { vue_ui_quick_chart: q } = gt(), W = P(null), le = P(null), oe = P(null), ve = P(null), T = P(mt()), G = P(!1), de = P(null), K = P(""), j = P(null), w = P([]), Me = P(0), ye = P(0), e = V({
      get: () => Be(),
      set: (u) => u
    });
    function Be() {
      const u = Je({
        userConfig: R.config,
        defaultConfig: q
      });
      return u.theme ? {
        ...Je({
          userConfig: pt.vue_ui_quick_chart[u.theme] || R.config,
          defaultConfig: u
        }),
        customPalette: xt[u.theme] || D
      } : u;
    }
    Ee(() => R.config, (u) => {
      e.value = Be(), S.value.width = e.value.width, S.value.height = e.value.height, Ve();
    }, { deep: !0 }), Ee(() => R.dataset, (u) => {
      y.value = he.value, k.value.start = 0, k.value.end = y.value.maxSeriesLength, ye.value += 1;
    }, { deep: !0 });
    const ce = V(() => yt(e.value.customPalette)), he = V(() => {
      const u = Nt({ dataset: kt(R.dataset, [
        "serie",
        "series",
        "data",
        "value",
        "values",
        "num"
      ]), barLineSwitch: e.value.chartIsBarUnderDatasetLength });
      return u || console.error("VueUiQuickChart : Dataset is not processable"), u;
    }), y = P(he.value), lt = V(() => !!y.value), z = V(() => y.value ? y.value.type : null);
    Ee(() => z.value, (u) => {
      u || bt({
        componentName: "VueUiQuickChart",
        type: "dataset"
      });
    }, { immediate: !0 });
    const { isPrinting: ke, isImaging: be, generatePdf: Ue, generateImage: De } = $t({
      elementId: `${z.value}_${T.value}`,
      fileName: e.value.title || z.value
    }), S = P({
      width: e.value.width,
      height: e.value.height
    }), Se = P({
      showTooltip: e.value.showTooltip
    }), we = P(null);
    vt(() => {
      Ve();
    });
    function Ve() {
      if (e.value.responsive) {
        const u = _t(() => {
          const { width: c, height: t } = Lt({
            chart: W.value,
            title: e.value.title ? le.value : null,
            legend: e.value.showLegend ? oe.value : null,
            slicer: [_.BAR, _.LINE].includes(z.value) && e.value.zoomXy && y.value.maxSeriesLength > 1 ? ve.value : null
          });
          S.value.width = c, S.value.height = t;
        });
        we.value = new ResizeObserver(u), we.value.observe(W.value.parentNode);
      }
    }
    dt(() => {
      we.value && we.value.disconnect();
    });
    const ot = V(() => {
      switch (z.value) {
        case _.LINE:
          return `0 0 ${S.value.width <= 0 ? 10 : S.value.width} ${S.value.height <= 0 ? 10 : S.value.height}`;
        case _.BAR:
          return `0 0 ${S.value.width <= 0 ? 10 : S.value.width} ${S.value.height <= 0 ? 10 : S.value.height}`;
        case _.DONUT:
          return `0 0 ${S.value.width <= 0 ? 10 : S.value.width} ${S.value.height <= 0 ? 10 : S.value.height}`;
        default:
          return `0 0 ${S.value.width <= 0 ? 10 : S.value.width} ${S.value.height <= 0 ? 10 : S.value.height}`;
      }
    });
    function qe(u) {
      return [...u].map((c) => c.value).reduce((c, t) => c + t, 0);
    }
    function fe(u) {
      return e.value.blurOnHover && ![null, void 0].includes(j.value) && j.value !== u ? `url(#blur_${T.value})` : "";
    }
    function We(u, c) {
      w.value.includes(u) ? w.value = w.value.filter((t) => t !== u) : w.value.length < c && w.value.push(u);
    }
    const je = P(null), Ge = P(null), Ae = P(!1);
    function it(u, c) {
      Ae.value = !0;
      let t = u.value;
      if (w.value.includes(u.id)) {
        let r = function() {
          t > n ? (Ae.value = !1, cancelAnimationFrame(Ge.value), y.value = {
            ...y.value,
            dataset: y.value.dataset.map((h, O) => u.id === `donut_${O}` ? {
              ...h,
              value: n,
              VALUE: n
            } : h)
          }) : (t += n * 0.025, y.value = {
            ...y.value,
            dataset: y.value.dataset.map((h, O) => u.id === `donut_${O}` ? {
              ...h,
              value: t,
              VALUE: t
            } : h)
          }, Ge.value = requestAnimationFrame(r));
        };
        w.value = w.value.filter((h) => h !== u.id);
        const n = he.value.dataset.find((h, O) => u.id === `donut_${O}`).VALUE;
        r();
      } else if (c.length > 1) {
        let n = function() {
          t < 0.1 ? (Ae.value = !1, cancelAnimationFrame(je.value), w.value.push(u.id), y.value = {
            ...y.value,
            dataset: y.value.dataset.map((r, h) => u.id === `donut_${h}` ? {
              ...r,
              value: 0,
              VALUE: 0
            } : r)
          }) : (t /= 1.1, y.value = {
            ...y.value,
            dataset: y.value.dataset.map((r, h) => u.id === `donut_${h}` ? {
              ...r,
              value: t,
              VALUE: t
            } : r)
          }, je.value = requestAnimationFrame(n));
        };
        n();
      }
    }
    const J = P(null);
    function ut(u) {
      J.value = u;
    }
    const He = V(() => e.value.donutThicknessRatio < 0.15 ? 0.15 : e.value.donutThicknessRatio > 0.4 ? 0.4 : e.value.donutThicknessRatio), C = V(() => {
      if (z.value !== _.DONUT) return null;
      const u = y.value.dataset.map((o, i) => ({
        ...o,
        value: o.VALUE || o.DATA || o.SERIE || o.VALUES || o.NUM || 0,
        name: o.NAME || o.DESCRIPTION || o.TITLE || o.LABEL || `Serie ${i}`,
        id: `donut_${i}`
      })).map((o, i) => ({
        ...o,
        color: o.COLOR ? Oe(o.COLOR) : ce.value[i + e.value.paletteStartIndex] || D[i + e.value.paletteStartIndex] || D[(i + e.value.paletteStartIndex) % D.length],
        immutableValue: o.value
      }));
      function c(o, i) {
        return M({
          v: isNaN(o.value / qe(i)) ? 0 : o.value / qe(i) * 100,
          s: "%",
          r: e.value.dataLabelRoundingPercentage
        });
      }
      function t(o) {
        return o.proportion * 100 > e.value.donutHideLabelUnderPercentage;
      }
      function n(o, i) {
        const b = he.value.dataset.find((I, F) => `donut_${F}` === o).VALUE;
        return Math.abs(String(Number(b.toFixed(0))).length - String(Number(i.toFixed(0))).length);
      }
      function r({ datapoint: o, seriesIndex: i }) {
        de.value = { datapoint: o, seriesIndex: i, config: e.value, dataset: u }, j.value = o.id;
        const b = e.value.tooltipCustomFormat;
        if (ze(b) && Fe(() => b({
          datapoint: o,
          seriesIndex: i,
          series: u,
          config: e.value
        })))
          K.value = b({
            datapoint: o,
            seriesIndex: i,
            series: u,
            config: e.value
          });
        else {
          let x = "";
          x += `<div style="width:100%;text-align:center;border-bottom:1px solid ${e.value.tooltipBorderColor};padding-bottom:6px;margin-bottom:3px;">${o.name}</div>`, x += `<div style="display:flex;flex-direction:row;gap:6px;align-items:center;"><svg viewBox="0 0 12 12" height="14" width="14"><circle cx="6" cy="6" r="6" stroke="none" fill="${o.color}"/></svg>`, x += `<b>${X(
            e.value.formatter,
            o.value,
            M({
              p: e.value.valuePrefix,
              v: o.value,
              s: e.value.valueSuffix,
              r: e.value.dataLabelRoundingValue
            }),
            { datapoint: o, seriesIndex: i }
          )}</b>`, x += `<span>(${M({ v: o.proportion * 100, s: "%", r: e.value.dataLabelRoundingPercentage })})</span></div>`, K.value = `<div>${x}</div>`;
        }
        G.value = !0;
      }
      function h() {
        G.value = !1, j.value = null, J.value = null;
      }
      const O = {
        centerX: S.value.width / 2,
        centerY: S.value.height / 2
      }, B = u.filter((o) => !w.value.includes(o.id)).map((o) => o.value || 0).reduce((o, i) => o + i, 0), ie = u.map((o, i) => ({
        ...o,
        proportion: (o.value || 0) / B,
        value: o.value || 0,
        absoluteValue: he.value.dataset.find((b, x) => `donut_${x}` === o.id).VALUE
      })), ee = S.value.width / 2, ue = S.value.height / 2, te = S.value.height * e.value.donutRadiusRatio;
      return {
        dataset: ie.filter((o) => !w.value.includes(o.id)),
        legend: ie,
        drawingArea: O,
        displayArcPercentage: c,
        isArcBigEnough: t,
        useTooltip: r,
        killTooltip: h,
        getSpaces: n,
        total: B,
        cx: ee,
        cy: ue,
        radius: te,
        chart: St(
          { series: u.filter((o) => !w.value.includes(o.id)) },
          ee,
          ue,
          te,
          te,
          1.99999,
          2,
          1,
          360,
          105.25,
          S.value.height * He.value
        )
      };
    }), k = P({
      start: 0,
      end: y.value.maxSeriesLength
    });
    function nt() {
      k.value = {
        start: 0,
        end: y.value.maxSeriesLength
      }, ye.value += 1;
    }
    const rt = V(() => {
      if (!e.value.zoomMinimap.show || z.value === _.DONUT) return [];
      let u = [];
      Y(y.value.dataset) && (u = y.value.dataset), Ce(y.value.dataset) && (u = y.value.dataset.map((r, h) => ({
        values: r.VALUE || r.DATA || r.SERIE || r.SERIES || r.VALUES || r.NUM || 0,
        id: z.value === _.LINE ? `line_${h}` : `bar_${h}`
      })).filter((r) => !w.value.includes(r.id)));
      const c = Y(u) ? u.length : Math.max(...u.map((r) => r.values.length));
      let t = [];
      if (Y(u))
        t = u;
      else
        for (let r = 0; r < c; r += 1)
          t.push(u.map((h) => h.values[r] || 0).reduce((h, O) => (h || 0) + (O || 0), 0));
      const n = Math.min(...t);
      return t.map((r) => r + (n < 0 ? Math.abs(n) : 0));
    }), d = V(() => {
      if (z.value !== _.LINE) return null;
      const u = {
        height: S.value.height,
        width: S.value.width
      }, c = {
        left: e.value.xyPaddingLeft,
        top: e.value.xyPaddingTop,
        right: u.width - e.value.xyPaddingRight,
        bottom: u.height - e.value.xyPaddingBottom,
        width: u.width - e.value.xyPaddingLeft - e.value.xyPaddingRight,
        height: u.height - e.value.xyPaddingTop - e.value.xyPaddingBottom
      };
      let t = [];
      Y(y.value.dataset) && (t = [
        {
          values: y.value.dataset.slice(k.value.start, k.value.end),
          absoluteIndices: y.value.dataset.map((o, i) => i).slice(k.value.start, k.value.end),
          name: e.value.title,
          color: ce.value[e.value.paletteStartIndex] || D[e.value.paletteStartIndex],
          id: "line_0"
        }
      ]), Ce(y.value.dataset) && (t = y.value.dataset.map((o, i) => ({
        ...o,
        values: o.VALUE || o.DATA || o.SERIE || o.SERIES || o.VALUES || o.NUM || 0,
        name: o.NAME || o.DESCRIPTION || o.TITLE || o.LABEL || `Serie ${i}`,
        id: `line_${i}`
      })).map((o, i) => ({
        ...o,
        color: o.COLOR ? Oe(o.COLOR) : ce.value[i + e.value.paletteStartIndex] || D[i + e.value.paletteStartIndex] || D[(i + e.value.paletteStartIndex) % D.length],
        values: o.values.slice(k.value.start, k.value.end),
        absoluteIndices: o.values.map((b, x) => x).slice(k.value.start, k.value.end)
      })));
      const n = {
        max: Math.max(...t.filter((o) => !w.value.includes(o.id)).flatMap((o) => o.values)),
        min: Math.min(...t.filter((o) => !w.value.includes(o.id)).flatMap((o) => o.values)),
        maxSeries: Math.max(...t.map((o) => o.values.length))
      }, r = Ze(n.min < 0 ? n.min : 0, n.max < 0 ? 0 : n.max, e.value.xyScaleSegments), h = n.min < 0 ? Math.abs(n.min) : 0, O = n.max < 0 ? c.top : c.bottom - h / (r.max + h) * c.height, B = c.width / n.maxSeries, ie = r.ticks.map((o) => ({
        y: c.bottom - c.height * ((o + h) / (r.max + h)),
        x: c.left - 8,
        value: o
      })), ee = t.map((o, i) => ({
        ...o,
        coordinates: o.values.map((b, x) => ({
          x: c.left + B * (x + 1) - B / 2,
          y: c.bottom - (b + h) / (r.max + h) * c.height,
          value: b
        }))
      })).map((o) => {
        let i = [];
        return o.coordinates.forEach((b) => {
          i.push(`${b.x},${b.y} `);
        }), {
          ...o,
          linePath: i.join(" ")
        };
      });
      function ue(o) {
        j.value = o, J.value = o;
        const i = t.map((x) => ({
          ...x,
          value: x.values[o],
          absoluteIndex: x.absoluteIndices[o]
        })).filter((x) => !w.value.includes(x.id));
        de.value = { datapoint: i, seriesIndex: o, config: e.value, dataset: t };
        const b = e.value.tooltipCustomFormat;
        if (ze(b) && Fe(() => b({
          datapoint: i,
          seriesIndex: o,
          series: t,
          config: e.value
        })))
          K.value = b({
            datapoint: i,
            seriesIndex: o,
            series: t,
            config: e.value
          });
        else {
          let x = "";
          e.value.xyPeriods[i[0].absoluteIndex] && (x += `<div style="border-bottom:1px solid ${e.value.tooltipBorderColor};padding-bottom:6px;margin-bottom:3px;">${e.value.xyPeriods[i[0].absoluteIndex]}</div>`), i.forEach((I, F) => {
            x += `
                    <div style="display:flex; flex-wrap: wrap; align-items:center; gap:3px;">
                        <svg viewBox="0 0 12 12" height="14" width="12"><circle cx="6" cy="6" r="6" stroke="none" fill="${I.color}"/></svg>
                        <span>${I.name}:</span>
                        <b>${X(
              e.value.formatter,
              I.value,
              M({
                p: e.value.valuePrefix,
                v: I.value,
                s: e.value.valueSuffix,
                r: e.value.dataLabelRoundingValue
              }),
              { datapoint: I, seriesIndex: F }
            )}
                        </b>
                    </div>
                `;
          }), K.value = x;
        }
        G.value = !0;
      }
      function te() {
        j.value = null, G.value = !1;
      }
      return {
        absoluteZero: O,
        dataset: ee.filter((o) => !w.value.includes(o.id)),
        legend: ee,
        drawingArea: c,
        extremes: n,
        slotSize: B,
        yLabels: ie,
        useTooltip: ue,
        killTooltip: te
      };
    }), v = V(() => {
      if (z.value !== _.BAR) return null;
      const u = {
        height: S.value.height,
        width: S.value.width
      }, c = {
        left: e.value.xyPaddingLeft,
        top: e.value.xyPaddingTop,
        right: u.width - e.value.xyPaddingRight,
        bottom: u.height - e.value.xyPaddingBottom,
        width: u.width - e.value.xyPaddingLeft - e.value.xyPaddingRight,
        height: u.height - e.value.xyPaddingTop - e.value.xyPaddingBottom
      };
      let t = [];
      Y(y.value.dataset) && (t = [
        {
          values: y.value.dataset.slice(k.value.start, k.value.end),
          absoluteIndices: y.value.dataset.map((i, b) => b).slice(k.value.start, k.value.end),
          name: e.value.title,
          color: ce.value[e.value.paletteStartIndex] || D[e.value.paletteStartIndex],
          id: "bar_0"
        }
      ]), Ce(y.value.dataset) && (t = y.value.dataset.map((i, b) => ({
        ...i,
        values: i.VALUE || i.DATA || i.SERIE || i.SERIES || i.VALUES || i.NUM || 0,
        name: i.NAME || i.DESCRIPTION || i.TITLE || i.LABEL || `Serie ${b}`,
        id: `bar_${b}`
      })).map((i, b) => ({
        ...i,
        color: i.COLOR ? Oe(i.COLOR) : ce.value[b + e.value.paletteStartIndex] || D[b + e.value.paletteStartIndex] || D[(b + e.value.paletteStartIndex) % D.length],
        values: i.values.slice(k.value.start, k.value.end),
        absoluteIndices: i.values.map((x, I) => I).slice(k.value.start, k.value.end)
      })));
      const n = {
        max: Math.max(...t.filter((i) => !w.value.includes(i.id)).flatMap((i) => i.values)) < 0 ? 0 : Math.max(...t.filter((i) => !w.value.includes(i.id)).flatMap((i) => i.values)),
        min: Math.min(...t.filter((i) => !w.value.includes(i.id)).flatMap((i) => i.values)),
        maxSeries: Math.max(...t.filter((i) => !w.value.includes(i.id)).map((i) => i.values.length))
      }, r = Ze(n.min < 0 ? n.min : 0, n.max, e.value.xyScaleSegments), h = r.min < 0 ? Math.abs(r.min) : 0, O = c.bottom - h / (r.max + h) * c.height, B = c.width / n.maxSeries, ie = r.ticks.map((i) => ({
        y: c.bottom - c.height * ((i + h) / (r.max + h)),
        x: c.left - 8,
        value: i
      })), ee = t.map((i, b) => ({
        ...i,
        coordinates: i.values.map((x, I) => {
          const F = (x + h) / (n.max + h) * c.height, ge = Math.abs(x) / Math.abs(n.min) * (c.height - O), Ie = h / (n.max + h) * c.height, me = B / t.filter((ae) => !w.value.includes(ae.id)).length - e.value.barGap / t.filter((ae) => !w.value.includes(ae.id)).length;
          return {
            x: c.left + B * I + me * b + e.value.barGap / 2,
            y: x > 0 ? c.bottom - F : O,
            height: x > 0 ? F - Ie : ge,
            value: x,
            width: me
          };
        })
      })), ue = t.filter((i) => !w.value.includes(i.id)).map((i, b) => ({
        ...i,
        coordinates: i.values.map((x, I) => {
          const F = (x + h) / (n.max + h) * c.height, ge = Math.abs(x) / (n.max + h) * c.height, Ie = h / (n.max + h) * c.height, me = B / t.filter((ae) => !w.value.includes(ae.id)).length - e.value.barGap / t.filter((ae) => !w.value.includes(ae.id)).length;
          return {
            x: c.left + B * I + me * b + e.value.barGap / 2,
            y: x > 0 ? c.bottom - F : O,
            height: x > 0 ? F - Ie : ge,
            value: x,
            width: me
          };
        })
      }));
      function te(i) {
        j.value = i, J.value = i;
        const b = t.map((I) => ({
          ...I,
          value: I.values[i],
          absoluteIndex: I.absoluteIndices[i]
        })).filter((I) => !w.value.includes(I.id));
        de.value = { datapoint: b, seriesIndex: i, config: e.value, dataset: t };
        const x = e.value.tooltipCustomFormat;
        if (ze(x) && Fe(() => x({
          datapoint: b,
          seriesIndex: i,
          series: t,
          config: e.value
        })))
          K.value = x({
            point: b,
            seriesIndex: i,
            series: t,
            config: e.value
          });
        else {
          let I = "";
          e.value.xyPeriods[b[0].absoluteIndex] && (I += `<div style="border-bottom:1px solid ${e.value.tooltipBorderColor};padding-bottom:6px;margin-bottom:3px;">${e.value.xyPeriods[b[0].absoluteIndex]}</div>`), b.forEach((F, ge) => {
            I += `
                    <div style="display:flex; flex-wrap: wrap; align-items:center; gap:3px;">
                        <svg viewBox="0 0 12 12" height="14" width="12"><rect x=0 y="0" width="12" height="12" rx="1" stroke="none" fill="${F.color}"/></svg>
                        <span>${F.name}:</span>
                        <b>${X(
              e.value.formatter,
              F.value,
              M({
                p: e.value.valuePrefix,
                v: F.value,
                s: e.value.valueSuffix,
                r: e.value.dataLabelRoundingValue
              }),
              { datapoint: F, seriesIndex: ge }
            )}
                        </b>
                    </div>
                `;
          }), K.value = I;
        }
        G.value = !0;
      }
      function o() {
        G.value = !1, j.value = null, J.value = null;
      }
      return {
        absoluteZero: O,
        dataset: ue.filter((i) => !w.value.includes(i.id)),
        legend: ee,
        drawingArea: c,
        extremes: n,
        slotSize: B,
        yLabels: ie,
        useTooltip: te,
        killTooltip: o
      };
    }), Pe = P(!1);
    function st(u) {
      Pe.value = u, Me.value += 1;
    }
    function Xe() {
      Se.value.showTooltip = !Se.value.showTooltip;
    }
    const _e = P(!1);
    function Te() {
      _e.value = !_e.value;
    }
    return $({
      generatePdf: Ue,
      generateImage: De,
      toggleTooltip: Xe,
      toggleAnnotator: Te
    }), (u, c) => lt.value ? (a(), l("div", {
      key: 0,
      id: `${z.value}_${T.value}`,
      ref_key: "quickChart",
      ref: W,
      class: ne({ "vue-ui-quick-chart": !0, "vue-data-ui-wrapper-fullscreen": Pe.value }),
      style: N(`background:${e.value.backgroundColor};color:${e.value.color};font-family:${e.value.fontFamily}; position: relative; ${e.value.responsive ? "height: 100%" : ""}`)
    }, [
      e.value.userOptionsButtons.annotator ? (a(), Le(Et, {
        key: 0,
        parent: W.value,
        backgroundColor: e.value.backgroundColor,
        color: e.value.color,
        active: _e.value,
        onClose: Te
      }, null, 8, ["parent", "backgroundColor", "color", "active"])) : m("", !0),
      e.value.showUserOptions ? (a(), Le(Ct, {
        ref: "details",
        key: `user_option_${Me.value}`,
        backgroundColor: e.value.backgroundColor,
        color: e.value.color,
        isPrinting: f(ke),
        isImaging: f(be),
        uid: T.value,
        hasTooltip: e.value.userOptionsButtons.tooltip && e.value.showTooltip,
        hasPdf: e.value.userOptionsButtons.pdf,
        hasImg: e.value.userOptionsButtons.img,
        hasFullscreen: e.value.userOptionsButtons.fullscreen,
        hasXls: !1,
        isTooltip: Se.value.showTooltip,
        isFullscreen: Pe.value,
        titles: { ...e.value.userOptionsButtonTitles },
        chartElement: W.value,
        position: e.value.userOptionsPosition,
        hasAnnotator: e.value.userOptionsButtons.annotator,
        isAnnotation: _e.value,
        onToggleFullscreen: st,
        onGeneratePdf: f(Ue),
        onGenerateImage: f(De),
        onToggleTooltip: Xe,
        onToggleAnnotator: Te
      }, ct({ _: 2 }, [
        u.$slots.optionTooltip ? {
          name: "optionTooltip",
          fn: Q(() => [
            U(u.$slots, "optionTooltip", {}, void 0, !0)
          ]),
          key: "0"
        } : void 0,
        u.$slots.optionPdf ? {
          name: "optionPdf",
          fn: Q(() => [
            U(u.$slots, "optionPdf", {}, void 0, !0)
          ]),
          key: "1"
        } : void 0,
        u.$slots.optionImg ? {
          name: "optionImg",
          fn: Q(() => [
            U(u.$slots, "optionImg", {}, void 0, !0)
          ]),
          key: "2"
        } : void 0,
        u.$slots.optionFullscreen ? {
          name: "optionFullscreen",
          fn: Q(({ toggleFullscreen: t, isFullscreen: n }) => [
            U(u.$slots, "optionFullscreen", H(re({ toggleFullscreen: t, isFullscreen: n })), void 0, !0)
          ]),
          key: "3"
        } : void 0,
        u.$slots.optionAnnotator ? {
          name: "optionAnnotator",
          fn: Q(({ toggleAnnotator: t, isAnnotator: n }) => [
            U(u.$slots, "optionAnnotator", H(re({ toggleAnnotator: t, isAnnotator: n })), void 0, !0)
          ]),
          key: "4"
        } : void 0
      ]), 1032, ["backgroundColor", "color", "isPrinting", "isImaging", "uid", "hasTooltip", "hasPdf", "hasImg", "hasFullscreen", "isTooltip", "isFullscreen", "titles", "chartElement", "position", "hasAnnotator", "isAnnotation", "onGeneratePdf", "onGenerateImage"])) : m("", !0),
      e.value.title ? (a(), l("div", {
        key: 2,
        ref_key: "quickChartTitle",
        ref: le,
        class: "vue-ui-quick-chart-title",
        style: N(`background:transparent;color:${e.value.color};font-size:${e.value.titleFontSize}px;font-weight:${e.value.titleBold ? "bold" : "normal"};text-align:${e.value.titleTextAlign}`)
      }, E(e.value.title), 5)) : m("", !0),
      z.value ? (a(), l("svg", {
        key: 3,
        xmlns: f(wt),
        viewBox: ot.value,
        style: N(`max-width:100%;overflow:visible;background:transparent;color:${e.value.color}`)
      }, [
        se(It),
        A("defs", null, [
          A("filter", {
            id: `blur_${T.value}`,
            x: "-50%",
            y: "-50%",
            width: "200%",
            height: "200%"
          }, [
            A("feGaussianBlur", {
              in: "SourceGraphic",
              stdDeviation: 2,
              id: `blur_std_${T.value}`
            }, null, 8, Wt),
            jt
          ], 8, qt),
          A("filter", {
            id: `shadow_${T.value}`,
            "color-interpolation-filters": "sRGB"
          }, [
            A("feDropShadow", {
              dx: "0",
              dy: "0",
              stdDeviation: "10",
              "flood-opacity": "0.5",
              "flood-color": e.value.donutShadowColor
            }, null, 8, Ht)
          ], 8, Gt)
        ]),
        z.value === _.DONUT ? (a(), l(p, { key: 0 }, [
          e.value.showDataLabels ? (a(), l("g", Xt, [
            (a(!0), l(p, null, L(C.value.chart, (t, n) => (a(), l(p, null, [
              C.value.isArcBigEnough(t) ? (a(), l("path", {
                key: 0,
                d: f(At)(t, { x: S.value.width / 2, y: S.value.height / 2 }, 16, 16, !1, !1, S.value.height * He.value),
                stroke: t.color,
                "stroke-width": e.value.donutLabelMarkerStrokeWidth,
                "stroke-linecap": "round",
                "stroke-linejoin": "round",
                fill: "none",
                filter: fe(t.id)
              }, null, 8, Zt)) : m("", !0)
            ], 64))), 256))
          ])) : m("", !0),
          A("circle", {
            cx: C.value.cx,
            cy: C.value.cy,
            r: C.value.radius,
            fill: e.value.backgroundColor,
            filter: e.value.donutUseShadow ? `url(#shadow_${T.value})` : ""
          }, null, 8, Yt),
          A("g", Jt, [
            (a(!0), l(p, null, L(C.value.chart, (t, n) => (a(), l("path", {
              d: t.arcSlice,
              fill: t.color,
              stroke: e.value.backgroundColor,
              "stroke-width": e.value.donutStrokeWidth,
              filter: fe(t.id)
            }, null, 8, Qt))), 256)),
            (a(!0), l(p, null, L(C.value.chart, (t, n) => (a(), l("path", {
              d: t.arcSlice,
              fill: "transparent",
              onMouseenter: (r) => C.value.useTooltip({ datapoint: t, seriesIndex: n }),
              onMouseout: c[0] || (c[0] = (r) => C.value.killTooltip()),
              onClick: (r) => g("selectDatapoint", t)
            }, null, 40, Kt))), 256))
          ]),
          e.value.showDataLabels ? (a(), l("g", ea, [
            (a(!0), l(p, null, L(C.value.chart, (t, n) => (a(), l(p, null, [
              C.value.isArcBigEnough(t) ? (a(), l("circle", {
                key: 0,
                cx: f(pe)(t).x,
                cy: f(Ne)(t) - 3.7,
                fill: t.color,
                stroke: e.value.backgroundColor,
                "stroke-width": 1,
                r: 3,
                filter: fe(t.id)
              }, null, 8, ta)) : m("", !0),
              C.value.isArcBigEnough(t) ? (a(), l("text", {
                key: 1,
                "text-anchor": f(pe)(t, !0, 20).anchor,
                x: f(pe)(t, !0).x,
                y: f(Ne)(t),
                fill: e.value.color,
                "font-size": e.value.dataLabelFontSize,
                filter: fe(t.id)
              }, E(C.value.displayArcPercentage(t, C.value.chart)) + " (" + E(f(X)(
                e.value.formatter,
                t.value,
                f(M)({
                  p: e.value.valuePrefix,
                  v: t.value,
                  s: e.value.valueSuffix,
                  r: e.value.dataLabelRoundingValue
                }),
                { datapoint: t, seriesIndex: n }
              )) + ") ", 9, aa)) : m("", !0),
              C.value.isArcBigEnough(t, !0, 20) ? (a(), l("text", {
                key: 2,
                "text-anchor": f(pe)(t).anchor,
                x: f(pe)(t, !0).x,
                y: f(Ne)(t) + e.value.dataLabelFontSize,
                fill: e.value.color,
                "font-size": e.value.dataLabelFontSize,
                filter: fe(t.id)
              }, E(t.name), 9, la)) : m("", !0)
            ], 64))), 256))
          ])) : m("", !0),
          e.value.donutShowTotal ? (a(), l("g", oa, [
            A("text", {
              "text-anchor": "middle",
              x: C.value.drawingArea.centerX,
              y: C.value.drawingArea.centerY - e.value.donutTotalLabelFontSize / 2,
              "font-size": e.value.donutTotalLabelFontSize,
              fill: e.value.color
            }, E(e.value.donutTotalLabelText), 9, ia),
            A("text", {
              "text-anchor": "middle",
              x: C.value.drawingArea.centerX,
              y: C.value.drawingArea.centerY + e.value.donutTotalLabelFontSize,
              "font-size": e.value.donutTotalLabelFontSize,
              fill: e.value.color
            }, E(f(M)({
              p: e.value.valuePrefix,
              v: C.value.total,
              s: e.value.valueSuffix,
              r: e.value.dataLabelRoundingValue
            })), 9, ua)
          ])) : m("", !0)
        ], 64)) : m("", !0),
        z.value === _.LINE ? (a(), l(p, { key: 1 }, [
          e.value.xyShowGrid ? (a(), l("g", na, [
            (a(!0), l(p, null, L(d.value.yLabels, (t) => (a(), l(p, null, [
              t.y <= d.value.drawingArea.bottom ? (a(), l("line", {
                key: 0,
                x1: d.value.drawingArea.left,
                x2: d.value.drawingArea.right,
                y1: t.y,
                y2: t.y,
                stroke: e.value.xyGridStroke,
                "stroke-width": e.value.xyGridStrokeWidth,
                "stroke-linecap": "round"
              }, null, 8, ra)) : m("", !0)
            ], 64))), 256)),
            (a(!0), l(p, null, L(d.value.extremes.maxSeries + 1, (t, n) => (a(), l("line", {
              x1: d.value.drawingArea.left + d.value.slotSize * n,
              x2: d.value.drawingArea.left + d.value.slotSize * n,
              y1: d.value.drawingArea.top,
              y2: d.value.drawingArea.bottom,
              stroke: e.value.xyGridStroke,
              "stroke-width": e.value.xyGridStrokeWidth,
              "stroke-linecap": "round"
            }, null, 8, sa))), 256))
          ])) : m("", !0),
          e.value.xyShowAxis ? (a(), l("g", va, [
            A("line", {
              x1: d.value.drawingArea.left,
              x2: d.value.drawingArea.left,
              y1: d.value.drawingArea.top,
              y2: d.value.drawingArea.bottom,
              stroke: e.value.xyAxisStroke,
              "stroke-width": e.value.xyAxisStrokeWidth,
              "stroke-linecap": "round"
            }, null, 8, da),
            A("line", {
              x1: d.value.drawingArea.left,
              x2: d.value.drawingArea.right,
              y1: isNaN(d.value.absoluteZero) ? d.value.drawingArea.bottom : d.value.absoluteZero,
              y2: isNaN(d.value.absoluteZero) ? d.value.drawingArea.bottom : d.value.absoluteZero,
              stroke: e.value.xyAxisStroke,
              "stroke-width": e.value.xyAxisStrokeWidth,
              "stroke-linecap": "round"
            }, null, 8, ca)
          ])) : m("", !0),
          e.value.xyShowScale ? (a(), l("g", ha, [
            (a(!0), l(p, null, L(d.value.yLabels, (t, n) => (a(), l(p, null, [
              t.y <= d.value.drawingArea.bottom ? (a(), l("line", {
                key: 0,
                x1: t.x + 4,
                x2: d.value.drawingArea.left,
                y1: t.y,
                y2: t.y,
                stroke: e.value.xyAxisStroke,
                "stroke-width": e.value.xyAxisStrokeWidth,
                "stroke-linecap": "round"
              }, null, 8, fa)) : m("", !0),
              t.y <= d.value.drawingArea.bottom ? (a(), l("text", {
                key: 1,
                x: t.x,
                y: t.y + e.value.xyLabelsYFontSize / 3,
                "text-anchor": "end",
                "font-size": e.value.xyLabelsYFontSize,
                fill: e.value.color
              }, E(f(X)(
                e.value.formatter,
                t.value,
                f(M)({
                  p: e.value.valuePrefix,
                  v: t.value,
                  s: e.value.valueSuffix,
                  r: e.value.dataLabelRoundingValue
                }),
                { datapoint: t, seriesIndex: n }
              )), 9, ga)) : m("", !0)
            ], 64))), 256))
          ])) : m("", !0),
          e.value.xyShowScale && e.value.xyPeriods.length ? (a(), l("g", ma, [
            (a(!0), l(p, null, L(e.value.xyPeriods.slice(k.value.start, k.value.end), (t, n) => (a(), l("line", {
              x1: d.value.drawingArea.left + d.value.slotSize * (n + 1) - d.value.slotSize / 2,
              x2: d.value.drawingArea.left + d.value.slotSize * (n + 1) - d.value.slotSize / 2,
              y1: d.value.drawingArea.bottom,
              y2: d.value.drawingArea.bottom + 4,
              stroke: e.value.xyAxisStroke,
              "stroke-width": e.value.xyAxisStrokeWidth,
              "stroke-linecap": "round"
            }, null, 8, pa))), 256)),
            (a(!0), l(p, null, L(e.value.xyPeriods.slice(k.value.start, k.value.end), (t, n) => (a(), l("text", {
              "font-size": e.value.xyLabelsXFontSize,
              "text-anchor": e.value.xyPeriodLabelsRotation > 0 ? "start" : e.value.xyPeriodLabelsRotation < 0 ? "end" : "middle",
              fill: e.value.color,
              transform: `translate(${d.value.drawingArea.left + d.value.slotSize * (n + 1) - d.value.slotSize / 2}, ${d.value.drawingArea.bottom + e.value.xyLabelsXFontSize + 6}), rotate(${e.value.xyPeriodLabelsRotation})`
            }, E(t), 9, xa))), 256))
          ])) : m("", !0),
          A("g", ya, [
            (a(!0), l(p, null, L(d.value.dataset, (t, n) => (a(), l("g", ka, [
              e.value.lineSmooth ? (a(), l(p, { key: 0 }, [
                A("path", {
                  d: `M ${f(Ye)(t.coordinates)}`,
                  stroke: e.value.backgroundColor,
                  "stroke-width": e.value.lineStrokeWidth + 1,
                  "stroke-linecap": "round",
                  fill: "none",
                  class: ne({ "quick-animation": !0, "vue-data-ui-line-animated": e.value.lineAnimated }),
                  style: { transition: "all 0.3s ease-in-out" }
                }, null, 10, ba),
                A("path", {
                  d: `M ${f(Ye)(t.coordinates)}`,
                  stroke: t.color,
                  "stroke-width": e.value.lineStrokeWidth,
                  "stroke-linecap": "round",
                  fill: "none",
                  class: ne({ "quick-animation": !0, "vue-data-ui-line-animated": e.value.lineAnimated }),
                  style: { transition: "all 0.3s ease-in-out" }
                }, null, 10, Sa)
              ], 64)) : (a(), l(p, { key: 1 }, [
                A("path", {
                  d: `M ${t.linePath}`,
                  stroke: e.value.backgroundColor,
                  "stroke-width": e.value.lineStrokeWidth + 1,
                  "stroke-linecap": "round",
                  fill: "none",
                  class: ne({ "quick-animation": !0, "vue-data-ui-line-animated": e.value.lineAnimated }),
                  style: { transition: "all 0.3s ease-in-out" }
                }, null, 10, wa),
                A("path", {
                  d: `M ${t.linePath}`,
                  stroke: t.color,
                  "stroke-width": e.value.lineStrokeWidth,
                  "stroke-linecap": "round",
                  fill: "none",
                  class: ne({ "quick-animation": !0, "vue-data-ui-line-animated": e.value.lineAnimated }),
                  style: { transition: "all 0.3s ease-in-out" }
                }, null, 10, Aa)
              ], 64)),
              (a(!0), l(p, null, L(t.coordinates, (r, h) => (a(), l("circle", {
                cx: r.x,
                cy: f(Z)(r.y),
                r: 3,
                fill: t.color,
                stroke: e.value.backgroundColor,
                "stroke-width": "0.5",
                class: "quick-animation",
                style: { transition: "all 0.3s ease-in-out" }
              }, null, 8, _a))), 256))
            ]))), 256))
          ]),
          e.value.showDataLabels ? (a(), l("g", La, [
            (a(!0), l(p, null, L(d.value.dataset, (t, n) => (a(), l(p, null, [
              (a(!0), l(p, null, L(t.coordinates, (r, h) => (a(), l("text", {
                "text-anchor": "middle",
                "font-size": e.value.dataLabelFontSize,
                fill: t.color,
                x: r.x,
                y: f(Z)(r.y) - e.value.dataLabelFontSize / 2,
                class: "quick-animation",
                style: { transition: "all 0.3s ease-in-out" }
              }, E(f(X)(
                e.value.formatter,
                f(Z)(r.value),
                f(M)({
                  p: e.value.valuePrefix,
                  v: f(Z)(r.value),
                  s: e.value.valueSuffix,
                  r: e.value.dataLabelRoundingValue
                }),
                { datapoint: r, seriesIndex: h }
              )), 9, za))), 256))
            ], 64))), 256))
          ])) : m("", !0),
          A("g", $a, [
            (a(!0), l(p, null, L(d.value.extremes.maxSeries, (t, n) => (a(), l("rect", {
              x: d.value.drawingArea.left + n * d.value.slotSize,
              y: d.value.drawingArea.top,
              height: d.value.drawingArea.height <= 0 ? 1e-5 : d.value.drawingArea.height,
              width: d.value.slotSize <= 0 ? 1e-5 : d.value.slotSize,
              fill: [j.value, J.value].includes(n) ? e.value.xyHighlighterColor : "transparent",
              style: N(`opacity:${e.value.xyHighlighterOpacity}`),
              onMouseenter: (r) => d.value.useTooltip(n),
              onMouseleave: c[1] || (c[1] = (r) => d.value.killTooltip()),
              onClick: (r) => g("selectDatapoint", d.value.dataset.map((h) => ({
                ...h,
                value: h.values[n]
              })))
            }, null, 44, Ca))), 256))
          ])
        ], 64)) : m("", !0),
        z.value === _.BAR ? (a(), l(p, { key: 2 }, [
          e.value.xyShowGrid ? (a(), l("g", Pa, [
            (a(!0), l(p, null, L(v.value.yLabels, (t) => (a(), l(p, null, [
              t.y <= v.value.drawingArea.bottom ? (a(), l("line", {
                key: 0,
                x1: v.value.drawingArea.left,
                x2: v.value.drawingArea.right,
                y1: t.y,
                y2: t.y,
                stroke: e.value.xyGridStroke,
                "stroke-width": e.value.xyGridStrokeWidth,
                "stroke-linecap": "round"
              }, null, 8, Ta)) : m("", !0)
            ], 64))), 256)),
            (a(!0), l(p, null, L(v.value.extremes.maxSeries + 1, (t, n) => (a(), l("line", {
              x1: v.value.drawingArea.left + v.value.slotSize * n,
              x2: v.value.drawingArea.left + v.value.slotSize * n,
              y1: v.value.drawingArea.top,
              y2: v.value.drawingArea.bottom,
              stroke: e.value.xyGridStroke,
              "stroke-width": e.value.xyGridStrokeWidth,
              "stroke-linecap": "round"
            }, null, 8, Ia))), 256))
          ])) : m("", !0),
          e.value.xyShowAxis ? (a(), l("g", Ea, [
            A("line", {
              x1: v.value.drawingArea.left,
              x2: v.value.drawingArea.left,
              y1: v.value.drawingArea.top,
              y2: v.value.drawingArea.bottom,
              stroke: e.value.xyAxisStroke,
              "stroke-width": e.value.xyAxisStrokeWidth,
              "stroke-linecap": "round"
            }, null, 8, Ra),
            A("line", {
              x1: v.value.drawingArea.left,
              x2: v.value.drawingArea.right,
              y1: isNaN(v.value.absoluteZero) ? v.value.drawingArea.bottom : v.value.absoluteZero,
              y2: isNaN(v.value.absoluteZero) ? v.value.drawingArea.bottom : v.value.absoluteZero,
              stroke: e.value.xyAxisStroke,
              "stroke-width": e.value.xyAxisStrokeWidth,
              "stroke-linecap": "round"
            }, null, 8, Oa)
          ])) : m("", !0),
          e.value.xyShowScale ? (a(), l("g", Na, [
            (a(!0), l(p, null, L(v.value.yLabels, (t, n) => (a(), l(p, null, [
              t.y <= v.value.drawingArea.bottom ? (a(), l("line", {
                key: 0,
                x1: t.x + 4,
                x2: v.value.drawingArea.left,
                y1: t.y,
                y2: t.y,
                stroke: e.value.xyAxisStroke,
                "stroke-width": e.value.xyAxisStrokeWidth,
                "stroke-linecap": "round"
              }, null, 8, Fa)) : m("", !0),
              t.y <= v.value.drawingArea.bottom ? (a(), l("text", {
                key: 1,
                x: t.x,
                y: t.y + e.value.xyLabelsYFontSize / 3,
                "text-anchor": "end",
                "font-size": e.value.xyLabelsYFontSize,
                fill: e.value.color
              }, E(f(X)(
                e.value.formatter,
                t.value,
                f(M)({
                  p: e.value.valuePrefix,
                  v: t.value,
                  s: e.value.valueSuffix,
                  r: e.value.dataLabelRoundingValue
                }),
                { datapoint: t, seriesIndex: n }
              )), 9, Ma)) : m("", !0)
            ], 64))), 256))
          ])) : m("", !0),
          e.value.xyShowScale && e.value.xyPeriods.length ? (a(), l("g", Ba, [
            (a(!0), l(p, null, L(e.value.xyPeriods.slice(k.value.start, k.value.end), (t, n) => (a(), l("line", {
              x1: v.value.drawingArea.left + v.value.slotSize * (n + 1) - v.value.slotSize / 2,
              x2: v.value.drawingArea.left + v.value.slotSize * (n + 1) - v.value.slotSize / 2,
              y1: v.value.drawingArea.bottom,
              y2: v.value.drawingArea.bottom + 4,
              stroke: e.value.xyAxisStroke,
              "stroke-width": e.value.xyAxisStrokeWidth,
              "stroke-linecap": "round"
            }, null, 8, Ua))), 256)),
            (a(!0), l(p, null, L(e.value.xyPeriods.slice(k.value.start, k.value.end), (t, n) => (a(), l("text", {
              "font-size": e.value.xyLabelsXFontSize,
              "text-anchor": e.value.xyPeriodLabelsRotation > 0 ? "start" : e.value.xyPeriodLabelsRotation < 0 ? "end" : "middle",
              transform: `translate(${v.value.drawingArea.left + v.value.slotSize * (n + 1) - v.value.slotSize / 2}, ${v.value.drawingArea.bottom + e.value.xyLabelsXFontSize + 6}) rotate(${e.value.xyPeriodLabelsRotation})`,
              fill: e.value.color
            }, E(t), 9, Da))), 256))
          ])) : m("", !0),
          A("g", Va, [
            (a(!0), l(p, null, L(v.value.dataset, (t, n) => (a(), l(p, null, [
              (a(!0), l(p, null, L(t.coordinates, (r, h) => (a(), l("rect", {
                x: r.x,
                width: r.width <= 0 ? 1e-5 : r.width,
                height: f(Z)(r.height <= 0 ? 1e-5 : r.height),
                y: f(Z)(r.y),
                fill: t.color,
                stroke: e.value.backgroundColor,
                "stroke-width": e.value.barStrokeWidth,
                "stroke-linecap": "round",
                class: ne({ "vue-data-ui-bar-animated": e.value.barAnimated && r.value < 0 })
              }, [
                e.value.barAnimated && r.value > 0 && !f(ke) && !f(be) ? (a(), l("animate", {
                  key: 0,
                  attributeName: "height",
                  from: 0,
                  to: r.height,
                  dur: "0.5s"
                }, null, 8, Wa)) : m("", !0),
                e.value.barAnimated && r.value > 0 && !f(ke) && !f(be) ? (a(), l("animate", {
                  key: 1,
                  attributeName: "y",
                  from: v.value.absoluteZero,
                  to: v.value.absoluteZero - r.height,
                  dur: "0.5s"
                }, null, 8, ja)) : m("", !0)
              ], 10, qa))), 256))
            ], 64))), 256))
          ]),
          e.value.showDataLabels ? (a(), l("g", Ga, [
            (a(!0), l(p, null, L(v.value.dataset, (t, n) => (a(), l(p, null, [
              (a(!0), l(p, null, L(t.coordinates, (r, h) => (a(), l("text", {
                x: r.x + r.width / 2,
                y: f(Z)(r.y) - e.value.dataLabelFontSize / 2,
                "text-anchor": "middle",
                "font-size": e.value.dataLabelFontSize,
                fill: t.color,
                class: "quick-animation"
              }, E(f(X)(
                e.value.formatter,
                f(Z)(r.value),
                f(M)({
                  p: e.value.valuePrefix,
                  v: f(Z)(r.value),
                  s: e.value.valueSuffix,
                  r: e.value.dataLabelRoundingValue
                }),
                { datapoint: r, seriesIndex: h }
              )), 9, Ha))), 256))
            ], 64))), 256))
          ])) : m("", !0),
          A("g", Xa, [
            (a(!0), l(p, null, L(v.value.extremes.maxSeries, (t, n) => (a(), l("rect", {
              x: v.value.drawingArea.left + n * v.value.slotSize,
              y: v.value.drawingArea.top,
              height: v.value.drawingArea.height <= 0 ? 1e-5 : v.value.drawingArea.height,
              width: v.value.slotSize <= 0 ? 1e-5 : v.value.slotSize,
              fill: [j.value, J.value].includes(n) ? e.value.xyHighlighterColor : "transparent",
              style: N(`opacity:${e.value.xyHighlighterOpacity}`),
              onMouseenter: (r) => v.value.useTooltip(n),
              onMouseleave: c[2] || (c[2] = (r) => v.value.killTooltip()),
              onClick: (r) => g("selectDatapoint", v.value.dataset.map((h) => ({
                ...h,
                value: h.values[n]
              })))
            }, null, 44, Za))), 256))
          ])
        ], 64)) : m("", !0),
        [_.LINE, _.BAR].includes(z.value) ? (a(), l("g", Ya, [
          e.value.xAxisLabel && z.value === _.LINE ? (a(), l("g", Ja, [
            A("text", {
              "font-size": e.value.axisLabelsFontSize,
              fill: e.value.color,
              "text-anchor": "middle",
              x: d.value.drawingArea.left + d.value.drawingArea.width / 2,
              y: S.value.height - e.value.axisLabelsFontSize / 3
            }, E(e.value.xAxisLabel), 9, Qa)
          ])) : m("", !0),
          e.value.xAxisLabel && z.value === _.BAR ? (a(), l("g", Ka, [
            A("text", {
              "font-size": e.value.axisLabelsFontSize,
              fill: e.value.color,
              "text-anchor": "middle",
              x: v.value.drawingArea.left + v.value.drawingArea.width / 2,
              y: S.value.height - e.value.axisLabelsFontSize / 3
            }, E(e.value.xAxisLabel), 9, el)
          ])) : m("", !0),
          e.value.yAxisLabel && z.value === _.LINE ? (a(), l("g", tl, [
            A("text", {
              "font-size": e.value.axisLabelsFontSize,
              fill: e.value.color,
              transform: `translate(${e.value.axisLabelsFontSize}, ${d.value.drawingArea.top + d.value.drawingArea.height / 2}) rotate(-90)`,
              "text-anchor": "middle"
            }, E(e.value.yAxisLabel), 9, al)
          ])) : m("", !0),
          e.value.yAxisLabel && z.value === _.BAR ? (a(), l("g", ll, [
            A("text", {
              "font-size": e.value.axisLabelsFontSize,
              fill: e.value.color,
              transform: `translate(${e.value.axisLabelsFontSize}, ${v.value.drawingArea.top + v.value.drawingArea.height / 2}) rotate(-90)`,
              "text-anchor": "middle"
            }, E(e.value.yAxisLabel), 9, ol)
          ])) : m("", !0)
        ])) : m("", !0)
      ], 12, Vt)) : m("", !0),
      z.value ? m("", !0) : (a(), Le(Tt, {
        key: 4,
        config: {
          type: "line",
          style: {
            backgroundColor: e.value.backgroundColor,
            line: {
              axis: {
                color: e.value.xyAxisStroke
              },
              path: {
                color: e.value.xyAxisStroke,
                strokeWidth: 0.5
              }
            }
          }
        }
      }, null, 8, ["config"])),
      u.$slots.watermark ? (a(), l("div", il, [
        U(u.$slots, "watermark", H(re({ isPrinting: f(ke) || f(be) })), void 0, !0)
      ])) : m("", !0),
      [_.BAR, _.LINE].includes(z.value) && e.value.zoomXy && y.value.maxSeriesLength > 1 ? (a(), l("div", {
        key: `slicer_${ye.value}`,
        ref_key: "quickChartSlicer",
        ref: ve
      }, [
        (a(), Le(Pt, {
          key: `slicer_${ye.value}`,
          background: e.value.zoomColor,
          borderColor: e.value.backgroundColor,
          fontSize: e.value.zoomFontSize,
          useResetSlot: e.value.zoomUseResetSlot,
          labelLeft: e.value.xyPeriods[k.value.start] ? e.value.xyPeriods[k.value.start] : "",
          labelRight: e.value.xyPeriods[k.value.end - 1] ? e.value.xyPeriods[k.value.end - 1] : "",
          textColor: e.value.color,
          inputColor: e.value.zoomColor,
          selectColor: e.value.zoomHighlightColor,
          max: y.value.maxSeriesLength,
          min: 0,
          valueStart: k.value.start,
          valueEnd: k.value.end,
          smoothMinimap: e.value.zoomMinimap.smooth,
          minimapSelectedColor: e.value.zoomMinimap.selectedColor,
          minimapSelectedColorOpacity: e.value.zoomMinimap.selectedColorOpacity,
          minimapSelectionRadius: e.value.zoomMinimap.selectionRadius,
          minimapLineColor: e.value.zoomMinimap.lineColor,
          minimap: rt.value,
          minimapIndicatorColor: e.value.zoomMinimap.indicatorColor,
          minimapSelectedIndex: J.value,
          start: k.value.start,
          "onUpdate:start": c[3] || (c[3] = (t) => k.value.start = t),
          end: k.value.end,
          "onUpdate:end": c[4] || (c[4] = (t) => k.value.end = t),
          onReset: nt,
          onTrapMouse: ut
        }, {
          "reset-action": Q(({ reset: t }) => [
            U(u.$slots, "reset-action", H(re({ reset: t })), void 0, !0)
          ]),
          _: 3
        }, 8, ["background", "borderColor", "fontSize", "useResetSlot", "labelLeft", "labelRight", "textColor", "inputColor", "selectColor", "max", "valueStart", "valueEnd", "smoothMinimap", "minimapSelectedColor", "minimapSelectedColorOpacity", "minimapSelectionRadius", "minimapLineColor", "minimap", "minimapIndicatorColor", "minimapSelectedIndex", "start", "end"]))
      ])) : m("", !0),
      e.value.showLegend ? (a(), l("div", {
        key: 7,
        ref_key: "quickChartLegend",
        ref: oe,
        class: "vue-ui-quick-chart-legend",
        style: N(`background:transparent;color:${e.value.color}`)
      }, [
        z.value === _.DONUT ? (a(!0), l(p, { key: 0 }, L(C.value.legend, (t, n) => (a(), l("div", {
          class: "vue-ui-quick-chart-legend-item",
          onClick: (r) => {
            it(t, C.value.dataset), g("selectLegend", t);
          },
          style: N(`cursor: ${C.value.legend.length > 1 ? "pointer" : "default"}; opacity:${w.value.includes(t.id) ? "0.5" : "1"}`)
        }, [
          e.value.useCustomLegend ? U(u.$slots, "legend", H(Re({ key: 0 }, { legend: t })), void 0, !0) : (a(), l(p, { key: 1 }, [
            se($e, {
              name: e.value.legendIcon,
              stroke: t.color,
              size: e.value.legendIconSize
            }, null, 8, ["name", "stroke", "size"]),
            A("span", {
              style: N(`font-size:${e.value.legendFontSize}px`)
            }, E(t.name), 5),
            A("span", {
              style: N(`font-size:${e.value.legendFontSize}px;font-variant-numeric:tabular-nums`)
            }, E(w.value.includes(t.id) ? "-" : f(X)(
              e.value.formatter,
              t.absoluteValue,
              f(M)({
                p: e.value.valuePrefix,
                v: t.absoluteValue,
                s: e.value.valueSuffix,
                r: e.value.dataLabelRoundingValue
              }),
              { datapoint: t, seriesIndex: n }
            )), 5),
            w.value.includes(t.id) ? (a(), l("span", {
              key: 0,
              style: N(`font-size:${e.value.legendFontSize}px`)
            }, " ( - % ) ", 4)) : Ae.value ? (a(), l("span", {
              key: 1,
              style: N(`font-size:${e.value.legendFontSize}px; font-variant-numeric: tabular-nums;`)
            }, " ( - % ) ", 4)) : (a(), l("span", {
              key: 2,
              style: N(`font-size:${e.value.legendFontSize}px; font-variant-numeric: tabular-nums;`)
            }, " (" + E(f(M)({
              v: t.value / C.value.total * 100,
              s: "%",
              r: e.value.dataLabelRoundingPercentage
            })) + ") ", 5))
          ], 64))
        ], 12, ul))), 256)) : m("", !0),
        z.value === _.LINE ? (a(!0), l(p, { key: 1 }, L(d.value.legend, (t, n) => (a(), l("div", {
          class: "vue-ui-quick-chart-legend-item",
          onClick: (r) => {
            We(t.id, d.value.legend.length - 1), g("selectLegend", t);
          },
          style: N(`cursor: ${d.value.legend.length > 1 ? "pointer" : "default"}; opacity:${w.value.includes(t.id) ? "0.5" : "1"}`)
        }, [
          e.value.useCustomLegend ? U(u.$slots, "legend", H(Re({ key: 0 }, { legend: t })), void 0, !0) : (a(), l(p, { key: 1 }, [
            se($e, {
              name: e.value.legendIcon,
              stroke: t.color,
              size: e.value.legendIconSize
            }, null, 8, ["name", "stroke", "size"]),
            A("span", {
              style: N(`font-size:${e.value.legendFontSize}px`)
            }, E(t.name), 5)
          ], 64))
        ], 12, nl))), 256)) : m("", !0),
        z.value === _.BAR ? (a(!0), l(p, { key: 2 }, L(v.value.legend, (t, n) => (a(), l("div", {
          class: "vue-ui-quick-chart-legend-item",
          onClick: (r) => {
            We(t.id, v.value.legend.length - 1), g("selectLegend", t);
          },
          style: N(`cursor: ${v.value.legend.length > 1 ? "pointer" : "default"}; opacity:${w.value.includes(t.id) ? "0.5" : "1"}`)
        }, [
          e.value.useCustomLegend ? U(u.$slots, "legend", H(Re({ key: 0 }, { legend: t })), void 0, !0) : (a(), l(p, { key: 1 }, [
            se($e, {
              name: e.value.legendIcon,
              stroke: t.color,
              size: e.value.legendIconSize
            }, null, 8, ["name", "stroke", "size"]),
            A("span", {
              style: N(`font-size:${e.value.legendFontSize}px`)
            }, E(t.name), 5)
          ], 64))
        ], 12, rl))), 256)) : m("", !0)
      ], 4)) : m("", !0),
      se(zt, {
        show: Se.value.showTooltip && G.value,
        backgroundColor: e.value.backgroundColor,
        color: e.value.color,
        borderRadius: e.value.tooltipBorderRadius,
        borderColor: e.value.tooltipBorderColor,
        borderWidth: e.value.tooltipBorderWidth,
        fontSize: e.value.tooltipFontSize,
        backgroundOpacity: e.value.tooltipBackgroundOpacity,
        position: e.value.tooltipPosition,
        offsetY: e.value.tooltipOffsetY,
        parent: W.value,
        content: K.value,
        isCustom: f(ze)(e.value.tooltipCustomFormat)
      }, {
        "tooltip-before": Q(() => [
          U(u.$slots, "tooltip-before", H(re({ ...de.value })), void 0, !0)
        ]),
        "tooltip-after": Q(() => [
          U(u.$slots, "tooltip-after", H(re({ ...de.value })), void 0, !0)
        ]),
        _: 3
      }, 8, ["show", "backgroundColor", "color", "borderRadius", "borderColor", "borderWidth", "fontSize", "backgroundOpacity", "position", "offsetY", "parent", "content", "isCustom"])
    ], 14, Dt)) : (a(), l("div", sl, [
      se($e, {
        name: "circleCancel",
        stroke: "red"
      }),
      vl
    ]));
  }
}, Al = /* @__PURE__ */ Rt(dl, [["__scopeId", "data-v-e73a7249"]]);
export {
  Al as default
};
