import { computed as p, ref as i, watch as Ee, onMounted as Be, onBeforeUnmount as De, openBlock as r, createElementBlock as s, normalizeClass as z, normalizeStyle as Q, createBlock as w, createCommentVNode as g, unref as h, createSlots as Ge, withCtx as y, renderSlot as m, normalizeProps as R, guardReactiveProps as M, createVNode as Z, createElementVNode as $, Fragment as P, renderList as T, toDisplayString as V, createTextVNode as Ce, nextTick as We } from "vue";
import { u as Xe, c as Ye, t as je, a as qe, p as x, o as He, e as S, b as Je, g as _e, d as we, O as $e, v as Ke, i as Pe, f as U, X as Qe, s as ee, w as Ze, P as Te, x as et, y as tt, q as at, r as ot } from "./index-DnVHQ2xI.js";
import { t as lt, u as rt } from "./useResponsive-NZB-WLRF.js";
import { _ as nt } from "./Title-5VmBwT4i.js";
import { u as st, U as ut } from "./usePrinter-BEeNAqS5.js";
import { _ as it } from "./Tooltip-Cj4EF7v1.js";
import ct from "./vue-ui-sparkbar-0ixbKZzf.js";
import { L as dt } from "./Legend-CYF2gpXG.js";
import { D as vt } from "./DataTable-DTk7C4Pr.js";
import pt from "./vue-ui-skeleton-aZmkNzAe.js";
import ht from "./vue-ui-accordion-DspS4q3f.js";
import { u as xe } from "./useNestedProp-Cox0K0Y5.js";
import { _ as gt } from "./PackageVersion-CvCRsT5_.js";
import { P as ft } from "./PenAndPaper-Jb0pLt3G.js";
import { _ as yt } from "./_plugin-vue_export-helper-CHgC5LLL.js";
const mt = ["id"], bt = ["xmlns", "viewBox"], kt = ["id"], Ct = ["stop-color"], _t = ["stop-color"], wt = { key: 0 }, $t = ["x1", "y1", "x2", "y2", "stroke", "stroke-width"], Pt = { key: 0 }, Tt = ["d", "stroke", "stroke-width"], xt = ["d", "stroke", "stroke-width"], At = { key: 1 }, Ot = ["x", "y", "text-anchor", "font-size", "fill", "onMouseenter"], Nt = ["points", "stroke", "stroke-width"], St = ["points", "stroke", "stroke-width", "fill"], Ft = { key: 2 }, It = ["cx", "cy", "fill", "r", "stroke"], Lt = {
  key: 4,
  class: "vue-data-ui-watermark"
}, zt = ["onClick"], Rt = {
  key: 0,
  style: { "max-width": "200px", margin: "0 auto" }
}, Mt = {
  __name: "vue-ui-radar",
  props: {
    config: {
      type: Object,
      default() {
        return {};
      }
    },
    dataset: {
      type: Object,
      default() {
        return {};
      }
    }
  },
  emits: ["selectLegend"],
  setup(Ae, { expose: Oe, emit: Ne }) {
    const v = Ae, { vue_ui_radar: Se } = Xe(), F = p(() => !!v.dataset && Object.keys(v.dataset).length), _ = i(Ye()), Fe = i(null), W = i(!1), X = i(""), te = i(0), A = i(null), ae = i(null), oe = i(null), le = i(0), re = i(0), ne = i(0), e = p({
      get: () => se(),
      set: (t) => t
    });
    function se() {
      const t = xe({
        userConfig: v.config,
        defaultConfig: Se
      });
      return t.theme ? {
        ...xe({
          userConfig: je.vue_ui_radar[t.theme] || v.config,
          defaultConfig: t
        }),
        customPalette: qe[t.theme] || x
      } : t;
    }
    Ee(() => v.config, (t) => {
      e.value = se(), ue(), le.value += 1, re.value += 1, ne.value += 1;
    }, { deep: !0 });
    const E = i(null);
    function ue() {
      if (He(v.dataset) && S({
        componentName: "VueUiRadar",
        type: "dataset"
      }), e.value.responsive) {
        const t = lt(() => {
          const { width: a, height: o } = rt({
            chart: A.value,
            title: e.value.style.chart.title.text ? ae.value : null,
            legend: e.value.style.chart.legend.show ? oe.value : null
          });
          u.value.width = a, u.value.height = o;
        });
        E.value = new ResizeObserver(t), E.value.observe(A.value.parentNode);
      }
    }
    Be(() => {
      ue();
    }), De(() => {
      E.value && E.value.disconnect();
    });
    const { isPrinting: ie, isImaging: ce, generatePdf: de, generateImage: ve } = st({
      elementId: `vue-ui-radar_${_.value}`,
      fileName: e.value.style.chart.title.text || "vue-ui-radar"
    }), pe = p(() => Je(e.value.customPalette)), k = i({
      dataLabels: {
        show: e.value.style.chart.layout.labels.dataLabels.show
      },
      showTable: e.value.table.show,
      showTooltip: e.value.style.chart.tooltip.show
    }), Ie = p(() => ({
      style: {
        backgroundColor: e.value.style.chart.tooltip.backgroundColor,
        animation: {
          show: e.value.style.chart.tooltip.animation.show,
          animationFrames: e.value.style.chart.tooltip.animation.animationFrames
        },
        labels: {
          fontSize: e.value.style.chart.tooltip.fontSize,
          name: {
            color: e.value.style.chart.tooltip.color
          }
        },
        gutter: {
          backgroundColor: "#CCCCCC",
          opacity: 30
        }
      }
    })), u = i({
      height: 312,
      width: 512
    }), c = i([]), I = i(null), O = i(!1);
    function he(t) {
      O.value = !0, c.value.includes(t) ? (I.value = t, c.value = c.value.filter((a) => a !== t), setTimeout(() => {
        O.value = !1, I.value = null;
      }, 500)) : (c.value.push(t), setTimeout(() => {
        O.value = !1;
      }, 500)), Ne("selectLegend", N.value.filter((a, o) => !c.value.includes(o)).map((a) => ({
        name: a.name,
        color: a.color,
        proportion: a.totalProportion
      })));
    }
    function Le() {
      return N.value.map((t) => ({
        name: t.name,
        color: t.color,
        proportion: t.totalProportion
      }));
    }
    const f = p(() => [null, void 0].includes(v.dataset.categories) ? (S({
      componentName: "VueUiRadar",
      type: "datasetAttribute",
      property: "categories ({ name: string; prefix?: string; suffix?: string}[])"
    }), []) : (v.dataset.categories.length === 0 ? S({
      componentName: "VueUiRadar",
      type: "datasetAttributeEmpty",
      property: "categories"
    }) : v.dataset.categories.forEach((t, a) => {
      _e({
        datasetObject: t,
        requiredAttributes: ["name"]
      }).forEach((o) => {
        S({
          componentName: "VueUiRadar",
          type: "datasetAttribute",
          property: `category.${o} at index ${a}`,
          index: a
        });
      });
    }), [null, void 0].includes(v.dataset.series) ? S({
      componentName: "VueUiRadar",
      type: "datasetAttribute",
      property: "series ({ name: string; values: number[]; color?: string; target: number}[])"
    }) : v.dataset.series.forEach((t, a) => {
      _e({
        datasetObject: t,
        requiredAttributes: ["name", "values", "target"]
      }).forEach((o) => {
        S({
          componentName: "VueUiRadar",
          type: "datasetSerieAttribute",
          key: "series",
          property: o,
          index: a
        });
      });
    }), v.dataset.categories.map((t, a) => ({
      name: t.name,
      categoryId: `radar_category_${_.value}_${a}`,
      color: we(t.color) || pe.value[a] || x[a] || x[a % x.length],
      prefix: t.prefix ?? "",
      suffix: t.suffix ?? ""
    })))), b = p(() => F.value ? v.dataset.series.map((t, a) => ({
      ...t,
      color: we(t.color) || pe.value[a] || x[a] || x[a % x.length],
      serieId: `radar_serie_${_.value}_${a}`,
      formatter: t.formatter || null
    })) : []), ge = p(() => Math.max(...b.value.flatMap((t) => t.values))), fe = p(() => b.value.length), Y = p(() => Math.min(u.value.width, u.value.height) / 3), ye = p(() => $e({
      plot: { x: u.value.width / 2, y: u.value.height / 2 },
      radius: Y.value,
      sides: fe.value,
      rotation: 0
    })), ze = p(() => {
      const t = [];
      for (let a = 0; a < Y.value; a += Y.value / e.value.style.chart.layout.grid.graduations)
        t.push(a);
      return t;
    }), C = p(() => ye.value.coordinates.map((t, a) => {
      const o = b.value[a].values.map((l) => Re({
        centerX: u.value.width / 2,
        centerY: u.value.height / 2,
        apexX: t.x,
        apexY: t.y,
        proportion: l / (b.value[a].target || ge.value)
      }));
      return {
        ...t,
        ...b.value[a],
        plots: o
      };
    }));
    function j({ x: t, y: a }) {
      let o = "middle";
      return t = Math.round(t), a = Math.round(a), t > u.value.width / 2 && (t += 12, o = "start"), t < u.value.width / 2 && (t -= 12, o = "end"), a > u.value.height / 2 && (a += 20), a < u.value.height / 2 && (a -= 12), a === u.value.height / 2 && (a += 4), { x: t, y: a, anchor: o };
    }
    function Re({ centerX: t, centerY: a, apexX: o, apexY: l, proportion: n }) {
      return {
        x: t + (o - t) * n,
        y: a + (l - a) * n
      };
    }
    const N = p(() => {
      const t = b.value.map((a, o) => a.values.map((l) => l / (a.target || ge.value)));
      return f.value.map((a, o) => ({
        ...a,
        totalProportion: Ke(t.map((l) => l[o]).reduce((l, n) => l + n, 0) / b.value.length),
        shape: "circle",
        opacity: c.value.includes(o) ? 0.5 : 1,
        segregate: () => he(o),
        isSegregated: c.value.includes(o)
      }));
    }), Me = p(() => ({
      cy: "radar-div-legend",
      backgroundColor: e.value.style.chart.legend.backgroundColor,
      color: e.value.style.chart.legend.color,
      fontSize: e.value.style.chart.legend.fontSize,
      paddingBottom: 12,
      fontWeight: e.value.style.chart.legend.bold ? "bold" : ""
    })), B = p(() => {
      const t = [
        { name: e.value.translations.datapoint, color: "" },
        { name: e.value.translations.target, color: "" },
        ...N.value
      ], a = v.dataset.series.map((l) => [
        l.name,
        Pe(
          l.formatter,
          l.target,
          U({
            p: l.prefix,
            v: l.target,
            s: l.suffix,
            r: e.value.table.td.roundingValue
          })
        ),
        ...l.values.map((n, d) => `${Pe(
          l.formatter,
          n,
          U({ p: f.value[d].prefix, v: n, s: f.value[d].suffix, r: e.value.table.td.roundingValue })
        )} (${isNaN(n / l.target) ? "" : U({
          v: n / l.target * 100,
          s: "%",
          r: e.value.table.td.roundingPercentage
        })})`)
      ]), o = {
        th: {
          backgroundColor: e.value.table.th.backgroundColor,
          color: e.value.table.th.color,
          outline: e.value.table.th.outline
        },
        td: {
          backgroundColor: e.value.table.td.backgroundColor,
          color: e.value.table.td.color,
          outline: e.value.table.td.outline
        },
        breakpoint: e.value.table.responsiveBreakpoint
      };
      return { head: t, body: a, config: o, colNames: t };
    }), D = i(null), q = i([]), H = i(null);
    function Ve(t, a) {
      q.value = [], D.value = a, W.value = !0;
      let o = "";
      H.value = {
        datapoint: t,
        seriesIndex: a,
        series: {
          categories: f.value,
          datapoints: b.value,
          radar: C.value
        },
        config: e.value
      };
      const l = e.value.style.chart.tooltip.customFormat;
      if (et(l) && tt(() => l({
        seriesIndex: a,
        datapoint: t,
        series: { categories: f.value, datapoints: b.value, radar: C.value },
        config: e.value
      })))
        X.value = l({
          seriesIndex: a,
          datapoint: t,
          series: { categories: f.value, datapoints: b.value, radar: C.value },
          config: e.value
        });
      else {
        o += `<div style="width:100%;text-align:center;border-bottom:1px solid ${e.value.style.chart.tooltip.borderColor};padding-bottom:6px;margin-bottom:3px;">${t.name}</div>`;
        for (let n = 0; n < t.values.length; n += 1)
          c.value.includes(n) || q.value.push({
            name: f.value[n].name,
            value: t.values[n] / t.target * 100,
            color: f.value[n].color,
            suffix: "%)",
            prefix: `${U({ p: f.value[n].prefix ?? "", v: t.values[n], s: f.value[n].suffix ?? "", r: e.value.style.chart.tooltip.roundingValue })} (`,
            rounding: e.value.style.chart.tooltip.roundingPercentage,
            formatter: t.formatter
          });
        X.value = o;
      }
    }
    function me() {
      We(() => {
        const t = [[e.value.style.chart.title.text], [e.value.style.chart.title.subtitle.text], [""]], a = [[""], [e.value.translations.target], ...N.value.flatMap((d) => [[d.name], ["%"]])], o = v.dataset.series.map((d, Vt) => [d.name, d.target, ...d.values.flatMap((K) => [
          K,
          isNaN(K / d.target) ? "" : K / d.target * 100
        ])]), l = t.concat([a]).concat(o), n = at(l);
        ot({ csvContent: n, title: e.value.style.chart.title.text || "vue-ui-radar" });
      });
    }
    const L = i(!1);
    function Ue(t) {
      L.value = t, te.value += 1;
    }
    function be() {
      k.value.showTable = !k.value.showTable;
    }
    function ke() {
      k.value.showTooltip = !k.value.showTooltip;
    }
    const G = i(!1);
    function J() {
      G.value = !G.value;
    }
    return Oe({
      getData: Le,
      generatePdf: de,
      generateCsv: me,
      generateImage: ve,
      toggleTable: be,
      toggleTooltip: ke,
      toggleAnnotator: J
    }), (t, a) => (r(), s("div", {
      class: z(`vue-ui-radar ${L.value ? "vue-data-ui-wrapper-fullscreen" : ""} ${e.value.useCssAnimation ? "" : "vue-ui-dna"}`),
      ref_key: "radarChart",
      ref: A,
      id: `vue-ui-radar_${_.value}`,
      style: Q(`font-family:${e.value.style.fontFamily};width:100%; ${e.value.responsive ? "height: 100%;" : ""} text-align:center;${e.value.style.chart.title.text ? "" : "padding-top:36px"};background:${e.value.style.chart.backgroundColor}`)
    }, [
      e.value.userOptions.buttons.annotator ? (r(), w(ft, {
        key: 0,
        parent: A.value,
        backgroundColor: e.value.style.chart.backgroundColor,
        color: e.value.style.chart.color,
        active: G.value,
        onClose: J
      }, null, 8, ["parent", "backgroundColor", "color", "active"])) : g("", !0),
      e.value.style.chart.title.text ? (r(), s("div", {
        key: 1,
        ref_key: "chartTitle",
        ref: ae,
        style: "width:100%;background:transparent;padding-bottom:12px"
      }, [
        (r(), w(nt, {
          key: `title_${le.value}`,
          config: {
            title: {
              cy: "radar-div-title",
              ...e.value.style.chart.title
            },
            subtitle: {
              cy: "radar-div-subtitle",
              ...e.value.style.chart.title.subtitle
            }
          }
        }, null, 8, ["config"]))
      ], 512)) : g("", !0),
      e.value.userOptions.show && F.value ? (r(), w(ut, {
        ref_key: "details",
        ref: Fe,
        key: `user_options_${te.value}`,
        backgroundColor: e.value.style.chart.backgroundColor,
        color: e.value.style.chart.color,
        isImaging: h(ce),
        isPrinting: h(ie),
        uid: _.value,
        hasTooltip: e.value.userOptions.buttons.tooltip && e.value.style.chart.tooltip.show,
        hasPdf: e.value.userOptions.buttons.pdf,
        hasImg: e.value.userOptions.buttons.img,
        hasXls: e.value.userOptions.buttons.csv,
        hasTable: e.value.userOptions.buttons.table,
        hasFullscreen: e.value.userOptions.buttons.fullscreen,
        isFullscreen: L.value,
        isTooltip: k.value.showTooltip,
        titles: { ...e.value.userOptions.buttonTitles },
        chartElement: A.value,
        position: e.value.userOptions.position,
        hasAnnotator: e.value.userOptions.buttons.annotator,
        isAnnotation: G.value,
        onToggleFullscreen: Ue,
        onGeneratePdf: h(de),
        onGenerateCsv: me,
        onGenerateImage: h(ve),
        onToggleTable: be,
        onToggleTooltip: ke,
        onToggleAnnotator: J
      }, Ge({ _: 2 }, [
        t.$slots.optionTooltip ? {
          name: "optionTooltip",
          fn: y(() => [
            m(t.$slots, "optionTooltip", {}, void 0, !0)
          ]),
          key: "0"
        } : void 0,
        t.$slots.optionPdf ? {
          name: "optionPdf",
          fn: y(() => [
            m(t.$slots, "optionPdf", {}, void 0, !0)
          ]),
          key: "1"
        } : void 0,
        t.$slots.optionCsv ? {
          name: "optionCsv",
          fn: y(() => [
            m(t.$slots, "optionCsv", {}, void 0, !0)
          ]),
          key: "2"
        } : void 0,
        t.$slots.optionImg ? {
          name: "optionImg",
          fn: y(() => [
            m(t.$slots, "optionImg", {}, void 0, !0)
          ]),
          key: "3"
        } : void 0,
        t.$slots.optionTable ? {
          name: "optionTable",
          fn: y(() => [
            m(t.$slots, "optionTable", {}, void 0, !0)
          ]),
          key: "4"
        } : void 0,
        t.$slots.optionFullscreen ? {
          name: "optionFullscreen",
          fn: y(({ toggleFullscreen: o, isFullscreen: l }) => [
            m(t.$slots, "optionFullscreen", R(M({ toggleFullscreen: o, isFullscreen: l })), void 0, !0)
          ]),
          key: "5"
        } : void 0,
        t.$slots.optionAnnotator ? {
          name: "optionAnnotator",
          fn: y(({ toggleAnnotator: o, isAnnotator: l }) => [
            m(t.$slots, "optionAnnotator", R(M({ toggleAnnotator: o, isAnnotator: l })), void 0, !0)
          ]),
          key: "6"
        } : void 0
      ]), 1032, ["backgroundColor", "color", "isImaging", "isPrinting", "uid", "hasTooltip", "hasPdf", "hasImg", "hasXls", "hasTable", "hasFullscreen", "isFullscreen", "isTooltip", "titles", "chartElement", "position", "hasAnnotator", "isAnnotation", "onGeneratePdf", "onGenerateImage"])) : g("", !0),
      F.value ? (r(), s("svg", {
        key: 3,
        xmlns: h(Qe),
        class: z({ "vue-data-ui-fullscreen--on": L.value, "vue-data-ui-fulscreen--off": !L.value }),
        viewBox: `0 0 ${u.value.width <= 0 ? 10 : u.value.width} ${u.value.height <= 0 ? 10 : u.value.height}`,
        style: Q(`max-width:100%;overflow:visible;background:transparent;color:${e.value.style.chart.color}`)
      }, [
        Z(gt),
        $("defs", null, [
          (r(!0), s(P, null, T(f.value, (o, l) => (r(), s("radialGradient", {
            cx: "50%",
            cy: "50%",
            r: "50%",
            fx: "50%",
            fy: "50%",
            id: `radar_gradient_${_.value}_${l}`
          }, [
            $("stop", {
              offset: "0%",
              "stop-color": h(ee)(h(Ze)(o.color, 0.05), e.value.style.chart.layout.dataPolygon.opacity)
            }, null, 8, Ct),
            $("stop", {
              offset: "100%",
              "stop-color": h(ee)(o.color, e.value.style.chart.layout.dataPolygon.opacity)
            }, null, 8, _t)
          ], 8, kt))), 256))
        ]),
        e.value.style.chart.layout.grid.show ? (r(), s("g", wt, [
          (r(!0), s(P, null, T(C.value, (o) => (r(), s("line", {
            x1: u.value.width / 2,
            y1: u.value.height / 2,
            x2: o.x,
            y2: o.y,
            stroke: e.value.style.chart.layout.grid.stroke,
            "stroke-width": e.value.style.chart.layout.grid.strokeWidth
          }, null, 8, $t))), 256)),
          e.value.style.chart.layout.grid.graduations > 0 ? (r(), s("g", Pt, [
            (r(!0), s(P, null, T(ze.value, (o) => (r(), s("path", {
              d: h($e)({
                plot: { x: u.value.width / 2, y: u.value.height / 2 },
                radius: o,
                sides: fe.value,
                rotation: 0
              }).path,
              fill: "none",
              stroke: e.value.style.chart.layout.grid.stroke,
              "stroke-width": e.value.style.chart.layout.grid.strokeWidth
            }, null, 8, Tt))), 256))
          ])) : g("", !0)
        ])) : g("", !0),
        $("path", {
          d: ye.value.path,
          fill: "none",
          stroke: e.value.style.chart.layout.outerPolygon.stroke,
          "stroke-width": e.value.style.chart.layout.outerPolygon.strokeWidth,
          "stroke-linejoin": "round",
          "stroke-linecap": "round"
        }, null, 8, xt),
        e.value.style.chart.layout.labels.dataLabels.show ? (r(), s("g", At, [
          (r(!0), s(P, null, T(C.value, (o, l) => (r(), s("text", {
            x: j(o).x,
            y: j(o).y,
            "text-anchor": j(o).anchor,
            "font-size": e.value.style.chart.layout.labels.dataLabels.fontSize,
            fill: e.value.style.chart.layout.labels.dataLabels.color,
            onMouseenter: (n) => Ve(o, l),
            onMouseleave: a[0] || (a[0] = (n) => {
              W.value = !1, D.value = null;
            })
          }, V(o.name), 41, Ot))), 256))
        ])) : g("", !0),
        (r(!0), s(P, null, T(f.value, (o, l) => (r(), s("g", null, [
          $("g", null, [
            e.value.useCssAnimation || !e.value.useCssAnimation && !c.value.includes(l) ? (r(), s("polygon", {
              key: 0,
              "data-cy-radar-path": "",
              points: h(Te)(C.value.map((n) => n.plots[l]), !1, !0),
              stroke: e.value.style.chart.backgroundColor,
              "stroke-width": e.value.style.chart.layout.dataPolygon.strokeWidth + 1,
              fill: "none",
              class: z({ "animated-out": c.value.includes(l) && e.value.useCssAnimation, "animated-in": O.value && I.value === l && e.value.useCssAnimation })
            }, null, 10, Nt)) : g("", !0),
            e.value.useCssAnimation || !e.value.useCssAnimation && !c.value.includes(l) ? (r(), s("polygon", {
              key: 1,
              "data-cy-radar-path": "",
              points: h(Te)(C.value.map((n) => n.plots[l]), !1, !0),
              stroke: o.color,
              "stroke-width": e.value.style.chart.layout.dataPolygon.strokeWidth,
              fill: e.value.style.chart.layout.dataPolygon.transparent ? "transparent" : e.value.style.chart.layout.dataPolygon.useGradient ? `url(#radar_gradient_${_.value}_${l})` : h(ee)(o.color, e.value.style.chart.layout.dataPolygon.opacity),
              class: z({ "animated-out": c.value.includes(l) && e.value.useCssAnimation, "animated-in": O.value && I.value === l && e.value.useCssAnimation })
            }, null, 10, St)) : g("", !0)
          ])
        ]))), 256)),
        e.value.style.chart.layout.plots.show ? (r(), s("g", Ft, [
          (r(!0), s(P, null, T(C.value, (o, l) => (r(), s("g", null, [
            (r(!0), s(P, null, T(o.plots, (n, d) => (r(), s("circle", {
              cx: n.x,
              cy: n.y,
              fill: c.value.includes(d) ? "transparent" : f.value[d].color,
              r: D.value !== null && D.value === l ? e.value.style.chart.layout.plots.radius * 1.6 : e.value.style.chart.layout.plots.radius,
              stroke: c.value.includes(d) ? "transparent" : e.value.style.chart.backgroundColor,
              "stroke-width": 0.5,
              class: z({ "animated-out": c.value.includes(d) && e.value.useCssAnimation, "animated-in": O.value && I.value === d && e.value.useCssAnimation })
            }, null, 10, It))), 256))
          ]))), 256))
        ])) : g("", !0),
        m(t.$slots, "svg", { svg: u.value }, void 0, !0)
      ], 14, bt)) : g("", !0),
      t.$slots.watermark ? (r(), s("div", Lt, [
        m(t.$slots, "watermark", R(M({ isPrinting: h(ie) || h(ce) })), void 0, !0)
      ])) : g("", !0),
      F.value ? g("", !0) : (r(), w(pt, {
        key: 5,
        config: {
          type: "radar",
          style: {
            backgroundColor: e.value.style.chart.backgroundColor,
            radar: {
              grid: {
                color: e.value.style.chart.layout.outerPolygon.stroke
              },
              shapes: {
                color: e.value.style.chart.layout.outerPolygon.stroke
              }
            }
          }
        }
      }, null, 8, ["config"])),
      $("div", {
        ref_key: "chartLegend",
        ref: oe
      }, [
        e.value.style.chart.legend.show ? (r(), w(dt, {
          key: `legend_${ne.value}`,
          legendSet: N.value,
          config: Me.value,
          onClickMarker: a[1] || (a[1] = ({ i: o }) => he(o))
        }, {
          item: y(({ legend: o, index: l }) => [
            $("div", {
              "data-cy-legend-item": "",
              onClick: (n) => o.segregate(),
              style: Q(`opacity:${c.value.includes(l) ? 0.5 : 1}`)
            }, V(o.name) + ": " + V(h(U)({
              v: o.totalProportion * 100,
              s: "%",
              r: e.value.style.chart.legend.roundingPercentage
            })), 13, zt)
          ]),
          _: 1
        }, 8, ["legendSet", "config"])) : m(t.$slots, "legend", {
          key: 1,
          legend: N.value
        }, void 0, !0)
      ], 512),
      Z(it, {
        show: k.value.showTooltip && W.value,
        backgroundColor: e.value.style.chart.tooltip.backgroundColor,
        color: e.value.style.chart.tooltip.color,
        borderRadius: e.value.style.chart.tooltip.borderRadius,
        borderColor: e.value.style.chart.tooltip.borderColor,
        borderWidth: e.value.style.chart.tooltip.borderWidth,
        backgroundOpacity: e.value.style.chart.tooltip.backgroundOpacity,
        fontSize: e.value.style.chart.tooltip.fontSize,
        position: e.value.style.chart.tooltip.position,
        offsetY: e.value.style.chart.tooltip.offsetY,
        parent: A.value,
        content: X.value,
        isCustom: e.value.style.chart.tooltip.customFormat && typeof e.value.style.chart.tooltip.customFormat == "function"
      }, {
        "tooltip-before": y(() => [
          m(t.$slots, "tooltip-before", R(M({ ...H.value })), void 0, !0)
        ]),
        "tooltip-after": y(() => [
          ["function"].includes(typeof e.value.style.chart.tooltip.customFormat) ? g("", !0) : (r(), s("div", Rt, [
            Z(ct, {
              dataset: q.value,
              config: Ie.value,
              backgroundOpacity: e.value.style.chart.tooltip.backgroundOpacity
            }, null, 8, ["dataset", "config", "backgroundOpacity"])
          ])),
          m(t.$slots, "tooltip-after", R(M({ ...H.value })), void 0, !0)
        ]),
        _: 3
      }, 8, ["show", "backgroundColor", "color", "borderRadius", "borderColor", "borderWidth", "backgroundOpacity", "fontSize", "position", "offsetY", "parent", "content", "isCustom"]),
      F.value ? (r(), w(ht, {
        key: 6,
        hideDetails: "",
        config: {
          open: k.value.showTable,
          maxHeight: 1e4,
          body: {
            backgroundColor: e.value.style.chart.backgroundColor,
            color: e.value.style.chart.color
          },
          head: {
            backgroundColor: e.value.style.chart.backgroundColor,
            color: e.value.style.chart.color
          }
        }
      }, {
        content: y(() => [
          (r(), w(vt, {
            key: `table_${re.value}`,
            colNames: B.value.colNames,
            head: B.value.head,
            body: B.value.body,
            config: B.value.config,
            title: `${e.value.style.chart.title.text}${e.value.style.chart.title.subtitle.text ? ` : ${e.value.style.chart.title.subtitle.text}` : ""}`,
            onClose: a[2] || (a[2] = (o) => k.value.showTable = !1)
          }, {
            th: y(({ th: o }) => [
              Ce(V(o.name), 1)
            ]),
            td: y(({ td: o }) => [
              Ce(V(o), 1)
            ]),
            _: 1
          }, 8, ["colNames", "head", "body", "config", "title"]))
        ]),
        _: 1
      }, 8, ["config"])) : g("", !0)
    ], 14, mt));
  }
}, ea = /* @__PURE__ */ yt(Mt, [["__scopeId", "data-v-14b2c666"]]);
export {
  ea as default
};
