import { computed as k, ref as p, watch as Je, onMounted as Ke, onBeforeUnmount as Qe, openBlock as o, createElementBlock as r, normalizeClass as Xe, normalizeStyle as q, createBlock as Y, createCommentVNode as d, unref as v, createSlots as Ze, withCtx as _, renderSlot as A, normalizeProps as Q, guardReactiveProps as Z, createVNode as he, createElementVNode as c, Fragment as P, renderList as X, toDisplayString as M, createTextVNode as et, nextTick as tt } from "vue";
import { u as lt, c as at, t as ot, a as st, p as U, o as ut, e as pe, b as rt, g as Ie, R as it, V as nt, X as vt, T as yt, s as fe, i as j, v as $, f as W, x as ct, y as dt, q as ht, r as pt } from "./index-DnVHQ2xI.js";
import { t as ft, u as gt } from "./useResponsive-NZB-WLRF.js";
import { _ as xt } from "./Title-5VmBwT4i.js";
import { u as mt, U as bt } from "./usePrinter-BEeNAqS5.js";
import { _ as kt } from "./Tooltip-Cj4EF7v1.js";
import { L as _t } from "./Legend-CYF2gpXG.js";
import { _ as De } from "./Shape-BpPn4eWR.js";
import { D as wt } from "./DataTable-DTk7C4Pr.js";
import Mt from "./vue-ui-skeleton-aZmkNzAe.js";
import $t from "./vue-ui-accordion-DspS4q3f.js";
import { u as Ye } from "./useNestedProp-Cox0K0Y5.js";
import { _ as Ct } from "./PackageVersion-CvCRsT5_.js";
import { P as zt } from "./PenAndPaper-Jb0pLt3G.js";
import { _ as At } from "./_plugin-vue_export-helper-CHgC5LLL.js";
const St = ["id"], Lt = ["xmlns", "viewBox"], Tt = { key: 0 }, Bt = ["x1", "x2", "y1", "y2", "stroke", "stroke-width"], Nt = ["x1", "x2", "y1", "y2", "stroke", "stroke-width"], Pt = { key: 1 }, Wt = ["points", "fill", "stroke-width", "stroke-dasharray", "stroke"], Ot = { key: 0 }, Ft = ["cx", "cy", "r", "fill", "stroke", "stroke-width", "onMouseover"], Xt = { key: 1 }, It = { key: 2 }, Dt = ["id"], Yt = ["stop-color"], jt = ["stop-color"], Vt = ["id"], Et = ["stop-color"], Gt = ["stop-color"], Rt = ["x", "y", "width", "height", "fill", "stroke", "stroke-width", "rx"], qt = ["x", "y", "height", "width", "fill", "stroke", "stroke-width", "rx"], Ut = { key: 0 }, Ht = ["d", "stroke", "stroke-width"], Jt = ["d", "stroke", "stroke-width"], Kt = ["d", "stroke", "stroke-width"], Qt = ["d", "stroke", "stroke-width"], Zt = {
  key: 3,
  style: { "pointer-events": "none !important" }
}, el = ["x1", "x2", "y1", "y2", "stroke", "stroke-width", "stroke-dasharray"], tl = ["x1", "x2", "y1", "y2", "stroke", "stroke-width", "stroke-dasharray"], ll = ["x", "y", "font-size", "fill", "font-weight", "text-anchor"], al = ["x", "y", "font-size", "fill", "font-weight"], ol = ["cx", "cy", "r", "fill", "stroke", "stroke-width"], sl = ["cx", "cy", "r", "fill", "stroke", "stroke-width"], ul = ["x", "y", "font-size", "fill", "font-weight", "text-anchor"], rl = { key: 4 }, il = ["x", "y", "font-size", "fill"], nl = ["x", "y", "font-size", "fill"], vl = ["id", "transform", "font-size", "font-weight", "fill"], yl = { key: 5 }, cl = ["x", "y", "font-size", "fill"], dl = ["x", "y", "font-size", "fill"], hl = ["font-size", "font-weight", "fill", "x", "y"], pl = ["id"], fl = ["x", "y", "width", "height"], gl = { key: 6 }, xl = ["x1", "x2", "y1", "y2", "stroke-dasharray", "stroke", "stroke-width", "clip-path"], ml = ["x", "y", "fill", "font-size", "font-weight"], bl = {
  key: 4,
  class: "vue-data-ui-watermark"
}, kl = ["onClick"], _l = {
  key: 0,
  style: { width: "100%", display: "flex", "align-items": "center", "justify-content": "center" }
}, wl = {
  viewBox: "0 0 20 20",
  height: "20",
  width: "20",
  style: { overflow: "hidden", background: "transparent" }
}, Ml = { key: 0 }, $l = ["innerHTML"], Cl = {
  __name: "vue-ui-scatter",
  props: {
    config: {
      type: Object,
      default() {
        return {};
      }
    },
    dataset: {
      type: Array,
      default() {
        return [];
      }
    }
  },
  setup(je, { expose: Ve }) {
    const O = je, { vue_ui_scatter: Ee } = lt(), ee = k(() => !!O.dataset && O.dataset.length), C = p(at()), Ge = p(null), ue = p(!1), re = p(""), ge = p(0), H = p(null), xe = p(null), me = p(null), be = p(0), ke = p(0), _e = p(0), e = k({
      get: () => we(),
      set: (l) => l
    });
    function we() {
      const l = Ye({
        userConfig: O.config,
        defaultConfig: Ee
      });
      return l.theme ? {
        ...Ye({
          userConfig: ot.vue_ui_scatter[l.theme] || O.config,
          defaultConfig: l
        }),
        customPalette: st[l.theme] || U
      } : l;
    }
    Je(() => O.config, (l) => {
      e.value = we(), Me(), be.value += 1, ke.value += 1, _e.value += 1;
    }, { deep: !0 });
    const te = p(null);
    Ke(() => {
      Me();
    });
    function Me() {
      if (ut(O.dataset) && pe({
        componentName: "VueUiScatter",
        type: "dataset"
      }), e.value.responsive) {
        const l = ft(() => {
          const { width: i, height: t } = gt({
            chart: H.value,
            title: e.value.style.title.text ? xe.value : null,
            legend: e.value.style.legend.show ? me.value : null
          });
          z.value.width = i, z.value.height = t;
        });
        te.value = new ResizeObserver(l), te.value.observe(H.value.parentNode);
      }
    }
    Qe(() => {
      te.value && te.value.disconnect();
    });
    const { isPrinting: $e, isImaging: Ce, generatePdf: ze, generateImage: Ae } = mt({
      elementId: `vue-ui-scatter_${C.value}`,
      fileName: e.value.style.title.text || "vue-ui-scatter"
    }), Se = k(() => rt(e.value.customPalette)), I = p({
      showTable: e.value.table.show,
      showTooltip: e.value.style.tooltip.show
    }), z = p({
      height: e.value.style.layout.height,
      width: e.value.style.layout.width
    }), le = k(() => e.value.style.layout.marginalBars.show ? e.value.style.layout.marginalBars.size + e.value.style.layout.marginalBars.offset : 0), u = k(() => ({
      top: e.value.style.layout.padding.top + le.value,
      right: z.value.width - e.value.style.layout.padding.right - le.value,
      bottom: z.value.height - e.value.style.layout.padding.bottom,
      left: e.value.style.layout.padding.left,
      height: z.value.height - e.value.style.layout.padding.top - e.value.style.layout.padding.bottom - le.value,
      width: z.value.width - e.value.style.layout.padding.left - e.value.style.layout.padding.right - le.value
    })), h = k(() => {
      O.dataset.forEach((a, n) => {
        Ie({
          datasetObject: a,
          requiredAttributes: ["values"]
        }).forEach((m) => {
          pe({
            componentName: "VueUiScatter",
            type: "datasetSerieAttribute",
            property: m,
            index: n
          });
        }), a.values && a.values.forEach((m, E) => {
          Ie({
            datasetObject: m,
            requiredAttributes: ["x", "y"]
          }).forEach((J) => {
            pe({
              componentName: "VueUiScatter",
              type: "datasetSerieAttribute",
              property: `values.${J}`,
              index: `${n} - ${E}`
            });
          });
        });
      });
      const l = Math.min(...V.value.filter((a) => !x.value.includes(a.id)).flatMap((a) => a.values.map((n) => n.x))), i = Math.max(...V.value.filter((a) => !x.value.includes(a.id)).flatMap((a) => a.values.map((n) => n.x))), t = Math.min(...V.value.filter((a) => !x.value.includes(a.id)).flatMap((a) => a.values.map((n) => n.y))), s = Math.max(...V.value.filter((a) => !x.value.includes(a.id)).flatMap((a) => a.values.map((n) => n.y)));
      return { xMin: l >= 0 ? 0 : l, xMax: i, yMin: t >= 0 ? 0 : t, yMax: s };
    }), f = k(() => ({
      x: u.value.left + Math.abs(h.value.xMin) / (h.value.xMax + Math.abs(h.value.xMin)) * u.value.width,
      y: u.value.bottom - Math.abs(h.value.yMin) / (h.value.yMax + Math.abs(h.value.yMin)) * u.value.height
    })), V = k(() => O.dataset.map((l, i) => {
      const t = `cluster_${C.value}_${i}`;
      return {
        ...l,
        id: t,
        color: l.color ? l.color : Se.value[i] || U[i] || U[i % U.length],
        opacity: x.value.includes(t) ? 0.5 : 1,
        shape: l.shape ?? "circle",
        segregate: () => Pe(t),
        isSegregated: x.value.includes(t)
      };
    })), Re = k(() => ({
      cy: "scatter-div-legend",
      backgroundColor: e.value.style.legend.backgroundColor,
      color: e.value.style.legend.color,
      fontSize: e.value.style.legend.fontSize,
      paddingBottom: 12,
      fontWeight: e.value.style.legend.bold ? "bold" : ""
    })), ie = k(() => V.value.map((l, i) => ({
      ...l,
      plots: l.values.map((t) => ({
        x: u.value.left + (t.x + Math.abs(h.value.xMin)) / (h.value.xMax + Math.abs(h.value.xMin)) * u.value.width,
        y: u.value.bottom - (t.y + Math.abs(h.value.yMin)) / (h.value.yMax + Math.abs(h.value.yMin)) * u.value.height,
        v: {
          ...t,
          name: t.name || ""
        },
        clusterName: l.name,
        color: l.color ? l.color : Se.value[i] || U[i] || U[i % U.length],
        id: `plot_${C.value}_${Math.random()}`,
        weight: t.weight ?? e.value.style.layout.plots.radius
      }))
    })).filter((l) => !x.value.includes(l.id))), S = k(() => ie.value.map((l) => {
      const i = l.plots.reduce((g, G) => g + G.x, 0) / l.plots.length, t = l.plots.reduce((g, G) => g + G.y, 0) / l.plots.length;
      let s = 0, a = 0, n = 0;
      for (const g of l.plots)
        s += (g.x - i) * (g.y - t), a += (g.x - i) ** 2, n += (g.y - t) ** 2;
      const m = s / Math.sqrt(a * n), E = m * (Math.sqrt(n) / Math.sqrt(a)), J = t - E * i, N = {
        x1: u.value.left,
        x2: u.value.right,
        y1: E * u.value.left + J,
        y2: E * u.value.right + J,
        coefficient: m
      }, w = (N.y2 - N.y1) / (N.x2 - N.x1), T = N.y1 - w * N.x1, F = Math.min(z.value.width - e.value.style.layout.padding.right, Math.max(e.value.style.layout.padding.left, (u.value.top - T) / w)), se = {
        x: F,
        y: w * F + T <= e.value.style.layout.padding.top ? u.value.top : w * F + T
      };
      return {
        ...l,
        correlation: N,
        label: se,
        plots: l.plots.map((g) => {
          const G = (g.x + w * g.y - w * T) / (1 + Math.pow(w, 2)), ye = (w * g.x + Math.pow(w, 2) * g.y + T) / (1 + Math.pow(w, 2)), b = Math.sqrt(Math.pow(g.x - G, 2) + Math.pow(g.y - ye, 2));
          return {
            ...g,
            deviation: b,
            shape: l.shape,
            color: l.color
          };
        })
      };
    })), Le = k(() => Math.max(...S.value.flatMap((l) => l.plots.map((i) => Math.abs(i.deviation)))));
    function qe() {
      return S.value;
    }
    function Te(l, i) {
      const t = Array.isArray(l) ? l.flatMap((b) => b.plots.map((R) => ({
        x: R.x,
        y: R.y
      }))) : l.plots.map((b) => ({
        x: b.x,
        y: b.y
      }));
      let s = 1 / 0, a = -1 / 0, n = 1 / 0, m = -1 / 0;
      t.forEach(({ x: b, y: R }) => {
        s = Math.min(s, b), a = Math.max(a, b), n = Math.min(n, R), m = Math.max(m, R);
      });
      const E = a - s, J = m - n, N = E / i, w = J / i, T = Array(i).fill(0), F = Array(i).fill(0);
      t.forEach(({ x: b, y: R }) => {
        const ce = Math.floor((b - s) / N), de = Math.floor((R - n) / w);
        T[ce] || (T[ce] = 0), F[de] || (F[de] = 0), T[ce] += 1, F[de] += 1;
      });
      const se = [], g = [];
      for (let b = 0; b < i; b += 1)
        se.push(s + (b + 0.5) * N), g.push(n + (b + 0.5) * w);
      const G = Math.max(...T), ye = Math.max(...F);
      return { x: T, y: F, avgX: se, avgY: g, maxX: G, maxY: ye };
    }
    const D = k(() => e.value.style.layout.marginalBars.tranches), L = k(() => Te(ie.value, D.value)), Ue = k(() => {
      const l = u.value.top - e.value.style.layout.marginalBars.offset, i = u.value.right + e.value.style.layout.marginalBars.offset;
      return ie.value.map((t) => {
        const s = Te(t, D.value);
        return {
          coords: s,
          dX: it(s.avgX.map((a, n) => ({
            x: a,
            y: l - s.x[n] / s.maxX * e.value.style.layout.marginalBars.size
          }))),
          dY: nt(s.avgY.map((a, n) => ({
            y: a,
            x: i + e.value.style.layout.marginalBars.size * s.y[n] / s.maxY
          }))),
          color: t.color,
          id: t.id
        };
      });
    }), B = p(void 0), y = p(null), ne = p(null);
    function Be(l, i) {
      B.value = l.id, y.value = l;
      let t = "";
      ne.value = {
        datapoint: l,
        seriesIndex: i,
        series: S.value,
        config: e.value
      };
      const s = e.value.style.tooltip.customFormat;
      ct(s) && dt(() => s({
        datapoint: l,
        seriesIndex: i,
        series: S.value,
        config: e.value
      })) ? re.value = s({
        datapoint: l,
        seriesIndex: i,
        series: S.value,
        config: e.value
      }) : (l.clusterName && (t += `<div style="display:flex;gap:3px;align-items:center">${l.clusterName}</div>`), l.v.name && (t += `<div>${l.v.name}</div>`), t += `<div style="text-align:left;margin-top:6px;padding-top:6px;border-top:1px solid ${e.value.style.tooltip.borderColor}">`, t += `<div>${e.value.style.layout.dataLabels.xAxis.name}: <b>${isNaN(l.v.x) ? "-" : j(
        e.value.style.layout.plots.selectors.labels.x.formatter,
        l.v.x,
        W({
          p: e.value.style.tooltip.prefix,
          v: l.v.x,
          s: e.value.style.tooltip.suffix,
          r: e.value.style.tooltip.roundingValue
        }),
        { datapoint: l, seriesIndex: i }
      )}</b></div>`, t += `<div>${e.value.style.layout.dataLabels.yAxis.name}: <b>${isNaN(l.v.y) ? "-" : j(
        e.value.style.layout.plots.selectors.labels.y.formatter,
        l.v.y,
        W({
          p: e.value.style.tooltip.prefix,
          v: l.v.y,
          s: e.value.style.tooltip.suffix,
          r: e.value.style.tooltip.roundingValue
        }),
        { datapoint: l, seriesIndex: i }
      )}</b></div>`, t += `${e.value.style.layout.plots.deviation.translation}: <b>${W({
        v: l.deviation,
        r: e.value.style.layout.plots.deviation.roundingValue
      })}</b>`, t += "</div>", re.value = `<div>${t}</div>`), ue.value = !0;
    }
    function Ne() {
      ue.value = !1, B.value = void 0, y.value = null;
    }
    const x = p([]);
    function Pe(l) {
      x.value.includes(l) ? x.value = x.value.filter((i) => i !== l) : x.value.length < O.dataset.length - 1 && x.value.push(l);
    }
    function We() {
      tt(() => {
        const l = ["", e.value.table.translations.correlationCoefficient, e.value.table.translations.nbrPlots, `${e.value.style.layout.dataLabels.xAxis.name} ${e.value.table.translations.average}`, `${e.value.style.layout.dataLabels.yAxis.name} ${e.value.table.translations.average}`], i = S.value.map((a) => [
          a.name,
          a.correlation.coefficient,
          a.plots.length,
          a.plots.map((n) => n.v.x).reduce((n, m) => n + m, 0) / a.plots.length,
          a.plots.map((n) => n.v.y).reduce((n, m) => n + m, 0) / a.plots.length
        ]), t = [[e.value.style.title.text], [e.value.style.title.subtitle.text], [[""], [""], [""]]].concat([l]).concat(i), s = ht(t);
        pt({ csvContent: s, title: e.value.style.title.text || "vue-ui-heatmap" });
      });
    }
    const ae = k(() => {
      const l = [
        e.value.table.translations.series,
        e.value.table.translations.correlationCoefficient,
        e.value.table.translations.nbrPlots,
        `${e.value.style.layout.dataLabels.xAxis.name} ${e.value.table.translations.average}`,
        `${e.value.style.layout.dataLabels.yAxis.name} ${e.value.table.translations.average}`
      ], i = S.value.map((s) => [
        {
          shape: s.shape,
          content: s.name,
          color: s.color
        },
        Number((s.correlation.coefficient ?? 0).toFixed(e.value.table.td.roundingValue)).toLocaleString(),
        s.plots.length.toLocaleString(),
        Number((s.plots.map((a) => a.v.x ?? 0).reduce((a, n) => a + n, 0) / s.plots.length).toFixed(e.value.table.td.roundingAverage)).toLocaleString(),
        Number((s.plots.map((a) => a.v.y ?? 0).reduce((a, n) => a + n, 0) / s.plots.length).toFixed(e.value.table.td.roundingAverage)).toLocaleString()
      ]), t = {
        th: {
          backgroundColor: e.value.table.th.backgroundColor,
          color: e.value.table.th.color,
          outline: e.value.table.th.outline
        },
        td: {
          backgroundColor: e.value.table.td.backgroundColor,
          color: e.value.table.td.color,
          outline: e.value.table.td.outline
        },
        breakpoint: e.value.table.responsiveBreakpoint
      };
      return { head: l, body: i, config: t, colNames: l };
    }), K = p(!1);
    function He(l) {
      K.value = l, ge.value += 1;
    }
    function Oe() {
      I.value.showTable = !I.value.showTable;
    }
    function Fe() {
      I.value.showTooltip = !I.value.showTooltip;
    }
    const oe = p(!1);
    function ve() {
      oe.value = !oe.value;
    }
    return Ve({
      getData: qe,
      generatePdf: ze,
      generateCsv: We,
      generateImage: Ae,
      toggleTable: Oe,
      toggleTooltip: Fe,
      toggleAnnotator: ve
    }), (l, i) => (o(), r("div", {
      class: Xe(`vue-ui-scatter ${K.value ? "vue-data-ui-wrapper-fullscreen" : ""} ${e.value.useCssAnimation ? "" : "vue-ui-dna"}`),
      ref_key: "scatterChart",
      ref: H,
      id: `vue-ui-scatter_${C.value}`,
      style: q(`font-family:${e.value.style.fontFamily};width:100%; text-align:center;${e.value.style.title.text ? "" : "padding-top:36px"};background:${e.value.style.backgroundColor};${e.value.responsive ? "height: 100%" : ""}`)
    }, [
      e.value.userOptions.buttons.annotator ? (o(), Y(zt, {
        key: 0,
        parent: H.value,
        backgroundColor: e.value.style.backgroundColor,
        color: e.value.style.color,
        active: oe.value,
        onClose: ve
      }, null, 8, ["parent", "backgroundColor", "color", "active"])) : d("", !0),
      e.value.style.title.text ? (o(), r("div", {
        key: 1,
        ref_key: "chartTitle",
        ref: xe,
        style: "width:100%;background:transparent"
      }, [
        (o(), Y(xt, {
          key: `title_${be.value}`,
          config: {
            title: {
              cy: "scatter-div-title",
              ...e.value.style.title
            },
            subtitle: {
              cy: "scatter-div-subtitle",
              ...e.value.style.title.subtitle
            }
          }
        }, null, 8, ["config"]))
      ], 512)) : d("", !0),
      e.value.userOptions.show && ee.value ? (o(), Y(bt, {
        ref_key: "details",
        ref: Ge,
        key: `user_options_${ge.value}`,
        backgroundColor: e.value.style.backgroundColor,
        color: e.value.style.color,
        isImaging: v(Ce),
        isPrinting: v($e),
        uid: C.value,
        hasTooltip: e.value.userOptions.buttons.tooltip && e.value.style.tooltip.show,
        hasPdf: e.value.userOptions.buttons.pdf,
        hasImg: e.value.userOptions.buttons.img,
        hasXls: e.value.userOptions.buttons.csv,
        hasTable: e.value.userOptions.buttons.table,
        hasFullscreen: e.value.userOptions.buttons.fullscreen,
        isTooltip: I.value.showTooltip,
        isFullscreen: K.value,
        titles: { ...e.value.userOptions.buttonTitles },
        chartElement: H.value,
        position: e.value.userOptions.position,
        hasAnnotator: e.value.userOptions.buttons.annotator,
        isAnnotation: oe.value,
        onToggleFullscreen: He,
        onGeneratePdf: v(ze),
        onGenerateCsv: We,
        onGenerateImage: v(Ae),
        onToggleTable: Oe,
        onToggleTooltip: Fe,
        onToggleAnnotator: ve
      }, Ze({ _: 2 }, [
        l.$slots.optionTooltip ? {
          name: "optionTooltip",
          fn: _(() => [
            A(l.$slots, "optionTooltip", {}, void 0, !0)
          ]),
          key: "0"
        } : void 0,
        l.$slots.optionPdf ? {
          name: "optionPdf",
          fn: _(() => [
            A(l.$slots, "optionPdf", {}, void 0, !0)
          ]),
          key: "1"
        } : void 0,
        l.$slots.optionCsv ? {
          name: "optionCsv",
          fn: _(() => [
            A(l.$slots, "optionCsv", {}, void 0, !0)
          ]),
          key: "2"
        } : void 0,
        l.$slots.optionImg ? {
          name: "optionImg",
          fn: _(() => [
            A(l.$slots, "optionImg", {}, void 0, !0)
          ]),
          key: "3"
        } : void 0,
        l.$slots.optionTable ? {
          name: "optionTable",
          fn: _(() => [
            A(l.$slots, "optionTable", {}, void 0, !0)
          ]),
          key: "4"
        } : void 0,
        l.$slots.optionFullscreen ? {
          name: "optionFullscreen",
          fn: _(({ toggleFullscreen: t, isFullscreen: s }) => [
            A(l.$slots, "optionFullscreen", Q(Z({ toggleFullscreen: t, isFullscreen: s })), void 0, !0)
          ]),
          key: "5"
        } : void 0,
        l.$slots.optionAnnotator ? {
          name: "optionAnnotator",
          fn: _(({ toggleAnnotator: t, isAnnotator: s }) => [
            A(l.$slots, "optionAnnotator", Q(Z({ toggleAnnotator: t, isAnnotator: s })), void 0, !0)
          ]),
          key: "6"
        } : void 0
      ]), 1032, ["backgroundColor", "color", "isImaging", "isPrinting", "uid", "hasTooltip", "hasPdf", "hasImg", "hasXls", "hasTable", "hasFullscreen", "isTooltip", "isFullscreen", "titles", "chartElement", "position", "hasAnnotator", "isAnnotation", "onGeneratePdf", "onGenerateImage"])) : d("", !0),
      ee.value ? (o(), r("svg", {
        key: 3,
        xmlns: v(vt),
        class: Xe({ "vue-data-ui-fullscreen--on": K.value, "vue-data-ui-fulscreen--off": !K.value }),
        viewBox: `0 0 ${z.value.width <= 0 ? 10 : z.value.width} ${z.value.height <= 0 ? 10 : z.value.height}`,
        style: q(`max-width:100%;overflow:visible;background:transparent;color:${e.value.style.color}`)
      }, [
        he(Ct),
        e.value.style.layout.axis.show ? (o(), r("g", Tt, [
          c("line", {
            x1: f.value.x,
            x2: f.value.x,
            y1: u.value.top,
            y2: u.value.bottom,
            stroke: e.value.style.layout.axis.stroke,
            "stroke-width": e.value.style.layout.axis.strokeWidth,
            "stroke-linecap": "round"
          }, null, 8, Bt),
          c("line", {
            x1: u.value.left,
            x2: u.value.right,
            y1: f.value.y,
            y2: f.value.y,
            stroke: e.value.style.layout.axis.stroke,
            "stroke-width": e.value.style.layout.axis.strokeWidth,
            "stroke-linecap": "round"
          }, null, 8, Nt)
        ])) : d("", !0),
        e.value.style.layout.plots.giftWrap.show ? (o(), r("g", Pt, [
          (o(!0), r(P, null, X(S.value, (t, s) => (o(), r("g", null, [
            t.plots.length > 2 ? (o(), r("polygon", {
              key: 0,
              points: v(yt)({ series: t.plots }),
              fill: v(fe)(t.color, e.value.style.layout.plots.giftWrap.fillOpacity * 100),
              "stroke-width": e.value.style.layout.plots.giftWrap.strokeWidth,
              "stroke-dasharray": e.value.style.layout.plots.giftWrap.strokeDasharray,
              stroke: t.color,
              "stroke-linejoin": "round",
              "stroke-linecap": "round"
            }, null, 8, Wt)) : d("", !0)
          ]))), 256))
        ])) : d("", !0),
        (o(!0), r(P, null, X(S.value, (t, s) => (o(), r("g", null, [
          !t.shape || t.shape === "circle" ? (o(), r("g", Ot, [
            (o(!0), r(P, null, X(t.plots, (a, n) => (o(), r("circle", {
              cx: a.x,
              cy: a.y,
              r: B.value && B.value === a.id ? a.weight * 2 : a.weight,
              fill: v(fe)(t.color, e.value.style.layout.plots.opacity * 100),
              stroke: e.value.style.layout.plots.stroke,
              "stroke-width": e.value.style.layout.plots.strokeWidth,
              onMouseover: (m) => Be(a, s),
              onMouseleave: Ne,
              style: q(`opacity:${B.value && B.value === a.id ? 1 : e.value.style.layout.plots.significance.useDistanceOpacity ? 1 - Math.abs(a.deviation) / Le.value : e.value.style.layout.plots.significance.show && Math.abs(a.deviation) > e.value.style.layout.plots.significance.deviationThreshold ? e.value.style.layout.plots.significance.opacity : 1}`)
            }, null, 44, Ft))), 256))
          ])) : (o(), r("g", Xt, [
            (o(!0), r(P, null, X(t.plots, (a, n) => (o(), Y(De, {
              plot: { x: a.x, y: a.y },
              radius: B.value && B.value === a.id ? a.weight * 2 : a.weight,
              shape: t.shape,
              color: v(fe)(t.color, e.value.style.layout.plots.opacity * 100),
              stroke: e.value.style.layout.plots.stroke,
              strokeWidth: e.value.style.layout.plots.strokeWidth,
              onMouseover: (m) => Be(a, s),
              onMouseleave: Ne,
              style: q(`opacity:${B.value && B.value === a.id ? 1 : e.value.style.layout.plots.significance.useDistanceOpacity ? 1 - Math.abs(a.deviation) / Le.value : e.value.style.layout.plots.significance.show && Math.abs(a.deviation) > e.value.style.layout.plots.significance.deviationThreshold ? e.value.style.layout.plots.significance.opacity : 1}`)
            }, null, 8, ["plot", "radius", "shape", "color", "stroke", "strokeWidth", "onMouseover", "style"]))), 256))
          ]))
        ]))), 256)),
        e.value.style.layout.marginalBars.show ? (o(), r("g", It, [
          c("defs", null, [
            c("linearGradient", {
              id: `marginal_x_${C.value}`,
              x1: "0%",
              y1: "0%",
              x2: "0%",
              y2: "100%"
            }, [
              c("stop", {
                offset: "0%",
                "stop-color": e.value.style.layout.marginalBars.fill
              }, null, 8, Yt),
              c("stop", {
                offset: "100%",
                "stop-color": e.value.style.backgroundColor
              }, null, 8, jt)
            ], 8, Dt),
            c("linearGradient", {
              id: `marginal_y_${C.value}`,
              x1: "0%",
              x2: "100%",
              y1: "0%",
              y2: "0%"
            }, [
              c("stop", {
                offset: "0%",
                "stop-color": e.value.style.backgroundColor
              }, null, 8, Et),
              c("stop", {
                offset: "100%",
                "stop-color": e.value.style.layout.marginalBars.fill
              }, null, 8, Gt)
            ], 8, Vt)
          ]),
          (o(!0), r(P, null, X(L.value.x, (t, s) => (o(), r("g", null, [
            t && L.value.avgX[s] ? (o(), r("rect", {
              key: 0,
              x: L.value.avgX[s] - u.value.width / D.value / 2,
              y: u.value.top - e.value.style.layout.marginalBars.offset - t / L.value.maxX * e.value.style.layout.marginalBars.size,
              width: u.value.width / D.value <= 0 ? 1e-4 : u.value.width / D.value,
              height: t / L.value.maxX * e.value.style.layout.marginalBars.size <= 0 ? 1e-4 : t / L.value.maxX * e.value.style.layout.marginalBars.size,
              fill: e.value.style.layout.marginalBars.useGradient ? `url(#marginal_x_${C.value})` : e.value.style.layout.marginalBars.fill,
              style: q(`opacity:${e.value.style.layout.marginalBars.opacity}`),
              stroke: e.value.style.backgroundColor,
              "stroke-width": e.value.style.layout.marginalBars.strokeWidth,
              rx: e.value.style.layout.marginalBars.borderRadius
            }, null, 12, Rt)) : d("", !0)
          ]))), 256)),
          (o(!0), r(P, null, X(L.value.y, (t, s) => (o(), r("g", null, [
            t && L.value.avgY[s] ? (o(), r("rect", {
              key: 0,
              x: u.value.right + e.value.style.layout.marginalBars.offset,
              y: L.value.avgY[s] - u.value.height / D.value / 2,
              height: u.value.height / D.value <= 0 ? 1e-4 : u.value.height / D.value,
              width: t / L.value.maxY * e.value.style.layout.marginalBars.size <= 0 ? 1e-4 : t / L.value.maxY * e.value.style.layout.marginalBars.size,
              fill: e.value.style.layout.marginalBars.useGradient ? `url(#marginal_y_${C.value})` : e.value.style.layout.marginalBars.fill,
              style: q(`opacity:${e.value.style.layout.marginalBars.opacity}`),
              stroke: e.value.style.backgroundColor,
              "stroke-width": e.value.style.layout.marginalBars.strokeWidth,
              rx: e.value.style.layout.marginalBars.borderRadius
            }, null, 12, qt)) : d("", !0)
          ]))), 256)),
          e.value.style.layout.marginalBars.showLines ? (o(), r("g", Ut, [
            (o(!0), r(P, null, X(Ue.value, (t) => (o(), r(P, null, [
              x.value.includes(t.id) ? d("", !0) : (o(), r("path", {
                key: 0,
                d: `M ${t.dX}`,
                stroke: e.value.style.backgroundColor,
                "stroke-width": e.value.style.layout.marginalBars.linesStrokeWidth + 1,
                "stroke-linecap": "round",
                "stroke-linejoin": "round",
                fill: "none"
              }, null, 8, Ht)),
              x.value.includes(t.id) ? d("", !0) : (o(), r("path", {
                key: 1,
                d: `M ${t.dX}`,
                stroke: t.color,
                "stroke-width": e.value.style.layout.marginalBars.linesStrokeWidth,
                "stroke-linecap": "round",
                "stroke-linejoin": "round",
                fill: "none"
              }, null, 8, Jt)),
              x.value.includes(t.id) ? d("", !0) : (o(), r("path", {
                key: 2,
                d: `M ${t.dY}`,
                stroke: e.value.style.backgroundColor,
                "stroke-width": e.value.style.layout.marginalBars.linesStrokeWidth + 1,
                "stroke-linecap": "round",
                "stroke-linejoin": "round",
                fill: "none"
              }, null, 8, Kt)),
              x.value.includes(t.id) ? d("", !0) : (o(), r("path", {
                key: 3,
                d: `M ${t.dY}`,
                stroke: t.color,
                "stroke-width": e.value.style.layout.marginalBars.linesStrokeWidth,
                "stroke-linecap": "round",
                "stroke-linejoin": "round",
                fill: "none"
              }, null, 8, Qt))
            ], 64))), 256))
          ])) : d("", !0)
        ])) : d("", !0),
        y.value && e.value.style.layout.plots.selectors.show ? (o(), r("g", Zt, [
          c("line", {
            x1: f.value.x,
            x2: y.value.x,
            y1: y.value.y,
            y2: y.value.y,
            stroke: e.value.style.layout.plots.selectors.stroke,
            "stroke-width": e.value.style.layout.plots.selectors.strokeWidth,
            "stroke-dasharray": e.value.style.layout.plots.selectors.strokeDasharray,
            "stroke-linecap": "round",
            class: "line-pointer"
          }, null, 8, el),
          c("line", {
            x1: y.value.x,
            x2: y.value.x,
            y1: f.value.y,
            y2: y.value.y,
            stroke: e.value.style.layout.plots.selectors.stroke,
            "stroke-width": e.value.style.layout.plots.selectors.strokeWidth,
            "stroke-dasharray": e.value.style.layout.plots.selectors.strokeDasharray,
            "stroke-linecap": "round",
            class: "line-pointer"
          }, null, 8, tl),
          c("text", {
            x: f.value.x + (y.value.x > f.value.x ? -6 : 6),
            y: y.value.y + e.value.style.layout.plots.selectors.labels.fontSize / 3,
            "font-size": e.value.style.layout.plots.selectors.labels.fontSize,
            fill: e.value.style.layout.plots.selectors.labels.color,
            "font-weight": e.value.style.layout.plots.selectors.labels.bold ? "bold" : "normal",
            "text-anchor": y.value.x > f.value.x ? "end" : "start"
          }, M(v(j)(
            e.value.style.layout.plots.selectors.labels.y.formatter,
            v($)(y.value.v.y),
            v(W)({
              p: e.value.style.layout.plots.selectors.labels.prefix,
              v: v($)(y.value.v.y),
              s: e.value.style.layout.plots.selectors.labels.suffix,
              r: e.value.style.layout.plots.selectors.labels.rounding
            }),
            { datapoint: y.value }
          )), 9, ll),
          c("text", {
            x: y.value.x,
            y: f.value.y + (y.value.y > f.value.y ? -6 : e.value.style.layout.plots.selectors.labels.fontSize + 6),
            "font-size": e.value.style.layout.plots.selectors.labels.fontSize,
            fill: e.value.style.layout.plots.selectors.labels.color,
            "font-weight": e.value.style.layout.plots.selectors.labels.bold ? "bold" : "normal",
            "text-anchor": "middle"
          }, M(v(j)(
            e.value.style.layout.plots.selectors.labels.y.formatter,
            v($)(y.value.v.x),
            v(W)({
              p: e.value.style.layout.plots.selectors.labels.prefix,
              v: v($)(y.value.v.x),
              s: e.value.style.layout.plots.selectors.labels.suffix,
              r: e.value.style.layout.plots.selectors.labels.rounding
            }),
            { datapoint: y.value }
          )), 9, al),
          c("circle", {
            cx: f.value.x,
            cy: y.value.y,
            r: e.value.style.layout.plots.selectors.markers.radius,
            fill: e.value.style.layout.plots.selectors.markers.fill,
            stroke: e.value.style.layout.plots.selectors.markers.stroke,
            "stroke-width": e.value.style.layout.plots.selectors.markers.strokeWidth,
            class: "line-pointer"
          }, null, 8, ol),
          c("circle", {
            cx: y.value.x,
            cy: f.value.y,
            r: e.value.style.layout.plots.selectors.markers.radius,
            fill: e.value.style.layout.plots.selectors.markers.fill,
            stroke: e.value.style.layout.plots.selectors.markers.stroke,
            "stroke-width": e.value.style.layout.plots.selectors.markers.strokeWidth,
            class: "line-pointer"
          }, null, 8, sl),
          e.value.style.layout.plots.selectors.labels.showName ? (o(), r("text", {
            key: 0,
            x: y.value.x,
            y: y.value.y + (y.value.y < f.value.y ? -e.value.style.layout.plots.selectors.labels.fontSize / 2 : e.value.style.layout.plots.selectors.labels.fontSize),
            "font-size": e.value.style.layout.plots.selectors.labels.fontSize,
            fill: e.value.style.layout.plots.selectors.labels.color,
            "font-weight": e.value.style.layout.plots.selectors.labels.bold ? "bold" : "normal",
            "text-anchor": y.value.x < u.value.left + 100 ? "start" : y.value.x > u.value.right - 100 ? "end" : y.value.x > f.value.x ? "start" : "end"
          }, M(y.value.v.name), 9, ul)) : d("", !0)
        ])) : d("", !0),
        e.value.style.layout.dataLabels.xAxis.show ? (o(), r("g", rl, [
          c("text", {
            x: u.value.left - 5,
            y: f.value.y + e.value.style.layout.dataLabels.xAxis.fontSize / 3,
            "text-anchor": "end",
            "font-size": e.value.style.layout.dataLabels.xAxis.fontSize,
            fill: e.value.style.layout.dataLabels.xAxis.color
          }, M(v(j)(
            e.value.style.layout.plots.selectors.labels.x.formatter,
            v($)(h.value.xMin),
            v(W)({
              p: e.value.style.layout.plots.selectors.labels.prefix,
              v: v($)(h.value.xMin),
              s: e.value.style.layout.plots.selectors.labels.suffix,
              r: e.value.style.layout.dataLabels.xAxis.rounding
            })
          )), 9, il),
          c("text", {
            x: u.value.right + 3,
            y: f.value.y + e.value.style.layout.dataLabels.xAxis.fontSize / 3,
            "text-anchor": "start",
            "font-size": e.value.style.layout.dataLabels.xAxis.fontSize,
            fill: e.value.style.layout.dataLabels.xAxis.color
          }, M(v(j)(
            e.value.style.layout.plots.selectors.labels.x.formatter,
            v($)(h.value.xMax),
            v(W)({
              p: e.value.style.layout.plots.selectors.labels.prefix,
              v: v($)(h.value.xMax),
              s: e.value.style.layout.plots.selectors.labels.suffix,
              r: e.value.style.layout.dataLabels.xAxis.rounding
            })
          )), 9, nl),
          c("text", {
            id: `vue-ui-scatter-xAxis-label-${C.value}`,
            transform: `translate(${e.value.style.layout.dataLabels.xAxis.fontSize * 2}, ${u.value.top + u.value.height / 2}), rotate(-90)`,
            "text-anchor": "middle",
            "font-size": e.value.style.layout.dataLabels.xAxis.fontSize,
            "font-weight": e.value.style.layout.dataLabels.xAxis.bold ? "bold" : "normal",
            fill: e.value.style.layout.dataLabels.xAxis.color
          }, M(e.value.style.layout.dataLabels.xAxis.name), 9, vl)
        ])) : d("", !0),
        e.value.style.layout.dataLabels.yAxis.show ? (o(), r("g", yl, [
          c("text", {
            x: f.value.x,
            y: u.value.bottom + e.value.style.layout.dataLabels.yAxis.fontSize + 3,
            "text-anchor": "middle",
            "font-size": e.value.style.layout.dataLabels.yAxis.fontSize,
            fill: e.value.style.layout.dataLabels.yAxis.color
          }, M(v(j)(
            e.value.style.layout.plots.selectors.labels.y.formatter,
            v($)(h.value.yMin),
            v(W)({
              p: e.value.style.layout.plots.selectors.labels.prefix,
              v: v($)(h.value.yMin),
              s: e.value.style.layout.plots.selectors.labels.suffix,
              r: e.value.style.layout.dataLabels.yAxis.rounding
            })
          )), 9, cl),
          c("text", {
            x: f.value.x,
            y: u.value.top - e.value.style.layout.dataLabels.yAxis.fontSize / 2,
            "text-anchor": "middle",
            "font-size": e.value.style.layout.dataLabels.yAxis.fontSize,
            fill: e.value.style.layout.dataLabels.yAxis.color
          }, M(v(j)(
            e.value.style.layout.plots.selectors.labels.y.formatter,
            v($)(h.value.yMax),
            v(W)({
              p: e.value.style.layout.plots.selectors.labels.prefix,
              v: v($)(h.value.yMax),
              s: e.value.style.layout.plots.selectors.labels.suffix,
              r: e.value.style.layout.dataLabels.yAxis.rounding
            })
          )), 9, dl),
          c("text", {
            "text-anchor": "middle",
            "font-size": e.value.style.layout.dataLabels.yAxis.fontSize,
            "font-weight": e.value.style.layout.dataLabels.yAxis.bold ? "bold" : "normal",
            fill: e.value.style.layout.dataLabels.yAxis.color,
            x: u.value.left + u.value.width / 2,
            y: u.value.bottom + 8 + e.value.style.layout.dataLabels.yAxis.fontSize * 2
          }, M(e.value.style.layout.dataLabels.yAxis.name), 9, hl)
        ])) : d("", !0),
        c("clipPath", {
          id: `clip_path_${C.value}`
        }, [
          c("rect", {
            x: u.value.left,
            y: u.value.top,
            width: u.value.width <= 0 ? 1e-4 : u.value.width,
            height: u.value.height <= 0 ? 1e-4 : u.value.height
          }, null, 8, fl)
        ], 8, pl),
        e.value.style.layout.correlation.show ? (o(), r("g", gl, [
          (o(!0), r(P, null, X(S.value, (t, s) => (o(), r("line", {
            x1: t.correlation.x1,
            x2: t.correlation.x2,
            y1: t.correlation.y1,
            y2: t.correlation.y2,
            "stroke-dasharray": e.value.style.layout.correlation.strokeDasharray,
            stroke: t.color,
            "stroke-width": e.value.style.layout.correlation.strokeWidth,
            "clip-path": `url(#clip_path_${C.value})`
          }, null, 8, xl))), 256)),
          (o(!0), r(P, null, X(S.value, (t, s) => (o(), r("g", null, [
            e.value.style.layout.correlation.label.show ? (o(), r("text", {
              key: 0,
              x: t.label.x,
              y: t.label.y,
              fill: e.value.style.layout.correlation.label.useSerieColor ? t.color : e.value.style.layout.correlation.label.color,
              "font-size": e.value.style.layout.correlation.label.fontSize,
              "font-weight": e.value.style.layout.correlation.label.bold ? "bold" : "normal"
            }, M(v(W)({
              v: v($)(t.correlation.coefficient),
              r: e.value.style.layout.correlation.label.roundingValue
            })), 9, ml)) : d("", !0)
          ]))), 256))
        ])) : d("", !0),
        A(l.$slots, "svg", { svg: z.value }, void 0, !0)
      ], 14, Lt)) : d("", !0),
      l.$slots.watermark ? (o(), r("div", bl, [
        A(l.$slots, "watermark", Q(Z({ isPrinting: v($e) || v(Ce) })), void 0, !0)
      ])) : d("", !0),
      ee.value ? d("", !0) : (o(), Y(Mt, {
        key: 5,
        config: {
          type: "quadrant",
          style: {
            backgroundColor: e.value.style.backgroundColor,
            quadrant: {
              grid: {
                color: e.value.style.layout.axis.stroke
              },
              plots: {
                color: e.value.style.layout.axis.stroke,
                radius: 1
              }
            }
          }
        }
      }, null, 8, ["config"])),
      c("div", {
        ref_key: "chartLegend",
        ref: me
      }, [
        e.value.style.legend.show ? (o(), Y(_t, {
          key: `legend_${_e.value}`,
          legendSet: V.value,
          config: Re.value,
          onClickMarker: i[0] || (i[0] = ({ legend: t }) => Pe(t.id))
        }, {
          item: _(({ legend: t }) => [
            c("div", {
              onClick: (s) => t.segregate(),
              style: q(`opacity:${x.value.includes(t.id) ? 0.5 : 1}`)
            }, M(t.name), 13, kl)
          ]),
          _: 1
        }, 8, ["legendSet", "config"])) : A(l.$slots, "legend", {
          key: 1,
          legend: V.value
        }, void 0, !0)
      ], 512),
      he(kt, {
        show: I.value.showTooltip && ue.value,
        backgroundColor: e.value.style.tooltip.backgroundColor,
        color: e.value.style.tooltip.color,
        borderRadius: e.value.style.tooltip.borderRadius,
        borderColor: e.value.style.tooltip.borderColor,
        borderWidth: e.value.style.tooltip.borderWidth,
        fontSize: e.value.style.tooltip.fontSize,
        backgroundOpacity: e.value.style.tooltip.backgroundOpacity,
        position: e.value.style.tooltip.position,
        offsetY: e.value.style.tooltip.offsetY,
        parent: H.value,
        content: re.value,
        isCustom: e.value.style.tooltip.customFormat && typeof e.value.style.tooltip.customFormat == "function"
      }, {
        "tooltip-before": _(() => [
          A(l.$slots, "tooltip-before", Q(Z({ ...ne.value })), void 0, !0)
        ]),
        "tooltip-after": _(() => [
          A(l.$slots, "tooltip-after", Q(Z({ ...ne.value })), void 0, !0)
        ]),
        default: _(() => [
          e.value.style.tooltip.showShape ? (o(), r("div", _l, [
            (o(), r("svg", wl, [
              he(De, {
                shape: y.value.shape,
                color: y.value.color,
                plot: { x: 10, y: 10 },
                radius: 7
              }, null, 8, ["shape", "color"])
            ]))
          ])) : d("", !0)
        ]),
        _: 3
      }, 8, ["show", "backgroundColor", "color", "borderRadius", "borderColor", "borderWidth", "fontSize", "backgroundOpacity", "position", "offsetY", "parent", "content", "isCustom"]),
      ee.value ? (o(), Y($t, {
        key: 6,
        hideDetails: "",
        config: {
          open: I.value.showTable,
          maxHeight: 1e4,
          body: {
            backgroundColor: e.value.style.backgroundColor,
            color: e.value.style.color
          },
          head: {
            backgroundColor: e.value.style.backgroundColor,
            color: e.value.style.color
          }
        }
      }, {
        content: _(() => [
          (o(), Y(wt, {
            key: `table_${ke.value}`,
            colNames: ae.value.colNames,
            head: ae.value.head,
            body: ae.value.body,
            config: ae.value.config,
            title: `${e.value.style.title.text}${e.value.style.title.subtitle.text ? ` : ${e.value.style.title.subtitle.text}` : ""}`,
            onClose: i[1] || (i[1] = (t) => I.value.showTable = !1)
          }, {
            th: _(({ th: t }) => [
              et(M(t), 1)
            ]),
            td: _(({ td: t }) => [
              t.shape ? (o(), r("div", Ml, [
                c("span", null, M(t.content), 1)
              ])) : (o(), r("div", {
                key: 1,
                innerHTML: t
              }, null, 8, $l))
            ]),
            _: 1
          }, 8, ["colNames", "head", "body", "config", "title"]))
        ]),
        _: 1
      }, 8, ["config"])) : d("", !0)
    ], 14, St));
  }
}, jl = /* @__PURE__ */ At(Cl, [["__scopeId", "data-v-53b514cf"]]);
export {
  jl as default
};
