import { useCssVars as Ke, computed as b, ref as i, watch as ze, onMounted as Je, onBeforeUnmount as Qe, openBlock as u, createElementBlock as c, normalizeClass as R, normalizeStyle as d, createBlock as M, createCommentVNode as m, unref as h, createSlots as Ze, withCtx as _, renderSlot as k, normalizeProps as U, guardReactiveProps as H, createElementVNode as n, toDisplayString as r, createVNode as re, Fragment as W, renderList as j, withKeys as et, createTextVNode as tt } from "vue";
import { u as at, c as lt, t as ot, a as nt, p as I, b as ut, o as Fe, e as Z, v as S, d as ie, i as ee, f as O, X as st, s as de, w as rt, x as it, y as dt, q as ct, r as vt } from "./index-DnVHQ2xI.js";
import { t as ht, u as pt } from "./useResponsive-NZB-WLRF.js";
import { _ as gt } from "./Title-5VmBwT4i.js";
import { u as yt, U as ft } from "./usePrinter-BEeNAqS5.js";
import { _ as bt } from "./Tooltip-Cj4EF7v1.js";
import { L as Me } from "./Legend-CYF2gpXG.js";
import mt from "./vue-ui-skeleton-aZmkNzAe.js";
import _t from "./BaseIcon-rRli6Sfv.js";
import kt from "./vue-ui-accordion-DspS4q3f.js";
import { u as Ie } from "./useNestedProp-Cox0K0Y5.js";
import { _ as xt } from "./PackageVersion-CvCRsT5_.js";
import { P as $t } from "./PenAndPaper-Jb0pLt3G.js";
import { _ as Ct } from "./_plugin-vue_export-helper-CHgC5LLL.js";
const wt = ["id"], Tt = ["onClick"], Lt = ["xmlns", "viewBox"], Pt = ["id"], Nt = ["stop-color"], St = ["stop-color"], Vt = ["x", "y", "width", "height", "fill", "rx"], zt = ["x", "y", "width", "height", "fill", "rx", "stroke", "stroke-width"], Ft = ["x2", "y1", "y2", "stroke", "stroke-width"], Mt = ["x1", "x2", "y1", "y2", "stroke", "stroke-width"], It = ["x", "y", "text-anchor", "font-size", "fill", "font-weight"], Ot = ["x", "y", "font-size", "fill", "font-weight"], At = ["x", "y", "font-size", "fill", "font-weight"], Bt = ["x", "y", "font-size", "fill", "font-weight"], Dt = ["y", "width", "height", "fill", "onMouseenter"], Rt = {
  key: 5,
  class: "vue-data-ui-watermark"
}, Xt = ["onClick"], Et = { style: "width:100%;padding-top: 36px;position:relative" }, Gt = { class: "vue-ui-data-table" }, Ut = { key: 0 }, Ht = { style: { width: "100%" } }, Wt = ["data-cell"], jt = { style: { display: "flex", "align-items": "center", gap: "5px", "justify-content": "flex-end", width: "100%", "padding-right": "3px" } }, Yt = ["data-cell"], qt = { style: { display: "flex", "align-items": "center", gap: "5px", "justify-content": "flex-end", width: "100%", "padding-right": "3px" } }, Kt = ["data-cell"], Jt = { style: { display: "flex", "align-items": "center", gap: "5px", "justify-content": "flex-end", width: "100%", "padding-right": "3px" } }, Qt = ["data-cell"], Zt = { style: { display: "flex", "align-items": "center", gap: "5px", "justify-content": "flex-end", width: "100%", "padding-right": "3px" } }, ea = ["data-cell"], ta = { style: { display: "flex", "align-items": "center", gap: "5px", "justify-content": "flex-end", width: "100%", "padding-right": "3px" } }, aa = ["data-cell"], la = { style: { display: "flex", "align-items": "center", gap: "5px", "justify-content": "flex-end", width: "100%", "padding-right": "3px" } }, oa = ["data-cell"], na = { style: { display: "flex", "align-items": "center", gap: "5px", "justify-content": "flex-end", width: "100%", "padding-right": "3px" } }, ua = {
  __name: "vue-ui-vertical-bar",
  props: {
    config: {
      type: Object,
      default() {
        return {};
      }
    },
    dataset: {
      type: Array,
      default() {
        return [];
      }
    }
  },
  emits: ["selectLegend"],
  setup(Oe, { expose: Ae, emit: Be }) {
    const C = Oe;
    Ke((a) => ({
      "19a6ca00": a.tdo
    }));
    const { vue_ui_vertical_bar: De } = at(), Y = b(() => !!C.dataset && C.dataset.length), V = i(lt()), Re = i(null), te = i(!1), ae = i(""), q = i(0), Xe = i(null), ce = i(0), A = i(null), ve = i(null), le = i(null), he = i(0), oe = i(0), e = b({
      get: () => pe(),
      set: (a) => a
    });
    function pe() {
      const a = Ie({
        userConfig: C.config,
        defaultConfig: De
      });
      return a.theme ? {
        ...Ie({
          userConfig: ot.vue_ui_vertical_bar[a.theme] || C.config,
          defaultConfig: a
        }),
        customPalette: nt[a.theme] || I
      } : a;
    }
    ze(() => C.config, (a) => {
      e.value = pe(), xe(), he.value += 1, oe.value += 1, v.value = e.value.style.chart.layout.bars.height, g.value = e.value.style.chart.layout.bars.gap;
    }, { deep: !0 }), ze(() => C.dataset, J, { deep: !0 });
    const { isPrinting: ge, isImaging: ye, generatePdf: fe, generateImage: be } = yt({
      elementId: `vue-ui-vertical-bar_${V.value}`,
      fileName: e.value.style.chart.title.text || "vue-ui-vertical-bar"
    }), me = b(() => ut(e.value.customPalette)), _e = i(null), ke = i(!1), Ee = b(() => e.value.table.responsiveBreakpoint), K = i(null);
    Je(() => {
      xe();
    });
    function xe() {
      if (Fe(C.dataset) && Z({
        componentName: "VueUiVerticalBar",
        type: "dataset"
      }), q.value = C.dataset.flatMap((a) => a.children && a.children.length > 0 ? a.children.length : 1).reduce((a, l) => a + l, 0), Ge(), e.value.responsive) {
        const a = ht(() => {
          const { width: l, height: t } = pt({
            chart: A.value,
            title: e.value.style.chart.title.text ? ve.value : null,
            legend: e.value.style.chart.legend.show ? le.value : null
          });
          we.value = l, v.value = t / q.value - g.value * 2;
        });
        K.value = new ResizeObserver(a), K.value.observe(A.value.parentNode);
      }
    }
    Qe(() => {
      K.value && K.value.disconnect();
    });
    function Ge() {
      new ResizeObserver((l) => {
        l.forEach((t) => {
          ke.value = t.contentRect.width < Ee.value;
        });
      }).observe(_e.value);
    }
    const $ = i({
      showTable: e.value.table.show,
      sortDesc: e.value.style.chart.layout.bars.sort === "desc",
      showTooltip: e.value.style.chart.tooltip.show
    }), $e = b(() => $.value.sortDesc), z = b(() => (C.dataset.forEach((a, l) => {
      !a.value && !a.children && Z({
        componentName: "VueUiVerticalBar",
        type: "datasetAttributeEmpty",
        property: `value (index ${l})`
      }), a.children && (Fe(a.children) ? Z({
        componentName: "VueUiVerticalBar",
        type: "datasetAttributeEmpty",
        property: `children (index ${l})`
      }) : a.children.forEach((t, o) => {
        [null, void 0].includes(t.name) && Z({
          componentName: "VueUiVerticalBar",
          type: "datasetSerieAttribute",
          property: "name",
          key: "children",
          index: o
        });
      }));
    }), C.dataset.map((a, l) => {
      const t = `vertical_parent_${l}_${V.value}`, o = a.children && a.children.length > 0, f = S(a.value ? a.value : o ? a.children.map((x) => x.value || 0).reduce((x, P) => x + P, 0) : 0), p = f >= 0 ? 1 : -1;
      return {
        ...a,
        id: t,
        shape: "square",
        opacity: T.value.includes(t) ? 0.5 : 1,
        value: Math.abs(f),
        sign: p,
        hasChildren: o,
        isChild: !1,
        segregate: () => X(t),
        isSegregated: T.value.includes(t),
        color: ie(a.color) || me.value[l] || I[l] || I[l % I.length],
        children: !a.children || !a.children.length ? [] : a.children.toSorted((x, P) => $e.value ? P.value - x.value : x.value - P.value).map((x, P) => ({
          ...x,
          value: S(Math.abs(x.value)),
          sign: x.value >= 0 ? 1 : -1,
          isChild: !0,
          parentId: t,
          parentName: a.name,
          parentValue: f,
          parentSign: p,
          id: `vertical_child_${l}_${P}_${V.value}`,
          childIndex: P,
          color: ie(x.color) || ie(a.color) || me.value[l] || I[l] || I[l % I.length]
        })).map((x, P) => ({
          ...x,
          isFirstChild: P === 0,
          isLastChild: P === a.children.length - 1
        }))
      };
    }).toSorted((a, l) => $e.value ? l.value - a.value : a.value - l.value))), Ce = b(() => ({
      cy: "vertical-bar-div-legend",
      backgroundColor: e.value.style.chart.legend.backgroundColor,
      color: e.value.style.chart.legend.color,
      fontSize: e.value.style.chart.legend.fontSize,
      paddingBottom: 12,
      fontWeight: e.value.style.chart.legend.bold ? "bold" : ""
    })), v = i(e.value.style.chart.layout.bars.height), g = i(e.value.style.chart.layout.bars.gap), Ue = b(() => (v.value + g.value) * q.value), we = i(512), y = b(() => ({
      width: we.value,
      height: Ue.value,
      padding: {
        top: 12,
        left: 128 + e.value.style.chart.layout.bars.offsetX,
        right: 64 + e.value.style.chart.layout.bars.paddingRight,
        bottom: 12
      }
    })), s = b(() => ({
      fullHeight: y.value.padding.top + y.value.padding.bottom + y.value.height,
      top: y.value.padding.top,
      left: y.value.padding.left,
      right: y.value.width - y.value.padding.right,
      bottom: y.value.padding.top + y.value.height,
      width: y.value.width - (y.value.padding.left + y.value.padding.right)
    }));
    function J() {
      q.value = F.value.flatMap((a) => a.children && a.children.length > 0 ? a.children.length : 1).reduce((a, l) => a + l, 0);
    }
    const T = i([]);
    function X(a) {
      T.value.includes(a) ? T.value = T.value.filter((l) => l !== a) : T.value.push(a), J(), Be("selectLegend", F.value);
    }
    const F = b(() => z.value.filter((a) => !T.value.includes(a.id))), L = b(() => F.value.map((a) => Math.abs(a.value)).reduce((a, l) => a + l, 0));
    function Te(a, l = !1, t = 0) {
      return l ? O({
        v: S(Math.abs(a) / L.value * 100),
        s: "%",
        r: t
      }) : Math.abs(a) / L.value;
    }
    const B = b(() => F.value.flatMap((a) => a.hasChildren ? a.children : a)), D = b(() => B.value.map((a) => a.sign).includes(-1)), He = b(() => Math.max(...F.value.flatMap((a) => a.children && a.children.length ? Math.max(...a.children.map((l) => l.value)) : a.value)));
    function N(a) {
      const l = a / He.value;
      return s.value.width / (D.value ? 2 : 1) * l;
    }
    function We(a) {
      return N(a) + s.value.left;
    }
    function E(a, l) {
      const t = F.value.find((p) => p.id === a.parentId), o = s.value.top + (g.value + v.value) * l, f = t.children.length * (g.value + v.value);
      return {
        y: o + f / 2 - e.value.style.chart.layout.bars.parentLabels.fontSize,
        name: t.name,
        value: [void 0, NaN, null].includes(t.value) ? "" : t.sign === 1 ? t.value : -t.value,
        percentageToTotal: isNaN(t.value / L.value) ? "" : Te(t.value, !0, e.value.style.chart.layout.bars.dataLabels.percentage.roundingPercentage),
        sign: t.sign
      };
    }
    function je() {
      return F.value;
    }
    const ne = i(null), ue = i(null);
    function Ye(a, l) {
      ue.value = {
        datapoint: a,
        seriesIndex: l,
        series: z.value,
        config: e.value
      }, te.value = !0, ne.value = a.id;
      let t = "";
      const o = a.isChild ? a.parentName : a.name, f = a.isChild ? a.name : "", p = e.value.style.chart.tooltip.customFormat;
      it(p) && dt(() => p({
        datapoint: a,
        series: z.value,
        config: e.value,
        seriesIndex: l
      })) ? ae.value = p({
        datapoint: a,
        series: z.value,
        config: e.value,
        seriesIndex: l
      }) : (t += `<div style="width:100%;text-align:center;border-bottom:1px solid ${e.value.style.chart.tooltip.borderColor};padding-bottom:6px;margin-bottom:3px;text-align:left;">
                <div style="display:flex;align-items:center;gap:4px;"><svg viewBox="0 0 12 12" height="14" width="14"><rect x="0" y="0" height="12" width="12" rx="2" stroke="none" fill="${a.color}"/></svg> ${o}</div>
                ${f ? `<div>${f}</div>` : ""}
            </div>`, e.value.style.chart.tooltip.showValue && (t += `<div>${e.value.translations.value}: <b>${ee(
        e.value.style.chart.layout.bars.dataLabels.value.formatter,
        a.sign === 1 ? a.value : -a.value,
        O({
          p: e.value.style.chart.tooltip.prefix,
          v: a.sign === 1 ? a.value : -a.value,
          s: e.value.style.chart.tooltip.suffix,
          r: e.value.style.chart.tooltip.roundingValue
        }),
        { datapoint: a, seriesIndex: l }
      )}</b></div>`), e.value.style.chart.tooltip.showPercentage && (t += `<div>${e.value.translations.percentageToTotal} : <b>${O({
        v: Math.abs(a.value) / L.value * 100,
        s: "%",
        r: e.value.style.chart.tooltip.roundingPercentage
      })}</b></div>`, a.isChild && (t += `<div>${e.value.translations.percentageToSerie}: <b>${O({
        v: Math.abs(a.value) / Math.abs(a.parentValue) * 100,
        s: "%",
        r: e.value.style.chart.tooltip.roundingPercentage
      })}</b></div>`)), ae.value = `<div style="text-align:left">${t}</div>`);
    }
    function Le(a, l, t, o) {
      if (!e.value.style.chart.layout.bars.dataLabels.value.show)
        return "";
      const f = ee(
        e.value.style.chart.layout.bars.dataLabels.value.formatter,
        S(o === -1 && a >= 0 ? -a : a),
        O({
          p: e.value.style.chart.layout.bars.dataLabels.value.prefix,
          v: S(o === -1 && a >= 0 ? -a : a),
          s: e.value.style.chart.layout.bars.dataLabels.value.suffix,
          r: e.value.style.chart.layout.bars.dataLabels.value.roundingValue
        }),
        { datapoint: l, seriesIndex: t }
      ), p = `(${Te(a, !0, e.value.style.chart.layout.bars.dataLabels.percentage.roundingPercentage)})`;
      return `${f}${e.value.style.chart.layout.bars.dataLabels.percentage.show ? ` ${p}` : ""}`;
    }
    const w = b(() => {
      const a = [
        e.value.translations.parentName,
        e.value.translations.value,
        e.value.translations.percentageToTotal,
        e.value.translations.childName,
        e.value.translations.value,
        e.value.translations.percentageToSerie,
        e.value.translations.percentageToTotal
      ], l = B.value.map((t) => t.isChild ? t.isFirstChild ? {
        color: t.color,
        parentName: t.parentName,
        parentValue: t.parentValue,
        percentageToTotal: t.parentValue / L.value,
        childName: t.name,
        childValue: t.sign === 1 ? t.value : -t.value,
        childPercentageToParent: Math.abs(t.value) / Math.abs(t.parentValue),
        childPercentageToTotal: Math.abs(t.value) / L.value
      } : {
        color: "",
        parentName: "",
        parentValue: "",
        percentageToTotal: "",
        childName: t.name,
        childValue: t.sign === 1 ? t.value : -t.value,
        childPercentageToParent: Math.abs(t.value) / Math.abs(t.parentValue),
        childPercentageToTotal: Math.abs(t.value) / L.value
      } : {
        color: t.color,
        parentName: t.name,
        parentValue: t.sign === 1 ? t.value : -t.value,
        percentageToTotal: Math.abs(t.value) / L.value,
        childName: "",
        childValue: "",
        childPercentageToParent: "",
        childPercentageToTotal: ""
      });
      return { head: a, body: l };
    });
    function Pe() {
      const a = [[e.value.style.chart.title.text], [e.value.style.chart.title.subtitle.text], [""]], l = w.value.head, t = w.value.body.map((p) => [
        p.parentName,
        p.parentValue,
        p.percentageToTotal,
        p.childName,
        p.childValue,
        p.childPercentageToParent,
        p.childPercentageToTotal
      ]), o = a.concat([l]).concat(t), f = ct(o);
      vt({ csvContent: f, title: e.value.style.chart.title.text || "vue-ui-vertical-bar" });
    }
    const G = i(!1);
    function qe(a) {
      G.value = a, ce.value += 1;
    }
    function Ne() {
      $.value.showTable = !$.value.showTable;
    }
    function Se() {
      $.value.sortDesc = !$.value.sortDesc, J();
    }
    function Ve() {
      $.value.showTooltip = !$.value.showTooltip;
    }
    const Q = i(!1);
    function se() {
      Q.value = !Q.value;
    }
    return Ae({
      getData: je,
      recalculateHeight: J,
      generatePdf: fe,
      generateCsv: Pe,
      generateImage: be,
      toggleTable: Ne,
      toggleSort: Se,
      toggleTooltip: Ve,
      toggleAnnotator: se
    }), (a, l) => (u(), c("div", {
      class: R(`vue-ui-vertical-bar ${G.value ? "vue-data-ui-wrapper-fullscreen" : ""} ${e.value.useCssAnimation ? "" : "vue-ui-dna"}`),
      ref_key: "verticalBarChart",
      ref: A,
      id: `vue-ui-vertical-bar_${V.value}`,
      style: d(`font-family:${e.value.style.fontFamily};width:100%; text-align:center;${e.value.style.chart.title.text ? "" : "padding-top:36px"};background:${e.value.style.chart.backgroundColor};${e.value.responsive ? "height: 100%" : ""}`)
    }, [
      e.value.userOptions.buttons.annotator ? (u(), M($t, {
        key: 0,
        parent: A.value,
        backgroundColor: e.value.style.chart.backgroundColor,
        color: e.value.style.chart.color,
        active: Q.value,
        onClose: se
      }, null, 8, ["parent", "backgroundColor", "color", "active"])) : m("", !0),
      e.value.style.chart.title.text ? (u(), c("div", {
        key: 1,
        ref_key: "chartTitle",
        ref: ve,
        style: "width:100%;background:transparent;padding-bottom:12px"
      }, [
        (u(), M(gt, {
          key: `title_${he.value}`,
          config: {
            title: {
              cy: "vertical-bar-div-title",
              ...e.value.style.chart.title
            },
            subtitle: {
              cy: "vertical-bar-div-subtitle",
              ...e.value.style.chart.title.subtitle
            }
          }
        }, null, 8, ["config"]))
      ], 512)) : m("", !0),
      e.value.userOptions.show && Y.value ? (u(), M(ft, {
        ref_key: "details",
        ref: Re,
        key: `user_options_${ce.value}`,
        backgroundColor: e.value.style.chart.backgroundColor,
        color: e.value.style.chart.color,
        isImaging: h(ye),
        isPrinting: h(ge),
        uid: V.value,
        hasTooltip: e.value.userOptions.buttons.tooltip && e.value.style.chart.tooltip.show,
        hasPdf: e.value.userOptions.buttons.pdf,
        hasImg: e.value.userOptions.buttons.img,
        hasXls: e.value.userOptions.buttons.csv,
        hasTable: e.value.userOptions.buttons.table,
        hasSort: e.value.userOptions.buttons.sort,
        hasFullscreen: e.value.userOptions.buttons.fullscreen,
        isFullscreen: G.value,
        isTooltip: $.value.showTooltip,
        titles: { ...e.value.userOptions.buttonTitles },
        chartElement: A.value,
        position: e.value.userOptions.position,
        hasAnnotator: e.value.userOptions.buttons.annotator,
        isAnnotation: Q.value,
        onToggleFullscreen: qe,
        onGeneratePdf: h(fe),
        onGenerateCsv: Pe,
        onGenerateImage: h(be),
        onToggleTable: Ne,
        onToggleSort: Se,
        onToggleTooltip: Ve,
        onToggleAnnotator: se
      }, Ze({ _: 2 }, [
        a.$slots.optionTooltip ? {
          name: "optionTooltip",
          fn: _(() => [
            k(a.$slots, "optionTooltip", {}, void 0, !0)
          ]),
          key: "0"
        } : void 0,
        a.$slots.optionPdf ? {
          name: "optionPdf",
          fn: _(() => [
            k(a.$slots, "optionPdf", {}, void 0, !0)
          ]),
          key: "1"
        } : void 0,
        a.$slots.optionCsv ? {
          name: "optionCsv",
          fn: _(() => [
            k(a.$slots, "optionCsv", {}, void 0, !0)
          ]),
          key: "2"
        } : void 0,
        a.$slots.optionImg ? {
          name: "optionImg",
          fn: _(() => [
            k(a.$slots, "optionImg", {}, void 0, !0)
          ]),
          key: "3"
        } : void 0,
        a.$slots.optionTable ? {
          name: "optionTable",
          fn: _(() => [
            k(a.$slots, "optionTable", {}, void 0, !0)
          ]),
          key: "4"
        } : void 0,
        a.$slots.optionLabels ? {
          name: "optionLabels",
          fn: _(() => [
            k(a.$slots, "optionLabels", {}, void 0, !0)
          ]),
          key: "5"
        } : void 0,
        a.$slots.optionSort ? {
          name: "optionSort",
          fn: _(() => [
            k(a.$slots, "optionSort", {}, void 0, !0)
          ]),
          key: "6"
        } : void 0,
        a.$slots.optionFullscreen ? {
          name: "optionFullscreen",
          fn: _(({ toggleFullscreen: t, isFullscreen: o }) => [
            k(a.$slots, "optionFullscreen", U(H({ toggleFullscreen: t, isFullscreen: o })), void 0, !0)
          ]),
          key: "7"
        } : void 0,
        a.$slots.optionAnnotator ? {
          name: "optionAnnotator",
          fn: _(({ toggleAnnotator: t, isAnnotator: o }) => [
            k(a.$slots, "optionAnnotator", U(H({ toggleAnnotator: t, isAnnotator: o })), void 0, !0)
          ]),
          key: "8"
        } : void 0
      ]), 1032, ["backgroundColor", "color", "isImaging", "isPrinting", "uid", "hasTooltip", "hasPdf", "hasImg", "hasXls", "hasTable", "hasSort", "hasFullscreen", "isFullscreen", "isTooltip", "titles", "chartElement", "position", "hasAnnotator", "isAnnotation", "onGeneratePdf", "onGenerateImage"])) : m("", !0),
      e.value.style.chart.legend.show && e.value.style.chart.legend.position === "top" ? (u(), c("div", {
        key: 3,
        ref_key: "chartLegend",
        ref: le
      }, [
        (u(), M(Me, {
          key: `legend_top_${oe.value}`,
          legendSet: z.value,
          config: Ce.value,
          onClickMarker: l[0] || (l[0] = ({ legend: t }) => X(t.id))
        }, {
          item: _(({ legend: t, index: o }) => [
            n("div", {
              "data-cy-legend-item": "",
              onClick: (f) => X(t.id),
              style: d(`opacity:${T.value.includes(t.id) ? 0.5 : 1}`)
            }, r(t.name) + ": " + r(h(ee)(
              e.value.style.chart.layout.bars.dataLabels.value.formatter,
              t.value,
              h(O)({
                p: e.value.style.chart.legend.prefix,
                v: t.value,
                s: e.value.style.chart.legend.suffix,
                r: e.value.style.chart.legend.roundingValue
              }),
              { datapoint: t, seriesIndex: o }
            )), 13, Tt)
          ]),
          _: 1
        }, 8, ["legendSet", "config"]))
      ], 512)) : m("", !0),
      Y.value ? (u(), c("svg", {
        key: 4,
        xmlns: h(st),
        class: R({ "vue-data-ui-fullscreen--on": G.value, "vue-data-ui-fulscreen--off": !G.value }),
        viewBox: `0 0 ${y.value.width <= 0 ? 10 : y.value.width} ${s.value.fullHeight <= 0 ? 10 : s.value.fullHeight}`,
        style: d(`max-width:100%;overflow:visible;background:transparent;color:${e.value.style.chart.color}`)
      }, [
        re(xt),
        (u(!0), c(W, null, j(B.value, (t, o) => (u(), c("linearGradient", {
          x1: "0%",
          y1: "0%",
          x2: "100%",
          y2: "0%",
          id: `vertical_bar_gradient_${V.value}_${o}`
        }, [
          n("stop", {
            offset: "0%",
            "stop-color": t.color
          }, null, 8, Nt),
          n("stop", {
            offset: "100%",
            "stop-color": h(de)(h(rt)(t.color, 0.03), 100 - e.value.style.chart.layout.bars.gradientIntensity)
          }, null, 8, St)
        ], 8, Pt))), 256)),
        (u(!0), c(W, null, j(B.value, (t, o) => (u(), c("g", null, [
          n("rect", {
            x: h(S)(D.value ? s.value.left + s.value.width / 2 - (t.sign === 1 ? 0 : N(t.value) <= 0 ? 1e-4 : N(t.value)) : s.value.left),
            y: s.value.top + (g.value + v.value) * o,
            width: h(S)(N(t.value) <= 0 ? 1e-4 : N(t.value)),
            height: v.value <= 0 ? 1e-4 : v.value,
            fill: e.value.style.chart.layout.bars.underlayerColor,
            rx: e.value.style.chart.layout.bars.borderRadius,
            class: R({ animated: e.value.useCssAnimation })
          }, null, 10, Vt)
        ]))), 256)),
        (u(!0), c(W, null, j(B.value, (t, o) => (u(), c("g", null, [
          n("rect", {
            x: h(S)(D.value ? s.value.left + s.value.width / 2 - (t.sign === 1 ? 0 : N(t.value) <= 0 ? 1e-4 : N(t.value)) : s.value.left),
            y: s.value.top + (g.value + v.value) * o,
            width: h(S)(N(t.value) <= 0 ? 1e-4 : N(t.value)),
            height: v.value <= 0 ? 1e-4 : v.value,
            fill: e.value.style.chart.layout.bars.useGradient ? `url(#vertical_bar_gradient_${V.value}_${o})` : h(de)(t.color, e.value.style.chart.layout.bars.fillOpacity),
            rx: e.value.style.chart.layout.bars.borderRadius,
            stroke: e.value.style.chart.layout.bars.useStroke ? t.color : "none",
            "stroke-width": e.value.style.chart.layout.bars.useStroke ? e.value.style.chart.layout.bars.strokeWidth : 0,
            class: R({ animated: e.value.useCssAnimation })
          }, null, 10, zt),
          (!t.isChild || t.isLastChild) && e.value.style.chart.layout.separators.show && o !== B.value.length - 1 ? (u(), c("line", {
            key: 0,
            x1: 0,
            x2: s.value.left,
            y1: v.value + g.value / 2 + s.value.top + (g.value + v.value) * o,
            y2: v.value + g.value / 2 + s.value.top + (g.value + v.value) * o,
            stroke: e.value.style.chart.layout.separators.color,
            "stroke-width": e.value.style.chart.layout.separators.strokeWidth,
            "stroke-linecap": "round"
          }, null, 8, Ft)) : m("", !0),
          D.value && e.value.style.chart.layout.separators.show ? (u(), c("line", {
            key: 1,
            x1: s.value.left + s.value.width / 2,
            x2: s.value.left + s.value.width / 2,
            y1: s.value.top,
            y2: s.value.bottom,
            stroke: e.value.style.chart.layout.separators.color,
            "stroke-width": e.value.style.chart.layout.separators.strokeWidth,
            "stroke-linecap": "round"
          }, null, 8, Mt)) : m("", !0),
          n("text", {
            x: D.value ? s.value.left + s.value.width / 2 + (t.sign === 1 ? -12 : 12) + (t.sign === 1 ? -e.value.style.chart.layout.bars.dataLabels.offsetX : e.value.style.chart.layout.bars.dataLabels.offsetX) : We(t.value) + 3 + e.value.style.chart.layout.bars.dataLabels.offsetX,
            y: s.value.top + (g.value + v.value) * o + v.value / 2 + e.value.style.chart.layout.bars.dataLabels.fontSize / 2,
            "text-anchor": !D.value || t.sign === -1 ? "start" : "end",
            "font-size": e.value.style.chart.layout.bars.dataLabels.fontSize,
            fill: e.value.style.chart.layout.bars.dataLabels.color,
            "font-weight": e.value.style.chart.layout.bars.dataLabels.bold ? "bold" : "normal"
          }, r(Le(t.value, t, o, t.sign)), 9, It),
          (t.isChild || !t.hasChildren) && e.value.style.chart.layout.bars.nameLabels.show ? (u(), c("text", {
            key: 2,
            "text-anchor": "end",
            x: s.value.left - 3 + e.value.style.chart.layout.bars.nameLabels.offsetX,
            y: s.value.top + (g.value + v.value) * o + v.value / 2 + e.value.style.chart.layout.bars.nameLabels.fontSize / 2,
            "font-size": e.value.style.chart.layout.bars.nameLabels.fontSize,
            fill: e.value.style.chart.layout.bars.nameLabels.color,
            "font-weight": e.value.style.chart.layout.bars.nameLabels.bold ? "bold" : "normal"
          }, r(t.name), 9, Ot)) : m("", !0),
          t.isChild && t.childIndex === 0 && e.value.style.chart.layout.bars.parentLabels.show ? (u(), c("text", {
            key: 3,
            x: 3 + e.value.style.chart.layout.bars.parentLabels.offsetX,
            y: E(t, o).y,
            "font-size": e.value.style.chart.layout.bars.parentLabels.fontSize,
            fill: e.value.style.chart.layout.bars.parentLabels.color,
            "font-weight": e.value.style.chart.layout.bars.parentLabels.bold ? "bold" : "normal",
            "text-anchor": "start"
          }, r(E(t, o).name), 9, At)) : m("", !0),
          t.isChild && t.childIndex === 0 && e.value.style.chart.layout.bars.parentLabels.show ? (u(), c("text", {
            key: 4,
            x: 3 + e.value.style.chart.layout.bars.parentLabels.offsetX,
            y: E(t, o).y + e.value.style.chart.layout.bars.parentLabels.fontSize + 6,
            "font-size": e.value.style.chart.layout.bars.parentLabels.fontSize,
            fill: e.value.style.chart.layout.bars.parentLabels.color,
            "font-weight": e.value.style.chart.layout.bars.dataLabels.bold ? "bold" : "normal",
            "text-anchor": "start"
          }, r(Le(E(t, o).value), E(t, o), o, t.parentSign || t.sign), 9, Bt)) : m("", !0),
          n("rect", {
            "data-cy-trap": "",
            x: 0,
            y: s.value.top + (g.value + v.value) * o - g.value / 2,
            width: y.value.width <= 0 ? 1e-4 : y.value.width,
            height: v.value + g.value <= 0 ? 1e-4 : v.value + g.value,
            fill: ne.value === t.id ? h(de)(e.value.style.chart.layout.highlighter.color, e.value.style.chart.layout.highlighter.opacity) : "transparent",
            onMouseenter: (f) => Ye(t, o),
            onMouseleave: l[1] || (l[1] = (f) => {
              Xe.value = null, te.value = !1, ne.value = null;
            })
          }, null, 40, Dt)
        ]))), 256)),
        k(a.$slots, "svg", { svg: y.value }, void 0, !0)
      ], 14, Lt)) : m("", !0),
      a.$slots.watermark ? (u(), c("div", Rt, [
        k(a.$slots, "watermark", U(H({ isPrinting: h(ge) || h(ye) })), void 0, !0)
      ])) : m("", !0),
      Y.value ? m("", !0) : (u(), M(mt, {
        key: 6,
        config: {
          type: "verticalBar",
          style: {
            backgroundColor: e.value.style.chart.backgroundColor,
            verticalBar: {
              axis: {
                color: "#CCCCCC"
              },
              color: "#CCCCCC"
            }
          }
        }
      }, null, 8, ["config"])),
      e.value.style.chart.legend.show && e.value.style.chart.legend.position === "bottom" ? (u(), c("div", {
        key: 7,
        ref_key: "chartLegend",
        ref: le
      }, [
        (u(), M(Me, {
          key: `legend_bottom_${oe.value}`,
          legendSet: z.value,
          config: Ce.value,
          onClickMarker: l[2] || (l[2] = ({ legend: t }) => X(t.id))
        }, {
          item: _(({ legend: t, index: o }) => [
            n("div", {
              onClick: (f) => X(t.id),
              style: d(`opacity:${T.value.includes(t.id) ? 0.5 : 1}`)
            }, r(t.name) + ": " + r(h(ee)(
              e.value.style.chart.layout.bars.dataLabels.value.formatter,
              t.value,
              h(O)({
                p: e.value.style.chart.legend.prefix,
                v: t.value,
                s: e.value.style.chart.legend.suffix,
                r: e.value.style.chart.legend.roundingValue
              }),
              { datapoint: t, seriesIndex: o }
            )), 13, Xt)
          ]),
          _: 1
        }, 8, ["legendSet", "config"]))
      ], 512)) : m("", !0),
      k(a.$slots, "legend", { legend: z.value }, void 0, !0),
      re(bt, {
        show: $.value.showTooltip && te.value && T.value.length < C.dataset.length,
        backgroundColor: e.value.style.chart.tooltip.backgroundColor,
        color: e.value.style.chart.tooltip.color,
        borderRadius: e.value.style.chart.tooltip.borderRadius,
        borderColor: e.value.style.chart.tooltip.borderColor,
        borderWidth: e.value.style.chart.tooltip.borderWidth,
        fontSize: e.value.style.chart.tooltip.fontSize,
        backgroundOpacity: e.value.style.chart.tooltip.backgroundOpacity,
        position: e.value.style.chart.tooltip.position,
        offsetY: e.value.style.chart.tooltip.offsetY,
        parent: A.value,
        content: ae.value,
        isCustom: e.value.style.chart.tooltip.customFormat && typeof e.value.style.chart.tooltip.customFormat == "function"
      }, {
        "tooltip-before": _(() => [
          k(a.$slots, "tooltip-before", U(H({ ...ue.value })), void 0, !0)
        ]),
        "tooltip-after": _(() => [
          k(a.$slots, "tooltip-after", U(H({ ...ue.value })), void 0, !0)
        ]),
        _: 3
      }, 8, ["show", "backgroundColor", "color", "borderRadius", "borderColor", "borderWidth", "fontSize", "backgroundOpacity", "position", "offsetY", "parent", "content", "isCustom"]),
      Y.value ? (u(), M(kt, {
        key: 8,
        hideDetails: "",
        config: {
          open: $.value.showTable,
          maxHeight: 1e4,
          body: {
            backgroundColor: e.value.style.chart.backgroundColor,
            color: e.value.style.chart.color
          },
          head: {
            backgroundColor: e.value.style.chart.backgroundColor,
            color: e.value.style.chart.color
          }
        }
      }, {
        content: _(() => [
          n("div", {
            ref_key: "tableContainer",
            ref: _e,
            class: "vue-ui-vertical-bar-table"
          }, [
            n("div", Et, [
              n("div", {
                role: "button",
                tabindex: "0",
                style: d(`width:32px; position: absolute; top: 0; right:4px; padding: 0 0px; display: flex; align-items:center;justify-content:center;height: 36px; width: 32px; cursor:pointer; background:${e.value.table.th.backgroundColor};`),
                onClick: l[3] || (l[3] = (t) => $.value.showTable = !1),
                onKeypress: l[4] || (l[4] = et((t) => $.value.showTable = !1, ["enter"]))
              }, [
                re(_t, {
                  name: "close",
                  stroke: e.value.table.th.color,
                  "stroke-width": 2
                }, null, 8, ["stroke"])
              ], 36),
              n("div", {
                style: { width: "100%", "container-type": "inline-size" },
                class: R({ "vue-ui-responsive": ke.value })
              }, [
                n("table", Gt, [
                  n("caption", {
                    style: d({ backgroundColor: e.value.table.th.backgroundColor, color: e.value.table.th.color, outline: e.value.table.th.outline }),
                    class: "vue-ui-data-table__caption"
                  }, [
                    tt(r(e.value.style.chart.title.text) + " ", 1),
                    e.value.style.chart.title.subtitle.text ? (u(), c("span", Ut, r(e.value.style.chart.title.subtitle.text), 1)) : m("", !0)
                  ], 4),
                  n("thead", null, [
                    n("tr", {
                      role: "row",
                      style: d(`background:${e.value.table.th.backgroundColor};color:${e.value.table.th.color}`)
                    }, [
                      (u(!0), c(W, null, j(w.value.head, (t) => (u(), c("th", {
                        style: d(`outline:${e.value.table.th.outline}`)
                      }, [
                        n("div", Ht, r(t), 1)
                      ], 4))), 256))
                    ], 4),
                    n("tr", null, [
                      n("th", {
                        style: d(`background:${e.value.table.th.backgroundColor};color:${e.value.table.th.color};outline:${e.value.table.th.outline}`)
                      }, null, 4),
                      n("th", {
                        style: d(`background:${e.value.table.th.backgroundColor};color:${e.value.table.th.color};outline:${e.value.table.th.outline};text-align:right;padding-right:5px;font-weight:bold`)
                      }, "∑ " + r(e.value.table.td.prefix) + r(isNaN(L.value) ? "" : L.value.toFixed(e.value.table.td.roundingValue)) + r(e.value.table.td.suffix), 5),
                      n("th", {
                        style: d(`background:${e.value.table.th.backgroundColor};color:${e.value.table.th.color};outline:${e.value.table.th.outline};text-align:right;padding-right:5px;font-weight:bold`)
                      }, "100%", 4),
                      n("th", {
                        style: d(`background:${e.value.table.th.backgroundColor};color:${e.value.table.th.color};outline:${e.value.table.th.outline}`)
                      }, null, 4),
                      n("th", {
                        style: d(`background:${e.value.table.th.backgroundColor};color:${e.value.table.th.color};outline:${e.value.table.th.outline}`)
                      }, null, 4),
                      n("th", {
                        style: d(`background:${e.value.table.th.backgroundColor};color:${e.value.table.th.color};outline:${e.value.table.th.outline}`)
                      }, null, 4),
                      n("th", {
                        style: d(`background:${e.value.table.th.backgroundColor};color:${e.value.table.th.color};outline:${e.value.table.th.outline}`)
                      }, null, 4)
                    ])
                  ]),
                  n("tbody", null, [
                    (u(!0), c(W, null, j(w.value.body, (t, o) => (u(), c("tr", {
                      class: R({ "vue-ui-data-table__tbody__row": !0, "vue-ui-data-table__tbody__row-even": o % 2 === 0, "vue-ui-data-table__tbody__row-odd": o % 2 !== 0 }),
                      style: d(`background:${e.value.table.td.backgroundColor};color:${e.value.table.td.color}`)
                    }, [
                      n("td", {
                        class: "vue-ui-data-table__tbody__td",
                        style: d(`outline:${e.value.table.td.outline};font-variant-numeric: tabular-nums;`),
                        "data-cell": w.value.head[0] ?? ""
                      }, [
                        n("div", jt, [
                          t.color ? (u(), c("span", {
                            key: 0,
                            style: d(`color:${t.color};margin-right:3px`)
                          }, "⬤", 4)) : m("", !0),
                          n("span", null, r(t.parentName), 1)
                        ])
                      ], 12, Wt),
                      n("td", {
                        class: "vue-ui-data-table__tbody__td",
                        style: d(`outline:${e.value.table.td.outline}`),
                        "data-cell": w.value.head[1] ?? ""
                      }, [
                        n("div", qt, r(e.value.table.td.prefix) + r(["", NaN, void 0].includes(t.parentValue) ? "" : t.parentValue.toFixed(e.value.table.td.roundingValue)) + r(e.value.table.td.suffix), 1)
                      ], 12, Yt),
                      n("td", {
                        class: "vue-ui-data-table__tbody__td",
                        style: d(`outline:${e.value.table.td.outline}`),
                        "data-cell": w.value.head[2] ?? ""
                      }, [
                        n("div", Jt, r(["", NaN, void 0].includes(t.percentageToTotal) ? "" : `${(t.percentageToTotal * 100).toFixed(e.value.table.td.roundingPercentage)}%`), 1)
                      ], 12, Kt),
                      n("td", {
                        class: "vue-ui-data-table__tbody__td",
                        style: d(`outline:${e.value.table.td.outline}`),
                        "data-cell": w.value.head[3] ?? ""
                      }, [
                        n("div", Zt, r(t.childName), 1)
                      ], 12, Qt),
                      n("td", {
                        class: "vue-ui-data-table__tbody__td",
                        style: d(`outline:${e.value.table.td.outline}`),
                        "data-cell": w.value.head[4] ?? ""
                      }, [
                        n("div", ta, r(e.value.table.td.prefix) + r(["", NaN, void 0].includes(t.childValue) ? "" : t.childValue.toFixed(e.value.table.td.roundingValue)) + r(e.value.table.td.suffix), 1)
                      ], 12, ea),
                      n("td", {
                        class: "vue-ui-data-table__tbody__td",
                        style: d(`outline:${e.value.table.td.outline}`),
                        "data-cell": w.value.head[5] ?? ""
                      }, [
                        n("div", la, r(["", NaN, void 0].includes(t.childPercentageToParent) ? "" : `${(t.childPercentageToParent * 100).toFixed(e.value.table.td.roundingPercentage)}%`), 1)
                      ], 12, aa),
                      n("td", {
                        class: "vue-ui-data-table__tbody__td",
                        style: d(`outline:${e.value.table.td.outline}`),
                        "data-cell": w.value.head[6] ?? ""
                      }, [
                        n("div", na, r(["", NaN, void 0].includes(t.childPercentageToTotal) ? "" : `${(t.childPercentageToTotal * 100).toFixed(e.value.table.td.roundingPercentage)}%`), 1)
                      ], 12, oa)
                    ], 6))), 256))
                  ])
                ])
              ], 2)
            ])
          ], 512)
        ]),
        _: 1
      }, 8, ["config"])) : m("", !0)
    ], 14, wt));
  }
}, ka = /* @__PURE__ */ Ct(ua, [["__scopeId", "data-v-fdf1fdac"]]);
export {
  ka as default
};
