import { computed as k, ref as n, watch as B, onMounted as te, onBeforeUnmount as ae, openBlock as s, createElementBlock as h, normalizeStyle as G, createBlock as w, createCommentVNode as d, unref as r, createSlots as le, withCtx as b, renderSlot as f, normalizeProps as I, guardReactiveProps as P, normalizeClass as E, createVNode as oe, Fragment as ne, renderList as se, toDisplayString as re } from "vue";
import { u as ue, c as ie, t as ce, o as ve, e as he, w as R, X as de, i as fe, v as j, f as ye } from "./index-DnVHQ2xI.js";
import { _ as me } from "./Title-5VmBwT4i.js";
import { u as pe, U as ge } from "./usePrinter-BEeNAqS5.js";
import { t as ke, u as we } from "./useResponsive-NZB-WLRF.js";
import be from "./vue-ui-skeleton-aZmkNzAe.js";
import { u as D } from "./useNestedProp-Cox0K0Y5.js";
import { _ as Ce } from "./PackageVersion-CvCRsT5_.js";
import { P as _e } from "./PenAndPaper-Jb0pLt3G.js";
import { _ as xe } from "./_plugin-vue_export-helper-CHgC5LLL.js";
const Ae = ["id"], Ie = ["xmlns", "viewBox"], Pe = ["x1", "x2", "y1", "y2", "stroke", "stroke-width", "stroke-linecap"], $e = ["cx", "cy", "r", "stroke", "stroke-width"], Fe = ["x", "y", "font-size", "fill", "font-weight"], Oe = {
  key: 4,
  class: "vue-data-ui-watermark"
}, ze = {
  __name: "vue-ui-wheel",
  props: {
    config: {
      type: Object,
      default() {
        return {};
      }
    },
    dataset: {
      type: Object,
      default() {
        return {};
      }
    }
  },
  setup(Y, { expose: H }) {
    const c = Y, { vue_ui_wheel: W } = ue(), C = k(() => !!c.dataset && Object.keys(c.dataset).length), _ = n(ie()), q = n(null), $ = n(0), y = n(null), F = n(null), O = n(0), e = k({
      get: () => z(),
      set: (t) => t
    });
    function z() {
      const t = D({
        userConfig: c.config,
        defaultConfig: W
      });
      return t.theme ? {
        ...D({
          userConfig: ce.vue_ui_wheel[t.theme] || c.config,
          defaultConfig: t
        })
      } : t;
    }
    B(() => c.config, (t) => {
      e.value = z(), U(), O.value += 1;
    }, { deep: !0 });
    const { isPrinting: S, isImaging: M, generatePdf: N, generateImage: L } = pe({
      elementId: _.value,
      fileName: e.value.style.chart.title.text || "vue-ui-wheel"
    }), l = n({
      size: 360,
      height: 360,
      width: 360
    }), x = n(e.value.style.chart.layout.percentage.fontSize), i = k(() => ({
      radius: Math.min(l.value.width, l.value.height) * 0.9 / 2,
      centerX: l.value.width / 2,
      centerY: l.value.height / 2
    }));
    function T(t, v = 1) {
      return {
        x: i.value.centerX + i.value.radius * Math.cos(29.85 + t * Math.PI / 180) * v,
        y: i.value.centerY + i.value.radius * Math.sin(29.85 + t * Math.PI / 180) * v
      };
    }
    const o = n(e.value.style.chart.animation.use ? 0 : c.dataset.percentage || 0);
    B(() => c.dataset, (t) => {
      e.value.style.chart.animation.use ? X(t.percentage) : o.value = t.percentage || 0;
    }, { deep: !0 });
    const m = n(null);
    te(() => {
      U();
    });
    function U() {
      if (ve(c.dataset) && he({
        componentName: "VueUiWheel",
        type: "dataset"
      }), X(c.dataset.percentage || 0), e.value.responsive) {
        const t = ke(() => {
          const { width: v, height: a } = we({
            chart: y.value,
            title: e.value.style.chart.title.text ? F.value : null
          });
          l.value.width = v, l.value.height = a, x.value = e.value.style.chart.layout.percentage.fontSize / 360 * Math.min(v, a);
        });
        m.value = new ResizeObserver(t), m.value.observe(y.value.parentNode);
      }
    }
    ae(() => {
      m.value && m.value.disconnect();
    });
    function X(t) {
      let v = e.value.style.chart.animation.speed;
      const a = Math.abs(t - o.value) / (v * 120);
      function u() {
        o.value < t ? o.value = Math.min(o.value + a, t) : o.value > t && (o.value = Math.max(o.value - a, t)), o.value !== t && requestAnimationFrame(u);
      }
      u();
    }
    const J = k(() => {
      const t = [];
      for (let a = 0; a < 100; a += 1) {
        const u = o.value > a ? e.value.style.chart.layout.wheel.ticks.activeColor : e.value.style.chart.layout.wheel.ticks.inactiveColor, { x: Q, y: Z } = T(l.value.size / 100 * a), { x: V, y: ee } = T(l.value.size / 100 * a, e.value.style.chart.layout.wheel.ticks.sizeRatio);
        t.push({
          x1: Q,
          y1: Z,
          x2: V,
          y2: ee,
          color: e.value.style.chart.layout.wheel.ticks.gradient.show ? R(u, a / 100 * (e.value.style.chart.layout.wheel.ticks.gradient.shiftHueIntensity / 100)) : u
        });
      }
      return t;
    }), p = n(!1);
    function K(t) {
      p.value = t, $.value += 1;
    }
    const g = n(!1);
    function A() {
      g.value = !g.value;
    }
    return H({
      generatePdf: N,
      generateImage: L,
      toggleAnnotator: A
    }), (t, v) => (s(), h("div", {
      class: "vue-ui-wheel",
      ref_key: "wheelChart",
      ref: y,
      id: _.value,
      style: G(`font-family:${e.value.style.fontFamily};width:100%; text-align:center;background:${e.value.style.chart.backgroundColor};${e.value.responsive ? "height:100%" : ""}`)
    }, [
      e.value.userOptions.buttons.annotator ? (s(), w(_e, {
        key: 0,
        parent: y.value,
        backgroundColor: e.value.style.chart.backgroundColor,
        color: e.value.style.chart.color,
        active: g.value,
        onClose: A
      }, null, 8, ["parent", "backgroundColor", "color", "active"])) : d("", !0),
      e.value.style.chart.title.text ? (s(), h("div", {
        key: 1,
        ref_key: "chartTitle",
        ref: F,
        style: "width:100%;background:transparent;padding-bottom:12px"
      }, [
        (s(), w(me, {
          key: `title_${O.value}`,
          config: {
            title: {
              cy: "wheel-title",
              ...e.value.style.chart.title
            },
            subtitle: {
              cy: "wheel-subtitle",
              ...e.value.style.chart.title.subtitle
            }
          }
        }, null, 8, ["config"]))
      ], 512)) : d("", !0),
      e.value.userOptions.show && C.value ? (s(), w(ge, {
        ref_key: "details",
        ref: q,
        key: `user_options_${$.value}`,
        backgroundColor: e.value.style.chart.backgroundColor,
        color: e.value.style.chart.color,
        isPrinting: r(S),
        isImaging: r(M),
        uid: _.value,
        hasPdf: e.value.userOptions.buttons.pdf,
        hasImg: e.value.userOptions.buttons.img,
        hasFullscreen: e.value.userOptions.buttons.fullscreen,
        hasXls: !1,
        isFullscreen: p.value,
        position: e.value.userOptions.position,
        titles: { ...e.value.userOptions.buttonTitles },
        hasAnnotator: e.value.userOptions.buttons.annotator,
        isAnnotation: g.value,
        chartElement: y.value,
        onToggleFullscreen: K,
        onGeneratePdf: r(N),
        onGenerateImage: r(L),
        onToggleAnnotator: A
      }, le({ _: 2 }, [
        t.$slots.optionPdf ? {
          name: "optionPdf",
          fn: b(() => [
            f(t.$slots, "optionPdf", {}, void 0, !0)
          ]),
          key: "0"
        } : void 0,
        t.$slots.optionImg ? {
          name: "optionImg",
          fn: b(() => [
            f(t.$slots, "optionImg", {}, void 0, !0)
          ]),
          key: "1"
        } : void 0,
        t.$slots.optionFullscreen ? {
          name: "optionFullscreen",
          fn: b(({ toggleFullscreen: a, isFullscreen: u }) => [
            f(t.$slots, "optionFullscreen", I(P({ toggleFullscreen: a, isFullscreen: u })), void 0, !0)
          ]),
          key: "2"
        } : void 0,
        t.$slots.optionAnnotator ? {
          name: "optionAnnotator",
          fn: b(({ toggleAnnotator: a, isAnnotator: u }) => [
            f(t.$slots, "optionAnnotator", I(P({ toggleAnnotator: a, isAnnotator: u })), void 0, !0)
          ]),
          key: "3"
        } : void 0
      ]), 1032, ["backgroundColor", "color", "isPrinting", "isImaging", "uid", "hasPdf", "hasImg", "hasFullscreen", "isFullscreen", "position", "titles", "hasAnnotator", "isAnnotation", "chartElement", "onGeneratePdf", "onGenerateImage"])) : d("", !0),
      C.value ? (s(), h("svg", {
        key: 3,
        xmlns: r(de),
        class: E({ "vue-data-ui-fullscreen--on": p.value, "vue-data-ui-fulscreen--off": !p.value }),
        viewBox: `0 0 ${l.value.width <= 0 ? 10 : l.value.width} ${l.value.height <= 0 ? 10 : l.value.height}`,
        style: G(`max-width:100%;overflow:visible;background:transparent;color:${e.value.style.chart.color}`)
      }, [
        oe(Ce),
        (s(!0), h(ne, null, se(J.value, (a, u) => (s(), h("line", {
          x1: a.x1,
          x2: a.x2,
          y1: a.y1,
          y2: a.y2,
          stroke: a.color,
          "stroke-width": 5 / 360 * Math.min(l.value.width, l.value.height),
          "stroke-linecap": e.value.style.chart.layout.wheel.ticks.rounded ? "round" : "butt",
          class: E({ "vue-ui-tick-animated": e.value.style.chart.animation.use && u <= o.value })
        }, null, 10, Pe))), 256)),
        e.value.style.chart.layout.innerCircle.show ? (s(), h("circle", {
          key: 0,
          cx: i.value.centerX,
          cy: i.value.centerY,
          r: i.value.radius * 0.8 <= 0 ? 1e-4 : i.value.radius * 0.8,
          stroke: e.value.style.chart.layout.innerCircle.stroke,
          "stroke-width": e.value.style.chart.layout.innerCircle.strokeWidth,
          fill: "none"
        }, null, 8, $e)) : d("", !0),
        e.value.style.chart.layout.percentage.show ? (s(), h("text", {
          key: 1,
          x: i.value.centerX,
          y: i.value.centerY + x.value / 3,
          "font-size": x.value,
          fill: e.value.style.chart.layout.wheel.ticks.gradient.show ? r(R)(e.value.style.chart.layout.wheel.ticks.activeColor, o.value / 100 * (e.value.style.chart.layout.wheel.ticks.gradient.shiftHueIntensity / 100)) : e.value.style.chart.layout.wheel.ticks.activeColor,
          "text-anchor": "middle",
          "font-weight": e.value.style.chart.layout.percentage.bold ? "bold" : "normal",
          style: { "font-variant-numeric": "tabluar-nums" }
        }, re(r(fe)(
          e.value.style.chart.layout.percentage.formatter,
          r(j)(o.value),
          r(ye)({
            v: r(j)(o.value),
            s: "%",
            r: e.value.style.chart.layout.percentage.rounding
          })
        )), 9, Fe)) : d("", !0),
        f(t.$slots, "svg", { svg: l.value }, void 0, !0)
      ], 14, Ie)) : d("", !0),
      t.$slots.watermark ? (s(), h("div", Oe, [
        f(t.$slots, "watermark", I(P({ isPrinting: r(S) || r(M) })), void 0, !0)
      ])) : d("", !0),
      C.value ? d("", !0) : (s(), w(be, {
        key: 5,
        config: {
          type: "wheel",
          style: {
            backgroundColor: e.value.style.chart.backgroundColor,
            wheel: {
              color: "#CCCCCC"
            }
          }
        }
      }, null, 8, ["config"]))
    ], 12, Ae));
  }
}, Re = /* @__PURE__ */ xe(ze, [["__scopeId", "data-v-98d0ddd9"]]);
export {
  Re as default
};
