import { computed as m, ref as x, onMounted as Je, watch as De, openBlock as a, createElementBlock as o, normalizeClass as P, normalizeStyle as re, createBlock as I, createCommentVNode as d, unref as c, createSlots as Qe, withCtx as F, renderSlot as D, normalizeProps as Y, guardReactiveProps as K, createVNode as Ze, createElementVNode as v, Fragment as p, renderList as k, toDisplayString as b, withKeys as et, createTextVNode as Te, nextTick as tt } from "vue";
import { u as lt, o as at, e as q, g as ot, c as Ie, t as ut, a as st, p as J, b as nt, I as rt, d as ie, C as Ee, m as ce, X as it, s as U, D as ct, i as ve, f as Q, j as Oe, k as Z, n as Ve, J as He, q as vt, r as dt } from "./index-DnVHQ2xI.js";
import { _ as ht } from "./Title-5VmBwT4i.js";
import { u as yt, U as ft } from "./usePrinter-BEeNAqS5.js";
import { D as gt } from "./DataTable-DTk7C4Pr.js";
import { L as bt } from "./Legend-CYF2gpXG.js";
import mt from "./vue-ui-skeleton-aZmkNzAe.js";
import { S as xt } from "./Slicer-CU7dRZR0.js";
import pt from "./vue-ui-accordion-DspS4q3f.js";
import { u as Me } from "./useNestedProp-Cox0K0Y5.js";
import { _ as kt } from "./PackageVersion-CvCRsT5_.js";
import { P as _t } from "./PenAndPaper-Jb0pLt3G.js";
import { _ as Ct } from "./_plugin-vue_export-helper-CHgC5LLL.js";
const wt = ["id"], Lt = ["xmlns", "viewBox"], At = ["id"], $t = ["stop-color"], St = ["stop-color"], Nt = ["id"], zt = ["stop-color"], Ft = ["stop-color"], Pt = ["stop-color"], Dt = { key: 0 }, Tt = ["x1", "x2", "y1", "y2", "stroke", "stroke-width"], It = ["x1", "x2", "y1", "y2", "stroke", "stroke-width"], Et = { key: 0 }, Ot = ["x1", "x2", "y1", "y2", "stroke", "stroke-width"], Vt = ["x1", "x2", "y1", "y2", "stroke", "stroke-width"], Ht = ["x", "y", "font-size", "fill", "font-weight"], Mt = ["text-anchor", "font-size", "fill", "transform"], Wt = ["x1", "y1", "x2", "y2", "stroke", "stroke-width"], Rt = { key: 1 }, Ut = ["cx", "cy", "r", "fill"], Xt = { key: 0 }, Gt = { key: 0 }, jt = ["d", "stroke"], Bt = ["text-anchor", "x", "y", "fill"], Yt = ["cx", "cy", "r", "fill"], Kt = { key: 0 }, qt = ["cx", "cy", "fill"], Jt = { key: 1 }, Qt = ["d", "fill", "stroke"], Zt = { key: 2 }, el = ["d", "fill", "stroke"], tl = ["x", "y", "font-size", "fill"], ll = ["x", "y", "width", "fill", "onClick"], al = ["x", "y", "width", "height", "onMouseenter", "onClick"], ol = {
  key: 3,
  "data-cy-zoom": "",
  class: "vue-ui-donut-evolution-dialog"
}, ul = ["x", "y", "width", "height", "fill"], sl = ["x1", "y1", "x2", "y2", "stroke"], nl = ["x1", "y2", "x2", "y1", "stroke"], rl = ["onKeypress", "cx", "cy", "r"], il = ["d", "stroke"], cl = ["cx", "cy", "r", "fill"], vl = ["d", "fill", "stroke"], dl = { class: "vue-ui-donut-evolution-focus" }, hl = ["text-anchor", "x", "y", "fill"], yl = ["cx", "cy", "r", "fill"], fl = ["cx", "cy", "r", "fill"], gl = ["x", "y", "fill"], bl = ["x", "y", "font-size", "fill"], ml = {
  key: 4,
  class: "vue-data-ui-watermark"
}, xl = ["onClick"], pl = { key: 0 }, kl = { key: 1 }, _l = { key: 0 }, Cl = { key: 1 }, wl = {
  __name: "vue-ui-donut-evolution",
  props: {
    config: {
      type: Object,
      default() {
        return {};
      }
    },
    dataset: {
      type: Array,
      default() {
        return [];
      }
    }
  },
  emits: ["selectLegend"],
  setup(We, { expose: Re, emit: de }) {
    const A = We, { vue_ui_donut_evolution: Ue } = lt(), X = m(() => !!A.dataset && A.dataset.length), h = x({
      start: 0,
      end: Math.max(...A.dataset.map((l) => l.values.length))
    });
    function he() {
      h.value = {
        start: 0,
        end: W.value
      }, ge.value += 1;
    }
    Je(() => {
      ye();
    });
    function ye() {
      at(A.dataset) ? q({
        componentName: "VueUiDonutEvolution",
        type: "dataset"
      }) : A.dataset.length && A.dataset.forEach((l, i) => {
        ot({
          datasetObject: l,
          requiredAttributes: ["name", "values"]
        }).forEach((t) => {
          q({
            componentName: "VueUiDonutEvolution",
            type: "datasetSerieAttribute",
            property: t,
            index: i
          });
        });
      });
    }
    const E = x(Ie()), _ = x([]), g = x(null), ee = x(null), $ = x(!1), S = x(null), te = x(null), fe = x(0), ge = x(0), be = x(0), me = x(0), xe = x(0), e = m({
      get: () => pe(),
      set: (l) => l
    });
    function pe() {
      const l = Me({
        userConfig: A.config,
        defaultConfig: Ue
      });
      return l.theme ? {
        ...Me({
          userConfig: ut.vue_ui_donut_evolution[l.theme] || A.config,
          defaultConfig: l
        }),
        customPalette: st[l.theme] || J
      } : l;
    }
    De(() => A.config, (l) => {
      e.value = pe(), ye(), be.value += 1, me.value += 1, xe.value += 1;
    }, { deep: !0 }), De(() => A.dataset, (l) => {
      he();
    }, { deep: !0 });
    const { isPrinting: ke, isImaging: _e, generatePdf: Ce, generateImage: we } = yt({
      elementId: E.value,
      fileName: e.value.style.chart.title.text || "vue-ui-donut-evolution"
    }), Xe = m(() => nt(e.value.customPalette)), G = x({
      showTable: e.value.table.show
    }), s = m(() => ({
      top: e.value.style.chart.layout.padding.top,
      right: e.value.style.chart.layout.padding.right,
      bottom: e.value.style.chart.layout.padding.bottom,
      left: e.value.style.chart.layout.padding.left
    })), r = m(() => {
      const l = e.value.style.chart.layout.height, i = e.value.style.chart.layout.width, t = l - s.value.top - s.value.bottom, n = i - s.value.left - s.value.right;
      return {
        absoluteHeight: l,
        absoluteWidth: i,
        centerX: s.value.left + n / 2,
        centerY: s.value.top + t / 2,
        height: t,
        width: n
      };
    }), T = m(() => (A.dataset.forEach((l, i) => {
      [null, void 0].includes(l.name) && q({
        componentName: "VueUiDonutEvolution",
        type: "datasetSerieAttribute",
        property: "name",
        index: i
      }), [null, void 0].includes(l.values) && q({
        componentName: "VueUiDonutEvolution",
        type: "datasetSerieAttribute",
        property: "values",
        index: i
      });
    }), A.dataset.map((l, i) => ({
      ...l,
      values: rt(l.values),
      color: ie(l.color) || Xe.value[i] || J[i] || J[i % J.length],
      length: (l.values || []).length,
      uid: Ie()
    })))), M = m(() => T.value.filter((l) => !_.value.includes(l.uid)).map((l) => ({
      ...l,
      values: l.values.filter((i, t) => t >= h.value.start && t <= h.value.end)
    }))), W = m(() => Math.max(...M.value.map((l) => l.length))), w = m(() => r.value.width / (h.value.end - h.value.start)), C = m(() => {
      const l = [];
      for (let u = 0; u < h.value.end - h.value.start; u += 1) {
        const f = M.value.map((z) => z.values[u] ?? null), y = f.filter((z) => [void 0, null].includes(z)).length === f.length, N = f.reduce((z, L) => z + L, 0), ne = f.map((z) => z / N), H = s.value.left + w.value * u + w.value / 2;
        l.push({
          index: u,
          percentages: ne,
          subtotal: y || N < 0 ? null : N,
          values: f,
          x: H
        });
      }
      const i = 0, t = Math.max(...l.map((u) => u.subtotal)), n = l.length === 1 ? t * 2 : t;
      return l.map((u, f) => {
        const y = w.value / 2 * 0.7, N = y > r.value.width / 16 ? r.value.width / 16 : y, ne = g.value === u.index ? r.value.width / 16 : N, H = l.length > 4 ? y * 2 : y * 2 > w.value / 2 * 0.7 ? w.value / 2 * 0.7 : y * 2, z = r.value.absoluteHeight - s.value.bottom - r.value.height * u.subtotal / Ee(i, n, e.value.style.chart.layout.grid.yAxis.dataLabels.steps).max;
        return {
          ...u,
          y: z,
          radius: N,
          activeRadius: ne,
          hoverRadius: H,
          donut: ce({
            series: M.value.map((L, Pe) => ({
              color: L.color,
              name: L.name,
              value: L.values[f] ?? 0
            }))
          }, u.x, z, N, N, 1.99999, 2, 1, 360, 105.25, N / 2),
          donutHover: ce({
            series: M.value.map((L, Pe) => ({
              color: L.color,
              name: L.name,
              value: L.values[f] ?? 0
            }))
          }, u.x, z, H, H, 1.99999, 2, 1, 360, 105.25, H / 2),
          donutFocus: ce({
            series: M.value.map((L, Pe) => ({
              color: L.color,
              name: L.name,
              value: L.values[f] ?? 0
            }))
          }, r.value.centerX, r.value.centerY, r.value.height / 3.6, r.value.height / 3.6, 1.99999, 2, 1, 360, 105.25, r.value.height / 6)
        };
      });
    });
    function j(l, i, t) {
      return ve(
        e.value.style.chart.layout.dataLabels.formatter,
        l,
        Q({
          p: e.value.style.chart.layout.dataLabels.prefix,
          v: l,
          s: e.value.style.chart.layout.dataLabels.suffix,
          r: e.value.style.chart.layout.dataLabels.rounding
        }),
        { datapoint: i, index: t }
      );
    }
    const le = m(() => ({
      max: Math.max(...C.value.map((l) => l.subtotal)),
      min: 0
    })), O = m(() => {
      const l = C.value.length === 1 ? le.value.max * 2 : le.value.max;
      return Ee(le.value.min, l, e.value.style.chart.layout.grid.yAxis.dataLabels.steps);
    });
    function Ge(l) {
      return l / O.value.max;
    }
    const je = m(() => O.value.ticks.map((l) => ({
      y: r.value.absoluteHeight - s.value.bottom - r.value.height * Ge(l),
      value: l
    })));
    function Le(l, i) {
      return isNaN(l.value / He(i, "value")) ? 0 : (l.value / He(i, "value") * 100).toFixed(0) + "%";
    }
    function Ae() {
      $.value || (g.value = null, ee.value = null);
    }
    function Be(l) {
      $.value || (g.value = l.index, ee.value = l);
    }
    const ae = x(null);
    function oe(l, i) {
      l.subtotal && (ee.value = null, g.value = null, $.value = !0, S.value = l, [null, void 0].includes(i) || (ae.value = i));
    }
    function $e() {
      S.value = null, $.value = !1, ae.value = null;
    }
    const Se = m(() => T.value.map((l, i) => ({
      name: l.name,
      value: l.values.slice(h.value.start, h.value.end).reduce((t, n) => t + n, 0),
      shape: "circle",
      uid: l.uid,
      color: l.color
    })).sort((l, i) => i.value - l.value).map((l) => ({
      ...l,
      opacity: _.value.includes(l.uid) ? 0.5 : 1,
      segregate: () => ue(l.uid),
      isSegregated: _.value.includes(l.uid)
    }))), Ne = m(() => C.value.map((l) => l.subtotal).reduce((l, i) => l + i, 0)), Ye = m(() => ({
      cy: "donut-div-legend",
      backgroundColor: e.value.style.chart.legend.backgroundColor,
      color: e.value.style.chart.legend.color,
      fontSize: e.value.style.chart.legend.fontSize,
      paddingBottom: 12,
      fontWeight: e.value.style.chart.legend.bold ? "bold" : ""
    }));
    function ue(l) {
      if (_.value.includes(l))
        _.value = _.value.filter((i) => i !== l), de("selectLegend", null);
      else {
        if (_.value.length === T.value.length - 1) return;
        _.value.push(l), de("selectLegend", T.value.find((i) => i.uid === l));
      }
      S.value && oe(C.value.find((i, t) => t === ae.value));
    }
    const V = m(() => {
      const l = [""].concat(T.value.filter((u) => !_.value.includes(u.uid)).map((u) => ({
        name: u.name,
        color: u.color
      }))).concat(["Σ"]);
      let i = [];
      for (let u = 0; u < W.value; u += 1) {
        const f = T.value.filter((y) => !_.value.includes(y.uid)).map((y) => y.values[u] ?? 0).reduce((y, N) => y + N, 0);
        i.push([e.value.style.chart.layout.grid.xAxis.dataLabels.values[u] ?? "-"].concat(T.value.filter((y) => !_.value.includes(y.uid)).map((y) => ({
          value: y.values[u] ?? 0,
          percentage: y.values[u] ? y.values[u] / f * 100 : 0
        }))).concat([`${e.value.style.chart.layout.dataLabels.prefix}${Number(f.toFixed(e.value.table.td.roundingValue))}${e.value.style.chart.layout.dataLabels.suffix}`]));
      }
      const t = {
        th: {
          backgroundColor: e.value.table.th.backgroundColor,
          color: e.value.table.th.color,
          outline: e.value.table.th.outline
        },
        td: {
          backgroundColor: e.value.table.td.backgroundColor,
          color: e.value.table.td.color,
          outline: e.value.table.td.outline
        },
        breakpoint: e.value.table.responsiveBreakpoint
      }, n = [
        e.value.table.columnNames.period
      ].concat(T.value.filter((u) => !_.value.includes(u.uid)).map((u) => u.name)).concat(e.value.table.columnNames.total);
      return { head: l, body: i, config: t, colNames: n };
    });
    function Ke() {
      return T.value;
    }
    function ze() {
      tt(() => {
        const l = [[e.value.style.chart.title.text], [e.value.style.chart.title.subtitle.text], [""]], i = [...V.value.head.map((f) => f.name ?? f)], t = [...V.value.body.map((f) => f.map((y) => y.value ?? y))], n = l.concat([i]).concat(t), u = vt(n);
        dt({ csvContent: u, title: e.value.style.chart.title.text || "vue-ui-donut-evolution" });
      });
    }
    const R = x(!1);
    function qe(l) {
      R.value = l, fe.value += 1;
    }
    function Fe() {
      G.value.showTable = !G.value.showTable;
    }
    const B = x(!1);
    function se() {
      B.value = !B.value;
    }
    return Re({
      getData: Ke,
      generatePdf: Ce,
      generateCsv: ze,
      generateImage: we,
      toggleTable: Fe,
      toggleAnnotator: se
    }), (l, i) => (a(), o("div", {
      ref_key: "donutEvolutionChart",
      ref: te,
      class: P(`vue-ui-donut-evolution ${R.value ? "vue-data-ui-wrapper-fullscreen" : ""} ${e.value.useCssAnimation ? "" : "vue-ui-dna"}`),
      style: re(`font-family:${e.value.style.fontFamily};width:100%; text-align:center;${e.value.style.chart.title.text ? "" : "padding-top:36px"};background:${e.value.style.chart.backgroundColor}`),
      id: E.value
    }, [
      e.value.userOptions.buttons.annotator ? (a(), I(_t, {
        key: 0,
        parent: te.value,
        backgroundColor: e.value.style.chart.backgroundColor,
        color: e.value.style.chart.color,
        active: B.value,
        onClose: se
      }, null, 8, ["parent", "backgroundColor", "color", "active"])) : d("", !0),
      e.value.style.chart.title.text ? (a(), o("div", {
        key: 1,
        style: "width:100%;background:transparent;padding-bottom:24px",
        onMouseleave: Ae
      }, [
        (a(), I(ht, {
          key: `title_${be.value}`,
          config: {
            title: {
              cy: "donut-evolution-div-title",
              ...e.value.style.chart.title
            },
            subtitle: {
              cy: "donut-evolution-div-subtitle",
              ...e.value.style.chart.title.subtitle
            }
          }
        }, null, 8, ["config"]))
      ], 32)) : d("", !0),
      e.value.userOptions.show && X.value ? (a(), I(ft, {
        ref: "details",
        key: `user_options_${fe.value}`,
        backgroundColor: e.value.style.chart.backgroundColor,
        color: e.value.style.chart.color,
        isPrinting: c(ke),
        isImaging: c(_e),
        uid: E.value,
        hasPdf: e.value.userOptions.buttons.pdf,
        hasImg: e.value.userOptions.buttons.img,
        hasXls: e.value.userOptions.buttons.csv,
        hasTable: e.value.userOptions.buttons.table,
        hasFullscreen: e.value.userOptions.buttons.fullscreen,
        isFullscreen: R.value,
        titles: { ...e.value.userOptions.buttonTitles },
        chartElement: te.value,
        position: e.value.userOptions.position,
        hasAnnotator: e.value.userOptions.buttons.annotator,
        isAnnotation: B.value,
        onToggleFullscreen: qe,
        onGeneratePdf: c(Ce),
        onGenerateCsv: ze,
        onGenerateImage: c(we),
        onToggleTable: Fe,
        onToggleAnnotator: se
      }, Qe({ _: 2 }, [
        l.$slots.optionPdf ? {
          name: "optionPdf",
          fn: F(() => [
            D(l.$slots, "optionPdf", {}, void 0, !0)
          ]),
          key: "0"
        } : void 0,
        l.$slots.optionCsv ? {
          name: "optionCsv",
          fn: F(() => [
            D(l.$slots, "optionCsv", {}, void 0, !0)
          ]),
          key: "1"
        } : void 0,
        l.$slots.optionImg ? {
          name: "optionImg",
          fn: F(() => [
            D(l.$slots, "optionImg", {}, void 0, !0)
          ]),
          key: "2"
        } : void 0,
        l.$slots.optionTable ? {
          name: "optionTable",
          fn: F(() => [
            D(l.$slots, "optionTable", {}, void 0, !0)
          ]),
          key: "3"
        } : void 0,
        l.$slots.optionFullscreen ? {
          name: "optionFullscreen",
          fn: F(({ toggleFullscreen: t, isFullscreen: n }) => [
            D(l.$slots, "optionFullscreen", Y(K({ toggleFullscreen: t, isFullscreen: n })), void 0, !0)
          ]),
          key: "4"
        } : void 0,
        l.$slots.optionAnnotator ? {
          name: "optionAnnotator",
          fn: F(({ toggleAnnotator: t, isAnnotator: n }) => [
            D(l.$slots, "optionAnnotator", Y(K({ toggleAnnotator: t, isAnnotator: n })), void 0, !0)
          ]),
          key: "5"
        } : void 0
      ]), 1032, ["backgroundColor", "color", "isPrinting", "isImaging", "uid", "hasPdf", "hasImg", "hasXls", "hasTable", "hasFullscreen", "isFullscreen", "titles", "chartElement", "position", "hasAnnotator", "isAnnotation", "onGeneratePdf", "onGenerateImage"])) : d("", !0),
      X.value ? (a(), o("svg", {
        key: 3,
        xmlns: c(it),
        class: P({ "vue-data-ui-fullscreen--on": R.value, "vue-data-ui-fulscreen--off": !R.value }),
        viewBox: `0 0 ${r.value.absoluteWidth} ${r.value.absoluteHeight}`,
        style: re(`max-width:100%; overflow: visible; background:transparent;color:${e.value.style.chart.color}`)
      }, [
        Ze(kt),
        v("defs", null, [
          v("linearGradient", {
            id: `hover_${E.value}`,
            x1: "0%",
            y1: "0%",
            x2: "0%",
            y2: "100%"
          }, [
            v("stop", {
              offset: "0%",
              "stop-color": c(U)(e.value.style.chart.backgroundColor, e.value.style.chart.layout.highlighter.opacity)
            }, null, 8, $t),
            v("stop", {
              offset: "100%",
              "stop-color": c(U)(e.value.style.chart.layout.highlighter.color, e.value.style.chart.layout.highlighter.opacity)
            }, null, 8, St)
          ], 8, At),
          v("radialGradient", {
            id: `focus_${E.value}`
          }, [
            v("stop", {
              offset: "0%",
              "stop-color": c(U)(c(ie)(e.value.style.chart.backgroundColor), 0)
            }, null, 8, zt),
            v("stop", {
              offset: "77%",
              "stop-color": c(U)("#FFFFFF", 30)
            }, null, 8, Ft),
            v("stop", {
              offset: "100%",
              "stop-color": c(U)(c(ie)(e.value.style.chart.backgroundColor), 0)
            }, null, 8, Pt)
          ], 8, Nt)
        ]),
        e.value.style.chart.layout.grid.show ? (a(), o("g", Dt, [
          v("line", {
            x1: s.value.left,
            x2: s.value.left,
            y1: s.value.top,
            y2: s.value.top + r.value.height,
            stroke: e.value.style.chart.layout.grid.stroke,
            "stroke-width": e.value.style.chart.layout.grid.strokeWidth,
            "stroke-linecap": "round"
          }, null, 8, Tt),
          v("line", {
            x1: s.value.left,
            x2: r.value.absoluteWidth - s.value.right,
            y1: r.value.absoluteHeight - s.value.bottom,
            y2: r.value.absoluteHeight - s.value.bottom,
            stroke: e.value.style.chart.layout.grid.stroke,
            "stroke-width": e.value.style.chart.layout.grid.strokeWidth,
            "stroke-linecap": "round"
          }, null, 8, It),
          e.value.style.chart.layout.grid.showVerticalLines ? (a(), o("g", Et, [
            (a(!0), o(p, null, k(h.value.end - h.value.start, (t, n) => (a(), o("line", {
              x1: s.value.left + (n + 1) * w.value,
              x2: s.value.left + (n + 1) * w.value,
              y1: s.value.top,
              y2: r.value.absoluteHeight - s.value.bottom,
              stroke: e.value.style.chart.layout.grid.stroke,
              "stroke-width": e.value.style.chart.layout.grid.strokeWidth,
              "stroke-linecap": "round"
            }, null, 8, Ot))), 256))
          ])) : d("", !0)
        ])) : d("", !0),
        e.value.style.chart.layout.grid.yAxis.dataLabels.show ? (a(), o("g", {
          key: 1,
          class: P({ "donut-opacity": !0, "donut-behind": g.value !== null || $.value })
        }, [
          (a(!0), o(p, null, k(je.value, (t, n) => (a(), o("g", null, [
            t.value >= O.value.min && t.value <= O.value.max ? (a(), o("line", {
              key: 0,
              x1: s.value.left,
              x2: s.value.left - 5,
              y1: t.y,
              y2: t.y,
              stroke: e.value.style.chart.layout.grid.stroke,
              "stroke-width": e.value.style.chart.layout.grid.strokeWidth
            }, null, 8, Vt)) : d("", !0),
            t.value >= O.value.min && t.value <= O.value.max ? (a(), o("text", {
              key: 1,
              x: s.value.left - 8 + e.value.style.chart.layout.grid.yAxis.dataLabels.offsetX,
              y: t.y + e.value.style.chart.layout.grid.yAxis.dataLabels.fontSize / 3,
              "font-size": e.value.style.chart.layout.grid.yAxis.dataLabels.fontSize,
              "text-anchor": "end",
              fill: e.value.style.chart.layout.grid.yAxis.dataLabels.color,
              "font-weight": e.value.style.chart.layout.grid.yAxis.dataLabels.bold ? "bold" : "normal"
            }, b(c(ct)(t.value) ? c(ve)(
              e.value.style.chart.layout.dataLabels.formatter,
              t.value,
              c(Q)({
                p: e.value.style.chart.layout.dataLabels.prefix,
                v: t.value,
                s: e.value.style.chart.layout.dataLabels.suffix,
                r: e.value.style.chart.layout.grid.yAxis.dataLabels.roundingValue
              }),
              { datapoint: t, seriesIndex: n }
            ) : ""), 9, Ht)) : d("", !0)
          ]))), 256))
        ], 2)) : d("", !0),
        e.value.style.chart.layout.grid.xAxis.dataLabels.show ? (a(), o("g", {
          key: 2,
          class: P({ "donut-opacity": !0, "donut-behind": $.value })
        }, [
          (a(!0), o(p, null, k(h.value.end - h.value.start, (t, n) => (a(), o("g", null, [
            e.value.style.chart.layout.grid.xAxis.dataLabels.showOnlyFirstAndLast && (n === 0 || n === W.value - 1) || !e.value.style.chart.layout.grid.xAxis.dataLabels.showOnlyFirstAndLast ? (a(), o("text", {
              key: 0,
              "text-anchor": e.value.style.chart.layout.grid.xAxis.dataLabels.rotation > 0 ? "start" : e.value.style.chart.layout.grid.xAxis.dataLabels.rotation < 0 ? "end" : "middle",
              "font-size": e.value.style.chart.layout.grid.xAxis.dataLabels.fontSize,
              fill: e.value.style.chart.layout.grid.xAxis.dataLabels.color,
              transform: `translate(${s.value.left + w.value * n + w.value / 2}, ${e.value.style.chart.layout.grid.xAxis.dataLabels.offsetY + r.value.absoluteHeight - s.value.bottom + e.value.style.chart.layout.grid.xAxis.dataLabels.fontSize * 2}), rotate(${e.value.style.chart.layout.grid.xAxis.dataLabels.rotation})`
            }, b(e.value.style.chart.layout.grid.xAxis.dataLabels.values[Number(n) + Number(h.value.start)] ?? ""), 9, Mt)) : d("", !0)
          ]))), 256))
        ], 2)) : d("", !0),
        (a(!0), o(p, null, k(C.value, (t, n) => (a(), o("g", null, [
          e.value.style.chart.layout.line.show && n < C.value.length - 1 && ![t.subtotal, C.value[n + 1].subtotal].includes(null) ? (a(), o("line", {
            key: 0,
            class: P({ "donut-opacity": !0, "donut-behind": g.value !== null || $.value }),
            x1: t.x,
            y1: t.y,
            x2: C.value[n + 1].x,
            y2: C.value[n + 1].y,
            stroke: e.value.style.chart.layout.line.stroke,
            "stroke-width": e.value.style.chart.layout.line.strokeWidth,
            "stroke-linecap": "round",
            "stroke-linejoin": "round"
          }, null, 10, Wt)) : d("", !0),
          t.subtotal !== null ? (a(), o("g", Rt, [
            t.subtotal ? (a(), o("circle", {
              key: 0,
              cx: t.x,
              cy: t.y,
              r: t.activeRadius,
              fill: e.value.style.chart.backgroundColor
            }, null, 8, Ut)) : d("", !0)
          ])) : d("", !0)
        ]))), 256)),
        (a(!0), o(p, null, k(C.value, (t, n) => (a(), o("g", {
          class: P({ "donut-opacity": !0, "donut-behind": n !== g.value && g.value !== null || $.value })
        }, [
          t.subtotal ? (a(), o("g", Xt, [
            g.value !== null && g.value === n ? (a(), o("g", Gt, [
              (a(!0), o(p, null, k(t.donutHover, (u) => (a(), o("g", null, [
                v("path", {
                  d: c(Oe)(u, { x: u.center.endX, y: u.center.endY }, 12, 12, { x: t.x, y: t.y }, !0, 20),
                  stroke: u.color,
                  "stroke-width": "1",
                  "stroke-linecap": "round",
                  "stroke-linejoin": "round",
                  fill: "none"
                }, null, 8, jt)
              ]))), 256)),
              (a(!0), o(p, null, k(t.donutHover, (u, f) => (a(), o("g", null, [
                v("text", {
                  "data-cy-hover-label": "",
                  "text-anchor": c(Z)(u, !0, 0).anchor,
                  x: c(Z)(u, !0, 3).x,
                  y: c(Ve)(u),
                  fill: e.value.style.chart.layout.grid.yAxis.dataLabels.color,
                  "font-size": 8,
                  "font-weight": "bold"
                }, b(u.name) + ": " + b(Le(u, t.donut)) + " (" + b(u.value === null ? "-" : j(u.value, u, f)) + ") ", 9, Bt)
              ]))), 256)),
              v("g", null, [
                v("circle", {
                  cx: t.x,
                  cy: t.y,
                  r: t.hoverRadius,
                  fill: e.value.style.chart.backgroundColor
                }, null, 8, Yt)
              ])
            ])) : d("", !0)
          ])) : d("", !0)
        ], 2))), 256)),
        (a(!0), o(p, null, k(C.value, (t, n) => (a(), o("g", {
          class: P({ "donut-opacity": !0, "donut-behind": n !== g.value && g.value !== null || $.value })
        }, [
          t.subtotal !== null ? (a(), o("g", Kt, [
            t.subtotal === 0 ? (a(), o("circle", {
              key: 0,
              cx: t.x,
              cy: t.y,
              r: 3,
              fill: e.value.style.chart.color
            }, null, 8, qt)) : g.value !== null && g.value === n ? (a(), o("g", Jt, [
              (a(!0), o(p, null, k(t.donutHover, (u, f) => (a(), o("path", {
                d: u.arcSlice,
                fill: `${u.color}`,
                "stroke-width": 1,
                stroke: e.value.style.chart.backgroundColor
              }, null, 8, Qt))), 256))
            ])) : (a(), o("g", Zt, [
              (a(!0), o(p, null, k(t.donut, (u, f) => (a(), o("path", {
                d: u.arcSlice,
                fill: `${u.color}`,
                "stroke-width": 0.5,
                stroke: e.value.style.chart.backgroundColor
              }, null, 8, el))), 256))
            ]))
          ])) : d("", !0)
        ], 2))), 256)),
        (a(!0), o(p, null, k(C.value, (t, n) => (a(), o("g", {
          class: P({ "donut-opacity": !0, "donut-behind": n !== g.value && g.value !== null || $.value })
        }, [
          t.subtotal !== null && e.value.style.chart.layout.dataLabels.show ? (a(), o("text", {
            key: 0,
            "text-anchor": "middle",
            x: t.x,
            y: g.value === t.index && t.subtotal ? t.y + e.value.style.chart.layout.dataLabels.fontSize / 3 : t.y - t.radius - e.value.style.chart.layout.dataLabels.fontSize + e.value.style.chart.layout.dataLabels.offsetY,
            "font-size": e.value.style.chart.layout.dataLabels.fontSize,
            "font-weight": "bold",
            fill: e.value.style.chart.layout.dataLabels.color
          }, b(j(t.subtotal, t, n)), 9, tl)) : d("", !0)
        ], 2))), 256)),
        (a(!0), o(p, null, k(C.value, (t, n) => (a(), o("rect", {
          x: s.value.left + n * w.value,
          y: r.value.absoluteHeight - s.value.bottom - 10,
          width: w.value,
          height: 10,
          fill: g.value === t.index ? `url(#hover_${E.value})` : "transparent",
          onClick: (u) => oe(t, n),
          class: P({ "donut-hover": g.value === t.index && t.subtotal })
        }, null, 10, ll))), 256)),
        (a(!0), o(p, null, k(C.value, (t, n) => (a(), o("rect", {
          "data-cy-trap": "",
          x: s.value.left + n * w.value,
          y: s.value.top,
          width: w.value,
          height: r.value.height,
          fill: "transparent",
          onMouseenter: (u) => Be(t),
          onMouseleave: Ae,
          onClick: (u) => oe(t, n),
          class: P({ "donut-hover": g.value === t.index && t.subtotal })
        }, null, 42, al))), 256)),
        $.value ? (a(), o("g", ol, [
          v("rect", {
            rx: 4,
            x: s.value.left,
            y: s.value.top,
            width: r.value.width,
            height: r.value.height,
            fill: e.value.style.chart.backgroundColor,
            style: { filter: "drop-shadow(0 12px 12px rgba(0,0,0,0.3))" }
          }, null, 8, ul),
          v("line", {
            "data-html2canvas-ignore": "",
            x1: r.value.absoluteWidth - s.value.right - 15,
            y1: s.value.top + 5,
            x2: r.value.absoluteWidth - s.value.right - 4,
            y2: s.value.top + 15.5,
            "stroke-linecap": "round",
            stroke: e.value.style.chart.color,
            "stroke-width": "1.5"
          }, null, 8, sl),
          v("line", {
            "data-html2canvas-ignore": "",
            x1: r.value.absoluteWidth - s.value.right - 15,
            y2: s.value.top + 5,
            x2: r.value.absoluteWidth - s.value.right - 4,
            y1: s.value.top + 15.5,
            "stroke-linecap": "round",
            stroke: e.value.style.chart.color,
            "stroke-width": "1.5"
          }, null, 8, nl),
          v("circle", {
            "data-cy-close": "",
            onClick: $e,
            onKeypress: et($e, ["enter"]),
            cx: r.value.absoluteWidth - s.value.right - r.value.width / 40,
            cy: s.value.top + r.value.height / 30,
            r: r.value.height / 12,
            fill: "transparent",
            style: { cursor: "pointer" },
            tabindex: "0"
          }, null, 40, rl),
          (a(!0), o(p, null, k(S.value.donutFocus, (t) => (a(), o("g", null, [
            v("path", {
              "data-cy-zoom-donut": "",
              d: c(Oe)(t, { x: r.value.centerX, y: r.value.centerY }, 12, 12, !1, !1, 15),
              stroke: t.color,
              "stroke-width": "1",
              "stroke-linecap": "round",
              "stroke-linejoin": "round",
              fill: "none",
              class: "vue-ui-donut-evolution-focus"
            }, null, 8, il)
          ]))), 256)),
          v("circle", {
            cx: s.value.left + r.value.width / 2,
            cy: s.value.top + r.value.height / 2,
            r: r.value.height / 7,
            fill: e.value.style.chart.backgroundColor
          }, null, 8, cl),
          (a(!0), o(p, null, k(S.value.donutFocus, (t, n) => (a(), o("path", {
            d: t.arcSlice,
            fill: `${t.color}`,
            "stroke-width": 1,
            stroke: e.value.style.chart.backgroundColor,
            class: "vue-ui-donut-evolution-focus"
          }, null, 8, vl))), 256)),
          (a(!0), o(p, null, k(S.value.donutFocus, (t, n) => (a(), o("g", dl, [
            v("text", {
              "text-anchor": c(Z)(t, !0, 20).anchor,
              x: c(Z)(t, !0, 10).x,
              y: c(Ve)(t),
              fill: e.value.style.chart.layout.grid.yAxis.dataLabels.color,
              "font-size": 10,
              "font-weight": "bold"
            }, b(t.name) + ": " + b(Le(t, S.value.donutFocus)) + " (" + b(t.value === null ? "-" : j(t.value, t, n)) + ") ", 9, hl)
          ]))), 256)),
          v("circle", {
            cx: s.value.left + r.value.width / 2,
            cy: s.value.top + r.value.height / 2,
            r: r.value.height / 3.8,
            fill: `url(#focus_${E.value})`
          }, null, 8, yl),
          v("circle", {
            cx: s.value.left + r.value.width / 2,
            cy: s.value.top + r.value.height / 2,
            r: r.value.height / 7.7,
            fill: e.value.style.chart.backgroundColor
          }, null, 8, fl),
          v("text", {
            "text-anchor": "middle",
            x: s.value.left + r.value.width / 2,
            y: s.value.top + r.value.height / 2 + 14 / 3,
            "font-size": 14,
            "font-weight": "bold",
            fill: e.value.style.chart.layout.dataLabels.color,
            class: "vue-ui-donut-evolution-focus"
          }, b(j(S.value.subtotal, S.value, null)), 9, gl),
          e.value.style.chart.layout.grid.xAxis.dataLabels.values[S.value.index] ? (a(), o("text", {
            key: 0,
            x: s.value.left + 6,
            y: s.value.top + e.value.style.chart.layout.grid.xAxis.dataLabels.fontSize * 2,
            "font-size": e.value.style.chart.layout.grid.xAxis.dataLabels.fontSize * 1.6,
            fill: e.value.style.chart.layout.dataLabels.color
          }, b(e.value.style.chart.layout.grid.xAxis.dataLabels.values[Number(S.value.index) + Number(h.value.start)]), 9, bl)) : d("", !0)
        ])) : d("", !0),
        D(l.$slots, "svg", { svg: r.value }, void 0, !0)
      ], 14, Lt)) : d("", !0),
      l.$slots.watermark ? (a(), o("div", ml, [
        D(l.$slots, "watermark", Y(K({ isPrinting: c(ke) || c(_e) })), void 0, !0)
      ])) : d("", !0),
      X.value ? d("", !0) : (a(), I(mt, {
        key: 5,
        config: {
          type: "donutEvolution",
          style: {
            backgroundColor: e.value.style.chart.backgroundColor,
            donutEvolution: {
              axis: {
                color: "#CCCCCC"
              },
              donuts: {
                color: "#CCCCCC"
              }
            }
          }
        }
      }, null, 8, ["config"])),
      W.value > 1 && e.value.style.chart.zoom.show ? (a(), I(xt, {
        key: `slicer_${ge.value}`,
        background: e.value.style.chart.zoom.color,
        borderColor: e.value.style.chart.backgroundColor,
        fontSize: e.value.style.chart.zoom.fontSize,
        useResetSlot: e.value.style.chart.zoom.useResetSlot,
        labelLeft: e.value.style.chart.layout.grid.xAxis.dataLabels.values[Number(h.value.start)] || "",
        labelRight: e.value.style.chart.layout.grid.xAxis.dataLabels.values[Number(h.value.end) - 1] || "",
        textColor: e.value.style.chart.color,
        inputColor: e.value.style.chart.zoom.color,
        selectColor: e.value.style.chart.zoom.highlightColor,
        max: W.value,
        min: 0,
        valueStart: h.value.start,
        valueEnd: h.value.end,
        start: h.value.start,
        "onUpdate:start": i[0] || (i[0] = (t) => h.value.start = t),
        end: h.value.end,
        "onUpdate:end": i[1] || (i[1] = (t) => h.value.end = t),
        onReset: he
      }, {
        "reset-action": F(({ reset: t }) => [
          D(l.$slots, "reset-action", Y(K({ reset: t })), void 0, !0)
        ]),
        _: 3
      }, 8, ["background", "borderColor", "fontSize", "useResetSlot", "labelLeft", "labelRight", "textColor", "inputColor", "selectColor", "max", "valueStart", "valueEnd", "start", "end"])) : d("", !0),
      e.value.style.chart.legend.show ? (a(), I(bt, {
        key: `legend_${xe.value}`,
        legendSet: Se.value,
        config: Ye.value,
        onClickMarker: i[2] || (i[2] = ({ legend: t }) => ue(t.uid))
      }, {
        item: F(({ legend: t, index: n }) => [
          v("div", {
            "data-cy-legend-item": "",
            onClick: (u) => ue(t.uid),
            style: re(`opacity:${_.value.includes(t.uid) ? 0.5 : 1}`)
          }, [
            Te(b(t.name) + ": " + b(c(ve)(
              e.value.style.chart.layout.dataLabels.formatter,
              t.value,
              c(Q)({
                p: e.value.style.chart.layout.dataLabels.prefix,
                v: t.value,
                s: e.value.style.chart.layout.dataLabels.suffix,
                r: e.value.style.chart.legend.roundingValue
              }),
              { datapoint: t, seriesIndex: n }
            )) + " ", 1),
            _.value.includes(t.uid) ? (a(), o("span", kl, " ( - % ) ")) : (a(), o("span", pl, " (" + b(isNaN(t.value / Ne.value) ? "-" : c(Q)({
              v: t.value / Ne.value * 100,
              s: "%",
              r: e.value.style.chart.legend.roundingPercentage
            })) + ") ", 1))
          ], 12, xl)
        ]),
        _: 1
      }, 8, ["legendSet", "config"])) : d("", !0),
      D(l.$slots, "legend", { legend: Se.value }, void 0, !0),
      X.value ? (a(), I(pt, {
        key: 8,
        hideDetails: "",
        config: {
          open: G.value.showTable,
          maxHeight: 1e4,
          body: {
            backgroundColor: e.value.style.chart.backgroundColor,
            color: e.value.style.chart.color
          },
          head: {
            backgroundColor: e.value.style.chart.backgroundColor,
            color: e.value.style.chart.color
          }
        }
      }, {
        content: F(() => [
          (a(), I(gt, {
            key: `table_${me.value}`,
            colNames: V.value.colNames,
            head: V.value.head,
            body: V.value.body,
            config: V.value.config,
            title: `${e.value.style.chart.title.text}${e.value.style.chart.title.subtitle.text ? ` : ${e.value.style.chart.title.subtitle.text}` : ""}`,
            onClose: i[3] || (i[3] = (t) => G.value.showTable = !1)
          }, {
            th: F(({ th: t }) => [
              Te(b(t.name ?? t), 1)
            ]),
            td: F(({ td: t }) => [
              t.value === null ? (a(), o("span", _l, "-")) : (a(), o("b", Cl, b(isNaN(t.value) ? "" : e.value.style.chart.layout.dataLabels.prefix) + b(!isNaN(t.value) && t.value !== null ? Number(t.value.toFixed(e.value.table.td.roundingValue)).toLocaleString() : t) + b(isNaN(t.value) ? "" : e.value.style.chart.layout.dataLabels.suffix), 1)),
              v("span", null, b(t.percentage && !isNaN(t.percentage) ? `(${Number(t.percentage.toFixed(e.value.table.td.roundingPercentage)).toLocaleString()}%)` : ""), 1)
            ]),
            _: 1
          }, 8, ["colNames", "head", "body", "config", "title"]))
        ]),
        _: 1
      }, 8, ["config"])) : d("", !0)
    ], 14, wt));
  }
}, Vl = /* @__PURE__ */ Ct(wl, [["__scopeId", "data-v-aa1d86f3"]]);
export {
  Vl as default
};
