import { computed as p, ref as h, watch as ie, onMounted as ce, onBeforeUnmount as ze, openBlock as o, createElementBlock as r, normalizeClass as de, normalizeStyle as H, createBlock as L, createCommentVNode as g, unref as d, createSlots as Xe, withCtx as _, renderSlot as k, normalizeProps as W, guardReactiveProps as R, createVNode as Se, Fragment as w, renderList as $, createElementVNode as n, toDisplayString as A, createTextVNode as ve, nextTick as Ne } from "vue";
import { u as Pe, c as he, t as Te, o as Ge, e as ye, g as De, v as be, C as Ie, f as z, X as fe, i as B, l as ge, h as me, q as Me, r as Fe } from "./index-DnVHQ2xI.js";
import { t as Oe, u as Ve } from "./useResponsive-NZB-WLRF.js";
import { _ as Ee } from "./Title-5VmBwT4i.js";
import { u as He, U as We } from "./usePrinter-BEeNAqS5.js";
import { D as Re } from "./DataTable-DTk7C4Pr.js";
import Be from "./vue-ui-skeleton-aZmkNzAe.js";
import { L as Ue } from "./Legend-CYF2gpXG.js";
import je from "./vue-ui-accordion-DspS4q3f.js";
import { u as pe } from "./useNestedProp-Cox0K0Y5.js";
import { _ as qe } from "./PackageVersion-CvCRsT5_.js";
import { P as Ye } from "./PenAndPaper-Jb0pLt3G.js";
import { _ as Ze } from "./_plugin-vue_export-helper-CHgC5LLL.js";
const Je = ["id"], Ke = ["xmlns", "viewBox"], Qe = { key: 0 }, et = ["x1", "x2", "y1", "y2", "stroke", "stroke-width", "stroke-dasharray"], tt = { key: 1 }, lt = ["x1", "x2", "y1", "y2", "stroke", "stroke-width", "stroke-dasharray"], at = ["x1", "x2", "y1", "y2", "stroke", "stroke-width", "stroke-dasharray"], st = { key: 2 }, ot = ["x", "y", "font-size", "fill", "font-weight"], rt = ["x", "y", "font-size", "fill"], nt = { key: 3 }, ut = ["x", "y", "font-size", "fill", "font-weight"], it = ["id"], ct = ["stop-color"], dt = ["stop-color"], vt = ["stop-color"], ht = ["id"], yt = ["stop-color"], bt = ["stop-color"], ft = ["stop-color"], gt = ["id"], mt = ["stop-color"], pt = ["stop-color"], _t = ["id"], kt = ["stop-color"], xt = ["stop-color"], Ct = { key: 0 }, wt = ["d", "fill"], $t = { key: 1 }, Lt = ["x", "y", "height", "width", "fill"], At = ["cx", "cy", "r", "fill", "stroke", "stroke-width"], zt = ["cx", "cy", "r", "fill", "stroke", "stroke-width"], Xt = { key: 2 }, St = ["x", "y", "fill", "font-size"], Nt = { key: 3 }, Pt = ["x", "y", "fill", "font-size"], Tt = {
  key: 4,
  class: "vue-data-ui-watermark"
}, Gt = ["xmlns", "height", "width"], Dt = ["fill"], It = ["innerHTML"], Mt = {
  __name: "vue-ui-dumbbell",
  props: {
    config: {
      type: Object,
      default() {
        return {};
      }
    },
    dataset: {
      type: Array,
      default() {
        return [];
      }
    }
  },
  emits: ["selectDatapoint"],
  setup(_e, { expose: ke, emit: Ft }) {
    const m = _e, { vue_ui_dumbbell: xe } = Pe(), X = p({
      get() {
        return !!m.dataset && m.dataset.length;
      },
      set(l) {
        return l;
      }
    }), y = h(he()), U = h(0), S = h(null), j = h(null), q = h(null), Y = h(0), Z = h(0), J = h(0), e = p({
      get: () => K(),
      set: (l) => l
    });
    function K() {
      const l = pe({
        userConfig: m.config,
        defaultConfig: xe
      });
      return l.theme ? {
        ...pe({
          userConfig: Te.vue_ui_dumbbell[l.theme] || m.config,
          defaultConfig: l
        })
      } : l;
    }
    ie(() => m.config, (l) => {
      e.value = K(), Q(), Y.value += 1, Z.value += 1, J.value += 1, v.value = e.value.style.chart.rowHeight, N.value = e.value.style.chart.width;
    }, { deep: !0 }), ie(() => m.dataset, (l) => {
      oe();
    }, { deep: !0 });
    const T = h(null);
    ce(() => {
      Q();
    });
    function Q() {
      if (Ge(m.dataset) ? ye({
        componentName: "VueUiDumbbell",
        type: "dataset"
      }) : m.dataset.forEach((l, u) => {
        De({
          datasetObject: l,
          requiredAttributes: ["name", "start", "end"]
        }).forEach((t) => {
          X.value = !1, ye({
            componentName: "VueUiDumbbell",
            type: "datasetSerieAttribute",
            property: t,
            index: u
          });
        });
      }), e.value.responsive) {
        const l = Oe(() => {
          const { width: u, height: t } = Ve({
            chart: S.value,
            title: e.value.style.chart.title.text ? j.value : null,
            legend: e.value.style.chart.legend.show ? q.value : null
          });
          N.value = u, v.value = t / m.dataset.length, b.value = D();
        });
        T.value = new ResizeObserver(l), T.value.observe(S.value.parentNode);
      }
    }
    ze(() => {
      T.value && T.value.disconnect();
    });
    const { isPrinting: ee, isImaging: te, generatePdf: le, generateImage: ae } = He({
      elementId: `dumbbell_${y.value}`,
      fileName: e.value.style.chart.title.text || "vue-ui-dumbbell"
    }), G = h({
      showTable: e.value.table.show
    }), x = p(() => m.dataset.map((l, u) => ({
      ...l,
      start: be(l.start),
      end: be(l.end),
      id: he()
    }))), O = p(() => ({
      max: Math.max(...x.value.flatMap((l) => [l.start, l.end])),
      min: Math.min(...x.value.flatMap((l) => [l.start, l.end]))
    })), c = p(() => Ie(O.value.min < 0 ? O.value.min : 0, O.value.max, e.value.style.chart.grid.scaleSteps)), v = h(e.value.style.chart.rowHeight), N = h(e.value.style.chart.width), s = p(() => {
      const l = v.value, u = e.value.style.chart.padding.left + e.value.style.chart.padding.right + N.value, t = e.value.style.chart.padding.top + e.value.style.chart.padding.bottom + l * m.dataset.length, a = c.value.ticks.length * (N.value / c.value.ticks.length);
      return {
        left: e.value.style.chart.padding.left,
        right: u - e.value.style.chart.padding.right,
        top: e.value.style.chart.padding.top,
        bottom: t - e.value.style.chart.padding.bottom,
        width: N.value,
        height: l * m.dataset.length,
        rowHeight: l,
        absoluteHeight: t,
        absoluteWidth: u,
        widthPlotReference: a
      };
    });
    function D() {
      return x.value.map((l, u) => {
        const t = s.value.left + (l.start + Math.abs(c.value.min)) / (c.value.max + Math.abs(c.value.min)) * s.value.widthPlotReference, a = s.value.left + (l.end + Math.abs(c.value.min)) / (c.value.max + Math.abs(c.value.min)) * s.value.widthPlotReference, i = t + (a - t) / 2;
        return {
          ...l,
          startX: t,
          endX: a,
          centerX: i,
          y: s.value.top + u * v.value + v.value / 2,
          endVal: l.start
        };
      });
    }
    const b = h([]), se = h(null), Ce = p(() => x.value.map((l) => l.end).reduce((l, u) => l + u, 0));
    ce(() => {
      oe();
    });
    function oe() {
      b.value = D();
      let l = b.value.map((t) => t.start).reduce((t, a) => t + a, 0);
      function u() {
        const t = x.value.map((a) => a.end - a.start);
        l >= Ce.value ? (cancelAnimationFrame(se.value), b.value = D()) : (b.value = b.value.map((a, i) => {
          a.endVal += t[i] * (e.value.animationSpeed / 100);
          const f = s.value.left + (a.start + Math.abs(c.value.min)) / (c.value.max + Math.abs(c.value.min)) * s.value.widthPlotReference, F = s.value.left + (a.endVal + Math.abs(c.value.min)) / (c.value.max + Math.abs(c.value.min)) * s.value.widthPlotReference, E = f + (F - f) / 2;
          return {
            ...a,
            startX: f,
            endX: F,
            centerX: E,
            y: s.value.top + i * v.value + v.value / 2,
            endVal: a.endVal
          };
        }), l = b.value.map((a) => a.endVal).reduce((a, i) => a + i, 0), se.value = requestAnimationFrame(u));
      }
      e.value.useAnimation ? u() : b.value = D();
    }
    const re = p(() => [
      { name: e.value.style.chart.legend.labelStart, color: e.value.style.chart.plots.gradient.show ? `url(#start_grad_${y.value})` : e.value.style.chart.plots.startColor },
      { name: e.value.style.chart.legend.labelEnd, color: e.value.style.chart.plots.gradient.show ? `url(#end_grad_${y.value})` : e.value.style.chart.plots.endColor }
    ]), we = p(() => ({
      cy: "donut-div-legend",
      backgroundColor: e.value.style.chart.legend.backgroundColor,
      color: e.value.style.chart.legend.color,
      fontSize: e.value.style.chart.legend.fontSize,
      paddingBottom: 12,
      paddingTop: 12,
      fontWeight: e.value.style.chart.legend.bold ? "bold" : ""
    })), C = p(() => {
      const l = b.value.map((t) => ({
        name: t.name
      })), u = b.value.map((t) => ({
        start: t.start,
        end: t.end
      }));
      return { head: l, body: u };
    }), I = p(() => {
      const l = [
        e.value.table.columnNames.series,
        e.value.table.columnNames.start,
        e.value.table.columnNames.end,
        e.value.table.columnNames.progression
      ], u = C.value.head.map((i, f) => {
        const F = z({
          p: e.value.style.chart.labels.prefix,
          v: C.value.body[f].start,
          s: e.value.style.chart.labels.suffix,
          r: e.value.table.td.roundingValue
        }), E = z({
          p: e.value.style.chart.labels.prefix,
          v: C.value.body[f].end,
          s: e.value.style.chart.labels.suffix,
          r: e.value.table.td.roundingValue
        }), Ae = z({
          v: 100 * (C.value.body[f].end / C.value.body[f].start - 1),
          s: "%",
          r: e.value.table.td.roundingPercentage
        });
        return [
          { name: i.name },
          F,
          E,
          Ae
        ];
      }), t = {
        th: {
          backgroundColor: e.value.table.th.backgroundColor,
          color: e.value.table.th.color,
          outline: e.value.table.th.outline
        },
        td: {
          backgroundColor: e.value.table.td.backgroundColor,
          color: e.value.table.td.color,
          outline: e.value.table.td.outline
        },
        breakpoint: e.value.table.responsiveBreakpoint
      };
      return {
        colNames: [
          e.value.table.columnNames.series,
          e.value.table.columnNames.start,
          e.value.table.columnNames.end,
          e.value.table.columnNames.progression
        ],
        head: l,
        body: u,
        config: t
      };
    });
    function ne() {
      Ne(() => {
        const l = C.value.head.map((a, i) => [[
          a.name
        ], [C.value.body[i].start], [C.value.body[i].end]]), u = [[e.value.style.chart.title.text], [e.value.style.chart.title.subtitle.text], [[e.value.table.columnNames.series], [e.value.table.columnNames.start], [e.value.table.columnNames.end]]].concat(l), t = Me(u);
        Fe({ csvContent: t, title: e.value.style.chart.title.text || "vue-ui-dumbbell" });
      });
    }
    const P = h(!1);
    function $e(l) {
      P.value = l, U.value += 1;
    }
    function Le() {
      return b.value;
    }
    function ue() {
      G.value.showTable = !G.value.showTable;
    }
    const M = h(!1);
    function V() {
      M.value = !M.value;
    }
    return ke({
      getData: Le,
      generatePdf: le,
      generateCsv: ne,
      generateImage: ae,
      toggleTable: ue,
      toggleAnnotator: V
    }), (l, u) => (o(), r("div", {
      ref_key: "dumbbellChart",
      ref: S,
      class: de(`vue-ui-dumbbell ${P.value ? "vue-data-ui-wrapper-fullscreen" : ""}`),
      style: H(`font-family:${e.value.style.fontFamily};width:100%; text-align:center;${e.value.style.chart.title.text ? "" : "padding-top:36px"};background:${e.value.style.chart.backgroundColor};${e.value.responsive ? "height:100%" : ""}`),
      id: `dumbbell_${y.value}`
    }, [
      e.value.userOptions.buttons.annotator ? (o(), L(Ye, {
        key: 0,
        parent: S.value,
        backgroundColor: e.value.style.chart.backgroundColor,
        color: e.value.style.chart.color,
        active: M.value,
        onClose: V
      }, null, 8, ["parent", "backgroundColor", "color", "active"])) : g("", !0),
      e.value.style.chart.title.text ? (o(), r("div", {
        key: 1,
        ref_key: "chartTitle",
        ref: j,
        style: "width:100%;background:transparent;padding-bottom:24px"
      }, [
        (o(), L(Ee, {
          key: `title_${Y.value}`,
          config: {
            title: {
              cy: "donut-div-title",
              ...e.value.style.chart.title
            },
            subtitle: {
              cy: "donut-div-subtitle",
              ...e.value.style.chart.title.subtitle
            }
          }
        }, null, 8, ["config"]))
      ], 512)) : g("", !0),
      e.value.userOptions.show && X.value ? (o(), L(We, {
        ref: "details",
        key: `user_option_${U.value}`,
        backgroundColor: e.value.style.chart.backgroundColor,
        color: e.value.style.chart.color,
        isPrinting: d(ee),
        isImaging: d(te),
        uid: y.value,
        hasPdf: e.value.userOptions.buttons.pdf,
        hasXls: e.value.userOptions.buttons.csv,
        hasImg: e.value.userOptions.buttons.img,
        hasTable: e.value.userOptions.buttons.table,
        hasFullscreen: e.value.userOptions.buttons.fullscreen,
        isFullscreen: P.value,
        titles: { ...e.value.userOptions.buttonTitles },
        chartElement: S.value,
        position: e.value.userOptions.position,
        hasAnnotator: e.value.userOptions.buttons.annotator,
        isAnnotation: M.value,
        onToggleFullscreen: $e,
        onGeneratePdf: d(le),
        onGenerateCsv: ne,
        onGenerateImage: d(ae),
        onToggleTable: ue,
        onToggleAnnotator: V
      }, Xe({ _: 2 }, [
        l.$slots.optionPdf ? {
          name: "optionPdf",
          fn: _(() => [
            k(l.$slots, "optionPdf", {}, void 0, !0)
          ]),
          key: "0"
        } : void 0,
        l.$slots.optionCsv ? {
          name: "optionCsv",
          fn: _(() => [
            k(l.$slots, "optionCsv", {}, void 0, !0)
          ]),
          key: "1"
        } : void 0,
        l.$slots.optionImg ? {
          name: "optionImg",
          fn: _(() => [
            k(l.$slots, "optionImg", {}, void 0, !0)
          ]),
          key: "2"
        } : void 0,
        l.$slots.optionTable ? {
          name: "optionTable",
          fn: _(() => [
            k(l.$slots, "optionTable", {}, void 0, !0)
          ]),
          key: "3"
        } : void 0,
        l.$slots.optionFullscreen ? {
          name: "optionFullscreen",
          fn: _(({ toggleFullscreen: t, isFullscreen: a }) => [
            k(l.$slots, "optionFullscreen", W(R({ toggleFullscreen: t, isFullscreen: a })), void 0, !0)
          ]),
          key: "4"
        } : void 0,
        l.$slots.optionAnnotator ? {
          name: "optionAnnotator",
          fn: _(({ toggleAnnotator: t, isAnnotator: a }) => [
            k(l.$slots, "optionAnnotator", W(R({ toggleAnnotator: t, isAnnotator: a })), void 0, !0)
          ]),
          key: "5"
        } : void 0
      ]), 1032, ["backgroundColor", "color", "isPrinting", "isImaging", "uid", "hasPdf", "hasXls", "hasImg", "hasTable", "hasFullscreen", "isFullscreen", "titles", "chartElement", "position", "hasAnnotator", "isAnnotation", "onGeneratePdf", "onGenerateImage"])) : g("", !0),
      X.value ? (o(), r("svg", {
        key: 3,
        xmlns: d(fe),
        class: de({ "vue-data-ui-fullscreen--on": P.value, "vue-data-ui-fulscreen--off": !P.value }),
        viewBox: `0 0 ${s.value.absoluteWidth <= 0 ? 10 : s.value.absoluteWidth} ${s.value.absoluteHeight <= 0 ? 10 : s.value.absoluteHeight}`,
        style: H(`max-width:100%; overflow: visible; background:transparent;color:${e.value.style.chart.color}`)
      }, [
        Se(qe),
        e.value.style.chart.grid.verticalGrid.show ? (o(), r("g", Qe, [
          (o(!0), r(w, null, $(c.value.ticks, (t, a) => (o(), r("line", {
            x1: s.value.left + a * s.value.width / (c.value.ticks.length - 1),
            x2: s.value.left + a * s.value.width / (c.value.ticks.length - 1),
            y1: s.value.top,
            y2: s.value.bottom,
            stroke: e.value.style.chart.grid.verticalGrid.stroke,
            "stroke-width": e.value.style.chart.grid.verticalGrid.strokeWidth,
            "stroke-dasharray": e.value.style.chart.grid.verticalGrid.strokeDasharray
          }, null, 8, et))), 256))
        ])) : g("", !0),
        e.value.style.chart.grid.horizontalGrid.show ? (o(), r("g", tt, [
          (o(!0), r(w, null, $(x.value, (t, a) => (o(), r("line", {
            x1: s.value.left,
            x2: s.value.right,
            y1: s.value.top + a * v.value,
            y2: s.value.top + a * v.value,
            stroke: e.value.style.chart.grid.horizontalGrid.stroke,
            "stroke-width": e.value.style.chart.grid.horizontalGrid.strokeWidth,
            "stroke-dasharray": e.value.style.chart.grid.horizontalGrid.strokeDasharray
          }, null, 8, lt))), 256)),
          n("line", {
            x1: s.value.left,
            x2: s.value.right,
            y1: s.value.bottom,
            y2: s.value.bottom,
            stroke: e.value.style.chart.grid.horizontalGrid.stroke,
            "stroke-width": e.value.style.chart.grid.horizontalGrid.strokeWidth,
            "stroke-dasharray": e.value.style.chart.grid.horizontalGrid.strokeDasharray
          }, null, 8, at)
        ])) : g("", !0),
        e.value.style.chart.labels.yAxisLabels.show ? (o(), r("g", st, [
          (o(!0), r(w, null, $(x.value, (t, a) => (o(), r("text", {
            x: s.value.left - 6 + e.value.style.chart.labels.yAxisLabels.offsetX,
            y: s.value.top + a * v.value + (e.value.style.chart.labels.yAxisLabels.showProgression ? v.value / 3 : v.value / 2) + e.value.style.chart.labels.yAxisLabels.fontSize / 3,
            "font-size": e.value.style.chart.labels.yAxisLabels.fontSize,
            fill: e.value.style.chart.labels.yAxisLabels.color,
            "font-weight": e.value.style.chart.labels.yAxisLabels.bold ? "bold" : "normal",
            "text-anchor": "end"
          }, A(t.name), 9, ot))), 256)),
          e.value.style.chart.labels.yAxisLabels.showProgression ? (o(!0), r(w, { key: 0 }, $(x.value, (t, a) => (o(), r("text", {
            x: s.value.left - 6 + e.value.style.chart.labels.yAxisLabels.offsetX,
            y: s.value.top + a * v.value + v.value / 1.3 + e.value.style.chart.labels.yAxisLabels.fontSize / 3,
            "font-size": e.value.style.chart.labels.yAxisLabels.fontSize,
            fill: e.value.style.chart.labels.yAxisLabels.color,
            "text-anchor": "end"
          }, A(d(z)({
            v: 100 * (t.end / t.start - 1),
            s: "%",
            r: e.value.style.chart.labels.yAxisLabels.rounding
          })), 9, rt))), 256)) : g("", !0)
        ])) : g("", !0),
        e.value.style.chart.labels.xAxisLabels.show ? (o(), r("g", nt, [
          (o(!0), r(w, null, $(c.value.ticks, (t, a) => (o(), r("text", {
            x: s.value.left + a * (s.value.width / (c.value.ticks.length - 1)),
            y: s.value.bottom + e.value.style.chart.labels.xAxisLabels.fontSize + e.value.style.chart.labels.xAxisLabels.offsetY,
            "font-size": e.value.style.chart.labels.xAxisLabels.fontSize,
            fill: e.value.style.chart.labels.xAxisLabels.color,
            "font-weight": e.value.style.chart.labels.xAxisLabels.bold ? "bold" : "normal",
            "text-anchor": "middle"
          }, A(d(B)(
            e.value.style.chart.labels.formatter,
            t,
            d(z)({
              p: e.value.style.chart.labels.prefix,
              v: t,
              s: e.value.style.chart.labels.suffix,
              r: e.value.style.chart.labels.xAxisLabels.rounding
            }),
            { datapoint: t, seriesIndex: a }
          )), 9, ut))), 256))
        ])) : g("", !0),
        n("defs", null, [
          n("radialGradient", {
            id: `start_grad_${y.value}`,
            fy: "30%"
          }, [
            n("stop", {
              offset: "10%",
              "stop-color": d(ge)(e.value.style.chart.plots.startColor, e.value.style.chart.plots.gradient.intensity / 100)
            }, null, 8, ct),
            n("stop", {
              offset: "90%",
              "stop-color": d(me)(e.value.style.chart.plots.startColor, 0.1)
            }, null, 8, dt),
            n("stop", {
              offset: "100%",
              "stop-color": e.value.style.chart.plots.startColor
            }, null, 8, vt)
          ], 8, it),
          n("radialGradient", {
            id: `end_grad_${y.value}`,
            fy: "30%"
          }, [
            n("stop", {
              offset: "10%",
              "stop-color": d(ge)(e.value.style.chart.plots.endColor, e.value.style.chart.plots.gradient.intensity / 100)
            }, null, 8, yt),
            n("stop", {
              offset: "90%",
              "stop-color": d(me)(e.value.style.chart.plots.endColor, 0.1)
            }, null, 8, bt),
            n("stop", {
              offset: "100%",
              "stop-color": e.value.style.chart.plots.endColor
            }, null, 8, ft)
          ], 8, ht)
        ]),
        (o(!0), r(w, null, $(b.value, (t, a) => (o(), r("g", null, [
          n("defs", null, [
            n("linearGradient", {
              id: `grad_positive_${y.value}`,
              x1: "0%",
              x2: "100%",
              y1: "0%",
              y2: "0%"
            }, [
              n("stop", {
                offset: "0%",
                "stop-color": e.value.style.chart.plots.startColor
              }, null, 8, mt),
              n("stop", {
                offset: "100%",
                "stop-color": e.value.style.chart.plots.endColor
              }, null, 8, pt)
            ], 8, gt),
            n("linearGradient", {
              id: `grad_negative_${y.value}`,
              x1: "0%",
              x2: "100%",
              y1: "0%",
              y2: "0%"
            }, [
              n("stop", {
                offset: "0%",
                "stop-color": e.value.style.chart.plots.endColor
              }, null, 8, kt),
              n("stop", {
                offset: "100%",
                "stop-color": e.value.style.chart.plots.startColor
              }, null, 8, xt)
            ], 8, _t)
          ]),
          e.value.style.chart.plots.link.type === "curved" ? (o(), r("g", Ct, [
            n("path", {
              d: `M 
                            ${t.startX},${t.y + e.value.style.chart.plots.radius / 2} 
                            C ${t.centerX},${t.y} ${t.centerX},${t.y} 
                            ${t.endX},${t.y + e.value.style.chart.plots.radius / 2}
                            L ${t.endX},${t.y - e.value.style.chart.plots.radius / 2}
                            C ${t.centerX},${t.y} ${t.centerX},${t.y}
                            ${t.startX},${t.y - e.value.style.chart.plots.radius / 2}
                            Z
                        `,
              fill: t.endX > t.startX ? `url(#grad_positive_${y.value})` : `url(#grad_negative_${y.value})`
            }, null, 8, wt)
          ])) : (o(), r("g", $t, [
            n("rect", {
              x: t.endX > t.startX ? t.startX : t.endX,
              y: t.y - e.value.style.chart.plots.link.strokeWidth / 2,
              height: e.value.style.chart.plots.link.strokeWidth,
              width: Math.abs(t.endX - t.startX),
              fill: t.endX > t.startX ? `url(#grad_positive_${y.value})` : `url(#grad_negative_${y.value})`
            }, null, 8, Lt)
          ])),
          n("circle", {
            cx: t.startX,
            cy: t.y,
            r: e.value.style.chart.plots.radius,
            fill: e.value.style.chart.plots.gradient.show ? `url(#start_grad_${y.value})` : e.value.style.chart.plots.startColor,
            stroke: e.value.style.chart.plots.stroke,
            "stroke-width": e.value.style.chart.plots.strokeWidth
          }, null, 8, At),
          n("circle", {
            cx: t.endX,
            cy: t.y,
            r: e.value.style.chart.plots.radius,
            fill: e.value.style.chart.plots.gradient.show ? `url(#end_grad_${y.value})` : e.value.style.chart.plots.endColor,
            stroke: e.value.style.chart.plots.stroke,
            "stroke-width": e.value.style.chart.plots.strokeWidth
          }, null, 8, zt),
          e.value.style.chart.labels.startLabels.show ? (o(), r("g", Xt, [
            (o(!0), r(w, null, $(b.value, (i, f) => (o(), r("text", {
              x: i.startX,
              y: s.value.top + (f + 1) * v.value - e.value.style.chart.labels.startLabels.fontSize / 3 + e.value.style.chart.labels.startLabels.offsetY,
              fill: e.value.style.chart.labels.startLabels.useStartColor ? e.value.style.chart.plots.startColor : e.value.style.chart.labels.startLabels.color,
              "font-size": e.value.style.chart.labels.startLabels.fontSize,
              "text-anchor": "middle"
            }, A(d(B)(
              e.value.style.chart.labels.formatter,
              i.start,
              d(z)({
                p: e.value.style.chart.labels.prefix,
                v: i.start,
                s: e.value.style.chart.labels.suffix,
                r: e.value.style.chart.labels.startLabels.rounding
              }),
              { datapoint: i, seriesIndex: f }
            )), 9, St))), 256))
          ])) : g("", !0),
          e.value.style.chart.labels.endLabels.show ? (o(), r("g", Nt, [
            (o(!0), r(w, null, $(b.value, (i, f) => (o(), r("text", {
              x: i.endX,
              y: s.value.top + f * v.value + e.value.style.chart.labels.endLabels.fontSize + e.value.style.chart.labels.endLabels.offsetY,
              fill: e.value.style.chart.labels.endLabels.useEndColor ? e.value.style.chart.plots.endColor : e.value.style.chart.labels.endLabels.color,
              "font-size": e.value.style.chart.labels.endLabels.fontSize,
              "text-anchor": "middle"
            }, A(d(B)(
              e.value.style.chart.labels.formatter,
              i.end,
              d(z)({
                p: e.value.style.chart.labels.prefix,
                v: i.end,
                s: e.value.style.chart.labels.suffix,
                r: e.value.style.chart.labels.endLabels.rounding
              }),
              { datapoint: i, seriesIndex: f }
            )), 9, Pt))), 256))
          ])) : g("", !0)
        ]))), 256)),
        k(l.$slots, "svg", { svg: s.value }, void 0, !0)
      ], 14, Ke)) : g("", !0),
      l.$slots.watermark ? (o(), r("div", Tt, [
        k(l.$slots, "watermark", W(R({ isPrinting: d(ee) || d(te) })), void 0, !0)
      ])) : g("", !0),
      X.value ? g("", !0) : (o(), L(Be, {
        key: 5,
        config: {
          type: "dumbbell",
          style: {
            backgroundColor: e.value.style.chart.backgroundColor,
            dumbbell: {
              color: "#CCCCCC"
            }
          }
        }
      }, null, 8, ["config"])),
      n("div", {
        ref_key: "chartLegend",
        ref: q
      }, [
        e.value.style.chart.legend.show && X.value ? (o(), L(Ue, {
          key: `legend_${J.value}`,
          legendSet: re.value,
          config: we.value
        }, {
          item: _(({ legend: t }) => [
            n("div", {
              style: H(`display:flex;align-items:center;gap:4px;font-size:${e.value.style.chart.legend.fontSize}px`)
            }, [
              (o(), r("svg", {
                xmlns: d(fe),
                viewBox: "0 0 20 20",
                height: e.value.style.chart.legend.fontSize,
                width: e.value.style.chart.legend.fontSize
              }, [
                n("circle", {
                  cx: 10,
                  cy: 10,
                  r: 9,
                  fill: t.color
                }, null, 8, Dt)
              ], 8, Gt)),
              ve(" " + A(t.name), 1)
            ], 4)
          ]),
          _: 1
        }, 8, ["legendSet", "config"])) : k(l.$slots, "legend", {
          key: 1,
          legend: re.value
        }, void 0, !0)
      ], 512),
      X.value ? (o(), L(je, {
        key: 6,
        hideDetails: "",
        config: {
          open: G.value.showTable,
          maxHeight: 1e4,
          body: {
            backgroundColor: e.value.style.chart.backgroundColor,
            color: e.value.style.chart.color
          },
          head: {
            backgroundColor: e.value.style.chart.backgroundColor,
            color: e.value.style.chart.color
          }
        }
      }, {
        content: _(() => [
          (o(), L(Re, {
            key: `table_${Z.value}`,
            colNames: I.value.colNames,
            head: I.value.head,
            body: I.value.body,
            config: I.value.config,
            title: `${e.value.style.chart.title.text}${e.value.style.chart.title.subtitle.text ? ` : ${e.value.style.chart.title.subtitle.text}` : ""}`,
            onClose: u[0] || (u[0] = (t) => G.value.showTable = !1)
          }, {
            th: _(({ th: t }) => [
              n("div", {
                innerHTML: t,
                style: { display: "flex", "align-items": "center" }
              }, null, 8, It)
            ]),
            td: _(({ td: t }) => [
              ve(A(t.name || t), 1)
            ]),
            _: 1
          }, 8, ["colNames", "head", "body", "config", "title"]))
        ]),
        _: 1
      }, 8, ["config"])) : g("", !0)
    ], 14, Je));
  }
}, Kt = /* @__PURE__ */ Ze(Mt, [["__scopeId", "data-v-546fc153"]]);
export {
  Kt as default
};
