import { useCssVars as Oe, computed as h, ref as p, watch as we, onMounted as Ne, openBlock as s, createElementBlock as n, normalizeClass as K, normalizeStyle as x, createBlock as G, createCommentVNode as c, unref as i, createSlots as Fe, withCtx as w, renderSlot as m, normalizeProps as X, guardReactiveProps as H, createVNode as oe, Fragment as A, renderList as S, createElementVNode as u, toDisplayString as f, withKeys as Pe, createTextVNode as Ve, nextTick as Ie } from "vue";
import { u as Be, o as Re, e as _e, c as se, t as Ee, M as Ge, g as Xe, N as ue, X as He, F as ne, i as F, f as O, v as z, x as De, y as Ue, q as Ye, r as je } from "./index-DnVHQ2xI.js";
import { _ as We } from "./Title-5VmBwT4i.js";
import { u as qe, U as Ke } from "./usePrinter-BEeNAqS5.js";
import { _ as Je } from "./Tooltip-Cj4EF7v1.js";
import Qe from "./vue-ui-skeleton-aZmkNzAe.js";
import Ze from "./BaseIcon-rRli6Sfv.js";
import et from "./vue-ui-accordion-DspS4q3f.js";
import { u as ke } from "./useNestedProp-Cox0K0Y5.js";
import { _ as tt } from "./PackageVersion-CvCRsT5_.js";
import { P as lt } from "./PenAndPaper-Jb0pLt3G.js";
import { _ as at } from "./_plugin-vue_export-helper-CHgC5LLL.js";
const ot = ["id"], st = {
  key: 1,
  style: "width:100%;background:transparent"
}, ut = ["xmlns", "viewBox"], nt = ["x", "y", "width", "height", "fill", "stroke", "stroke-width"], it = ["x", "y", "width", "height", "fill", "stroke", "stroke-width"], rt = ["font-size", "font-weight", "fill", "x", "y"], vt = ["x", "y", "width", "height", "onMouseover"], dt = { key: 0 }, yt = ["font-size", "fill", "x", "y", "font-weight"], ct = { key: 0 }, ht = ["text-anchor", "font-size", "fill", "font-weight", "transform"], pt = { key: 1 }, gt = ["x", "y", "width", "height", "stroke", "stroke-width"], ft = { key: 2 }, bt = ["id"], mt = ["stop-color"], xt = ["stop-color"], wt = ["x", "y", "font-size", "fill"], _t = ["x", "y", "height", "rx", "fill"], kt = ["x", "y", "font-size", "fill"], $t = ["stroke", "x1", "x2", "y1", "y2"], Ct = ["fill", "d"], Lt = { key: 3 }, At = {
  id: "colorScaleHorizontal",
  x1: "0%",
  x2: "100%",
  y1: "0%",
  y2: "0%"
}, zt = ["stop-color"], Tt = ["stop-color"], Mt = ["x", "y", "width", "height", "rx"], St = ["x", "y", "font-size", "fill"], Ot = ["x", "y", "font-size", "fill"], Nt = ["stroke", "x1", "x2", "y1", "y2"], Ft = ["fill", "d"], Pt = {
  key: 4,
  class: "vue-data-ui-watermark"
}, Vt = { class: "vue-ui-data-table" }, It = { key: 0 }, Bt = ["data-cell"], Rt = { style: { display: "flex", "align-items": "center", gap: "5px", "justify-content": "flex-end", width: "100%", "padding-right": "3px" } }, Et = ["data-cell"], Gt = { style: { display: "flex", "align-items": "center", gap: "5px", "justify-content": "flex-end", width: "100%", "padding-right": "3px" } }, Xt = {
  __name: "vue-ui-heatmap",
  props: {
    config: {
      type: Object,
      default() {
        return {};
      }
    },
    dataset: {
      type: Array,
      default() {
        return [];
      }
    }
  },
  setup(D, { expose: $e }) {
    const r = D;
    Oe((t) => ({
      ac37324c: t.tdo
    }));
    const { vue_ui_heatmap: Ce } = Be(), U = h(() => !!r.dataset && r.dataset.length);
    Re(r.dataset) && _e({
      componentName: "VueUiHeatmap",
      type: "dataset"
    });
    const P = p(se()), Y = p(null), Le = p(null), J = p(!1), Q = p(""), ie = p(void 0), V = p(null), re = p(0), ve = p(null), de = p(!1), ye = p(0), e = h({
      get: () => ce(),
      set: (t) => t
    });
    function ce() {
      const t = ke({
        userConfig: r.config,
        defaultConfig: Ce
      });
      let a = {};
      return t.theme ? a = {
        ...ke({
          userConfig: Ee.vue_ui_heatmap[t.theme] || r.config,
          defaultConfig: t
        })
      } : a = t, r.config && Ge(r.config, "style.layout.dataLabels.xAxis.showOnlyAtModulo") ? a.style.layout.dataLabels.xAxis.showOnlyAtModulo = r.config.style.layout.dataLabels.xAxis.showOnlyAtModulo : a.style.layout.dataLabels.xAxis.showOnlyAtModulo = null, a;
    }
    we(() => r.config, (t) => {
      e.value = ce(), Z(), ye.value += 1;
    }, { deep: !0 }), we(() => r.dataset, () => {
      Z();
    }, { deep: !0 });
    const { isPrinting: he, isImaging: pe, generatePdf: ge, generateImage: fe } = qe({
      elementId: `heatmap__${P.value}`,
      fileName: e.value.style.title.text || "vue-ui-heatmap"
    }), _ = p({
      showTable: e.value.table.show,
      showTooltip: e.value.style.tooltip.show
    }), Ae = h(() => e.value.table.responsiveBreakpoint);
    function ze() {
      new ResizeObserver((a) => {
        a.forEach((o) => {
          de.value = o.contentRect.width < Ae.value;
        });
      }).observe(ve.value);
    }
    Ne(Z);
    function Z() {
      ze();
    }
    const N = h(() => Math.max(...r.dataset.flatMap((t) => (t.values || []).length))), k = h(() => {
      const t = e.value.style.layout.padding.top + e.value.style.layout.padding.bottom + r.dataset.length * e.value.style.layout.cells.height, a = e.value.style.layout.padding.left + e.value.style.layout.padding.right + (N.value < r.dataset.length ? r.dataset.length : N.value) * e.value.style.layout.cells.height, o = t + (e.value.style.legend.show ? e.value.style.legend.position === "right" ? 0 : e.value.style.layout.cells.height * 2 : 0);
      return {
        height: t,
        heightWithLegend: o,
        width: a
      };
    }), j = h(() => e.value.style.legend.position), l = h(() => ({
      top: e.value.style.layout.padding.top,
      left: e.value.style.layout.padding.left,
      right: k.value.width - e.value.style.layout.padding.right - (j.value === "right" && e.value.style.legend.show ? 92 : 0),
      bottom: k.value.height - e.value.style.layout.padding.bottom,
      height: k.value.height - e.value.style.layout.padding.top - e.value.style.layout.padding.bottom,
      width: k.value.width - e.value.style.layout.padding.right - e.value.style.layout.padding.left - (j.value === "right" && e.value.style.legend.show ? 92 : 0)
    })), ee = h(() => d.value.height * r.dataset.length), b = h(() => Math.max(...r.dataset.flatMap((t) => t.values))), T = h(() => Math.min(...r.dataset.flatMap((t) => t.values))), M = h(() => {
      const t = r.dataset.flatMap((o) => o.values);
      return t.reduce((o, v) => o + v, 0) / t.length;
    }), d = h(() => ({
      width: l.value.width / N.value,
      height: l.value.width / (N.value < r.dataset.length ? r.dataset.length : N.value)
    })), $ = h(() => {
      const t = e.value.style.layout.dataLabels.yAxis.values.length ? e.value.style.layout.dataLabels.yAxis.values : r.dataset.map((o) => o.name), a = e.value.style.layout.dataLabels.xAxis.values;
      return {
        yLabels: t,
        xLabels: a.slice(0, N.value)
      };
    }), W = h(() => (r.dataset.forEach((t, a) => {
      Xe({
        datasetObject: t,
        requiredAttributes: ["values"]
      }).forEach((o) => {
        _e({
          componentName: "VueUiHeatmap",
          type: "datasetSerieAttribute",
          property: "values",
          index: a
        });
      });
    }), r.dataset.map((t) => ({
      ...t,
      temperatures: (t.values || []).map((a, o) => a >= M.value ? {
        side: "up",
        color: ue(e.value.style.layout.cells.colors.cold, e.value.style.layout.cells.colors.hot, T.value, b.value, a),
        ratio: Math.abs(Math.abs(a - M.value) / Math.abs(b.value - M.value)) > 1 ? 1 : Math.abs(Math.abs(a - M.value) / Math.abs(b.value - M.value)),
        value: a,
        yAxisName: t.name,
        xAxisName: $.value.xLabels[o],
        id: `vue-data-ui-heatmap-cell-${se()}`
      } : {
        side: "down",
        ratio: Math.abs(1 - Math.abs(a) / Math.abs(M.value)) > 1 ? 1 : Math.abs(1 - Math.abs(a) / Math.abs(M.value)),
        color: ue(e.value.style.layout.cells.colors.cold, e.value.style.layout.cells.colors.hot, T.value, b.value, a),
        value: a,
        yAxisName: t.name,
        xAxisName: $.value.xLabels[o],
        id: `vue-data-ui-heatmap-cell-${se()}`
      })
    })))), C = p(null), I = p(null);
    function Te(t, a, o, v) {
      V.value = { x: o, y: v };
      const { value: y, yAxisName: g, xAxisName: L, id: Se } = t;
      ie.value = Se, C.value = y, I.value = {
        datapoint: t,
        seriesIndex: a,
        series: W.value,
        config: e.value
      }, J.value = !0;
      let le = "";
      const ae = e.value.style.tooltip.customFormat;
      De(ae) && Ue(() => ae({
        datapoint: t,
        seriesIndex: a,
        series: W.value,
        config: e.value
      })) ? Q.value = ae({
        datapoint: t,
        seriesIndex: a,
        series: W.value,
        config: e.value
      }) : (le += `<div>${g} ${L ? `${L}` : ""}</div>`, le += `<div style="margin-top:6px;padding-top:6px;border-top:1px solid ${e.value.style.tooltip.borderColor};font-weight:bold;display:flex;flex-direction:row;gap:12px;align-items:center;justify-content:center"><span style="color:${ue(e.value.style.layout.cells.colors.cold, e.value.style.layout.cells.colors.hot, T.value, b.value, y)}">⬤</span><span>${isNaN(y) ? "-" : F(
        e.value.style.layout.cells.value.formatter,
        y,
        O({
          p: e.value.style.layout.dataLabels.prefix,
          v: y,
          s: e.value.style.layout.dataLabels.suffix,
          r: e.value.style.tooltip.roundingValue
        }),
        { datapoint: t, seriesIndex: a }
      )}</span></div>`, Q.value = `<div style="font-size:${e.value.style.tooltip.fontSize}px">${le}</div>`);
    }
    const B = h(() => l.value.top + ee.value * (1 - C.value / b.value)), R = h(() => l.value.left + (k.value.width - l.value.left - e.value.style.layout.padding.right) * (C.value / b.value));
    h(() => {
      const t = r.dataset.map((o) => ({
        name: o.name
      })), a = r.dataset.map((o) => o.values);
      return { head: t, body: a };
    });
    function be() {
      Ie(() => {
        const t = ["", ...r.dataset.map((y, g) => y.name)], a = [];
        for (let y = 0; y < $.value.xLabels.length; y += 1) {
          const g = [$.value.xLabels[y]];
          for (let L = 0; L < r.dataset.length; L += 1)
            g.push([r.dataset[L].values[y]]);
          a.push(g);
        }
        const o = [[e.value.style.title.text], [e.value.style.title.subtitle.text], [[""], [""], [""]]].concat([t]).concat(a), v = Ye(o);
        je({ csvContent: v, title: e.value.style.title.text || "vue-ui-heatmap" });
      });
    }
    const E = p(!1);
    function Me(t) {
      E.value = t, re.value += 1;
    }
    function me() {
      _.value.showTable = !_.value.showTable;
    }
    function xe() {
      _.value.showTooltip = !_.value.showTooltip;
    }
    const q = p(!1);
    function te() {
      q.value = !q.value;
    }
    return $e({
      generatePdf: ge,
      generateCsv: be,
      generateImage: fe,
      toggleTable: me,
      toggleTooltip: xe,
      toggleAnnotator: te
    }), (t, a) => (s(), n("div", {
      ref_key: "heatmapChart",
      ref: Y,
      class: K(`vue-ui-heatmap ${E.value ? "vue-data-ui-wrapper-fullscreen" : ""}`),
      style: x(`font-family:${e.value.style.fontFamily};width:100%; text-align:center;${e.value.style.title.text ? "" : "padding-top:36px"};background:${e.value.style.backgroundColor}`),
      id: `heatmap__${P.value}`
    }, [
      e.value.userOptions.buttons.annotator ? (s(), G(lt, {
        key: 0,
        parent: Y.value,
        backgroundColor: e.value.style.backgroundColor,
        color: e.value.style.color,
        active: q.value,
        onClose: te
      }, null, 8, ["parent", "backgroundColor", "color", "active"])) : c("", !0),
      e.value.style.title.text ? (s(), n("div", st, [
        (s(), G(We, {
          key: `title_${ye.value}`,
          config: {
            title: {
              cy: "heatmap-div-title",
              ...e.value.style.title
            },
            subtitle: {
              cy: "heatmap-div-subtitle",
              ...e.value.style.title.subtitle
            }
          }
        }, null, 8, ["config"]))
      ])) : c("", !0),
      e.value.userOptions.show && U.value ? (s(), G(Ke, {
        ref_key: "details",
        ref: Le,
        key: `user_options_${re.value}`,
        backgroundColor: e.value.style.backgroundColor,
        color: e.value.style.color,
        isImaging: i(pe),
        isPrinting: i(he),
        uid: P.value,
        hasTooltip: e.value.userOptions.buttons.tooltip && e.value.style.tooltip.show,
        hasPdf: e.value.userOptions.buttons.pdf,
        hasImg: e.value.userOptions.buttons.img,
        hasXls: e.value.userOptions.buttons.csv,
        hasTable: e.value.userOptions.buttons.table,
        hasFullscreen: e.value.userOptions.buttons.fullscreen,
        isFullscreen: E.value,
        isTooltip: _.value.showTooltip,
        titles: { ...e.value.userOptions.buttonTitles },
        chartElement: Y.value,
        position: e.value.userOptions.position,
        hasAnnotator: e.value.userOptions.buttons.annotator,
        isAnnotation: q.value,
        onToggleFullscreen: Me,
        onGeneratePdf: i(ge),
        onGenerateCsv: be,
        onGenerateImage: i(fe),
        onToggleTable: me,
        onToggleTooltip: xe,
        onToggleAnnotator: te
      }, Fe({ _: 2 }, [
        t.$slots.optionTooltip ? {
          name: "optionTooltip",
          fn: w(() => [
            m(t.$slots, "optionTooltip", {}, void 0, !0)
          ]),
          key: "0"
        } : void 0,
        t.$slots.optionPdf ? {
          name: "optionPdf",
          fn: w(() => [
            m(t.$slots, "optionPdf", {}, void 0, !0)
          ]),
          key: "1"
        } : void 0,
        t.$slots.optionCsv ? {
          name: "optionCsv",
          fn: w(() => [
            m(t.$slots, "optionCsv", {}, void 0, !0)
          ]),
          key: "2"
        } : void 0,
        t.$slots.optionImg ? {
          name: "optionImg",
          fn: w(() => [
            m(t.$slots, "optionImg", {}, void 0, !0)
          ]),
          key: "3"
        } : void 0,
        t.$slots.optionTable ? {
          name: "optionTable",
          fn: w(() => [
            m(t.$slots, "optionTable", {}, void 0, !0)
          ]),
          key: "4"
        } : void 0,
        t.$slots.optionFullscreen ? {
          name: "optionFullscreen",
          fn: w(({ toggleFullscreen: o, isFullscreen: v }) => [
            m(t.$slots, "optionFullscreen", X(H({ toggleFullscreen: o, isFullscreen: v })), void 0, !0)
          ]),
          key: "5"
        } : void 0,
        t.$slots.optionAnnotator ? {
          name: "optionAnnotator",
          fn: w(({ toggleAnnotator: o, isAnnotator: v }) => [
            m(t.$slots, "optionAnnotator", X(H({ toggleAnnotator: o, isAnnotator: v })), void 0, !0)
          ]),
          key: "6"
        } : void 0
      ]), 1032, ["backgroundColor", "color", "isImaging", "isPrinting", "uid", "hasTooltip", "hasPdf", "hasImg", "hasXls", "hasTable", "hasFullscreen", "isFullscreen", "isTooltip", "titles", "chartElement", "position", "hasAnnotator", "isAnnotation", "onGeneratePdf", "onGenerateImage"])) : c("", !0),
      U.value ? (s(), n("svg", {
        key: 3,
        xmlns: i(He),
        class: K({ "vue-data-ui-fullscreen--on": E.value, "vue-data-ui-fulscreen--off": !E.value }),
        viewBox: `0 0 ${k.value.width} ${k.value.heightWithLegend}`,
        style: x(`max-width:100%;overflow:visible;background:transparent;color:${e.value.style.color}`)
      }, [
        oe(tt),
        (s(!0), n(A, null, S(W.value, (o, v) => (s(), n("g", null, [
          (s(!0), n(A, null, S(o.temperatures, (y, g) => (s(), n("g", null, [
            u("rect", {
              x: l.value.left + d.value.width * g + e.value.style.layout.cells.spacing / 2,
              y: l.value.top + d.value.height * v + e.value.style.layout.cells.spacing / 2,
              width: d.value.width - e.value.style.layout.cells.spacing,
              height: d.value.height - e.value.style.layout.cells.spacing,
              fill: e.value.style.layout.cells.colors.underlayer,
              stroke: e.value.style.backgroundColor,
              "stroke-width": e.value.style.layout.cells.spacing
            }, null, 8, nt),
            u("rect", {
              x: l.value.left + d.value.width * g + e.value.style.layout.cells.spacing / 2,
              y: l.value.top + d.value.height * v + e.value.style.layout.cells.spacing / 2,
              width: d.value.width - e.value.style.layout.cells.spacing,
              height: d.value.height - e.value.style.layout.cells.spacing,
              fill: y.color,
              stroke: e.value.style.backgroundColor,
              "stroke-width": e.value.style.layout.cells.spacing
            }, null, 8, it),
            e.value.style.layout.cells.value.show ? (s(), n("text", {
              key: 0,
              "text-anchor": "middle",
              "font-size": e.value.style.layout.cells.value.fontSize,
              "font-weight": e.value.style.layout.cells.value.bold ? "bold" : "normal",
              fill: i(ne)(y.color),
              x: l.value.left + d.value.width * g + d.value.width / 2,
              y: l.value.top + d.value.height * v + d.value.height / 2 + e.value.style.layout.cells.value.fontSize / 3
            }, f(i(F)(
              e.value.style.layout.cells.value.formatter,
              y.value,
              i(O)({
                p: e.value.style.layout.dataLabels.prefix,
                v: y.value,
                s: e.value.style.layout.dataLabels.suffix,
                r: e.value.style.layout.cells.value.roundingValue
              }),
              { datapoint: y }
            )), 9, rt)) : c("", !0)
          ]))), 256)),
          (s(!0), n(A, null, S(o.temperatures, (y, g) => (s(), n("g", null, [
            u("rect", {
              x: l.value.left + d.value.width * g,
              y: l.value.top + d.value.height * v,
              width: d.value.width,
              height: d.value.height,
              fill: "transparent",
              stroke: "none",
              onMouseover: (L) => Te(y, v, l.value.left + d.value.width * g, l.value.top + d.value.height * v),
              onMouseout: a[0] || (a[0] = (L) => {
                J.value = !1, ie.value = void 0, C.value = null, V.value = null;
              })
            }, null, 40, vt)
          ]))), 256)),
          e.value.style.layout.dataLabels.yAxis.show ? (s(), n("g", dt, [
            u("text", {
              "font-size": e.value.style.layout.dataLabels.yAxis.fontSize,
              fill: e.value.style.layout.dataLabels.yAxis.color,
              x: l.value.left + e.value.style.layout.dataLabels.yAxis.offsetX - 6,
              y: l.value.top + d.value.height * v + d.value.height / 2 + e.value.style.layout.dataLabels.yAxis.fontSize / 3 + e.value.style.layout.dataLabels.yAxis.offsetY,
              "text-anchor": "end",
              "font-weight": e.value.style.layout.dataLabels.yAxis.bold ? "bold" : "normal"
            }, f($.value.yLabels[v]), 9, yt)
          ])) : c("", !0)
        ]))), 256)),
        e.value.style.layout.dataLabels.xAxis.show ? (s(), n("g", ct, [
          (s(!0), n(A, null, S($.value.xLabels, (o, v) => (s(), n(A, null, [
            !e.value.style.layout.dataLabels.xAxis.showOnlyAtModulo || e.value.style.layout.dataLabels.xAxis.showOnlyAtModulo && v % e.value.style.layout.dataLabels.xAxis.showOnlyAtModulo === 0 ? (s(), n("text", {
              key: 0,
              "text-anchor": e.value.style.layout.dataLabels.xAxis.rotation === 0 ? "middle" : e.value.style.layout.dataLabels.xAxis.rotation < 0 ? "start" : "end",
              "font-size": e.value.style.layout.dataLabels.xAxis.fontSize,
              fill: e.value.style.layout.dataLabels.xAxis.color,
              "font-weight": e.value.style.layout.dataLabels.xAxis.bold ? "bold" : "normal",
              transform: `translate(${l.value.left + d.value.width / 2 + l.value.width / $.value.xLabels.length * v + e.value.style.layout.dataLabels.xAxis.offsetX}, ${l.value.top + e.value.style.layout.dataLabels.xAxis.offsetY - 6}), rotate(${e.value.style.layout.dataLabels.xAxis.rotation})`
            }, f(o), 9, ht)) : c("", !0)
          ], 64))), 256))
        ])) : c("", !0),
        V.value ? (s(), n("g", pt, [
          u("rect", {
            style: { "pointer-events": "none" },
            x: V.value.x - e.value.style.layout.cells.selected.border / 2 + e.value.style.layout.cells.spacing,
            y: V.value.y - e.value.style.layout.cells.selected.border / 2 + e.value.style.layout.cells.spacing,
            width: d.value.width - e.value.style.layout.cells.spacing + e.value.style.layout.cells.selected.border - e.value.style.layout.cells.spacing,
            height: d.value.height - e.value.style.layout.cells.spacing + e.value.style.layout.cells.selected.border - e.value.style.layout.cells.spacing,
            fill: "transparent",
            stroke: e.value.style.layout.cells.selected.color,
            "stroke-width": e.value.style.layout.cells.selected.border,
            rx: 1
          }, null, 8, gt)
        ])) : c("", !0),
        e.value.style.legend.show && j.value === "right" ? (s(), n("g", ft, [
          u("defs", null, [
            u("linearGradient", {
              id: `colorScaleVertical_${P.value}`,
              x2: "0%",
              y2: "100%"
            }, [
              u("stop", {
                offset: "0%",
                "stop-color": e.value.style.layout.cells.colors.hot
              }, null, 8, mt),
              u("stop", {
                offset: "100%",
                "stop-color": e.value.style.layout.cells.colors.cold
              }, null, 8, xt)
            ], 8, bt)
          ]),
          u("text", {
            x: l.value.right + 36 + 18,
            y: l.value.top - e.value.style.legend.fontSize * 1.5,
            "text-anchor": "middle",
            "font-size": e.value.style.legend.fontSize * 2,
            fill: e.value.style.legend.color
          }, f(i(F)(
            e.value.style.layout.cells.value.formatter,
            i(z)(b.value),
            i(O)({
              p: e.value.style.layout.dataLabels.prefix,
              v: i(z)(b.value),
              s: e.value.style.layout.dataLabels.suffix,
              r: e.value.style.legend.roundingValue
            })
          )), 9, wt),
          u("rect", {
            x: l.value.right + 36,
            y: l.value.top,
            width: 36,
            height: ee.value,
            rx: e.value.style.legend.scaleBorderRadius,
            fill: `url(#colorScaleVertical_${P.value})`
          }, null, 8, _t),
          u("text", {
            x: l.value.right + 36 + 18,
            y: l.value.top + ee.value + e.value.style.legend.fontSize * 2.5,
            "text-anchor": "middle",
            "font-size": e.value.style.legend.fontSize * 2,
            fill: e.value.style.legend.color
          }, f(i(F)(
            e.value.style.layout.cells.value.formatter,
            i(z)(T.value),
            i(O)({
              p: e.value.style.layout.dataLabels.prefix,
              v: i(z)(T.value),
              s: e.value.style.layout.dataLabels.suffix,
              r: e.value.style.legend.roundingValue
            })
          )), 9, kt),
          C.value !== null ? (s(), n("line", {
            key: 0,
            stroke: i(ne)(I.value.datapoint.color),
            "stroke-width": "2",
            x1: l.value.right + 36,
            x2: l.value.right + 72,
            y1: B.value,
            y2: B.value
          }, null, 8, $t)) : c("", !0),
          C.value !== null ? (s(), n("path", {
            key: 1,
            fill: e.value.style.color,
            stroke: "none",
            d: `M ${l.value.right + 36},${B.value} ${l.value.right + 26},${B.value - 8} ${l.value.right + 26},${B.value + 8}z`
          }, null, 8, Ct)) : c("", !0)
        ])) : c("", !0),
        e.value.style.legend.show && j.value === "bottom" ? (s(), n("g", Lt, [
          u("defs", null, [
            u("linearGradient", At, [
              u("stop", {
                offset: "0%",
                "stop-color": e.value.style.layout.cells.colors.cold
              }, null, 8, zt),
              u("stop", {
                offset: "100%",
                "stop-color": e.value.style.layout.cells.colors.hot
              }, null, 8, Tt)
            ])
          ]),
          u("rect", {
            x: l.value.left,
            y: l.value.bottom + e.value.style.layout.cells.height,
            width: k.value.width - l.value.left - e.value.style.layout.padding.right,
            height: e.value.style.layout.cells.height,
            rx: e.value.style.legend.scaleBorderRadius > e.value.style.layout.cells.height / 2 ? e.value.style.layout.cells.height / 2 : e.value.style.legend.scaleBorderRadius,
            fill: "url(#colorScaleHorizontal)"
          }, null, 8, Mt),
          u("text", {
            x: l.value.left,
            y: l.value.bottom + e.value.style.layout.cells.height * 2 + e.value.style.legend.fontSize * 2,
            "text-anchor": "start",
            "font-size": e.value.style.legend.fontSize * 2,
            fill: e.value.style.legend.color
          }, f(i(F)(
            e.value.style.layout.cells.value.formatter,
            i(z)(T.value),
            i(O)({
              p: e.value.style.layout.dataLabels.prefix,
              v: i(z)(T.value),
              s: e.value.style.layout.dataLabels.suffix,
              r: e.value.style.legend.roundingValue
            })
          )), 9, St),
          u("text", {
            x: l.value.right,
            y: l.value.bottom + e.value.style.layout.cells.height * 2 + e.value.style.legend.fontSize * 2,
            "text-anchor": "end",
            "font-size": e.value.style.legend.fontSize * 2,
            fill: e.value.style.legend.color
          }, f(i(F)(
            e.value.style.layout.cells.value.formatter,
            i(z)(b.value),
            i(O)({
              p: e.value.style.layout.dataLabels.prefix,
              v: i(z)(b.value),
              s: e.value.style.layout.dataLabels.suffix,
              r: e.value.style.legend.roundingValue
            })
          )), 9, Ot),
          C.value !== null ? (s(), n("line", {
            key: 0,
            stroke: i(ne)(I.value.datapoint.color),
            "stroke-width": "2",
            x1: R.value,
            x2: R.value,
            y1: l.value.bottom + e.value.style.layout.cells.height,
            y2: l.value.bottom + e.value.style.layout.cells.height * 2
          }, null, 8, Nt)) : c("", !0),
          C.value !== null ? (s(), n("path", {
            key: 1,
            fill: e.value.style.color,
            stroke: "none",
            d: `M ${R.value},${l.value.bottom + e.value.style.layout.cells.height} ${R.value - 12},${l.value.bottom + e.value.style.layout.cells.height - 20} ${R.value + 12},${l.value.bottom + e.value.style.layout.cells.height - 20}z`
          }, null, 8, Ft)) : c("", !0)
        ])) : c("", !0),
        m(t.$slots, "svg", { svg: k.value }, void 0, !0)
      ], 14, ut)) : c("", !0),
      t.$slots.watermark ? (s(), n("div", Pt, [
        m(t.$slots, "watermark", X(H({ isPrinting: i(he) || i(pe) })), void 0, !0)
      ])) : c("", !0),
      U.value ? c("", !0) : (s(), G(Qe, {
        key: 5,
        config: {
          type: "heatmap",
          style: {
            backgroundColor: e.value.style.backgroundColor,
            heatmap: {
              color: "#CCCCCC"
            }
          }
        }
      }, null, 8, ["config"])),
      oe(Je, {
        show: _.value.showTooltip && J.value,
        backgroundColor: e.value.style.tooltip.backgroundColor,
        color: e.value.style.tooltip.color,
        borderRadius: e.value.style.tooltip.borderRadius,
        borderColor: e.value.style.tooltip.borderColor,
        borderWidth: e.value.style.tooltip.borderWidth,
        fontSize: e.value.style.tooltip.fontSize,
        backgroundOpacity: e.value.style.tooltip.backgroundOpacity,
        position: e.value.style.tooltip.position,
        offsetY: e.value.style.tooltip.offsetY,
        parent: Y.value,
        content: Q.value,
        isCustom: e.value.style.tooltip.customFormat && typeof e.value.style.tooltip.customFormat == "function"
      }, {
        "tooltip-before": w(() => [
          m(t.$slots, "tooltip-before", X(H({ ...I.value })), void 0, !0)
        ]),
        "tooltip-after": w(() => [
          m(t.$slots, "tooltip-after", X(H({ ...I.value })), void 0, !0)
        ]),
        _: 3
      }, 8, ["show", "backgroundColor", "color", "borderRadius", "borderColor", "borderWidth", "fontSize", "backgroundOpacity", "position", "offsetY", "parent", "content", "isCustom"]),
      U.value ? (s(), G(et, {
        key: 6,
        hideDetails: "",
        config: {
          open: _.value.showTable,
          maxHeight: 1e4,
          body: {
            backgroundColor: e.value.style.backgroundColor,
            color: e.value.style.color
          },
          head: {
            backgroundColor: e.value.style.backgroundColor,
            color: e.value.style.color
          }
        }
      }, {
        content: w(() => [
          u("div", {
            ref_key: "tableContainer",
            ref: ve,
            class: "vue-ui-heatmap-table"
          }, [
            u("div", {
              style: "width:100%;overflow-x:auto;padding-top:36px;position:relative",
              class: K({ "vue-ui-responsive": de.value })
            }, [
              u("div", {
                role: "button",
                tabindex: "0",
                style: x(`width:32px; position: absolute; top: 0; left:4px; padding: 0 0px; display: flex; align-items:center;justify-content:center;height: 36px; width: 32px; cursor:pointer; background:${e.value.table.th.backgroundColor};`),
                onClick: a[1] || (a[1] = (o) => _.value.showTable = !1),
                onKeypress: a[2] || (a[2] = Pe((o) => _.value.showTable = !1, ["enter"]))
              }, [
                oe(Ze, {
                  name: "close",
                  stroke: e.value.table.th.color,
                  "stroke-width": 2
                }, null, 8, ["stroke"])
              ], 36),
              u("table", Vt, [
                u("caption", {
                  style: x(`backgroundColor:${e.value.table.th.backgroundColor};color:${e.value.table.th.color};outline:${e.value.table.th.outline}`)
                }, [
                  Ve(f(e.value.style.title.text) + " ", 1),
                  e.value.style.title.subtitle.text ? (s(), n("span", It, f(e.value.style.title.subtitle.text), 1)) : c("", !0)
                ], 4),
                u("thead", null, [
                  u("tr", {
                    role: "row",
                    style: x(`background:${e.value.table.th.backgroundColor};color:${e.value.table.th.color}`)
                  }, [
                    u("th", {
                      style: x(`outline:${e.value.table.th.outline};padding-right:6px`)
                    }, null, 4),
                    (s(!0), n(A, null, S(D.dataset, (o, v) => (s(), n("th", {
                      align: "right",
                      style: x(`outline:${e.value.table.th.outline};padding-right:6px`)
                    }, f(o.name), 5))), 256))
                  ], 4)
                ]),
                u("tbody", null, [
                  (s(!0), n(A, null, S($.value.xLabels, (o, v) => (s(), n("tr", {
                    role: "row",
                    class: K({ "vue-ui-data-table__tbody__row": !0, "vue-ui-data-table__tbody__row-even": v % 2 === 0, "vue-ui-data-table__tbody__row-odd": v % 2 !== 0 }),
                    style: x(`background:${e.value.table.td.backgroundColor};color:${e.value.table.td.color}`)
                  }, [
                    u("td", {
                      "data-cell": e.value.table.colNames.xAxis,
                      class: "vue-ui-data-table__tbody__td",
                      style: x(`outline:${e.value.table.td.outline}`)
                    }, [
                      u("div", Rt, f(o), 1)
                    ], 12, Bt),
                    (s(!0), n(A, null, S(D.dataset, (y, g) => (s(), n("td", {
                      class: "vue-ui-data-table__tbody__td",
                      "data-cell": D.dataset[g].name,
                      style: x(`outline:${e.value.table.td.outline}`)
                    }, [
                      u("div", Gt, f(isNaN(y.values[v]) ? "-" : i(O)({ p: e.value.style.layout.dataLabels.prefix, v: y.values[v], s: e.value.style.layout.dataLabels.suffix, r: e.value.table.td.roundingValue })), 1)
                    ], 12, Et))), 256))
                  ], 6))), 256))
                ])
              ])
            ], 2)
          ], 512)
        ]),
        _: 1
      }, 8, ["config"])) : c("", !0)
    ], 14, ot));
  }
}, tl = /* @__PURE__ */ at(Xt, [["__scopeId", "data-v-247d7da4"]]);
export {
  tl as default
};
