import { toRef as ue, resolveComponent as ce, openBlock as a, createElementBlock as r, Fragment as y, renderList as z, withModifiers as M, createBlock as T, createCommentVNode as m, createElementVNode as x, toDisplayString as Ae, normalizeStyle as ie, createVNode as S, computed as B, onMounted as Ke, ref as f, watch as Qe, normalizeClass as Fe, unref as N, createSlots as _e, withCtx as k, renderSlot as $, normalizeProps as W, guardReactiveProps as q, createTextVNode as et, nextTick as Re } from "vue";
import { u as tt, o as ot, e as lt, c as Se, t as at, a as nt, p as Le, b as st, X as rt, l as it, O as ut, q as ct, r as dt, x as vt, y as ft } from "./index-DnVHQ2xI.js";
import { _ as pt } from "./Title-5VmBwT4i.js";
import { u as ht, U as gt } from "./usePrinter-BEeNAqS5.js";
import { D as yt } from "./DataTable-DTk7C4Pr.js";
import { _ as mt } from "./Tooltip-Cj4EF7v1.js";
import Z from "./BaseIcon-rRli6Sfv.js";
import bt from "./vue-ui-skeleton-aZmkNzAe.js";
import kt from "./vue-ui-accordion-DspS4q3f.js";
import { u as De } from "./useNestedProp-Cox0K0Y5.js";
import { _ as Ct } from "./PackageVersion-CvCRsT5_.js";
import { P as $t } from "./PenAndPaper-Jb0pLt3G.js";
import { _ as xt } from "./_plugin-vue_export-helper-CHgC5LLL.js";
const wt = ["cx", "cy", "r", "fill", "stroke", "stroke-width", "onClick", "onMouseover"], Pt = {
  __name: "RecursiveCircles",
  props: {
    color: {
      type: String,
      default: "#000000"
    },
    dataset: {
      type: Array,
      default: () => []
    },
    hoveredUid: {
      type: String,
      default: null
    },
    linkColor: {
      type: String,
      default: "#CCCCCC"
    },
    stroke: {
      type: String,
      default: "#FFFFFF"
    },
    strokeHovered: {
      type: String,
      default: "#000000"
    }
  },
  emits: ["zoom", "hover"],
  setup(n, { emit: C }) {
    const b = n;
    function c(s) {
      C("zoom", s);
    }
    function d(s) {
      C("hover", s);
    }
    return ue(b, "dataset").value.forEach((s) => {
      s.nodes && s.nodes.length > 0 && s.nodes.forEach((v) => {
        v.ancestor = s;
      });
    }), (s, v) => {
      const R = ce("RecursiveCircles", !0);
      return a(!0), r(y, null, z(n.dataset, (p) => (a(), r(y, null, [
        p.polygonPath && p.polygonPath.coordinates ? (a(), r(y, { key: 0 }, [
          (a(!0), r(y, null, z(p.polygonPath.coordinates, (D, J) => (a(), r("circle", {
            cx: D.x,
            cy: D.y,
            r: p.circleRadius,
            fill: `url(#gradient_${p.color})`,
            stroke: n.hoveredUid && n.hoveredUid === p.uid ? n.strokeHovered : n.stroke,
            "stroke-width": n.hoveredUid && n.hoveredUid === p.uid ? p.circleRadius / 6 : p.circleRadius / 12,
            style: { cursor: "pointer" },
            onClick: M((A) => c(p), ["stop"]),
            onMouseover: (A) => d(p),
            onMouseleave: v[0] || (v[0] = (A) => d(null))
          }, null, 40, wt))), 256)),
          p.nodes && p.nodes.length > 0 ? (a(), T(R, {
            key: 0,
            dataset: p.nodes,
            color: n.color,
            stroke: n.stroke,
            strokeHovered: n.strokeHovered,
            hoveredUid: n.hoveredUid,
            onZoom: c,
            onHover: d
          }, null, 8, ["dataset", "color", "stroke", "strokeHovered", "hoveredUid"])) : m("", !0)
        ], 64)) : m("", !0)
      ], 64))), 256);
    };
  }
}, Tt = ["x1", "y1", "x2", "y2", "stroke", "stroke-width"], Ft = ["x1", "y1", "x2", "y2", "stroke", "stroke-width"], Rt = {
  __name: "RecursiveLinks",
  props: {
    dataset: {
      type: Array,
      default: () => []
    },
    color: {
      type: String,
      default: "#DDDDDD"
    },
    backgroundColor: {
      type: String,
      default: "#FFFFFF"
    }
  },
  setup(n) {
    return ue(n, "dataset").value.forEach((c) => {
      c.nodes && c.nodes.length > 0 && c.nodes.forEach((d) => {
        d.ancestor = c;
      });
    }), (c, d) => {
      const L = ce("RecursiveLinks", !0);
      return a(), r(y, null, [
        (a(!0), r(y, null, z(n.dataset, (s) => (a(), r(y, null, [
          s.polygonPath && s.polygonPath.coordinates ? (a(!0), r(y, { key: 0 }, z(s.polygonPath.coordinates, (v, R) => (a(), r(y, null, [
            s.ancestor && s.ancestor.polygonPath ? (a(), r(y, { key: 0 }, [
              x("line", {
                x1: v.x,
                y1: v.y,
                x2: s.ancestor.polygonPath.coordinates[0].x,
                y2: s.ancestor.polygonPath.coordinates[0].y,
                stroke: n.backgroundColor,
                "stroke-width": s.circleRadius / 1.5
              }, null, 8, Tt),
              x("line", {
                x1: v.x,
                y1: v.y,
                x2: s.ancestor.polygonPath.coordinates[0].x,
                y2: s.ancestor.polygonPath.coordinates[0].y,
                stroke: n.color,
                "stroke-width": s.circleRadius / 2
              }, null, 8, Ft)
            ], 64)) : m("", !0)
          ], 64))), 256)) : m("", !0)
        ], 64))), 256)),
        (a(!0), r(y, null, z(n.dataset, (s) => (a(), r(y, null, [
          s.polygonPath && s.polygonPath.coordinates ? (a(), r(y, { key: 0 }, [
            s.nodes && s.nodes.length > 0 ? (a(), T(L, {
              key: 0,
              dataset: s.nodes,
              color: n.color,
              backgroundColor: n.backgroundColor
            }, null, 8, ["dataset", "color", "backgroundColor"])) : m("", !0)
          ], 64)) : m("", !0)
        ], 64))), 256))
      ], 64);
    };
  }
}, St = ["x", "y", "fill", "font-size"], Lt = {
  __name: "RecursiveLabels",
  props: {
    color: {
      type: String,
      default: "#000000"
    },
    dataset: {
      type: Array,
      default: () => []
    },
    hoveredUid: {
      type: String,
      default: null
    }
  },
  emits: ["zoom", "hover"],
  setup(n, { emit: C }) {
    return ue(n, "dataset").value.forEach((d) => {
      d.nodes && d.nodes.length > 0 && d.nodes.forEach((L) => {
        L.ancestor = d;
      });
    }), (d, L) => {
      const s = ce("RecursiveLabels", !0);
      return a(!0), r(y, null, z(n.dataset, (v) => (a(), r(y, null, [
        v.polygonPath && v.polygonPath.coordinates ? (a(), r(y, { key: 0 }, [
          (a(!0), r(y, null, z(v.polygonPath.coordinates, (R) => (a(), r("text", {
            x: R.x,
            y: R.y + v.circleRadius * 2,
            fill: n.color,
            "font-size": v.circleRadius,
            "text-anchor": "middle",
            style: { opacity: "0.8", "pointer-events": "none" }
          }, Ae(v.name), 9, St))), 256)),
          v.nodes && v.nodes.length > 0 ? (a(), T(s, {
            key: 0,
            dataset: v.nodes,
            color: n.color,
            hoveredUid: n.hoveredUid
          }, null, 8, ["dataset", "color", "hoveredUid"])) : m("", !0)
        ], 64)) : m("", !0)
      ], 64))), 256);
    };
  }
}, Dt = { style: { position: "relative", height: "100%", width: "100%" } }, At = {
  __name: "BaseDirectionPad",
  props: {
    color: {
      type: String,
      default: "#FF0000"
    },
    isFullscreen: {
      type: Boolean,
      default: !1
    }
  },
  emits: ["moveLeft", "moveTop", "moveRight", "moveBottom", "reset"],
  setup(n, { emit: C }) {
    return (b, c) => (a(), r("div", {
      style: ie(`position: ${n.isFullscreen ? "fixed" : "absolute"};bottom:0;right:${n.isFullscreen ? "12px" : "0"};width:80px;height:80px`),
      "data-html2canvas-ignore": ""
    }, [
      x("div", Dt, [
        x("button", {
          onClick: c[0] || (c[0] = M((d) => C("moveLeft"), ["stop"])),
          style: { position: "absolute", left: "0", top: "50%", transform: "translateY(-50%)", height: "24px", width: "24px", padding: "0", background: "transparent", border: "none", display: "flex", "align-items": "center", "justify-content": "center" }
        }, [
          S(Z, {
            stroke: n.color,
            name: "arrowLeft",
            style: { cursor: "pointer" }
          }, null, 8, ["stroke"])
        ]),
        x("button", {
          onClick: c[1] || (c[1] = M((d) => C("moveTop"), ["stop"])),
          style: { position: "absolute", top: "0", left: "50%", transform: "translateX(-50%)", height: "24px", width: "24px", padding: "0", background: "transparent", border: "none", display: "flex", "align-items": "center", "justify-content": "center" }
        }, [
          S(Z, {
            stroke: n.color,
            name: "arrowTop",
            style: { cursor: "pointer" }
          }, null, 8, ["stroke"])
        ]),
        x("button", {
          onClick: c[2] || (c[2] = M((d) => C("moveRight"), ["stop"])),
          style: { position: "absolute", right: "0", top: "50%", transform: "translateY(-50%)", height: "24px", width: "24px", padding: "0", background: "transparent", border: "none", display: "flex", "align-items": "center", "justify-content": "center" }
        }, [
          S(Z, {
            stroke: n.color,
            name: "arrowRight",
            style: { cursor: "pointer" }
          }, null, 8, ["stroke"])
        ]),
        x("button", {
          onClick: c[3] || (c[3] = M((d) => C("moveBottom"), ["stop"])),
          style: { position: "absolute", bottom: "0", left: "50%", transform: "translateX(-50%)", height: "24px", width: "24px", padding: "0", background: "transparent", border: "none", display: "flex", "align-items": "center", "justify-content": "center" }
        }, [
          S(Z, {
            stroke: n.color,
            name: "arrowBottom",
            style: { cursor: "pointer" }
          }, null, 8, ["stroke"])
        ]),
        x("button", {
          onClick: c[4] || (c[4] = M((d) => C("reset"), ["stop"])),
          style: { position: "absolute", top: "50%", left: "50%", transform: "translate(-50%,-50%)", height: "24px", width: "24px", padding: "0", background: "transparent", border: "none", display: "flex", "align-items": "center", "justify-content": "center" }
        }, [
          S(Z, {
            stroke: n.color,
            name: "close",
            style: { cursor: "pointer" },
            strokeWidth: 2
          }, null, 8, ["stroke"])
        ])
      ])
    ], 4));
  }
}, It = ["id"], Ut = {
  key: 1,
  style: "width:100%;background:transparent;"
}, Nt = ["xmlns", "viewBox"], zt = ["id"], Ot = ["stop-color"], Bt = ["stop-color"], Mt = {
  key: 5,
  class: "vue-data-ui-watermark"
}, Ht = ["innerHTML"], Et = {
  __name: "vue-ui-molecule",
  props: {
    config: {
      type: Object,
      default() {
        return {};
      }
    },
    dataset: {
      type: Array,
      default() {
        return [];
      }
    }
  },
  setup(n, { expose: C }) {
    const b = n, { vue_ui_molecule: c } = tt(), d = B(() => !!b.dataset && b.dataset.length);
    Ke(() => {
      L();
    });
    function L() {
      ot(b.dataset) && lt({
        componentName: "VueUiMolecule",
        type: "dataset"
      });
    }
    const s = f(Se()), v = f(null), R = f(!1), p = f(""), D = f(null), J = f(null), A = f(!1), w = f(null), de = f(null), _ = f(0), ve = f(0), fe = f(0), t = B({
      get: () => pe(),
      set: (e) => e
    });
    function pe() {
      const e = De({
        userConfig: b.config,
        defaultConfig: c
      });
      return e.theme ? {
        ...De({
          userConfig: at.vue_ui_molecule[e.theme] || b.config,
          defaultConfig: e
        }),
        customPalette: nt[e.theme] || Le
      } : e;
    }
    Qe(() => b.config, (e) => {
      t.value = pe(), L(), ve.value += 1, fe.value += 1;
    }, { deep: !0 });
    const { isPrinting: he, isImaging: ge, generatePdf: ye, generateImage: me } = ht({
      elementId: `cluster_${s.value}`,
      fileName: t.value.style.chart.title.text || "vue-ui-molecule"
    }), Ie = B(() => st(t.value.customPalette)), P = f({
      showTable: t.value.table.show,
      showDataLabels: !0,
      showTooltip: t.value.style.chart.tooltip.show
    });
    function be(e, l = 0) {
      return Array.isArray(e) && e.length > 0 && e[0].nodes ? be(e[0].nodes, l + 1) : l;
    }
    function Ue() {
      const e = be(b.dataset);
      let l = 100, o = l;
      for (let u = 0; u < e; u += 1)
        l /= 1, o += l;
      return {
        height: o,
        width: o
      };
    }
    const I = f(Ue()), ee = f(`0 0 ${I.value.width} ${I.value.height}`);
    function ke(e, l = { x: -I.value.width / 2.43, y: I.value.height / 2 }, o = I.value.width / 1.1, u = 24, i = 0, h = 0, j = "#BBBBBB") {
      if (e && e.length > 0) {
        const se = ut({
          plot: l,
          radius: o,
          sides: e.length,
          rotation: i
        });
        e.forEach((g, O) => {
          const V = se.coordinates[O];
          let U;
          if (g.ancestor ? g.ancestor.ancestor ? U = g.ancestor.color || j : (U = Ie.value[h] || Le[h] || j, h += 1) : U = j, g.polygonPath = {
            coordinates: [V]
          }, g.circleRadius = u, g.color = U, g.uid = Se(), g.nodes && g.nodes.length > 0) {
            const re = !g.ancestor || !g.ancestor.ancestor ? h : 0;
            g.nodes = ke(
              g.nodes,
              V,
              o / 2.9,
              u / 2.2,
              i + Math.PI * O / g.nodes.length,
              re,
              U
            );
          }
        });
      }
      return e;
    }
    function Ne(e) {
      const l = /* @__PURE__ */ new Set();
      function o(i) {
        i.forEach((h) => {
          h.color && !l.has(h.color) && l.add(h.color), h.nodes && h.nodes.length > 0 && o(h.nodes);
        });
      }
      o(e);
      const u = {};
      return Array.from(l).forEach((i, h) => {
        u[i] = `gradient_${h}`;
      }), u;
    }
    const ze = B(() => Ne(F.value)), F = B(() => ke(b.dataset));
    function te() {
      A.value = !1, J.value = null, de.value = null, w.value = null, le({
        polygonPath: {
          coordinates: [{ x: I.value.width / 2, y: I.value.height / 2 }]
        },
        circleRadius: 24
      });
    }
    const oe = f(null);
    function le(e) {
      D.value.focus(), Re(() => {
        oe.value && cancelAnimationFrame(oe.value);
        const l = ee.value.split(" "), o = parseFloat(l[0]), u = parseFloat(l[1]), i = parseFloat(l[2]), h = parseFloat(l[3]), { x: j, y: se } = e.polygonPath.coordinates[0], { circleRadius: g } = e, O = 8.34, V = j - g * O, U = se - g * O, re = g * O * 2, Ve = g * O * 2, Ye = Math.sqrt((V - o) ** 2 + (U - u) ** 2), Y = Math.min(1200, Math.max(20, Math.floor(Ye / 10))), We = (V - o) / Y, qe = (U - u) / Y, Ze = (re - i) / Y, Je = (Ve - h) / Y;
        let E = 0;
        function Te() {
          ee.value = `${o + We * E} ${u + qe * E} ${i + Ze * E} ${h + Je * E}`, E += t.value.style.chart.zoom.speed, E <= Y && (oe.value = requestAnimationFrame(Te));
        }
        Te();
      });
    }
    function Oe(e) {
      J.value === e.uid ? te() : (J.value = e.uid, de.value = e, w.value = {
        circleRadius: e.circleRadius,
        polygonPath: {
          coordinates: [{ x: e.polygonPath.coordinates[0].x, y: e.polygonPath.coordinates[0].y }]
        }
      }, le(e), A.value = e.uid !== F.value[0].uid);
    }
    function Be(e) {
      if (e.target.nodeName !== "circle")
        te(), A.value = !1;
      else
        return;
    }
    const ae = f(null);
    function Me(e) {
      ae.value = {
        datapoint: e,
        seriesIndex: -1,
        series: F.value,
        config: t.value
      };
      const l = t.value.style.chart.tooltip.customFormat;
      if (vt(l) && ft(() => l({
        seriesIndex: -1,
        datapoint: e,
        series: F.value,
        config: t.value
      })))
        p.value = l({
          seriesIndex: -1,
          // well, ok
          datapoint: e,
          series: F.value,
          config: t.value
        });
      else {
        let o = "";
        o += `<div style="display:flex;align-items:center;gap:3px"><div style="color:${e.color}">⬤</div><div>${e.name}</div></div>`, e.details && (o += `<div style="width:100%;border-top:1px solid ${t.value.style.chart.tooltip.borderColor};margin-top: 2px">${e.details}</div>`), p.value = `<div style="font-family:inherit">${o}</div>`;
      }
    }
    const Ce = f(null), X = f(null);
    function He(e) {
      Ce.value = e, e ? (R.value = !0, Me(e), X.value = e.uid) : (R.value = !1, p.value = "", X.value = null);
    }
    function K(e) {
      e === "right" && (w.value.polygonPath.coordinates[0].x += w.value.circleRadius), e === "left" && (w.value.polygonPath.coordinates[0].x -= w.value.circleRadius), e === "top" && (w.value.polygonPath.coordinates[0].y -= w.value.circleRadius), e === "bottom" && (w.value.polygonPath.coordinates[0].y += w.value.circleRadius), le(w.value);
    }
    function Ee(e) {
      const l = [];
      function o(u) {
        u.forEach((i) => {
          const h = {
            name: i.name,
            details: i.details || "-",
            ancestor: i.ancestor && i.ancestor.name || "-",
            color: i.color || ""
          };
          l.push(h), i.nodes && i.nodes.length > 0 && o(i.nodes, i.name);
        });
      }
      return o(e), l;
    }
    const Xe = B(() => Ee(F.value)), H = B(() => {
      const e = [
        t.value.table.translations.nodeName,
        t.value.table.translations.details,
        t.value.table.translations.ancestor
      ], l = Xe.value.map((i, h) => [
        {
          color: i.color,
          name: i.name
        },
        i.details,
        i.ancestor || ""
      ]), o = {
        th: {
          backgroundColor: t.value.table.th.backgroundColor,
          color: t.value.table.th.color,
          outline: t.value.table.th.outline
        },
        td: {
          backgroundColor: t.value.table.td.backgroundColor,
          color: t.value.table.td.color,
          outline: t.value.table.td.outline
        },
        breakpoint: t.value.table.responsiveBreakpoint
      }, u = [
        t.value.table.translations.nodeName,
        t.value.table.translations.details,
        t.value.table.translations.ancestor
      ];
      return {
        head: e,
        body: l,
        config: o,
        colNames: u
      };
    });
    function $e() {
      Re(() => {
        const e = H.value.body.map((u, i) => [[u[0].name], [u[1]], [u[2]]]), l = [[t.value.style.chart.title.text], [t.value.style.chart.title.subtitle.text], [[...H.value.head]]].concat(e), o = ct(l);
        dt({ csvContent: o, title: t.value.style.chart.title.text || "vue-ui-molecule" });
      });
    }
    function Ge() {
      return F.value;
    }
    const G = f(!1);
    function je(e) {
      G.value = e, _.value += 1;
    }
    function xe() {
      P.value.showTable = !P.value.showTable;
    }
    function we() {
      P.value.showDataLabels = !P.value.showDataLabels;
    }
    function Pe() {
      P.value.showTooltip = !P.value.showTooltip;
    }
    const Q = f(!1);
    function ne() {
      Q.value = !Q.value;
    }
    return C({
      getData: Ge,
      generatePdf: ye,
      generateCsv: $e,
      generateImage: me,
      toggleTable: xe,
      toggleLabels: we,
      toggleTooltip: Pe,
      toggleAnnotator: ne
    }), (e, l) => (a(), r("div", {
      onMouseleave: l[7] || (l[7] = (o) => {
        Ce.value = null, X.value = null;
      }),
      ref_key: "moleculeChart",
      ref: D,
      class: Fe(`vue-ui-molecule ${G.value ? "vue-data-ui-wrapper-fullscreen" : ""}`),
      style: ie(`font-family:${t.value.style.fontFamily};width:100%; text-align:center;background:${t.value.style.chart.backgroundColor}`),
      id: `cluster_${s.value}`
    }, [
      t.value.userOptions.buttons.annotator ? (a(), T($t, {
        key: 0,
        parent: D.value,
        backgroundColor: t.value.style.chart.backgroundColor,
        color: t.value.style.chart.color,
        active: Q.value,
        onClose: ne
      }, null, 8, ["parent", "backgroundColor", "color", "active"])) : m("", !0),
      t.value.style.chart.title.text ? (a(), r("div", Ut, [
        (a(), T(pt, {
          key: `title_${ve.value}`,
          config: {
            title: {
              cy: "molecule-div-title",
              ...t.value.style.chart.title
            },
            subtitle: {
              cy: "molecule-div-subtitle",
              ...t.value.style.chart.title.subtitle
            }
          }
        }, null, 8, ["config"]))
      ])) : m("", !0),
      t.value.userOptions.show && d.value ? (a(), T(gt, {
        ref_key: "details",
        ref: v,
        key: `user_options_${_.value}`,
        backgroundColor: t.value.style.chart.backgroundColor,
        color: t.value.style.chart.color,
        isPrinting: N(he),
        isImaging: N(ge),
        uid: s.value,
        hasTooltip: t.value.userOptions.buttons.tooltip && t.value.style.chart.tooltip.show,
        hasPdf: t.value.userOptions.buttons.pdf,
        hasXls: t.value.userOptions.buttons.csv,
        hasImg: t.value.userOptions.buttons.img,
        hasTable: t.value.userOptions.buttons.table,
        hasLabel: t.value.userOptions.buttons.labels,
        hasFullscreen: t.value.userOptions.buttons.fullscreen,
        isTooltip: P.value.showTooltip,
        titles: { ...t.value.userOptions.buttonTitles },
        chartElement: D.value,
        position: t.value.userOptions.position,
        hasAnnotator: t.value.userOptions.buttons.annotator,
        isAnnotation: Q.value,
        onToggleFullscreen: je,
        onGeneratePdf: N(ye),
        onGenerateCsv: $e,
        onGenerateImage: N(me),
        onToggleTable: xe,
        onToggleLabels: we,
        onToggleTooltip: Pe,
        onToggleAnnotator: ne
      }, _e({ _: 2 }, [
        e.$slots.optionTooltip ? {
          name: "optionTooltip",
          fn: k(() => [
            $(e.$slots, "optionTooltip", {}, void 0, !0)
          ]),
          key: "0"
        } : void 0,
        e.$slots.optionPdf ? {
          name: "optionPdf",
          fn: k(() => [
            $(e.$slots, "optionPdf", {}, void 0, !0)
          ]),
          key: "1"
        } : void 0,
        e.$slots.optionCsv ? {
          name: "optionCsv",
          fn: k(() => [
            $(e.$slots, "optionCsv", {}, void 0, !0)
          ]),
          key: "2"
        } : void 0,
        e.$slots.optionImg ? {
          name: "optionImg",
          fn: k(() => [
            $(e.$slots, "optionImg", {}, void 0, !0)
          ]),
          key: "3"
        } : void 0,
        e.$slots.optionTable ? {
          name: "optionTable",
          fn: k(() => [
            $(e.$slots, "optionTable", {}, void 0, !0)
          ]),
          key: "4"
        } : void 0,
        e.$slots.optionLabels ? {
          name: "optionLabels",
          fn: k(() => [
            $(e.$slots, "optionLabels", {}, void 0, !0)
          ]),
          key: "5"
        } : void 0,
        e.$slots.optionFullscreen ? {
          name: "optionFullscreen",
          fn: k(({ toggleFullscreen: o, isFullscreen: u }) => [
            $(e.$slots, "optionFullscreen", W(q({ toggleFullscreen: o, isFullscreen: u })), void 0, !0)
          ]),
          key: "6"
        } : void 0,
        e.$slots.optionAnnotator ? {
          name: "optionAnnotator",
          fn: k(({ toggleAnnotator: o, isAnnotator: u }) => [
            $(e.$slots, "optionAnnotator", W(q({ toggleAnnotator: o, isAnnotator: u })), void 0, !0)
          ]),
          key: "7"
        } : void 0
      ]), 1032, ["backgroundColor", "color", "isPrinting", "isImaging", "uid", "hasTooltip", "hasPdf", "hasXls", "hasImg", "hasTable", "hasLabel", "hasFullscreen", "isTooltip", "titles", "chartElement", "position", "hasAnnotator", "isAnnotation", "onGeneratePdf", "onGenerateImage"])) : m("", !0),
      d.value ? (a(), r("svg", {
        key: 3,
        xmlns: N(rt),
        viewBox: ee.value,
        class: Fe({ "vue-data-ui-fullscreen--on": G.value, "vue-data-ui-fulscreen--off": !G.value }),
        style: ie(`overflow: hidden; background:transparent;color:${t.value.style.chart.color}`),
        onClick: l[0] || (l[0] = M((o) => Be(o), ["stop"]))
      }, [
        S(Ct),
        x("defs", null, [
          (a(!0), r(y, null, z(Object.keys(ze.value), (o) => (a(), r("radialGradient", {
            id: `gradient_${o}`,
            cx: "50%",
            cy: "30%",
            r: "50%",
            fx: "50%",
            fy: "50%"
          }, [
            x("stop", {
              offset: "0%",
              "stop-color": N(it)(o, 0.5)
            }, null, 8, Ot),
            x("stop", {
              offset: "100%",
              "stop-color": o
            }, null, 8, Bt)
          ], 8, zt))), 256))
        ]),
        S(Rt, {
          dataset: F.value,
          color: t.value.style.chart.links.stroke,
          backgroundColor: t.value.style.chart.backgroundColor
        }, null, 8, ["dataset", "color", "backgroundColor"]),
        S(Pt, {
          dataset: F.value,
          hoveredUid: X.value,
          stroke: t.value.style.chart.nodes.stroke,
          strokeHovered: t.value.style.chart.nodes.strokeHovered,
          onZoom: Oe,
          onHover: He
        }, null, 8, ["dataset", "hoveredUid", "stroke", "strokeHovered"]),
        P.value.showDataLabels ? (a(), T(Lt, {
          key: 0,
          dataset: F.value,
          color: t.value.style.chart.color,
          hoveredUid: X.value
        }, null, 8, ["dataset", "color", "hoveredUid"])) : m("", !0),
        $(e.$slots, "svg", { svg: I.value }, void 0, !0)
      ], 14, Nt)) : m("", !0),
      A.value ? (a(), T(At, {
        key: `direction_pad_${_.value}`,
        color: t.value.style.chart.color,
        isFullscreen: G.value,
        onMoveLeft: l[1] || (l[1] = (o) => K("left")),
        onMoveRight: l[2] || (l[2] = (o) => K("right")),
        onMoveTop: l[3] || (l[3] = (o) => K("top")),
        onMoveBottom: l[4] || (l[4] = (o) => K("bottom")),
        onReset: l[5] || (l[5] = (o) => {
          te(), A.value = !1;
        })
      }, null, 8, ["color", "isFullscreen"])) : m("", !0),
      e.$slots.watermark ? (a(), r("div", Mt, [
        $(e.$slots, "watermark", W(q({ isPrinting: N(he) || N(ge) })), void 0, !0)
      ])) : m("", !0),
      d.value ? m("", !0) : (a(), T(bt, {
        key: 6,
        config: {
          type: "molecule",
          style: {
            backgroundColor: t.value.style.chart.backgroundColor,
            molecule: {
              color: "#CCCCCC"
            }
          }
        }
      }, null, 8, ["config"])),
      S(mt, {
        show: P.value.showTooltip && R.value,
        backgroundColor: t.value.style.chart.tooltip.backgroundColor,
        color: t.value.style.chart.tooltip.color,
        borderRadius: t.value.style.chart.tooltip.borderRadius,
        borderColor: t.value.style.chart.tooltip.borderColor,
        borderWidth: t.value.style.chart.tooltip.borderWidth,
        fontSize: t.value.style.chart.tooltip.fontSize,
        backgroundOpacity: t.value.style.chart.tooltip.backgroundOpacity,
        position: t.value.style.chart.tooltip.position,
        offsetY: t.value.style.chart.tooltip.offsetY,
        parent: D.value,
        content: p.value,
        isCustom: t.value.style.chart.tooltip.customFormat && typeof t.value.style.chart.tooltip.customFormat == "function"
      }, {
        "tooltip-before": k(() => [
          $(e.$slots, "tooltip-before", W(q({ ...ae.value })), void 0, !0)
        ]),
        "tooltip-after": k(() => [
          $(e.$slots, "tooltip-after", W(q({ ...ae.value })), void 0, !0)
        ]),
        _: 3
      }, 8, ["show", "backgroundColor", "color", "borderRadius", "borderColor", "borderWidth", "fontSize", "backgroundOpacity", "position", "offsetY", "parent", "content", "isCustom"]),
      d.value ? (a(), T(kt, {
        key: 7,
        hideDetails: "",
        config: {
          open: P.value.showTable,
          maxHeight: 1e4,
          body: {
            backgroundColor: t.value.style.chart.backgroundColor,
            color: t.value.style.chart.color
          },
          head: {
            backgroundColor: t.value.style.chart.backgroundColor,
            color: t.value.style.chart.color
          }
        }
      }, {
        content: k(() => [
          (a(), T(yt, {
            key: `table_${fe.value}`,
            colNames: H.value.colNames,
            head: H.value.head,
            body: H.value.body,
            config: H.value.config,
            title: `${t.value.style.chart.title.text}${t.value.style.chart.title.subtitle.text ? ` : ${t.value.style.chart.title.subtitle.text}` : ""}`,
            onClose: l[6] || (l[6] = (o) => P.value.showTable = !1)
          }, {
            th: k(({ th: o }) => [
              x("div", {
                innerHTML: o,
                style: { display: "flex", "align-items": "center" }
              }, null, 8, Ht)
            ]),
            td: k(({ td: o }) => [
              et(Ae(o.name || o), 1)
            ]),
            _: 1
          }, 8, ["colNames", "head", "body", "config", "title"]))
        ]),
        _: 1
      }, 8, ["config"])) : m("", !0)
    ], 46, It));
  }
}, to = /* @__PURE__ */ xt(Et, [["__scopeId", "data-v-900f33cd"]]);
export {
  to as default
};
