import { computed as d, ref as s, watch as ge, onMounted as Re, onBeforeUnmount as De, openBlock as n, createElementBlock as u, normalizeClass as V, normalizeStyle as q, createBlock as C, createCommentVNode as y, unref as v, createSlots as Le, withCtx as h, renderSlot as f, normalizeProps as S, guardReactiveProps as M, createVNode as pe, Fragment as F, renderList as N, createElementVNode as _, toDisplayString as P, createTextVNode as ze, nextTick as Ye } from "vue";
import { u as Be, c as Ve, t as Xe, a as Ge, p as ye, b as Ue, o as Ee, e as J, d as He, X as We, f as R, i as K, x as me, q as je, r as qe, y as Je } from "./index-DnVHQ2xI.js";
import { t as Ke, u as Qe } from "./useResponsive-NZB-WLRF.js";
import { _ as Ze } from "./Title-5VmBwT4i.js";
import { u as et, U as tt } from "./usePrinter-BEeNAqS5.js";
import { L as at } from "./Legend-CYF2gpXG.js";
import { D as lt } from "./DataTable-DTk7C4Pr.js";
import { _ as ot } from "./Tooltip-Cj4EF7v1.js";
import rt from "./vue-ui-skeleton-aZmkNzAe.js";
import nt from "./vue-ui-accordion-DspS4q3f.js";
import { u as be } from "./useNestedProp-Cox0K0Y5.js";
import { _ as st } from "./PackageVersion-CvCRsT5_.js";
import { P as ut } from "./PenAndPaper-Jb0pLt3G.js";
import { _ as it } from "./_plugin-vue_export-helper-CHgC5LLL.js";
const ct = ["id"], dt = ["xmlns", "viewBox"], vt = ["cx", "cy", "r", "stroke", "stroke-width", "stroke-dasharray", "stroke-dashoffset"], ht = ["cx", "cy", "r", "stroke", "stroke-width", "stroke-dasharray", "stroke-dashoffset"], ft = ["id"], gt = ["stdDeviation"], pt = ["filter"], yt = ["cx", "cy", "r", "stroke-width", "stroke-dasharray", "stroke-dashoffset"], mt = ["cx", "cy", "r", "stroke-width", "stroke-dasharray", "stroke-dashoffset", "onMouseenter"], bt = { key: 1 }, kt = ["onMouseenter"], $t = ["x", "y", "font-size", "fill", "font-weight"], wt = {
  key: 4,
  class: "vue-data-ui-watermark"
}, Ct = ["onClick"], xt = ["innerHTML"], Tt = {
  __name: "vue-ui-onion",
  props: {
    config: {
      type: Object,
      default() {
        return {};
      }
    },
    dataset: {
      type: Array,
      default() {
        return [];
      }
    }
  },
  emits: ["selectLegend"],
  setup(ke, { expose: $e, emit: we }) {
    const k = ke, { vue_ui_onion: Ce } = Be(), D = d(() => !!k.dataset && k.dataset.length), x = s(Ve()), xe = s(null), Q = s(0), L = s(!1), X = s(""), p = s([]), T = s(null), Z = s(null), ee = s(null), te = s(0), ae = s(0), le = s(0), e = d({
      get: () => oe(),
      set: (a) => a
    });
    function oe() {
      const a = be({
        userConfig: k.config,
        defaultConfig: Ce
      });
      return a.theme ? {
        ...be({
          userConfig: Xe.vue_ui_onion[a.theme] || k.config,
          defaultConfig: a
        }),
        customPalette: Ge[a.theme] || ye
      } : a;
    }
    ge(() => k.config, (a) => {
      e.value = oe(), ie(), te.value += 1, ae.value += 1, le.value += 1;
    }, { deep: !0 });
    const { isPrinting: re, isImaging: ne, generatePdf: se, generateImage: ue } = et({
      elementId: `vue-ui-onion_${x.value}`,
      fileName: e.value.style.chart.title.text || "vue-ui-onion"
    }), Te = d(() => Ue(e.value.customPalette)), $ = s({
      showTable: e.value.table.show,
      showTooltip: e.value.style.chart.tooltip.show
    }), r = s({
      height: 512,
      width: 512,
      padding: {
        top: 64,
        left: 64,
        right: 64,
        bottom: 64
      },
      minRadius: 64
    }), z = s(null);
    Re(() => {
      ie();
    });
    function ie() {
      if (Ee(k.dataset) && J({
        componentName: "VueUiOnion",
        type: "dataset"
      }), e.value.responsive) {
        const o = Ke(() => {
          const { width: t, height: l } = Qe({
            chart: T.value,
            title: e.value.style.chart.title.text ? Z.value : null,
            legend: e.value.style.chart.legend.show ? ee.value : null
          });
          r.value.width = t, r.value.height = l, r.value.padding.top = Math.max(t, l) * 0.125, r.value.padding.right = Math.max(t, l) * 0.125, r.value.padding.bottom = Math.max(t, l) * 0.125, r.value.padding.left = Math.max(t, l) * 0.125, r.value.minRadius = Math.min(t, l) * 0.125;
        });
        z.value = new ResizeObserver(o), z.value.observe(T.value.parentNode);
      }
    }
    De(() => {
      z.value && z.value.disconnect();
    });
    const i = d(() => ({
      top: r.value.padding.top,
      left: r.value.padding.left,
      right: r.value.width - r.value.padding.right,
      bottom: r.value.height - r.value.padding.bottom,
      centerX: r.value.width / 2,
      centerY: r.value.height / 2,
      width: r.value.width - r.value.padding.right - r.value.padding.left,
      height: r.value.height - r.value.padding.bottom - r.value.padding.top,
      minRadius: r.value.minRadius,
      maxRadius: Math.min(r.value.width, r.value.height) - r.value.padding.top * 2
    })), c = d(() => (k.dataset.forEach((a, o) => {
      [null, void 0].includes(a.name) && J({
        componentName: "VueUiOnion",
        type: "datasetSerieAttribute",
        property: "name",
        index: o
      }), [void 0].includes(a.percentage) && J({
        componentName: "VueUiOnion",
        type: "datasetSerieAttribute",
        property: "percentage",
        index: o
      });
    }), k.dataset.map((a, o) => {
      const t = `onion_serie_${o}_${x.value}`;
      return {
        ...a,
        percentage: a.percentage || 0,
        targetPercentage: a.percentage || 0,
        color: He(a.color) || Te.value[o] || ye[o],
        id: t,
        shape: "circle",
        opacity: p.value.includes(t) ? 0.5 : 1,
        absoluteIndex: o,
        segregate: () => ce(t),
        isSegregated: p.value.includes(t)
      };
    }))), O = s(c.value), _e = d(() => e.value.useStartAnimation), Pe = s(null), Oe = d(() => Math.max(...c.value.map((a) => a.percentage))), G = s(!1);
    ge(() => c.value, Ae, { immediate: !0 });
    function Ae() {
      if (_e.value && !G.value) {
        let o = function() {
          a >= Oe.value ? (cancelAnimationFrame(Pe.value), O.value = c.value, G.value = !0) : (O.value = c.value.map((t) => ({
            ...t,
            percentage: a < t.targetPercentage ? a : t.targetPercentage
          })), a += 1, requestAnimationFrame(o), G.value = !0);
        };
        O.value = c.value.map((t) => ({
          ...t,
          percentage: 0
        }));
        let a = 0;
        o();
      } else
        O.value = c.value;
    }
    const Ie = d(() => ({
      cy: "onion-div-legend",
      backgroundColor: e.value.style.chart.legend.backgroundColor,
      color: e.value.style.chart.legend.color,
      fontSize: e.value.style.chart.legend.fontSize,
      paddingBottom: 12,
      fontWeight: e.value.style.chart.legend.bold ? "bold" : ""
    })), Se = d(() => c.value.filter((a) => !p.value.includes(a.id)).length), w = d(() => {
      const a = Math.min(i.value.width, i.value.height) / 2 / c.value.length;
      return {
        gutter: (a > e.value.style.chart.layout.maxThickness ? e.value.style.chart.layout.maxThickness : a) * e.value.style.chart.layout.gutter.width,
        track: (a > e.value.style.chart.layout.maxThickness ? e.value.style.chart.layout.maxThickness : a) * e.value.style.chart.layout.track.width
      };
    }), m = d(() => O.value.filter((a) => !p.value.includes(a.id)).map((a, o) => {
      const t = (i.value.maxRadius - w.value.track) / Se.value / 2 * (1 + o), l = i.value.centerY - t;
      return {
        percentage: a.percentage || 0,
        ...a,
        labelY: l,
        radius: t,
        path: Me(t, a.percentage || 0)
      };
    }));
    function Me(a, o) {
      const t = 2 * Math.PI * a, l = t * 0.75, g = `${l} ${t}`, I = l * (1 - o / 100);
      return {
        bgDashArray: `${l} ${t}`,
        bgDashOffset: 0,
        dashArray: g,
        dashOffset: I,
        fullOffset: 0,
        active: `
            M ${i.value.centerX},${i.value.centerY - a} 
            A ${a},${a} 0 1 1 
            ${i.value.centerX + a * Math.cos(Math.PI * 3 / 4)},${i.value.centerY + a * Math.sin(Math.PI * 3 / 4)}
        `.trim()
      };
    }
    function ce(a) {
      p.value.includes(a) ? p.value = p.value.filter((o) => o !== a) : p.value.push(a), we("selectLegend", m.value);
    }
    function Fe() {
      return m.value;
    }
    const U = d(() => {
      const a = [e.value.table.translations.serie, e.value.table.translations.percentage, e.value.table.translations.value], o = m.value.map((t) => [
        t.name,
        t.percentage,
        t.value
      ]);
      return { head: a, body: o };
    }), Y = d(() => {
      const a = U.value.head, o = m.value.map((l) => [
        `<span style="color:${l.color}">⬤</span> ${l.name}`,
        `${Number(l.percentage ?? 0).toFixed(e.value.table.td.roundingPercentage).toLocaleString()}%`,
        `${l.prefix || ""}${[null, void 0, NaN, "NaN"].includes(l.value) ? "-" : l.value.toFixed(e.value.table.td.roundingValue).toLocaleString()}${l.suffix || ""}`
      ]), t = {
        th: {
          backgroundColor: e.value.table.th.backgroundColor,
          color: e.value.table.th.color,
          outline: e.value.table.th.outline
        },
        td: {
          backgroundColor: e.value.table.td.backgroundColor,
          color: e.value.table.td.color,
          outline: e.value.table.td.outline
        },
        breakpoint: e.value.table.responsiveBreakpoint
      };
      return { head: a, body: o, config: t, colNames: a };
    });
    function de() {
      Ye(() => {
        const a = [[e.value.style.chart.title.text], [e.value.style.chart.title.subtitle.text], [""]], o = U.value.head, t = U.value.body, l = a.concat([o]).concat(t), g = je(l);
        qe({ csvContent: g, title: e.value.style.chart.title.text || "vue-ui-onion" });
      });
    }
    const b = s(void 0), A = s(!1);
    function Ne(a) {
      A.value = a, Q.value += 1;
    }
    const E = s(null);
    function ve({ datapoint: a, seriesIndex: o, show: t = !0 }) {
      const l = a.absoluteIndex;
      b.value = o, E.value = {
        datapoint: a,
        seriesIndex: l,
        series: c.value,
        config: e.value
      }, L.value = t;
      let g = "";
      const I = e.value.style.chart.tooltip.customFormat;
      if (me(I) && Je(() => I({
        seriesIndex: l,
        datapoint: a,
        series: c.value,
        config: e.value
      })))
        X.value = I({
          seriesIndex: l,
          datapoint: a,
          series: c.value,
          config: e.value
        });
      else {
        const W = e.value.style.chart.tooltip.showPercentage, j = e.value.style.chart.tooltip.showValue;
        g += `<div style="width: 100%; border-bottom: 1px solid ${e.value.style.chart.tooltip.borderColor}; padding-bottom: 6px;margin-bottom:3px;display:flex;flex-direction:row;gap:3px;align-items:center"><svg viewBox="0 0 12 12" height="14" width="14"><circle cx="6" cy="6" r="6" stroke="none" fill="${a.color}"/></svg><span></span>${a.name}</span></div>`, g += `<div style="width:100%;text-align:left;"><b>${W ? R({ p: "", v: a.percentage, s: "%", r: e.value.style.chart.tooltip.roundingPercentage }) : ""}</b> ${W && j ? "(" : ""}${j ? K(
          e.value.style.chart.layout.labels.value.formatter,
          a.value,
          R({
            p: a.prefix || "",
            v: a.value,
            s: a.suffix || "",
            r: e.value.style.chart.tooltip.roundingValue
          }),
          { datapoint: a, seriesIndex: o }
        ) : ""}${W && j ? ")" : ""}</div>`, X.value = `<div>${g}</div>`;
      }
    }
    function he() {
      $.value.showTable = !$.value.showTable;
    }
    function fe() {
      $.value.showTooltip = !$.value.showTooltip;
    }
    const B = s(!1);
    function H() {
      B.value = !B.value;
    }
    return $e({
      getData: Fe,
      generatePdf: se,
      generateCsv: de,
      generateImage: ue,
      toggleTable: he,
      toggleTooltip: fe,
      toggleAnnotator: H
    }), (a, o) => (n(), u("div", {
      class: V(`vue-ui-onion ${A.value ? "vue-data-ui-wrapper-fullscreen" : ""} ${e.value.useCssAnimation ? "" : "vue-ui-dna"}`),
      ref_key: "onionChart",
      ref: T,
      id: `vue-ui-onion_${x.value}`,
      style: q(`font-family:${e.value.style.fontFamily};width:100%; ${e.value.responsive ? "height: 100%;" : ""} text-align:center;background:${e.value.style.chart.backgroundColor}`)
    }, [
      e.value.userOptions.buttons.annotator ? (n(), C(ut, {
        key: 0,
        parent: T.value,
        backgroundColor: e.value.style.chart.backgroundColor,
        color: e.value.style.chart.color,
        active: B.value,
        onClose: H
      }, null, 8, ["parent", "backgroundColor", "color", "active"])) : y("", !0),
      e.value.style.chart.title.text ? (n(), u("div", {
        key: 1,
        ref_key: "chartTitle",
        ref: Z,
        style: "width:100%;background:transparent"
      }, [
        (n(), C(Ze, {
          key: `title_${te.value}`,
          config: {
            title: {
              cy: "onion-div-title",
              ...e.value.style.chart.title
            },
            subtitle: {
              cy: "onion-div-subtitle",
              ...e.value.style.chart.title.subtitle
            }
          }
        }, null, 8, ["config"]))
      ], 512)) : y("", !0),
      e.value.userOptions.show && D.value ? (n(), C(tt, {
        ref_key: "details",
        ref: xe,
        key: `user_options${Q.value}`,
        backgroundColor: e.value.style.chart.backgroundColor,
        color: e.value.style.chart.color,
        isImaging: v(ne),
        isPrinting: v(re),
        uid: x.value,
        hasTooltip: e.value.userOptions.buttons.tooltip && e.value.style.chart.tooltip.show,
        hasPdf: e.value.userOptions.buttons.pdf,
        hasImg: e.value.userOptions.buttons.img,
        hasXls: e.value.userOptions.buttons.csv,
        hasTable: e.value.userOptions.buttons.table,
        hasFullscreen: e.value.userOptions.buttons.fullscreen,
        isFullscreen: A.value,
        isTooltip: $.value.showTooltip,
        titles: { ...e.value.userOptions.buttonTitles },
        chartElement: T.value,
        position: e.value.userOptions.position,
        hasAnnotator: e.value.userOptions.buttons.annotator,
        isAnnotation: B.value,
        onToggleFullscreen: Ne,
        onGeneratePdf: v(se),
        onGenerateCsv: de,
        onGenerateImage: v(ue),
        onToggleTable: he,
        onToggleTooltip: fe,
        onToggleAnnotator: H
      }, Le({ _: 2 }, [
        a.$slots.optionTooltip ? {
          name: "optionTooltip",
          fn: h(() => [
            f(a.$slots, "optionTooltip", {}, void 0, !0)
          ]),
          key: "0"
        } : void 0,
        a.$slots.optionPdf ? {
          name: "optionPdf",
          fn: h(() => [
            f(a.$slots, "optionPdf", {}, void 0, !0)
          ]),
          key: "1"
        } : void 0,
        a.$slots.optionCsv ? {
          name: "optionCsv",
          fn: h(() => [
            f(a.$slots, "optionCsv", {}, void 0, !0)
          ]),
          key: "2"
        } : void 0,
        a.$slots.optionImg ? {
          name: "optionImg",
          fn: h(() => [
            f(a.$slots, "optionImg", {}, void 0, !0)
          ]),
          key: "3"
        } : void 0,
        a.$slots.optionTable ? {
          name: "optionTable",
          fn: h(() => [
            f(a.$slots, "optionTable", {}, void 0, !0)
          ]),
          key: "4"
        } : void 0,
        a.$slots.optionFullscreen ? {
          name: "optionFullscreen",
          fn: h(({ toggleFullscreen: t, isFullscreen: l }) => [
            f(a.$slots, "optionFullscreen", S(M({ toggleFullscreen: t, isFullscreen: l })), void 0, !0)
          ]),
          key: "5"
        } : void 0,
        a.$slots.optionAnnotator ? {
          name: "optionAnnotator",
          fn: h(({ toggleAnnotator: t, isAnnotator: l }) => [
            f(a.$slots, "optionAnnotator", S(M({ toggleAnnotator: t, isAnnotator: l })), void 0, !0)
          ]),
          key: "6"
        } : void 0
      ]), 1032, ["backgroundColor", "color", "isImaging", "isPrinting", "uid", "hasTooltip", "hasPdf", "hasImg", "hasXls", "hasTable", "hasFullscreen", "isFullscreen", "isTooltip", "titles", "chartElement", "position", "hasAnnotator", "isAnnotation", "onGeneratePdf", "onGenerateImage"])) : y("", !0),
      D.value ? (n(), u("svg", {
        key: 3,
        xmlns: v(We),
        class: V({ "vue-data-ui-fullscreen--on": A.value, "vue-data-ui-fulscreen--off": !A.value }),
        viewBox: `0 0 ${r.value.width <= 0 ? 1e-4 : r.value.width} ${r.value.height <= 0 ? 1e-4 : r.value.height}`,
        style: q(`max-width:100%;overflow:visible;background:transparent;color:${e.value.style.chart.color}`)
      }, [
        pe(st),
        (n(!0), u(F, null, N(m.value, (t, l) => (n(), u("circle", {
          cx: i.value.centerX,
          cy: i.value.centerY,
          r: t.radius <= 0 ? 1e-4 : t.radius,
          stroke: e.value.style.chart.layout.gutter.color,
          "stroke-width": w.value.gutter,
          fill: "none",
          "stroke-dasharray": t.path.bgDashArray,
          "stroke-dashoffset": t.path.fullOffset,
          "stroke-linecap": "round",
          class: V({ "vue-ui-onion-path": !0, "vue-ui-onion-blur": e.value.useBlurOnHover && ![null, void 0].includes(b.value) && b.value !== l }),
          style: { transform: "rotate(-90deg)", "transform-origin": "50% 50%" }
        }, null, 10, vt))), 256)),
        (n(!0), u(F, null, N(m.value, (t, l) => (n(), u("circle", {
          cx: i.value.centerX,
          cy: i.value.centerY,
          r: t.radius < 0 ? 1e-4 : t.radius,
          stroke: `${t.color}`,
          "stroke-width": w.value.track,
          fill: "none",
          "stroke-dasharray": t.path.dashArray,
          "stroke-dashoffset": t.path.dashOffset,
          class: V({ "vue-ui-onion-path": !0, "vue-ui-onion-blur": e.value.useBlurOnHover && ![null, void 0].includes(b.value) && b.value !== l }),
          "stroke-linecap": "round",
          style: { transform: "rotate(-90deg)", "transform-origin": "50% 50%" }
        }, null, 10, ht))), 256)),
        _("defs", null, [
          _("filter", {
            id: `blur_${x.value}`,
            x: "-50%",
            y: "-50%",
            width: "200%",
            height: "200%"
          }, [
            _("feGaussianBlur", {
              in: "SourceGraphic",
              stdDeviation: 100 / e.value.style.chart.gradientIntensity
            }, null, 8, gt)
          ], 8, ft)
        ]),
        e.value.style.chart.useGradient ? (n(), u("g", {
          key: 0,
          filter: `url(#blur_${x.value})`
        }, [
          (n(!0), u(F, null, N(m.value, (t, l) => (n(), u("circle", {
            cx: i.value.centerX,
            cy: i.value.centerY,
            r: t.radius <= 0 ? 1e-4 : t.radius,
            stroke: "white",
            "stroke-width": w.value.track / 3,
            fill: "none",
            "stroke-linecap": "round",
            "stroke-dasharray": t.path.dashArray,
            "stroke-dashoffset": t.path.dashOffset,
            style: { transform: "rotate(-90deg)", "transform-origin": "50% 50%" }
          }, null, 8, yt))), 256))
        ], 8, pt)) : y("", !0),
        (n(!0), u(F, null, N(m.value, (t, l) => (n(), u("circle", {
          "data-cy-trap": "",
          cx: i.value.centerX,
          cy: i.value.centerY,
          r: t.radius <= 0 ? 1e-4 : t.radius,
          stroke: "transparent",
          "stroke-width": Math.max(w.value.track, w.value.gutter),
          fill: "none",
          "stroke-dasharray": t.path.bgDashArray,
          "stroke-dashoffset": t.path.fullOffset,
          "stroke-linecap": "round",
          class: "vue-ui-onion-path",
          style: { transform: "rotate(-90deg)", "transform-origin": "50% 50%" },
          onMouseenter: (g) => ve({
            datapoint: t,
            show: !0,
            seriesIndex: l
          }),
          onMouseleave: o[0] || (o[0] = (g) => {
            b.value = void 0, L.value = !1;
          })
        }, null, 40, mt))), 256)),
        e.value.style.chart.layout.labels.show ? (n(), u("g", bt, [
          (n(!0), u(F, null, N(m.value, (t, l) => (n(), u("g", {
            onMouseenter: (g) => ve({
              datapoint: t,
              show: !0,
              seriesIndex: l
            }),
            onMouseleave: o[1] || (o[1] = (g) => {
              b.value = void 0, L.value = !1;
            })
          }, [
            p.value.includes(t.id) ? y("", !0) : (n(), u("text", {
              key: 0,
              x: r.value.width / 2 - w.value.gutter * 0.8 + e.value.style.chart.layout.labels.offsetX,
              y: t.labelY + e.value.style.chart.layout.labels.offsetY,
              "text-anchor": "end",
              "font-size": e.value.style.chart.layout.labels.fontSize,
              fill: e.value.useBlurOnHover && ![null, void 0].includes(b.value) && b.value === l ? t.color : e.value.style.chart.layout.labels.color,
              "font-weight": e.value.style.chart.layout.labels.bold ? "bold" : "normal"
            }, P(t.name ? t.name + ": " : "") + " " + P(e.value.style.chart.layout.labels.percentage.show ? v(R)({
              v: t.percentage,
              s: "%",
              r: e.value.style.chart.layout.labels.roundingPercentage
            }) : "") + " " + P(!e.value.style.chart.layout.labels.percentage.show && e.value.style.chart.layout.labels.value.show ? `: ${v(K)(
              e.value.style.chart.layout.labels.value.formatter,
              t.value,
              v(R)({
                p: t.prefix || "",
                v: t.value || 0,
                s: t.suffix || "",
                r: e.value.style.chart.layout.labels.roundingValue
              }),
              { datapoint: t, seriesIndex: l }
            )}` : `${e.value.style.chart.layout.labels.value.show && t.value ? `(${v(K)(
              e.value.style.chart.layout.labels.value.formatter,
              t.value,
              v(R)({
                p: t.prefix || "",
                v: t.value || 0,
                s: t.suffix || "",
                r: e.value.style.chart.layout.labels.roundingValue
              }),
              { datapoint: t, seriesIndex: l }
            )})` : ""}`), 9, $t))
          ], 40, kt))), 256))
        ])) : y("", !0),
        f(a.$slots, "svg", { svg: r.value }, void 0, !0)
      ], 14, dt)) : y("", !0),
      a.$slots.watermark ? (n(), u("div", wt, [
        f(a.$slots, "watermark", S(M({ isPrinting: v(re) || v(ne) })), void 0, !0)
      ])) : y("", !0),
      D.value ? y("", !0) : (n(), C(rt, {
        key: 5,
        config: {
          type: "onion",
          style: {
            backgroundColor: e.value.style.chart.backgroundColor,
            onion: {
              color: e.value.style.chart.layout.gutter.color
            }
          }
        }
      }, null, 8, ["config"])),
      _("div", {
        ref_key: "chartLegend",
        ref: ee
      }, [
        e.value.style.chart.legend.show ? (n(), C(at, {
          key: `legend_${le.value}`,
          legendSet: c.value,
          config: Ie.value,
          onClickMarker: o[2] || (o[2] = ({ legend: t }) => ce(t.id))
        }, {
          item: h(({ legend: t }) => [
            _("div", {
              "data-cy-legend-item": "",
              onClick: (l) => t.segregate(),
              style: q(`opacity:${p.value.includes(t.id) ? 0.5 : 1}`)
            }, P(t.name ? t.name + ": " : "") + " " + P((t.percentage || 0).toFixed(e.value.style.chart.legend.roundingPercentage)) + "% ", 13, Ct)
          ]),
          _: 1
        }, 8, ["legendSet", "config"])) : f(a.$slots, "legend", {
          key: 1,
          legend: c.value
        }, void 0, !0)
      ], 512),
      pe(ot, {
        show: $.value.showTooltip && L.value,
        backgroundColor: e.value.style.chart.tooltip.backgroundColor,
        color: e.value.style.chart.tooltip.color,
        borderRadius: e.value.style.chart.tooltip.borderRadius,
        borderColor: e.value.style.chart.tooltip.borderColor,
        borderWidth: e.value.style.chart.tooltip.borderWidth,
        fontSize: e.value.style.chart.tooltip.fontSize,
        backgroundOpacity: e.value.style.chart.tooltip.backgroundOpacity,
        position: e.value.style.chart.tooltip.position,
        offsetY: e.value.style.chart.tooltip.offsetY,
        parent: T.value,
        content: X.value,
        isCustom: v(me)(e.value.style.chart.tooltip.customFormat)
      }, {
        "tooltip-before": h(() => [
          f(a.$slots, "tooltip-before", S(M({ ...E.value })), void 0, !0)
        ]),
        "tooltip-after": h(() => [
          f(a.$slots, "tooltip-after", S(M({ ...E.value })), void 0, !0)
        ]),
        _: 3
      }, 8, ["show", "backgroundColor", "color", "borderRadius", "borderColor", "borderWidth", "fontSize", "backgroundOpacity", "position", "offsetY", "parent", "content", "isCustom"]),
      D.value ? (n(), C(nt, {
        key: 6,
        hideDetails: "",
        config: {
          open: $.value.showTable,
          maxHeight: 1e4,
          head: {
            backgroundColor: e.value.style.chart.backgroundColor,
            color: e.value.style.chart.color
          },
          body: {
            backgroundColor: e.value.style.chart.backgroundColor,
            color: e.value.style.chart.color
          }
        }
      }, {
        content: h(() => [
          (n(), C(lt, {
            key: `table_${ae.value}`,
            colNames: Y.value.colNames,
            head: Y.value.head,
            body: Y.value.body,
            config: Y.value.config,
            title: `${e.value.style.chart.title.text}${e.value.style.chart.title.subtitle.text ? ` : ${e.value.style.chart.title.subtitle.text}` : ""}`,
            onClose: o[3] || (o[3] = (t) => $.value.showTable = !1)
          }, {
            th: h(({ th: t }) => [
              ze(P(t), 1)
            ]),
            td: h(({ td: t }) => [
              _("div", { innerHTML: t }, null, 8, xt)
            ]),
            _: 1
          }, 8, ["colNames", "head", "body", "config", "title"]))
        ]),
        _: 1
      }, 8, ["config"])) : y("", !0)
    ], 14, ct));
  }
}, Bt = /* @__PURE__ */ it(Tt, [["__scopeId", "data-v-61bb1aef"]]);
export {
  Bt as default
};
