import { useCssVars as $e, computed as c, ref as o, watch as Ce, onMounted as be, onBeforeUnmount as xe, openBlock as n, createElementBlock as u, normalizeStyle as C, createBlock as A, createCommentVNode as m, unref as h, createSlots as we, withCtx as O, renderSlot as p, normalizeProps as S, guardReactiveProps as T, normalizeClass as R, createVNode as Ae, createElementVNode as Oe, Fragment as P, renderList as I, toDisplayString as Pe } from "vue";
import { u as Ie, c as Fe, t as Ee, a as ze, p as te, b as Le, o as Ne, e as le, g as Se, X as Te } from "./index-DnVHQ2xI.js";
import { t as Re, u as Me } from "./useResponsive-NZB-WLRF.js";
import { _ as je } from "./Title-5VmBwT4i.js";
import { u as Be, U as Ge } from "./usePrinter-BEeNAqS5.js";
import Ue from "./vue-ui-skeleton-aZmkNzAe.js";
import { u as ne } from "./useNestedProp-Cox0K0Y5.js";
import { _ as De } from "./PackageVersion-CvCRsT5_.js";
import { P as Ve } from "./PenAndPaper-Jb0pLt3G.js";
import { _ as We } from "./_plugin-vue_export-helper-CHgC5LLL.js";
const Xe = ["id"], Ye = ["xmlns", "viewBox"], qe = ["cx", "cy", "r", "stroke", "stroke-width"], He = { key: 0 }, Je = ["stroke", "d", "stroke-width"], Ke = { key: 1 }, Qe = ["stroke", "x1", "x2", "y1", "y2"], Ze = ["text-anchor", "transform", "x", "y", "onClick", "font-weight", "font-size", "fill"], et = ["cx", "cy", "fill", "onClick", "r"], tt = {
  key: 4,
  class: "vue-data-ui-watermark"
}, lt = {
  __name: "vue-ui-relation-circle",
  props: {
    dataset: {
      type: Array,
      default() {
        return [];
      }
    },
    config: {
      type: Object,
      default() {
        return {};
      }
    }
  },
  setup(re, { expose: ae }) {
    const d = re;
    $e((e) => ({
      "0bc2311e": ce.value,
      "6cb258d0": ue.value,
      "0108e0b2": de.value
    }));
    const { vue_ui_relation_circle: se } = Ie(), F = c(() => !!d.dataset && Object.keys(d.dataset).length), k = o(Fe()), M = o(0), _ = o(null), j = o(null), B = o(0), l = c({
      get: () => G(),
      set: (e) => e
    });
    function G() {
      const e = ne({
        userConfig: d.config,
        defaultConfig: se
      });
      return e.theme ? {
        ...ne({
          userConfig: Ee.vue_ui_relation_circle[e.theme] || d.config,
          defaultConfig: e
        }),
        customPalette: ze[e.theme] || te
      } : e;
    }
    Ce(() => d.config, (e) => {
      l.value = G(), Y(), B.value += 1;
    }, { deep: !0 });
    const { isPrinting: U, isImaging: D, generatePdf: V, generateImage: W } = Be({
      elementId: `relation_circle_${k.value}`,
      fileName: l.value.style.title.text || "vue-ui-relation-circle"
    }), X = c(() => Le(l.value.customPalette)), f = o([]), y = o([]), s = o({}), v = o([]), ie = o(0), E = c(() => d.dataset.slice(0, l.value.style.limit)), z = o(l.value.style.size), i = o({
      height: l.value.style.size,
      width: l.value.style.size
    }), g = c({
      get() {
        return z.value * l.value.style.circle.radiusProportion;
      },
      set(e) {
        return e;
      }
    }), oe = c(() => l.value.style.links.curved), ue = c(() => `${l.value.style.animation.speedMs}ms`), ce = c(() => g.value * 2), de = c(() => g.value * 4), b = o(null);
    be(() => {
      Y(), document.getElementById(`relation_circle_${k.value}`).addEventListener("click", q);
    });
    function Y() {
      if (Ne(d.dataset) ? le({
        componentName: "VueUiRelationCircle",
        type: "dataset"
      }) : d.dataset.forEach((e, r) => {
        Se({
          datasetObject: e,
          requiredAttributes: ["id", "label", "relations", "weights"]
        }).forEach((t) => {
          le({
            componentName: "VueUiRelationCircle",
            type: "datasetSerieAttribute",
            property: t,
            index: r
          });
        });
      }), l.value.responsive) {
        const e = Re(() => {
          const { width: r, height: t } = Me({
            chart: _.value,
            title: l.value.style.title.text ? j.value : null
          });
          z.value = Math.min(r, t), i.value.width = r, i.value.height = t, g.value = z.value * l.value.style.circle.radiusProportion, f.value = [], y.value = [], H(), J();
        });
        b.value = new ResizeObserver(e), b.value.observe(_.value.parentNode);
      } else
        f.value = [], y.value = [], H(), J();
    }
    xe(() => {
      document.getElementById(`relation_circle_${k.value}`).removeEventListener("click", q), b.value && b.value.disconnect();
    });
    function q(e) {
      const r = e.target;
      r && Array.from(r.classList).includes("vue-ui-user-options") || r && Array.from(r.classList).includes("vue-ui-user-options-summary") || r && Array.from(r.classList).includes("vue-data-ui-button") || r && Array.from(r.classList).includes("vue-ui-relation-circle-legend") || (s.value = {}, v.value = []);
    }
    function H() {
      const e = 6.28319 / E.value.length, r = 360 / E.value.length;
      let t = 0, a = 0;
      E.value.forEach(($, N) => {
        const ke = g.value * Math.cos(t) + i.value.width / 2, _e = g.value * Math.sin(t) + i.value.height / 2 + l.value.style.circle.offsetY;
        f.value.push({ x: ke, y: _e, ...$, color: $.color ? $.color : X.value[N] ? X.value[N] : te[N], regAngle: a }), t += e, a += r;
      });
    }
    function J() {
      f.value.forEach((e) => {
        f.value.filter((t) => t.relations.includes(e.id)).forEach((t, a) => {
          y.value.push({
            weight: e.weights && e.weights[a] ? e.weights[a] : 1,
            relationId: `${e.id}_${t.id}`,
            x1: e.x,
            y1: e.y,
            x2: t.x,
            y2: t.y,
            colorSource: e.color,
            colorTarget: t.color,
            ...e
          });
        });
      });
    }
    const ve = c(() => Math.max(...y.value.map((e) => e.weight)));
    function fe(e) {
      return Object.hasOwn(s.value, "x") ? v.value.includes(e.id) ? "opacity:1" : "opacity:0.1" : "opacity:1";
    }
    function K(e) {
      return Object.hasOwn(s.value, "x") ? e.colorTarget : e.colorSource;
    }
    function Q(e) {
      return Object.hasOwn(s.value, "x") ? v.value.includes(e.id) && e.relationId === `${e.id}_${s.value.id}` || e.relationId === `${s.value.id}_${e.id}` ? `opacity:1;stroke-width:${ee(e)}` : "opacity: 0" : "opacity: 1";
    }
    function ge(e) {
      return e.regAngle > 90 && e.regAngle < 270 ? "end" : "start";
    }
    function he(e) {
      return e.regAngle > 90 && e.regAngle < 270 ? e.x - 5 : e.x + 5;
    }
    function ye(e) {
      return Object.hasOwn(s.value, "x") ? s.value.id === e.id || v.value.includes(e.id) ? "opacity:1" : "opacity:0.2" : "opacity:1";
    }
    function me(e) {
      return e.regAngle > 90 && e.regAngle < 270 ? `rotate(${e.regAngle + 180},${e.x},${e.y})` : `rotate(${e.regAngle},${e.x},${e.y})`;
    }
    function Z(e) {
      ie.value = 360 - e.regAngle, s.value.id && e.id === s.value.id ? (s.value = {}, v.value = []) : (s.value = e, v.value = [...e.relations]);
    }
    function ee(e) {
      return e.weight / ve.value * l.value.style.links.maxWidth;
    }
    const x = o(!1);
    function pe(e) {
      x.value = e, M.value += 1;
    }
    const w = o(!1);
    function L() {
      w.value = !w.value;
    }
    return ae({
      generatePdf: V,
      generateImage: W,
      toggleAnnotator: L
    }), (e, r) => (n(), u("div", {
      ref_key: "relationCircleChart",
      ref: _,
      class: "vue-ui-relation-circle",
      style: C(`width:100%;background:${l.value.style.backgroundColor};text-align:center;${l.value.responsive ? "height: 100%" : ""}`),
      id: `relation_circle_${k.value}`
    }, [
      l.value.userOptions.buttons.annotator ? (n(), A(Ve, {
        key: 0,
        parent: _.value,
        backgroundColor: l.value.style.backgroundColor,
        color: l.value.style.color,
        active: w.value,
        onClose: L
      }, null, 8, ["parent", "backgroundColor", "color", "active"])) : m("", !0),
      l.value.style.title.text ? (n(), u("div", {
        key: 1,
        ref_key: "chartTitle",
        ref: j,
        style: "width:100%;background:transparent"
      }, [
        (n(), A(je, {
          key: `title_${B.value}`,
          config: {
            title: {
              cy: "relation-div-title",
              ...l.value.style.title
            },
            subtitle: {
              cy: "relation-div-subtitle",
              ...l.value.style.title.subtitle
            }
          }
        }, null, 8, ["config"]))
      ], 512)) : m("", !0),
      l.value.userOptions.show && F.value ? (n(), A(Ge, {
        ref: "details",
        key: `user_options_${M.value}`,
        backgroundColor: l.value.style.backgroundColor,
        color: l.value.style.color,
        isPrinting: h(U),
        isImaging: h(D),
        uid: k.value,
        hasPdf: l.value.userOptions.buttons.pdf,
        hasImg: l.value.userOptions.buttons.img,
        hasFullscreen: l.value.userOptions.buttons.img,
        hasXls: !1,
        isFullscreen: x.value,
        titles: { ...l.value.userOptions.buttonTitles },
        chartElement: _.value,
        position: l.value.userOptions.position,
        hasAnnotator: l.value.userOptions.buttons.annotator,
        isAnnotation: w.value,
        onToggleFullscreen: pe,
        onGeneratePdf: h(V),
        onGenerateImage: h(W),
        onToggleAnnotator: L
      }, we({ _: 2 }, [
        e.$slots.optionPdf ? {
          name: "optionPdf",
          fn: O(() => [
            p(e.$slots, "optionPdf", {}, void 0, !0)
          ]),
          key: "0"
        } : void 0,
        e.$slots.optionImg ? {
          name: "optionImg",
          fn: O(() => [
            p(e.$slots, "optionImg", {}, void 0, !0)
          ]),
          key: "1"
        } : void 0,
        e.$slots.optionFullscreen ? {
          name: "optionFullscreen",
          fn: O(({ toggleFullscreen: t, isFullscreen: a }) => [
            p(e.$slots, "optionFullscreen", S(T({ toggleFullscreen: t, isFullscreen: a })), void 0, !0)
          ]),
          key: "2"
        } : void 0,
        e.$slots.optionAnnotator ? {
          name: "optionAnnotator",
          fn: O(({ toggleAnnotator: t, isAnnotator: a }) => [
            p(e.$slots, "optionAnnotator", S(T({ toggleAnnotator: t, isAnnotator: a })), void 0, !0)
          ]),
          key: "3"
        } : void 0
      ]), 1032, ["backgroundColor", "color", "isPrinting", "isImaging", "uid", "hasPdf", "hasImg", "hasFullscreen", "isFullscreen", "titles", "chartElement", "position", "hasAnnotator", "isAnnotation", "onGeneratePdf", "onGenerateImage"])) : m("", !0),
      F.value ? (n(), u("svg", {
        key: 3,
        xmlns: h(Te),
        class: R([{ "vue-data-ui-fullscreen--on": x.value, "vue-data-ui-fulscreen--off": !x.value }, "relation-circle"]),
        viewBox: `0 0 ${i.value.width <= 0 ? 10 : i.value.width} ${i.value.height <= 0 ? 10 : i.value.height}`,
        width: "100%",
        style: "user-select:none; background:transparent"
      }, [
        Ae(De),
        Oe("circle", {
          cx: (i.value.width <= 0 ? 1e-4 : i.value.width) / 2,
          cy: (i.value.height <= 0 ? 1e-4 : i.value.height) / 2 + l.value.style.circle.offsetY,
          r: g.value <= 0 ? 1e-4 : g.value,
          stroke: l.value.style.circle.stroke,
          "stroke-width": l.value.style.circle.strokeWidth,
          fill: "transparent",
          class: "main-circle"
        }, null, 8, qe),
        oe.value ? (n(), u("g", He, [
          (n(!0), u(P, null, I(y.value, (t, a) => (n(), u("path", {
            key: `relation_${a}`,
            style: C(Q(t)),
            stroke: K(t),
            class: R(["relation", { "vue-ui-relation-circle-selected": s.value.hasOwnProperty("id") && v.value.includes(t.id) }]),
            d: `M${t.x1},${t.y1} C${t.x1},${t.y1} ${i.value.width / 2},${i.value.height / 2 + l.value.style.circle.offsetY} ${t.x2},${t.y2}`,
            fill: "none",
            "stroke-width": ee(t),
            "stroke-linecap": "round"
          }, null, 14, Je))), 128))
        ])) : (n(), u("g", Ke, [
          (n(!0), u(P, null, I(y.value, (t, a) => (n(), u("line", {
            key: `relation_${a}`,
            stroke: K(t),
            style: C(Q(t)),
            x1: t.x1,
            x2: t.x2,
            y1: t.y1,
            y2: t.y2,
            class: R({ "vue-ui-relation-circle-selected": s.value.hasOwnProperty("id") && v.value.includes(t.id) }),
            "stroke-linecap": "round"
          }, null, 14, Qe))), 128))
        ])),
        (n(!0), u(P, null, I(f.value, (t, a) => (n(), u("text", {
          key: `plot_text_${a}`,
          "text-anchor": ge(t),
          transform: me(t),
          x: he(t),
          y: t.y + 5,
          onClick: ($) => Z(t),
          class: "vue-ui-relation-circle-legend",
          "transform-origin": "start",
          "font-weight": s.value.id === t.id ? "900" : "400",
          style: C(`font-family:${l.value.style.fontFamily};${ye(t)}`),
          "font-size": l.value.style.labels.fontSize,
          fill: l.value.style.labels.color
        }, Pe(t.label), 13, Ze))), 128)),
        (n(!0), u(P, null, I(f.value, (t, a) => (n(), u("circle", {
          cx: t.x,
          cy: t.y,
          key: `plot_${a}`,
          style: C(fe(t)),
          class: "vue-ui-relation-circle-plot",
          fill: l.value.style.plot.color,
          onClick: ($) => Z(t),
          r: l.value.style.plot.radius
        }, null, 12, et))), 128)),
        p(e.$slots, "svg", { svg: i.value }, void 0, !0)
      ], 10, Ye)) : m("", !0),
      e.$slots.watermark ? (n(), u("div", tt, [
        p(e.$slots, "watermark", S(T({ isPrinting: h(U) || h(D) })), void 0, !0)
      ])) : m("", !0),
      F.value ? m("", !0) : (n(), A(Ue, {
        key: 5,
        config: {
          type: "relationCircle",
          style: {
            backgroundColor: l.value.style.backgroundColor,
            relationCircle: {
              color: "#CCCCCC"
            }
          }
        }
      }, null, 8, ["config"]))
    ], 12, Xe));
  }
}, ft = /* @__PURE__ */ We(lt, [["__scopeId", "data-v-c84e98e7"]]);
export {
  ft as default
};
