import { computed as p, ref as n, watch as Oe, onMounted as Fe, onBeforeUnmount as We, openBlock as r, createElementBlock as i, normalizeClass as F, normalizeStyle as Q, createBlock as T, createCommentVNode as c, unref as h, createSlots as Ie, withCtx as f, renderSlot as m, normalizeProps as W, guardReactiveProps as I, createVNode as ge, Fragment as g, renderList as C, createElementVNode as k, toDisplayString as L, mergeProps as Me, createTextVNode as De, nextTick as Ge } from "vue";
import { u as Ee, c as Z, t as Ve, a as He, p as A, o as Re, e as ee, g as ke, b as Ue, d as xe, v as Be, C as Xe, f as B, X as je, i as te, l as Ye, h as Je, x as Ce, y as qe, q as Ke, r as Qe, E as Ze } from "./index-DnVHQ2xI.js";
import { t as et, u as tt } from "./useResponsive-NZB-WLRF.js";
import { _ as lt } from "./Title-5VmBwT4i.js";
import { u as at, U as ot } from "./usePrinter-BEeNAqS5.js";
import { _ as st } from "./Tooltip-Cj4EF7v1.js";
import { D as rt } from "./DataTable-DTk7C4Pr.js";
import ut from "./vue-ui-skeleton-aZmkNzAe.js";
import { _ as it } from "./Shape-BpPn4eWR.js";
import nt from "./vue-ui-accordion-DspS4q3f.js";
import { u as we } from "./useNestedProp-Cox0K0Y5.js";
import { _ as vt } from "./PackageVersion-CvCRsT5_.js";
import { P as ct } from "./PenAndPaper-Jb0pLt3G.js";
import { _ as ht } from "./_plugin-vue_export-helper-CHgC5LLL.js";
const dt = ["id"], pt = ["xmlns", "viewBox"], ft = { key: 0 }, yt = { key: 0 }, bt = ["x1", "x2", "y1", "y2", "stroke", "stroke-width", "stroke-dasharray"], mt = { key: 1 }, gt = ["x1", "x2", "y1", "y2", "stroke", "stroke-width", "stroke-dasharray"], kt = ["x1", "x2", "y1", "y2", "stroke", "stroke-width"], xt = ["x1", "x2", "y1", "y2", "stroke", "stroke-width"], Ct = ["x", "y", "fill", "font-size"], wt = ["x", "y", "font-size", "fill"], _t = ["fill", "font-size", "transform"], $t = ["fill", "font-size", "x", "y"], Tt = ["x1", "x2", "y1", "y2", "stroke"], Lt = ["cx", "cy", "fill"], At = ["cx", "cy", "fill"], Pt = ["id"], St = ["stop-color"], zt = ["stop-color"], Nt = ["stop-color"], Ot = { key: 0 }, Ft = ["x", "y", "font-size", "fill"], Wt = {
  key: 4,
  class: "vue-data-ui-watermark"
}, It = ["innerHTML"], Mt = {
  __name: "vue-ui-strip-plot",
  props: {
    config: {
      type: Object,
      default() {
        return {};
      }
    },
    dataset: {
      type: Array,
      default() {
        return [];
      }
    }
  },
  emits: ["selectDatapoint"],
  setup(_e, { expose: $e, emit: Te }) {
    const y = _e, { vue_ui_strip_plot: Le } = Ee(), w = p({
      get() {
        return !!y.dataset && y.dataset.length;
      },
      set(t) {
        return t;
      }
    }), X = n(Z()), le = n(0), j = n(!1), Y = n(""), P = n(null), ae = n(null), oe = n(!1), se = n(0), re = n(0), e = p({
      get: () => ue(),
      set: (t) => t
    });
    function ue() {
      const t = we({
        userConfig: y.config,
        defaultConfig: Le
      });
      return t.theme ? {
        ...we({
          userConfig: Ve.vue_ui_strip_plot[t.theme] || y.config,
          defaultConfig: t
        }),
        customPalette: He[t.theme] || A
      } : t;
    }
    Oe(() => y.config, (t) => {
      e.value = ue(), ie(), se.value += 1, re.value += 1;
    }, { deep: !0 });
    const M = n(null);
    Fe(() => {
      ie();
    });
    function ie() {
      if (Re(y.dataset) ? ee({
        componentName: "VueUiStripPlot",
        type: "dataset"
      }) : y.dataset.forEach((t, o) => {
        ke({
          datasetObject: t,
          requiredAttributes: ["name", "plots"]
        }).forEach((l) => {
          w.value = !1, ee({
            componentName: "VueUiStripPlot",
            type: "datasetSerieAttribute",
            property: l,
            index: o
          });
        }), t.plots && t.plots.forEach((l, s) => {
          ke({
            datasetObject: l,
            requiredAttributes: ["name", "value"]
          }).forEach((u) => {
            w.value = !1, ee({
              componentName: "VueUiStripPlot",
              type: "datasetSerieAttribute",
              property: u,
              index: `${o},${s}`
            });
          });
        });
      }), e.value.responsive) {
        const t = et(() => {
          const { width: o, height: l } = tt({
            chart: P.value,
            title: e.value.style.chart.title.text ? ae.value : null
          });
          D.value = l, S.value.width = o, S.value.height = l, N.value = (o - b.value.left - b.value.right) / y.dataset.length, G.value = Ze({
            relator: Math.min(l, o),
            adjuster: 600,
            source: e.value.style.chart.plots.radius,
            threshold: 6,
            fallback: 6
          });
        });
        M.value = new ResizeObserver(t), M.value.observe(P.value.parentNode);
      }
      oe.value = !0, setTimeout(() => {
        z.value = !1;
      }, Ae.value * 50);
    }
    We(() => {
      M.value && M.value.disconnect();
    });
    const { isPrinting: ne, isImaging: ve, generatePdf: ce, generateImage: he } = at({
      elementId: `strip-plot_${X.value}`,
      fileName: e.value.style.chart.title.text || "vue-ui-strip-plot"
    }), de = p(() => Ue(e.value.customPalette)), z = n(e.value.useCssAnimation), d = n({
      showTable: e.value.table.show,
      dataLabels: {
        show: e.value.style.chart.labels.bestPlotLabel.show
      },
      showTooltip: e.value.style.chart.tooltip.show
    }), b = n({
      top: e.value.style.chart.padding.top,
      bottom: e.value.style.chart.padding.bottom,
      left: e.value.style.chart.padding.left,
      right: e.value.style.chart.padding.right
    }), N = n(e.value.style.chart.stripWidth), D = n(e.value.style.chart.height), G = n(e.value.style.chart.plots.radius), S = n({
      width: N.value * y.dataset.length + b.value.left + b.value.right,
      height: e.value.style.chart.height
    }), a = p(() => {
      const t = N.value * y.dataset.length + b.value.left + b.value.right;
      return {
        left: b.value.left,
        right: t - b.value.right,
        top: b.value.top,
        bottom: D.value - b.value.bottom,
        width: N.value * y.dataset.length,
        height: D.value - b.value.top - b.value.bottom,
        stripWidth: N.value,
        absoluteHeight: D.value,
        absoluteWidth: t
      };
    }), E = p(() => w.value ? y.dataset.map((t, o) => {
      const l = Z();
      return {
        ...t,
        id: l,
        color: t.color ? xe(t.color) : de.value[o] || A[o] || A[o % A.length],
        plots: t.plots.map((s) => ({
          ...s,
          value: Be(s.value),
          parentId: l,
          color: t.color ? xe(t.color) : de.value[o] || A[o] || A[o % A.length],
          id: Z()
        })).sort((s, u) => s.value - u.value)
      };
    }) : null), x = p(() => (E.value || []).map((t, o) => ({
      ...t,
      plots: t.plots.map((l) => ({
        ...l,
        x: a.value.left + (o + 1) * a.value.stripWidth - a.value.stripWidth / 2
      }))
    }))), Ae = p(() => Math.max(...x.value.map((t) => t.plots.length))), J = p(() => {
      const t = x.value.flatMap((o) => o.plots.map((l) => l.value));
      return {
        max: Math.max(...t),
        min: Math.min(...t)
      };
    }), _ = p(() => Xe(J.value.min < 0 ? J.value.min : 0, J.value.max, e.value.style.chart.grid.scaleSteps)), Pe = p(() => (x.value || []).map((t, o) => ({
      ...t,
      plots: t.plots.map((l) => ({
        ...l,
        y: a.value.bottom - (l.value + Math.abs(_.value.min)) / (_.value.max + Math.abs(_.value.min)) * a.value.height
      }))
    }))), pe = p(() => _.value.ticks.map((t) => ({
      y: a.value.bottom - a.value.height * ((t + Math.abs(_.value.min)) / (_.value.max + Math.abs(_.value.min))),
      x1: a.value.left,
      x2: a.value.right,
      value: t
    }))), q = n(null), v = n(null);
    function Se({ datapoint: t, seriesIndex: o }) {
      q.value = { datapoint: t, seriesIndex: o, config: e.value, series: E.value }, j.value = !0, v.value = t;
      const l = e.value.style.chart.tooltip.customFormat;
      if (Ce(l) && qe(() => l({
        seriesIndex: o,
        datapoint: t,
        series: E.value,
        config: e.value
      })))
        Y.value = l({
          seriesIndex: o,
          datapoint: t,
          series: E.value,
          config: e.value
        });
      else {
        let s = "";
        s += `<div style="display:flex;flex-direction:row;gap:6px;align-items:center;"><svg viewBox="0 0 12 12" height="14" width="14"><circle cx="6" cy="6" r="6" stroke="none" fill="${e.value.style.chart.plots.gradient.show ? `url(#${t.parentId})` : t.color}"/></svg>${t.name}</div>`, s += `<div>${te(
          e.value.style.chart.labels.formatter,
          t.value,
          B({
            p: e.value.style.chart.labels.prefix,
            v: t.value,
            s: e.value.style.chart.labels.suffix,
            r: e.value.style.chart.tooltip.roundingValue
          }),
          { datapoint: t, seriesIndex: o }
        )}</div>`, Y.value = `<div>${s}</div>`;
      }
    }
    const V = p(() => {
      const t = x.value.flatMap((l) => JSON.parse(JSON.stringify(l.plots)).sort((s, u) => u.value - s.value).map((s) => ({
        name: `${l.name} - ${s.name}`,
        color: s.color
      }))), o = x.value.flatMap((l) => JSON.parse(JSON.stringify(l.plots)).sort((s, u) => u.value - s.value).map((s) => s.value));
      return { head: t, body: o };
    });
    function fe() {
      Ge(() => {
        const t = V.value.head.map((s, u) => [[
          s.name
        ], [V.value.body[u]]]), o = [[e.value.style.chart.title.text], [e.value.style.chart.title.subtitle.text], [[e.value.table.columnNames.series], [e.value.table.columnNames.value]]].concat(t), l = Ke(o);
        Qe({ csvContent: l, title: e.value.style.chart.title.text || "vue-ui-strip-plot" });
      });
    }
    const H = p(() => {
      const t = [
        e.value.table.columnNames.series,
        e.value.table.columnNames.value
      ], o = V.value.head.map((u, $) => {
        const U = B({
          p: e.value.style.chart.labels.prefix,
          v: V.value.body[$],
          s: e.value.style.chart.labels.suffix,
          r: e.value.table.td.roundingValue
        });
        return [
          {
            color: u.color,
            name: u.name
          },
          U
        ];
      }), l = {
        th: {
          backgroundColor: e.value.table.th.backgroundColor,
          color: e.value.table.th.color,
          outline: e.value.table.th.outline
        },
        td: {
          backgroundColor: e.value.table.td.backgroundColor,
          color: e.value.table.td.color,
          outline: e.value.table.td.outline
        },
        breakpoint: e.value.table.responsiveBreakpoint
      };
      return {
        colNames: [
          e.value.table.columnNames.series,
          e.value.table.columnNames.value
        ],
        head: t,
        body: o,
        config: l
      };
    }), O = n(!1);
    function ze(t) {
      O.value = t, le.value += 1;
    }
    function Ne() {
      return x.value;
    }
    function ye() {
      d.value.showTable = !d.value.showTable;
    }
    function be() {
      d.value.dataLabels.show = !d.value.dataLabels.show;
    }
    function me() {
      d.value.showTooltip = !d.value.showTooltip;
    }
    const R = n(!1);
    function K() {
      R.value = !R.value;
    }
    return $e({
      getData: Ne,
      generatePdf: ce,
      generateCsv: fe,
      generateImage: he,
      toggleTable: ye,
      toggleLabels: be,
      toggleTooltip: me,
      toggleAnnotator: K
    }), (t, o) => (r(), i("div", {
      ref_key: "stripPlotChart",
      ref: P,
      class: F(`vue-ui-strip-plot ${O.value ? "vue-data-ui-wrapper-fullscreen" : ""} ${e.value.useCssAnimation ? "" : "vue-ui-dna"}`),
      style: Q(`font-family:${e.value.style.fontFamily};width:100%; text-align:center;${e.value.style.chart.title.text ? "" : "padding-top:36px"};background:${e.value.style.chart.backgroundColor};${e.value.responsive ? "height:100%" : ""}`),
      id: `strip-plot_${X.value}`
    }, [
      e.value.userOptions.buttons.annotator ? (r(), T(ct, {
        key: 0,
        parent: P.value,
        backgroundColor: e.value.style.chart.backgroundColor,
        color: e.value.style.chart.color,
        active: R.value,
        onClose: K
      }, null, 8, ["parent", "backgroundColor", "color", "active"])) : c("", !0),
      e.value.style.chart.title.text ? (r(), i("div", {
        key: 1,
        ref_key: "chartTitle",
        ref: ae,
        style: "width:100%;background:transparent;padding-bottom:24px"
      }, [
        (r(), T(lt, {
          key: `title_${se.value}`,
          config: {
            title: {
              cy: "donut-div-title",
              ...e.value.style.chart.title
            },
            subtitle: {
              cy: "donut-div-subtitle",
              ...e.value.style.chart.title.subtitle
            }
          }
        }, null, 8, ["config"]))
      ], 512)) : c("", !0),
      e.value.userOptions.show && w.value ? (r(), T(ot, {
        ref: "details",
        key: `user_option_${le.value}`,
        backgroundColor: e.value.style.chart.backgroundColor,
        color: e.value.style.chart.color,
        isPrinting: h(ne),
        isImaging: h(ve),
        uid: X.value,
        hasTooltip: e.value.userOptions.buttons.tooltip && e.value.style.chart.tooltip.show,
        hasPdf: e.value.userOptions.buttons.pdf,
        hasXls: e.value.userOptions.buttons.csv,
        hasImg: e.value.userOptions.buttons.img,
        hasTable: e.value.userOptions.buttons.table,
        hasLabel: e.value.userOptions.buttons.labels,
        hasFullscreen: e.value.userOptions.buttons.fullscreen,
        isTooltip: d.value.showTooltip,
        isFullscreen: O.value,
        titles: { ...e.value.userOptions.buttonTitles },
        chartElement: P.value,
        position: e.value.userOptions.position,
        hasAnnotator: e.value.userOptions.buttons.annotator,
        isAnnotation: R.value,
        onToggleFullscreen: ze,
        onGeneratePdf: h(ce),
        onGenerateCsv: fe,
        onGenerateImage: h(he),
        onToggleTable: ye,
        onToggleLabels: be,
        onToggleTooltip: me,
        onToggleAnnotator: K
      }, Ie({ _: 2 }, [
        t.$slots.optionTooltip ? {
          name: "optionTooltip",
          fn: f(() => [
            m(t.$slots, "optionTooltip", {}, void 0, !0)
          ]),
          key: "0"
        } : void 0,
        t.$slots.optionPdf ? {
          name: "optionPdf",
          fn: f(() => [
            m(t.$slots, "optionPdf", {}, void 0, !0)
          ]),
          key: "1"
        } : void 0,
        t.$slots.optionCsv ? {
          name: "optionCsv",
          fn: f(() => [
            m(t.$slots, "optionCsv", {}, void 0, !0)
          ]),
          key: "2"
        } : void 0,
        t.$slots.optionImg ? {
          name: "optionImg",
          fn: f(() => [
            m(t.$slots, "optionImg", {}, void 0, !0)
          ]),
          key: "3"
        } : void 0,
        t.$slots.optionTable ? {
          name: "optionTable",
          fn: f(() => [
            m(t.$slots, "optionTable", {}, void 0, !0)
          ]),
          key: "4"
        } : void 0,
        t.$slots.optionLabels ? {
          name: "optionLabels",
          fn: f(() => [
            m(t.$slots, "optionLabels", {}, void 0, !0)
          ]),
          key: "5"
        } : void 0,
        t.$slots.optionFullscreen ? {
          name: "optionFullscreen",
          fn: f(({ toggleFullscreen: l, isFullscreen: s }) => [
            m(t.$slots, "optionFullscreen", W(I({ toggleFullscreen: l, isFullscreen: s })), void 0, !0)
          ]),
          key: "6"
        } : void 0,
        t.$slots.optionAnnotator ? {
          name: "optionAnnotator",
          fn: f(({ toggleAnnotator: l, isAnnotator: s }) => [
            m(t.$slots, "optionAnnotator", W(I({ toggleAnnotator: l, isAnnotator: s })), void 0, !0)
          ]),
          key: "7"
        } : void 0
      ]), 1032, ["backgroundColor", "color", "isPrinting", "isImaging", "uid", "hasTooltip", "hasPdf", "hasXls", "hasImg", "hasTable", "hasLabel", "hasFullscreen", "isTooltip", "isFullscreen", "titles", "chartElement", "position", "hasAnnotator", "isAnnotation", "onGeneratePdf", "onGenerateImage"])) : c("", !0),
      w.value ? (r(), i("svg", {
        key: 3,
        xmlns: h(je),
        class: F({ "vue-data-ui-fullscreen--on": O.value, "vue-data-ui-fulscreen--off": !O.value }),
        viewBox: `0 0 ${S.value.width <= 0 ? 10 : S.value.width} ${S.value.height <= 0 ? 10 : S.value.height}`,
        style: Q(`max-width:100%; overflow: visible; background:transparent;color:${e.value.style.chart.color};`)
      }, [
        ge(vt),
        e.value.style.chart.grid.show ? (r(), i("g", ft, [
          e.value.style.chart.grid.horizontalGrid.show ? (r(), i("g", yt, [
            (r(!0), i(g, null, C(pe.value, (l) => (r(), i("line", {
              x1: l.x1,
              x2: l.x2,
              y1: l.y,
              y2: l.y,
              stroke: e.value.style.chart.grid.horizontalGrid.stroke,
              "stroke-width": e.value.style.chart.grid.horizontalGrid.strokeWidth,
              "stroke-dasharray": e.value.style.chart.grid.horizontalGrid.strokeDasharray,
              "stroke-linecap": "round"
            }, null, 8, bt))), 256))
          ])) : c("", !0),
          e.value.style.chart.grid.verticalGrid.show ? (r(), i("g", mt, [
            (r(!0), i(g, null, C(x.value, (l, s) => (r(), i("line", {
              x1: a.value.left + (s + 1) * a.value.stripWidth,
              x2: a.value.left + (s + 1) * a.value.stripWidth,
              y1: a.value.top,
              y2: a.value.bottom,
              stroke: e.value.style.chart.grid.verticalGrid.stroke,
              "stroke-width": e.value.style.chart.grid.verticalGrid.strokeWidth,
              "stroke-dasharray": e.value.style.chart.grid.verticalGrid.strokeDasharray,
              "stroke-linecap": "round"
            }, null, 8, gt))), 256))
          ])) : c("", !0),
          k("line", {
            x1: a.value.left,
            x2: a.value.left,
            y1: a.value.top,
            y2: a.value.bottom,
            stroke: e.value.style.chart.grid.stroke,
            "stroke-width": e.value.style.chart.grid.strokeWidth,
            "stroke-linecap": "round"
          }, null, 8, kt),
          k("line", {
            x1: a.value.left,
            x2: a.value.right,
            y1: a.value.bottom,
            y2: a.value.bottom,
            stroke: e.value.style.chart.grid.stroke,
            "stroke-width": e.value.style.chart.grid.strokeWidth,
            "stroke-linecap": "round"
          }, null, 8, xt)
        ])) : c("", !0),
        e.value.style.chart.labels.yAxisLabels.show ? (r(!0), i(g, { key: 1 }, C(pe.value, (l, s) => (r(), i("text", {
          x: l.x1 - e.value.style.chart.labels.yAxisLabels.fontSize / 2 + e.value.style.chart.labels.yAxisLabels.offsetX,
          y: l.y + e.value.style.chart.labels.yAxisLabels.fontSize / 3,
          fill: e.value.style.chart.labels.yAxisLabels.color,
          "font-size": e.value.style.chart.labels.yAxisLabels.fontSize,
          "text-anchor": "end"
        }, L(h(te)(
          e.value.style.chart.labels.formatter,
          l.value,
          h(B)({
            p: e.value.style.chart.labels.prefix,
            v: l.value,
            s: e.value.style.chart.labels.suffix,
            r: e.value.style.chart.labels.yAxisLabels.rounding
          }),
          { datapoint: l, seriesIndex: s }
        )), 9, Ct))), 256)) : c("", !0),
        e.value.style.chart.labels.xAxisLabels.show ? (r(!0), i(g, { key: 2 }, C(x.value, (l, s) => (r(), i("text", {
          x: a.value.left + (s + 1) * a.value.stripWidth - a.value.stripWidth / 2,
          y: a.value.bottom + e.value.style.chart.labels.xAxisLabels.fontSize * 2 + e.value.style.chart.labels.xAxisLabels.offsetY,
          "font-size": e.value.style.chart.labels.xAxisLabels.fontSize,
          fill: e.value.style.chart.labels.xAxisLabels.color,
          "text-anchor": "middle"
        }, L(l.name), 9, wt))), 256)) : c("", !0),
        e.value.style.chart.labels.axis.yLabel ? (r(), i("text", {
          key: 3,
          fill: e.value.style.chart.labels.axis.color,
          "font-size": e.value.style.chart.labels.axis.fontSize,
          transform: `translate(${e.value.style.chart.labels.axis.fontSize + e.value.style.chart.labels.axis.yLabelOffsetX}, ${a.value.top + a.value.height / 2}) rotate(-90)`,
          "text-anchor": "middle"
        }, L(e.value.style.chart.labels.axis.yLabel), 9, _t)) : c("", !0),
        e.value.style.chart.labels.axis.xLabel ? (r(), i("text", {
          key: 4,
          fill: e.value.style.chart.labels.axis.color,
          "font-size": e.value.style.chart.labels.axis.fontSize,
          x: a.value.left + a.value.width / 2,
          y: a.value.absoluteHeight,
          "text-anchor": "middle"
        }, L(e.value.style.chart.labels.axis.xLabel), 9, $t)) : c("", !0),
        v.value ? (r(), i(g, { key: 5 }, [
          k("line", {
            x1: a.value.left,
            x2: a.value.right,
            y1: v.value.y,
            y2: v.value.y,
            stroke: v.value.color,
            "stroke-width": 1,
            class: F({ "select-circle": e.value.useCssAnimation })
          }, null, 10, Tt),
          k("circle", {
            cx: a.value.left,
            cy: v.value.y,
            r: 3,
            fill: v.value.color,
            class: F({ "select-circle": e.value.useCssAnimation })
          }, null, 10, Lt),
          k("circle", {
            cx: a.value.right,
            cy: v.value.y,
            r: 3,
            fill: v.value.color,
            class: F({ "select-circle": e.value.useCssAnimation })
          }, null, 10, At)
        ], 64)) : c("", !0),
        k("defs", null, [
          (r(!0), i(g, null, C(x.value, (l) => (r(), i("radialGradient", {
            id: l.id,
            fy: "30%"
          }, [
            k("stop", {
              offset: "10%",
              "stop-color": h(Ye)(l.color, e.value.style.chart.plots.gradient.intensity / 100)
            }, null, 8, St),
            k("stop", {
              offset: "90%",
              "stop-color": h(Je)(l.color, 0.1)
            }, null, 8, zt),
            k("stop", {
              offset: "100%",
              "stop-color": l.color
            }, null, 8, Nt)
          ], 8, Pt))), 256))
        ]),
        (r(!0), i(g, null, C(Pe.value, (l, s) => (r(), i(g, null, [
          (r(!0), i(g, null, C(l.plots, (u, $) => (r(), T(it, Me({
            plot: { x: u.x, y: oe.value ? u.y : a.value.top },
            radius: v.value && v.value.id === u.id ? G.value * 1.5 : G.value,
            shape: e.value.style.chart.plots.shape,
            stroke: e.value.style.chart.plots.stroke,
            strokeWidth: e.value.style.chart.plots.strokeWidth,
            color: e.value.style.chart.plots.gradient.show ? `url(#${l.id})` : l.color,
            onMouseenter: (U) => Se({ datapoint: u, seriesIndex: $ }),
            onMouseleave: o[0] || (o[0] = (U) => {
              j.value = !1, v.value = null;
            }),
            onClick: (U) => Te("selectDatapoint", u),
            style: `transition: all 0.2s ease-in-out; opacity:${v.value ? v.value.id === u.id ? 1 : 0.2 : e.value.style.chart.plots.opacity};${z.value ? `transition-delay:${$ * 50}ms` : ""}`,
            class: { "vue-ui-strip-plot-animated": e.value.useCssAnimation && z.value, "vue-ui-strip-plot-select-circle": e.value.useCssAnimation && !z.value }
          }, t.$attrs), null, 16, ["plot", "radius", "shape", "stroke", "strokeWidth", "color", "onMouseenter", "onClick", "style", "class"]))), 256)),
          d.value.dataLabels.show ? (r(), i("g", Ot, [
            (r(!0), i(g, null, C(l.plots, (u, $) => (r(), i(g, null, [
              $ === l.plots.length - 1 || v.value && v.value.id === u.id && !d.value.showTooltip ? (r(), i("text", {
                key: 0,
                x: u.x,
                y: u.y + e.value.style.chart.labels.bestPlotLabel.offsetY - G.value * (v.value && v.value.id === u.id && !d.value.showTooltip ? 2 : 1.5),
                "font-size": e.value.style.chart.labels.bestPlotLabel.fontSize,
                fill: e.value.style.chart.labels.bestPlotLabel.color,
                "text-anchor": "middle",
                style: Q(`opacity:${e.value.useCssAnimation && z.value ? 0 : 1};transition:opacity 0.2s ease-in;`)
              }, L(u.name) + " " + L(e.value.style.chart.labels.bestPlotLabel.showValue ? h(te)(
                e.value.style.chart.labels.formatter,
                u.value,
                h(B)({
                  p: `(${e.value.style.chart.labels.prefix}`,
                  v: u.value,
                  s: `${e.value.style.chart.labels.suffix})`,
                  r: e.value.style.chart.labels.bestPlotLabel.rounding
                }),
                { datapoint: u, seriesIndex: $ }
              ) : ""), 13, Ft)) : c("", !0)
            ], 64))), 256))
          ])) : c("", !0)
        ], 64))), 256)),
        m(t.$slots, "svg", { svg: a.value }, void 0, !0)
      ], 14, pt)) : c("", !0),
      t.$slots.watermark ? (r(), i("div", Wt, [
        m(t.$slots, "watermark", W(I({ isPrinting: h(ne) || h(ve) })), void 0, !0)
      ])) : c("", !0),
      w.value ? c("", !0) : (r(), T(ut, {
        key: 5,
        config: {
          type: "stripPlot",
          style: {
            backgroundColor: e.value.style.chart.backgroundColor,
            stripPlot: {
              color: "#CCCCCC"
            }
          }
        }
      }, null, 8, ["config"])),
      ge(st, {
        show: d.value.showTooltip && j.value,
        backgroundColor: e.value.style.chart.tooltip.backgroundColor,
        color: e.value.style.chart.tooltip.color,
        borderRadius: e.value.style.chart.tooltip.borderRadius,
        borderColor: e.value.style.chart.tooltip.borderColor,
        borderWidth: e.value.style.chart.tooltip.borderWidth,
        fontSize: e.value.style.chart.tooltip.fontSize,
        backgroundOpacity: e.value.style.chart.tooltip.backgroundOpacity,
        position: e.value.style.chart.tooltip.position,
        offsetY: e.value.style.chart.tooltip.offsetY,
        parent: P.value,
        content: Y.value,
        isCustom: h(Ce)(e.value.style.chart.tooltip.customFormat)
      }, {
        "tooltip-before": f(() => [
          m(t.$slots, "tooltip-before", W(I({ ...q.value })), void 0, !0)
        ]),
        "tooltip-after": f(() => [
          m(t.$slots, "tooltip-after", W(I({ ...q.value })), void 0, !0)
        ]),
        _: 3
      }, 8, ["show", "backgroundColor", "color", "borderRadius", "borderColor", "borderWidth", "fontSize", "backgroundOpacity", "position", "offsetY", "parent", "content", "isCustom"]),
      w.value ? (r(), T(nt, {
        key: 6,
        hideDetails: "",
        config: {
          open: d.value.showTable,
          maxHeight: 1e4,
          body: {
            backgroundColor: e.value.style.chart.backgroundColor,
            color: e.value.style.chart.color
          },
          head: {
            backgroundColor: e.value.style.chart.backgroundColor,
            color: e.value.style.chart.color
          }
        }
      }, {
        content: f(() => [
          (r(), T(rt, {
            key: `table_${re.value}`,
            colNames: H.value.colNames,
            head: H.value.head,
            body: H.value.body,
            config: H.value.config,
            title: `${e.value.style.chart.title.text}${e.value.style.chart.title.subtitle.text ? ` : ${e.value.style.chart.title.subtitle.text}` : ""}`,
            onClose: o[1] || (o[1] = (l) => d.value.showTable = !1)
          }, {
            th: f(({ th: l }) => [
              k("div", {
                innerHTML: l,
                style: { display: "flex", "align-items": "center" }
              }, null, 8, It)
            ]),
            td: f(({ td: l }) => [
              De(L(l.name || l), 1)
            ]),
            _: 1
          }, 8, ["colNames", "head", "body", "config", "title"]))
        ]),
        _: 1
      }, 8, ["config"])) : c("", !0)
    ], 14, dt));
  }
}, Qt = /* @__PURE__ */ ht(Mt, [["__scopeId", "data-v-9f23e4f7"]]);
export {
  Qt as default
};
