import { ref as v, computed as m, watch as W, onMounted as ma, onBeforeUnmount as xa, openBlock as w, createElementBlock as ne, normalizeStyle as q, normalizeClass as La, createBlock as P, createCommentVNode as Y, unref as _, createSlots as ka, withCtx as b, renderSlot as k, normalizeProps as B, guardReactiveProps as X, createElementVNode as J, createVNode as Ca, toDisplayString as Ge, createTextVNode as wa } from "vue";
import { u as Sa, c as $a, t as za, a as Ta, p as A, b as Ma, C as ge, i as K, f as Q, I as Ra, d as Ve, $ as Ia, o as Oa, e as Pa, x as je, y as Fa, q as Ea, r as Na, s as ee, l as _a } from "./index-DnVHQ2xI.js";
import { d as Aa, c as Da, a as qe, t as Ha, l as C, r as pe, b as F, p as Je, u as Wa } from "./useResponsive-NZB-WLRF.js";
import { _ as Ya } from "./Tooltip-Cj4EF7v1.js";
import { L as Ba } from "./Legend-CYF2gpXG.js";
import { _ as Xa } from "./Title-5VmBwT4i.js";
import { S as Ua } from "./Slicer-CU7dRZR0.js";
import { u as Za, U as Ga } from "./usePrinter-BEeNAqS5.js";
import Va from "./vue-ui-accordion-DspS4q3f.js";
import { D as ja } from "./DataTable-DTk7C4Pr.js";
import qa from "./vue-ui-skeleton-aZmkNzAe.js";
import { u as Ke } from "./useNestedProp-Cox0K0Y5.js";
import { P as Ja } from "./PenAndPaper-Jb0pLt3G.js";
import { _ as Ka } from "./_plugin-vue_export-helper-CHgC5LLL.js";
const Qa = ["id"], et = ["onClick"], at = {
  key: 2,
  class: "vue-data-ui-watermark"
}, tt = ["innerHTML"], lt = {
  __name: "vue-ui-xy-canvas",
  props: {
    dataset: {
      type: Array,
      default() {
        return [];
      }
    },
    config: {
      type: Object,
      default() {
        return {};
      }
    }
  },
  emits: ["selectLegend"],
  setup(be, { expose: Qe, emit: ea }) {
    const E = be, { vue_ui_xy_canvas: aa } = Sa(), ie = v($a()), U = v(null), $ = v(null), Z = v(null), s = v(null), f = v(1), M = v(1), ae = v(!1), d = v(null), te = v(""), me = v(null), S = v([]), D = v(1), N = v(!0), z = v(!0), ve = v(null), xe = v(0), Le = v(0), ce = v(!1), ke = v(null), Ce = v(null), we = v(null), Se = v(0), $e = v(0), ze = v(0), de = m(() => !!E.dataset && E.dataset.length), a = m({
      get: () => Te(),
      set: (e) => e
    });
    function Te() {
      const e = Ke({
        userConfig: E.config,
        defaultConfig: aa
      });
      return e.theme ? {
        ...Ke({
          userConfig: za.vue_ui_xy_canvas[e.theme] || E.config,
          defaultConfig: e
        }),
        customPalette: Ta[e.theme] || A
      } : e;
    }
    W(() => E.config, (e) => {
      a.value = Te(), Ae(), Se.value += 1, $e.value += 1, ze.value += 1;
    }, { deep: !0 });
    const Me = v(a.value.style.chart.aspectRatio), { isPrinting: Re, isImaging: Ie, generatePdf: Oe, generateImage: Pe } = Za({
      elementId: `xy_canvas_${ie.value}`,
      fileName: a.value.style.chart.title.text || "vue-ui-xy-canvas"
    }), u = v({
      showTable: a.value.table.show,
      showDataLabels: a.value.style.chart.dataLabels.show,
      stacked: a.value.style.chart.stacked,
      showTooltip: a.value.style.chart.tooltip.show
    });
    function ta(e) {
      ce.value = e, Le.value += 1;
    }
    const Fe = m(() => Ma(a.value.customPalette)), R = m(() => H.value ? Math.max(...H.value.filter((e, l) => !S.value.includes(e.absoluteIndex)).map((e) => e.series.length)) : 0), t = m(() => {
      const e = f.value - f.value * (a.value.style.chart.paddingProportions.left + a.value.style.chart.paddingProportions.right);
      return {
        canvasWidth: f.value,
        canvasHeight: M.value,
        left: f.value * a.value.style.chart.paddingProportions.left,
        top: M.value * a.value.style.chart.paddingProportions.top,
        right: f.value - f.value * a.value.style.chart.paddingProportions.right,
        bottom: M.value - M.value * a.value.style.chart.paddingProportions.bottom,
        width: e,
        height: M.value - M.value * (a.value.style.chart.paddingProportions.top + a.value.style.chart.paddingProportions.bottom),
        slot: e / (r.value.end - r.value.start)
      };
    });
    function Ee(e, l) {
      return e / l;
    }
    function la({ hasAutoScale: e, series: l, min: o, max: i, scale: c, yOffset: y, individualHeight: n, stackIndex: g = null }) {
      return l.map((L, ye) => {
        const T = c.min < 0 ? Math.abs(c.min) : 0, I = Ee(L + T, T + c.max);
        let O, G;
        e && (O = Math.abs(c.min), G = Ee(L + O, c.max + O));
        let V = 0;
        return g === null ? V = t.value.bottom - t.value.height * (e ? G : I) : V = t.value.bottom - y - n * (e ? G : I), {
          x: t.value.left + t.value.slot * ye + t.value.slot / 2,
          y: V,
          value: L
        };
      });
    }
    const p = m(() => {
      const e = Math.min(...H.value.filter((n, g) => !S.value.includes(n.absoluteIndex)).flatMap((n) => n.series.slice(r.value.start, r.value.end))), l = Math.max(...H.value.filter((n, g) => !S.value.includes(n.absoluteIndex)).flatMap((n) => n.series.slice(r.value.start, r.value.end))), o = ge(e < 0 ? e : 0, l === e ? e + 1 < 0 ? 0 : e + 1 : l < 0 ? 0 : l, a.value.style.chart.scale.ticks), i = o.min < 0 ? Math.abs(o.min) : 0, c = t.value.bottom - t.value.height * (i / (o.max + i)), y = o.ticks.map((n) => ({
        y: t.value.bottom - t.value.height * ((n + i) / (o.max + i)),
        x: t.value.left - 8,
        value: n
      }));
      return {
        absoluteMin: i,
        max: l,
        min: e,
        scale: o,
        yLabels: y,
        zero: c
      };
    }), oa = m(() => h.value.map((e) => `
            <div style="display:flex;flex-direction:row;gap:6px;align-items:center;">
                <svg viewBox="0 0 10 10" height="12" width="12">
                    <circle cx="5" cy="5" r="5" fill="${e.color}"/>
                </svg>
                <span>${e.name ? e.name + ": " : ""}</span>
                <span>${K(
      a.value.style.chart.dataLabels.formatter,
      e.series[d.value],
      Q({
        p: e.prefix || "",
        v: e.series[d.value],
        s: e.suffix || "",
        r: e.rounding || 0
      }),
      { datapoint: e, seriesIndex: d.value }
    )}</span>
            </div>
        `)), H = m(() => E.dataset.map((e, l) => ({
      ...e,
      series: Ra(e.series),
      absoluteIndex: l,
      color: Ve(e.color || Fe.value[l] || A[l] || A[l % A.length])
    })));
    W(R, (e) => {
      e && Ne();
    });
    const h = m(() => Ia(H.value.filter((e, l) => !S.value.includes(e.absoluteIndex))).map((e, l) => ({
      ...e,
      series: e.series.slice(r.value.start, r.value.end)
    })).map((e, l) => {
      let o = Math.min(...e.series) || 0, i = Math.max(...e.series) || 1;
      o === i && (o = o >= 0 ? i - 1 : o, i = i >= 0 ? i : o + 1);
      const y = {
        ratios: e.series.filter((j) => ![null, void 0].includes(j)).map((j) => (j - o) / (i - o)),
        valueMin: o,
        valueMax: i
      }, n = e.scaleSteps || a.value.style.chart.scale.ticks;
      let g;
      e.autoScaling ? g = ge(y.valueMin, y.valueMax, n) : g = ge(y.valueMin < 0 ? y.valueMin : 0, y.valueMax <= 0 ? 0 : y.valueMax, n);
      const L = u.value.stacked ? t.value.height * (1 - e.cumulatedStackRatio) : 0, ye = u.value.stacked ? t.value.height / a.value.style.chart.stackGap : 0, T = u.value.stacked ? t.value.height * e.stackRatio - ye : t.value.height, I = g.min < 0 ? Math.abs(g.min) : 0;
      let O;
      e.autoScaling && u.value.stacked && i <= 0 ? O = t.value.bottom - L - T : O = t.value.bottom - L - T * (I / (g.max + I));
      const G = g.ticks.map((j, ba) => ({
        y: t.value.bottom - L - T * (ba / (g.ticks.length - 1)),
        x: t.value.left - 8,
        value: j
      })), V = la({
        hasAutoScale: u.value.stacked && e.autoScaling,
        series: e.series,
        min: u.value.stacked ? o : p.value.min,
        max: u.value.stacked ? i : p.value.max,
        scale: u.value.stacked ? g : p.value.scale,
        yOffset: L,
        individualHeight: T,
        stackIndex: u.value.stacked ? l : null
      });
      return {
        ...e,
        coordinatesLine: V,
        min: o,
        max: i,
        localScale: g,
        localZero: O,
        localMin: I,
        localYLabels: G,
        yOffset: L,
        individualHeight: T
      };
    })), r = v({
      start: 0,
      end: R.value
    });
    function Ne() {
      r.value = {
        start: 0,
        end: R.value
      }, xe.value += 1;
    }
    const ra = m(() => h.value.filter((e) => ["line", "plot", void 0].includes(e.type))), x = m(() => h.value.filter((e) => e.type === "bar"));
    function ua() {
      if (!$.value)
        return;
      const e = Z.value.offsetWidth, l = Z.value.offsetHeight;
      $.value.width = e * D.value * 2, $.value.height = l * D.value * 2, f.value = e * D.value * 2, M.value = l * D.value * 2, s.value.scale(D.value, D.value), he();
    }
    function sa() {
      if (s.value.clearRect(0, 0, 1e4, 1e4), s.value.fillStyle = a.value.style.chart.backgroundColor, s.value.fillRect(0, 0, t.value.canvasWidth, t.value.canvasHeight), u.value.stacked)
        a.value.style.chart.grid.y.verticalLines.show && r.value.end - r.value.start < a.value.style.chart.grid.y.verticalLines.hideUnderXLength && h.value.forEach((e) => {
          for (let l = 0; l < r.value.end - r.value.start + 1; l += 1)
            C(
              s.value,
              [
                {
                  x: t.value.left + t.value.slot * l,
                  y: t.value.bottom - e.yOffset - e.individualHeight
                },
                {
                  x: t.value.left + t.value.slot * l,
                  y: t.value.bottom - e.yOffset
                }
              ],
              {
                color: a.value.style.chart.grid.y.verticalLines.color
              }
            );
        }), a.value.style.chart.grid.x.horizontalLines.show && (a.value.style.chart.grid.x.horizontalLines.alternate ? h.value.forEach((e) => {
          e.localYLabels.forEach((l, o) => {
            o < e.localYLabels.length - 1 && pe(
              s.value,
              [
                { x: t.value.left, y: l.y },
                { x: t.value.right, y: l.y },
                { x: t.value.right, y: e.localYLabels[o + 1].y },
                { x: t.value.left, y: e.localYLabels[o + 1].y }
              ],
              {
                fillColor: o % 2 === 0 ? "transparent" : ee(a.value.style.chart.grid.x.horizontalLines.color, a.value.style.chart.grid.x.horizontalLines.opacity),
                strokeColor: "transparent"
              }
            );
          });
        }) : h.value.forEach((e) => {
          e.localYLabels.slice(r.value.start, r.value.end).forEach((l) => {
            C(
              s.value,
              [
                { x: t.value.left, y: l.y },
                { x: t.value.right, y: l.y }
              ],
              {
                color: a.value.style.chart.grid.x.horizontalLines.color
              }
            );
          });
        })), a.value.style.chart.grid.zeroLine.show && h.value.forEach((e) => {
          C(
            s.value,
            [
              { x: t.value.left, y: e.localZero },
              { x: t.value.right, y: e.localZero }
            ],
            {
              color: a.value.style.chart.grid.zeroLine.color,
              lineDash: a.value.style.chart.grid.zeroLine.dashed ? [10, 10] : [0, 0]
            }
          );
        }), a.value.style.chart.grid.y.axisLabels.show && h.value.forEach((e) => {
          C(
            s.value,
            [
              { x: t.value.left, y: t.value.bottom - e.yOffset },
              { x: t.value.left, y: t.value.bottom - e.yOffset - e.individualHeight }
            ],
            {
              color: e.color
            }
          ), C(
            s.value,
            [
              { x: t.value.right, y: t.value.bottom - e.yOffset },
              { x: t.value.right, y: t.value.bottom - e.yOffset - e.individualHeight }
            ],
            {
              color: e.color
            }
          ), e.localYLabels.forEach((l, o) => {
            F(
              s.value,
              K(
                a.value.style.chart.dataLabels.formatter,
                l.value,
                Q({
                  p: e.prefix || a.value.style.chart.grid.y.axisLabels.prefix || "",
                  v: l.value,
                  s: e.suffix || a.value.style.chart.grid.y.axisLabels.suffix || "",
                  r: e.rounding || a.value.style.chart.grid.y.axisLabels.rounding || 0
                }),
                { datapoint: l, seriesIndex: o }
              ),
              l.x + a.value.style.chart.grid.y.axisLabels.offsetX,
              l.y,
              {
                align: "right",
                font: `${Math.round(f.value / 40 * a.value.style.chart.grid.y.axisLabels.fontSizeRatio)}px ${a.value.style.fontFamily}`,
                color: e.color
              }
            );
          });
        }), h.value.forEach((e) => {
          F(
            s.value,
            e.name,
            f.value / 35,
            t.value.bottom - e.yOffset - e.individualHeight / 2,
            {
              align: "center",
              rotation: -90,
              color: e.color,
              font: `${Math.round(f.value / 40 * a.value.style.chart.grid.y.axisLabels.fontSizeRatio)}px ${a.value.style.fontFamily}`
            }
          );
        });
      else {
        if (a.value.style.chart.grid.y.verticalLines.show && r.value.end - r.value.start < a.value.style.chart.grid.y.verticalLines.hideUnderXLength)
          for (let e = 0; e < r.value.end - r.value.start + 1; e += 1)
            C(
              s.value,
              [
                { x: t.value.left + t.value.slot * e, y: t.value.top },
                { x: t.value.left + t.value.slot * e, y: t.value.bottom }
              ],
              {
                color: a.value.style.chart.grid.y.verticalLines.color
              }
            );
        a.value.style.chart.grid.x.horizontalLines.show && (a.value.style.chart.grid.x.horizontalLines.alternate ? p.value.yLabels.forEach((e, l) => {
          l < p.value.yLabels.length - 1 && pe(
            s.value,
            [
              { x: t.value.left, y: e.y },
              { x: t.value.right, y: e.y },
              { x: t.value.right, y: p.value.yLabels[l + 1].y },
              { x: t.value.left, y: p.value.yLabels[l + 1].y }
            ],
            {
              fillColor: l % 2 === 0 ? "transparent" : ee(a.value.style.chart.grid.x.horizontalLines.color, a.value.style.chart.grid.x.horizontalLines.opacity),
              strokeColor: "transparent"
            }
          );
        }) : p.value.yLabels.forEach((e) => {
          C(
            s.value,
            [
              { x: t.value.left, y: e.y },
              { x: t.value.right, y: e.y }
            ],
            {
              color: a.value.style.chart.grid.x.horizontalLines.color
            }
          );
        })), a.value.style.chart.grid.y.showAxis && C(
          s.value,
          [
            { x: t.value.left, y: t.value.top },
            { x: t.value.left, y: t.value.bottom }
          ],
          {
            color: a.value.style.chart.grid.y.axisColor,
            lineWidth: a.value.style.chart.grid.y.axisThickness
          }
        ), a.value.style.chart.grid.x.showAxis && C(
          s.value,
          [
            { x: t.value.left, y: t.value.bottom },
            { x: t.value.right, y: t.value.bottom }
          ],
          {
            color: a.value.style.chart.grid.x.axisColor,
            lineWidth: a.value.style.chart.grid.x.axisThickness
          }
        ), a.value.style.chart.grid.zeroLine.show && C(
          s.value,
          [
            { x: t.value.left, y: p.value.zero },
            { x: t.value.right, y: p.value.zero }
          ],
          {
            color: a.value.style.chart.grid.zeroLine.color,
            lineDash: a.value.style.chart.grid.zeroLine.dashed ? [10, 10] : [0, 0]
          }
        ), a.value.style.chart.grid.y.axisLabels.show && p.value.yLabels.forEach((e, l) => {
          F(
            s.value,
            K(
              a.value.style.chart.dataLabels.formatter,
              e.value,
              Q({
                p: a.value.style.chart.grid.y.axisLabels.prefix || "",
                v: e.value,
                s: a.value.style.chart.grid.y.axisLabels.suffix || "",
                r: a.value.style.chart.grid.y.axisLabels.rounding || 0
              }),
              { datapoint: e, seriesIndex: l }
            ),
            e.x + a.value.style.chart.grid.y.axisLabels.offsetX,
            e.y,
            {
              align: "right",
              font: `${Math.round(f.value / 40 * a.value.style.chart.grid.y.axisLabels.fontSizeRatio)}px ${a.value.style.fontFamily}`,
              color: a.value.style.chart.grid.y.axisLabels.color
            }
          );
        });
      }
      a.value.style.chart.grid.y.axisName && F(
        s.value,
        a.value.style.chart.grid.y.axisName,
        f.value - f.value / 40 * a.value.style.chart.grid.y.axisLabels.fontSizeRatio * 1.2,
        t.value.bottom - t.value.height / 2,
        {
          font: `${Math.round(f.value / 40 * a.value.style.chart.grid.y.axisLabels.fontSizeRatio)}px ${a.value.style.fontFamily}`,
          color: a.value.style.chart.color,
          align: "center",
          rotation: 90
        }
      ), a.value.style.chart.grid.x.axisName && F(
        s.value,
        a.value.style.chart.grid.x.axisName,
        f.value / 2,
        M.value,
        {
          font: `${Math.round(f.value / 40 * a.value.style.chart.grid.y.axisLabels.fontSizeRatio)}px ${a.value.style.fontFamily}`,
          color: a.value.style.chart.color,
          align: "center"
        }
      );
    }
    function na(e) {
      for (let l = 0; l < e.coordinatesLine.length; l += 1) {
        const o = (d.value === l ? f.value / 150 : a.value.style.chart.line.plots.show ? f.value / 200 : 0) * a.value.style.chart.line.plots.radiusRatio;
        qe(
          s.value,
          { x: e.coordinatesLine[l].x, y: e.coordinatesLine[l].y },
          o,
          {
            color: a.value.style.chart.backgroundColor,
            fillStyle: e.color,
            strokeColor: "transparent"
          }
        );
      }
    }
    function ia(e) {
      for (let l = 0; l < e.coordinatesLine.length; l += 1)
        F(
          s.value,
          K(
            a.value.style.chart.dataLabels.formatter,
            e.coordinatesLine[l].value,
            Q({
              p: e.prefix || "",
              v: e.coordinatesLine[l].value,
              s: e.suffix || "",
              r: e.rounding || 0
            }),
            { datapoint: e.coordinatesLine[l], seriesIndex: l }
          ),
          e.coordinatesLine[l].x,
          e.coordinatesLine[l].y + a.value.style.chart.dataLabels.offsetY,
          {
            align: "center",
            font: `${Math.round(f.value / 40 * a.value.style.chart.dataLabels.fontSizeRatio)}px ${a.value.style.fontFamily}`,
            color: a.value.style.chart.dataLabels.useSerieColor ? e.color : a.value.style.chart.dataLabels.color,
            strokeColor: a.value.style.chart.backgroundColor,
            lineWidth: 0.8
          }
        );
    }
    function va() {
      for (let e = r.value.start; e < r.value.end; e += 1)
        (r.value.end - r.value.start < a.value.style.chart.grid.y.timeLabels.modulo || r.value.end - r.value.start >= a.value.style.chart.grid.y.timeLabels.modulo && (e % Math.floor((r.value.end - r.value.start) / a.value.style.chart.grid.y.timeLabels.modulo) === 0 || e === d.value + r.value.start)) && F(
          s.value,
          a.value.style.chart.grid.y.timeLabels.values[e] || e + 1,
          t.value.left + t.value.slot * (e - r.value.start) + t.value.slot / 2,
          t.value.bottom + f.value / a.value.style.chart.grid.y.timeLabels.offsetY,
          {
            align: a.value.style.chart.grid.y.timeLabels.rotation === 0 ? "center" : a.value.style.chart.grid.y.timeLabels.rotation > 0 ? "left" : "right",
            font: `${Math.round(f.value / 40 * a.value.style.chart.grid.y.timeLabels.fontSizeRatio)}px ${a.value.style.fontFamily}`,
            color: ee(a.value.style.chart.grid.y.timeLabels.color, d.value !== null ? d.value + r.value.start === e ? 100 : 20 : 100),
            rotation: a.value.style.chart.grid.y.timeLabels.rotation
          }
        );
    }
    function _e() {
      C(
        s.value,
        [
          { x: t.value.left + t.value.slot * d.value + t.value.slot / 2, y: t.value.top },
          { x: t.value.left + t.value.slot * d.value + t.value.slot / 2, y: t.value.bottom }
        ],
        {
          color: a.value.style.chart.selector.color,
          lineDash: a.value.style.chart.selector.dashed ? [8, 8] : [0, 0],
          lineWidth: 2,
          linceCap: "round"
        }
      );
    }
    function ca() {
      x.value.forEach((e, l) => {
        for (let o = 0; o < e.coordinatesLine.length; o += 1)
          pe(
            s.value,
            [
              {
                x: t.value.left + t.value.slot * o + t.value.slot / 10 + (u.value.stacked ? 0 : t.value.slot / x.value.length * l - (l === 0 ? 0 : t.value.slot / (5 * x.value.length) * l)),
                y: u.value.stacked ? e.localZero : p.value.zero
              },
              {
                x: t.value.left + t.value.slot * o + t.value.slot / 10 + (u.value.stacked ? 0 : t.value.slot / x.value.length * l - (l === 0 ? 0 : t.value.slot / (5 * x.value.length) * l)) + t.value.slot * 0.8 / (u.value.stacked ? 1 : x.value.length),
                y: u.value.stacked ? e.localZero : p.value.zero
              },
              {
                x: t.value.left + t.value.slot * o + t.value.slot / 10 + (u.value.stacked ? 0 : t.value.slot / x.value.length * l - (l === 0 ? 0 : t.value.slot / (5 * x.value.length) * l)) + t.value.slot * 0.8 / (u.value.stacked ? 1 : x.value.length),
                y: e.coordinatesLine[o].y
              },
              {
                x: t.value.left + t.value.slot * o + t.value.slot / 10 + (u.value.stacked ? 0 : t.value.slot / x.value.length * l - (l === 0 ? 0 : t.value.slot / (5 * x.value.length) * l)),
                y: e.coordinatesLine[o].y
              }
            ],
            {
              strokeColor: a.value.style.chart.backgroundColor,
              gradient: {
                type: "linear",
                start: {
                  x: e.coordinatesLine[o].x,
                  y: e.coordinatesLine[o].y
                },
                end: {
                  x: e.coordinatesLine[o].x,
                  y: u.value.stacked ? e.localZero : p.value.zero
                },
                stops: [
                  { offset: 0, color: e.color },
                  { offset: 1, color: _a(e.color, 0.5) }
                ]
              }
            }
          ), u.value.showDataLabels && [!0, void 0].includes(e.dataLabels) && F(
            s.value,
            K(
              a.value.style.chart.dataLabels.formatter,
              e.coordinatesLine[o].value,
              Q({
                p: e.prefix || "",
                v: e.coordinatesLine[o].value,
                s: e.suffix || "",
                r: e.rounding || 0
              }),
              { datapoint: e.coordinatesLine[o], seriesIndex: o }
            ),
            t.value.left + t.value.slot * o + t.value.slot / 10 + (u.value.stacked ? 0 : t.value.slot / x.value.length * l - (l === 0 ? 0 : t.value.slot / (5 * x.value.length) * l)) + t.value.slot * 0.4 / (u.value.stacked ? 1 : x.value.length),
            (e.coordinatesLine[o].value < 0 ? u.value.stacked ? e.localZero : p.value.zero : e.coordinatesLine[o].y) + a.value.style.chart.dataLabels.offsetY,
            {
              align: "center",
              font: `${Math.round(f.value / 40 * a.value.style.chart.dataLabels.fontSizeRatio)}px ${a.value.style.fontFamily}`,
              color: a.value.style.chart.dataLabels.useSerieColor ? e.color : a.value.style.chart.dataLabels.color,
              strokeColor: a.value.style.chart.backgroundColor,
              lineWidth: 0.8
            }
          );
      });
    }
    function da(e) {
      e.useArea ? u.value.stacked ? Je(
        s.value,
        [{ x: e.coordinatesLine[0].x, y: e.localZero }, ...e.coordinatesLine, { x: e.coordinatesLine.at(-1).x, y: e.localZero }],
        {
          fillColor: ee(e.color, a.value.style.chart.area.opacity),
          strokeColor: "transparent"
        }
      ) : Je(
        s.value,
        [{ x: e.coordinatesLine[0].x, y: p.value.zero }, ...e.coordinatesLine, { x: e.coordinatesLine.at(-1).x, y: p.value.zero }],
        {
          fillColor: ee(e.color, a.value.style.chart.area.opacity),
          strokeColor: "transparent"
        }
      ) : C(s.value, e.coordinatesLine, {
        color: e.color,
        lineWidth: 3
      });
    }
    function ha() {
      h.value.forEach((e, l) => {
        C(
          s.value,
          [
            { x: t.value.left, y: t.value.bottom - e.yOffset },
            { x: t.value.right, y: t.value.bottom - e.yOffset }
          ],
          {
            color: a.value.style.chart.grid.x.horizontalLines.color,
            lineWidth: 1
          }
        );
      });
    }
    function he() {
      sa(), N.value ? (z.value && d.value !== null && a.value.style.chart.selector.show && _e(), ca(), u.value.stacked && a.value.style.chart.grid.x.showAxis && ha(), ra.value.forEach((e) => {
        (e.type === "line" || !e.type) && da(e), z.value && (na(e), u.value.showDataLabels && [!0, void 0].includes(e.dataLabels) && ia(e));
      }), ve.value = Da($.value)) : (ve.value && (s.value.clearRect(0, 0, 1e4, 1e4), s.value.drawImage(ve.value, 0, 0)), z.value && d.value !== null && a.value.style.chart.selector.show && _e(), z.value && d.value !== null && h.value.forEach((e) => {
        if (e.type === "line" || !e.type || e.type === "plot") {
          if (!e.coordinatesLine[d.value]) return;
          e.coordinatesLine[d.value].x !== void 0 && e.coordinatesLine[d.value].y !== void 0 && qe(
            s.value,
            {
              x: e.coordinatesLine[d.value].x,
              y: e.coordinatesLine[d.value].y
            },
            f.value / 150 * a.value.style.chart.line.plots.radiusRatio,
            {
              color: a.value.style.chart.backgroundColor,
              fillStyle: e.color,
              strokeColor: "transparent"
            }
          );
        }
      })), a.value.style.chart.grid.y.timeLabels.show && va(), N.value = !1;
    }
    const le = Aa(() => {
      z.value = !0, ua();
    }, R.value > 200 ? 10 : 1, !z.value);
    function fa(e) {
      const { left: l } = $.value.getBoundingClientRect(), o = e.clientX - l;
      if (o * 2 < t.value.left || o * 2 > t.value.right) {
        ae.value = !1, d.value = null;
        return;
      }
      const i = o * 2 - t.value.left;
      if (d.value = Math.floor(i / t.value.slot), ae.value = !0, !z.value) return;
      let c = "";
      const y = a.value.style.chart.tooltip.customFormat;
      je(y) && Fa(() => y({
        seriesIndex: d.value,
        datapoint: h.value.map((n) => ({
          shape: n.shape || null,
          name: n.name,
          color: n.color,
          type: n.type || "line",
          value: n.series.find((g, L) => L === d.value)
        })),
        series: h.value,
        config: a.value
      })) ? te.value = y({
        seriesIndex: d.value,
        datapoint: h.value.map((n) => ({
          shape: n.shape || null,
          name: n.name,
          color: n.color,
          type: n.type || "line",
          value: n.series.find((g, L) => L === d.value)
        })),
        series: h.value,
        config: a.value
      }) : (a.value.style.chart.grid.y.timeLabels.values.slice(r.value.start, r.value.end)[d.value] && (c += `<div style="padding-bottom: 6px; margin-bottom: 4px; border-bottom: 1px solid ${a.value.style.chart.tooltip.borderColor}; width:100%">${a.value.style.chart.grid.y.timeLabels.values.slice(r.value.start, r.value.end)[d.value]}</div>`), c += oa.value.join(""), te.value = c), z.value = !1;
    }
    W(() => d.value, (e) => {
      le();
    }), W(() => r.value, (e) => {
      N.value = !0, he();
    }, {
      deep: !0
    }), W(() => u.value.showDataLabels, (e) => {
      N.value = !0, he();
    }), W(() => u.value.stacked, (e) => {
      N.value = !0, z.value = !0, le();
    });
    function ya() {
      ae.value = !1, d.value = null, te.value = "";
    }
    const oe = v(null), re = v(null);
    ma(() => {
      Ae();
    });
    function Ae() {
      if (Oa(E.dataset) ? Pa({
        componentName: "VueUiXyCanvas",
        type: "dataset"
      }) : $.value && (s.value = $.value.getContext("2d", { willReadFrequently: !0 })), a.value.responsive) {
        const e = Ha(() => {
          const { width: l, height: o } = Wa({
            chart: U.value,
            title: a.value.style.chart.title.text ? ke.value : null,
            legend: a.value.style.chart.legend.show ? Ce.value : null,
            slicer: a.value.style.chart.zoom.show && R.value > 1 ? we.value : null
          });
          Me.value = `${l} / ${o}`;
        });
        oe.value = new ResizeObserver(e), oe.value.observe(U.value.parentNode);
      }
      re.value = new ResizeObserver((e) => {
        for (const l of e)
          l.contentBoxSize && Z.value && (N.value = !0, le());
      }), re.value.observe(Z.value);
    }
    xa(() => {
      re.value && re.value.disconnect(), oe.value && oe.value.disconnect();
    });
    function De(e) {
      ea("selectLegend", h.value.find((l) => l.absoluteIndex === e)), S.value.includes(e) ? S.value = S.value.filter((l) => l !== e) : S.value.push(e), N.value = !0, le();
    }
    const He = m(() => H.value.map((e, l) => ({
      ...e,
      name: e.name,
      color: Ve(e.color) || Fe.value[l] || A[l] || A[l % A.length],
      shape: e.shape || "circle",
      prefix: e.prefix || "",
      suffix: e.suffix || "",
      rounding: e.rounding || 0
    })).map((e) => ({
      ...e,
      opacity: S.value.includes(e.absoluteIndex) ? 0.5 : 1,
      segregate: () => De(e.absoluteIndex),
      isSegregated: S.value.includes(e.absoluteIndex)
    }))), ga = m(() => ({
      cy: "donut-div-legend",
      backgroundColor: a.value.style.chart.legend.backgroundColor,
      color: a.value.style.chart.legend.color,
      fontSize: a.value.style.chart.legend.fontSize,
      paddingBottom: 12,
      fontWeight: a.value.style.chart.legend.bold ? "bold" : ""
    })), ue = m(() => {
      const e = [""].concat(h.value.map((c) => c.name)).concat(' <svg xmlns="http://www.w3.org/2000/svg" width="16" height="16" viewBox="0 0 24 24" stroke-width="1.5" stroke="currentColor" fill="none" stroke-linecap="round" stroke-linejoin="round"><path stroke="none" d="M0 0h24v24H0z" fill="none"/><path d="M18 16v2a1 1 0 0 1 -1 1h-11l6 -7l-6 -7h11a1 1 0 0 1 1 1v2" /></svg>');
      let l = [];
      for (let c = 0; c < R.value; c += 1) {
        const y = h.value.map((n) => n.series[c] ?? 0).reduce((n, g) => n + g, 0);
        l.push([a.value.style.chart.grid.y.timeLabels.values.slice(r.value.start, r.value.end)[c] ?? c + 1].concat(h.value.map((n) => (n.series[c] ?? 0).toFixed(a.value.table.rounding))).concat((y ?? 0).toFixed(a.value.table.rounding)));
      }
      const o = {
        th: {
          backgroundColor: a.value.table.th.backgroundColor,
          color: a.value.table.th.color,
          outline: a.value.table.th.outline
        },
        td: {
          backgroundColor: a.value.table.td.backgroundColor,
          color: a.value.table.td.color,
          outline: a.value.table.td.outline
        },
        breakpoint: a.value.table.responsiveBreakpoint
      }, i = [a.value.table.columnNames.period].concat(h.value.map((c) => c.name)).concat(a.value.table.columnNames.total);
      return { head: e, body: l.slice(0, r.value.end - r.value.start), config: o, colNames: i };
    }), We = m(() => {
      if (h.value.length === 0) return { head: [], body: [], config: {}, columnNames: [] };
      const e = h.value.map((o) => ({
        label: o.name,
        color: o.color,
        type: o.type
      })), l = [];
      for (let o = r.value.start; o < r.value.end; o += 1) {
        const i = [a.value.style.chart.grid.y.timeLabels.values[o] || o + 1];
        h.value.forEach((c) => {
          i.push(Number((c.series[o] || 0).toFixed(a.value.table.rounding)));
        }), l.push(i);
      }
      return { head: e, body: l };
    });
    function Ye() {
      const e = [[a.value.style.chart.title.text], [a.value.style.chart.title.subtitle.text], [""]], l = ["", ...We.value.head.map((y) => y.label)], o = We.value.body, i = e.concat([l]).concat(o), c = Ea(i);
      Na({ csvContent: c, title: a.value.style.chart.title.text || "vue-ui-xy-canvas" });
    }
    function pa() {
      return h.value;
    }
    function Be() {
      u.value.showTable = !u.value.showTable;
    }
    function Xe() {
      u.value.showDataLabels = !u.value.showDataLabels;
    }
    function Ue() {
      u.value.stacked = !u.value.stacked;
    }
    function Ze() {
      u.value.showTooltip = !u.value.showTooltip;
    }
    const se = v(!1);
    function fe() {
      se.value = !se.value;
    }
    return Qe({
      getData: pa,
      generateCsv: Ye,
      generatePdf: Oe,
      generateImage: Pe,
      toggleTable: Be,
      toggleLabels: Xe,
      toggleStack: Ue,
      toggleTooltip: Ze,
      toggleAnnotator: fe
    }), (e, l) => (w(), ne("div", {
      style: q(`width:100%; position:relative; ${a.value.responsive ? "height: 100%" : ""}`),
      ref_key: "xy",
      ref: U,
      id: `xy_canvas_${ie.value}`,
      class: La(`vue-ui-donut ${ce.value ? "vue-data-ui-wrapper-fullscreen" : ""}`)
    }, [
      a.value.style.chart.title.text ? (w(), ne("div", {
        key: 0,
        ref_key: "chartTitle",
        ref: ke,
        style: q(`width:100%;background:${a.value.style.chart.backgroundColor};`)
      }, [
        (w(), P(Xa, {
          key: `title_${Se.value}`,
          config: {
            title: {
              cy: "xy-canvas-title",
              ...a.value.style.chart.title
            },
            subtitle: {
              cy: "xy-canvas-subtitle",
              ...a.value.style.chart.title.subtitle
            }
          }
        }, null, 8, ["config"]))
      ], 4)) : Y("", !0),
      a.value.userOptions.show && de.value ? (w(), P(Ga, {
        ref: "details",
        key: `user_option_${Le.value}`,
        backgroundColor: a.value.style.chart.backgroundColor,
        color: a.value.style.chart.color,
        isPrinting: _(Re),
        isImaging: _(Ie),
        uid: ie.value,
        hasTooltip: a.value.userOptions.buttons.tooltip && a.value.style.chart.tooltip.show,
        hasPdf: a.value.userOptions.buttons.pdf,
        hasImg: a.value.userOptions.buttons.img,
        hasXls: a.value.userOptions.buttons.csv,
        hasLabel: a.value.userOptions.buttons.labels,
        hasStack: be.dataset.length > 1 && a.value.userOptions.buttons.stack,
        hasFullscreen: a.value.userOptions.buttons.fullscreen,
        hasTable: r.value.end - r.value.start < 200 && a.value.userOptions.buttons.table,
        isFullscreen: ce.value,
        isTooltip: u.value.showTooltip,
        isStacked: u.value.stacked,
        titles: { ...a.value.userOptions.buttonTitles },
        chartElement: U.value,
        position: a.value.userOptions.position,
        hasAnnotator: a.value.userOptions.buttons.annotator,
        isAnnotation: se.value,
        onToggleFullscreen: ta,
        onGeneratePdf: _(Oe),
        onGenerateCsv: Ye,
        onGenerateImage: _(Pe),
        onToggleTable: Be,
        onToggleLabels: Xe,
        onToggleStack: Ue,
        onToggleTooltip: Ze,
        onToggleAnnotator: fe
      }, ka({ _: 2 }, [
        e.$slots.optionTooltip ? {
          name: "optionTooltip",
          fn: b(() => [
            k(e.$slots, "optionTooltip", {}, void 0, !0)
          ]),
          key: "0"
        } : void 0,
        e.$slots.optionPdf ? {
          name: "optionPdf",
          fn: b(() => [
            k(e.$slots, "optionPdf", {}, void 0, !0)
          ]),
          key: "1"
        } : void 0,
        e.$slots.optionCsv ? {
          name: "optionCsv",
          fn: b(() => [
            k(e.$slots, "optionCsv", {}, void 0, !0)
          ]),
          key: "2"
        } : void 0,
        e.$slots.optionImg ? {
          name: "optionImg",
          fn: b(() => [
            k(e.$slots, "optionImg", {}, void 0, !0)
          ]),
          key: "3"
        } : void 0,
        e.$slots.optionTable ? {
          name: "optionTable",
          fn: b(() => [
            k(e.$slots, "optionTable", {}, void 0, !0)
          ]),
          key: "4"
        } : void 0,
        e.$slots.optionLabels ? {
          name: "optionLabels",
          fn: b(() => [
            k(e.$slots, "optionLabels", {}, void 0, !0)
          ]),
          key: "5"
        } : void 0,
        e.$slots.optionStack ? {
          name: "optionStack",
          fn: b(() => [
            k(e.$slots, "optionStack", {}, void 0, !0)
          ]),
          key: "6"
        } : void 0,
        e.$slots.optionFullscreen ? {
          name: "optionFullscreen",
          fn: b(({ toggleFullscreen: o, isFullscreen: i }) => [
            k(e.$slots, "optionFullscreen", B(X({ toggleFullscreen: o, isFullscreen: i })), void 0, !0)
          ]),
          key: "7"
        } : void 0,
        e.$slots.optionAnnotator ? {
          name: "optionAnnotator",
          fn: b(({ toggleAnnotator: o, isAnnotator: i }) => [
            k(e.$slots, "optionAnnotator", B(X({ toggleAnnotator: o, isAnnotator: i })), void 0, !0)
          ]),
          key: "8"
        } : void 0
      ]), 1032, ["backgroundColor", "color", "isPrinting", "isImaging", "uid", "hasTooltip", "hasPdf", "hasImg", "hasXls", "hasLabel", "hasStack", "hasFullscreen", "hasTable", "isFullscreen", "isTooltip", "isStacked", "titles", "chartElement", "position", "hasAnnotator", "isAnnotation", "onGeneratePdf", "onGenerateImage"])) : Y("", !0),
      J("div", {
        class: "vue-ui-xy-canvas",
        style: q(`position: relative; aspect-ratio: ${Me.value}`),
        ref_key: "container",
        ref: Z
      }, [
        de.value ? (w(), ne("canvas", {
          key: 0,
          ref_key: "canvas",
          ref: $,
          style: { width: "100%", height: "100%" },
          onMousemove: l[0] || (l[0] = (o) => fa(o)),
          onMouseleave: ya
        }, null, 544)) : (w(), P(qa, {
          key: 1,
          config: {
            type: "line",
            style: {
              backgroundColor: a.value.style.chart.backgroundColor,
              line: {
                axis: {
                  color: "#CCCCCC"
                },
                path: {
                  color: "#CCCCCC",
                  strokeWidth: 0.5
                }
              }
            }
          }
        }, null, 8, ["config"])),
        Ca(Ya, {
          show: u.value.showTooltip && ae.value,
          backgroundColor: a.value.style.chart.tooltip.backgroundColor,
          color: a.value.style.chart.tooltip.color,
          fontSize: a.value.style.chart.tooltip.fontSize,
          borderRadius: a.value.style.chart.tooltip.borderRadius,
          borderColor: a.value.style.chart.tooltip.borderColor,
          borderWidth: a.value.style.chart.tooltip.borderWidth,
          position: a.value.style.chart.tooltip.position,
          offsetY: a.value.style.chart.tooltip.offsetY,
          parent: $.value,
          content: te.value,
          backgroundOpacity: a.value.style.chart.tooltip.backgroundOpacity,
          isCustom: _(je)(a.value.style.chart.tooltip.customFormat)
        }, {
          "tooltip-before": b(() => [
            k(e.$slots, "tooltip-before", B(X({ ...me.value })), void 0, !0)
          ]),
          "tooltip-after": b(() => [
            k(e.$slots, "tooltip-after", B(X({ ...me.value })), void 0, !0)
          ]),
          _: 3
        }, 8, ["show", "backgroundColor", "color", "fontSize", "borderRadius", "borderColor", "borderWidth", "position", "offsetY", "parent", "content", "backgroundOpacity", "isCustom"])
      ], 4),
      J("div", {
        ref_key: "chartSlicer",
        ref: we,
        style: q(`width:100%;background:${a.value.style.chart.backgroundColor}`),
        "data-html2canvas-ignore": ""
      }, [
        a.value.style.chart.zoom.show && R.value > 1 ? (w(), P(Ua, {
          key: `slicer_${xe.value}`,
          background: a.value.style.chart.zoom.color,
          borderColor: a.value.style.chart.backgroundColor,
          fontSize: a.value.style.chart.zoom.fontSize,
          useResetSlot: a.value.style.chart.zoom.useResetSlot,
          labelLeft: a.value.style.chart.grid.y.timeLabels.values[r.value.start] ? a.value.style.chart.grid.y.timeLabels.values[r.value.start] : "",
          labelRight: a.value.style.chart.grid.y.timeLabels.values[r.value.end - 1] ? a.value.style.chart.grid.y.timeLabels.values[r.value.end - 1] : "",
          textColor: a.value.style.chart.color,
          inputColor: a.value.style.chart.zoom.color,
          selectColor: a.value.style.chart.zoom.highlightColor,
          max: R.value,
          min: 0,
          valueStart: r.value.start,
          valueEnd: r.value.end,
          start: r.value.start,
          "onUpdate:start": l[1] || (l[1] = (o) => r.value.start = o),
          end: r.value.end,
          "onUpdate:end": l[2] || (l[2] = (o) => r.value.end = o),
          onReset: Ne
        }, {
          "reset-action": b(({ reset: o }) => [
            k(e.$slots, "reset-action", B(X({ reset: o })), void 0, !0)
          ]),
          _: 3
        }, 8, ["background", "borderColor", "fontSize", "useResetSlot", "labelLeft", "labelRight", "textColor", "inputColor", "selectColor", "max", "valueStart", "valueEnd", "start", "end"])) : Y("", !0)
      ], 4),
      J("div", {
        ref_key: "chartLegend",
        ref: Ce
      }, [
        a.value.style.chart.legend.show && de.value ? (w(), P(Ba, {
          legendSet: He.value,
          config: ga.value,
          key: `legend_${ze.value}`,
          onClickMarker: l[3] || (l[3] = ({ i: o }) => De(o))
        }, {
          item: b(({ legend: o, index: i }) => [
            J("div", {
              onClick: (c) => o.segregate(),
              style: q(`opacity:${S.value.includes(i) ? 0.5 : 1}`)
            }, Ge(o.name), 13, et)
          ]),
          _: 1
        }, 8, ["legendSet", "config"])) : k(e.$slots, "legend", {
          key: 1,
          legend: He.value
        }, void 0, !0)
      ], 512),
      e.$slots.watermark ? (w(), ne("div", at, [
        k(e.$slots, "watermark", B(X({ isPrinting: _(Re) || _(Ie) })), void 0, !0)
      ])) : Y("", !0),
      r.value.end - r.value.start < 200 ? (w(), P(Va, {
        key: 3,
        hideDetails: "",
        config: {
          open: u.value.showTable,
          maxHeight: 1e4,
          body: {
            backgroundColor: a.value.style.chart.backgroundColor,
            color: a.value.style.chart.color
          },
          head: {
            backgroundColor: a.value.style.chart.backgroundColor,
            color: a.value.style.chart.color
          }
        }
      }, {
        content: b(() => [
          (w(), P(ja, {
            key: `table_${$e.value}`,
            colNames: ue.value.colNames,
            head: ue.value.head,
            body: ue.value.body,
            config: ue.value.config,
            title: `${a.value.style.chart.title.text}${a.value.style.chart.title.subtitle.text ? ` : ${a.value.style.chart.title.subtitle.text}` : ""}`,
            onClose: l[4] || (l[4] = (o) => u.value.showTable = !1)
          }, {
            th: b(({ th: o }) => [
              J("div", { innerHTML: o }, null, 8, tt)
            ]),
            td: b(({ td: o }) => [
              wa(Ge(o), 1)
            ]),
            _: 1
          }, 8, ["colNames", "head", "body", "config", "title"]))
        ]),
        _: 1
      }, 8, ["config"])) : Y("", !0),
      a.value.userOptions.buttons.annotator && h.value.length ? (w(), P(Ja, {
        key: 4,
        parent: U.value,
        backgroundColor: a.value.style.chart.backgroundColor,
        color: a.value.style.chart.color,
        active: se.value,
        onClose: fe
      }, null, 8, ["parent", "backgroundColor", "color", "active"])) : Y("", !0)
    ], 14, Qa));
  }
}, bt = /* @__PURE__ */ Ka(lt, [["__scopeId", "data-v-01470008"]]);
export {
  bt as default
};
